/*
 *  astar.h
 *
 *  Created by frederic Vernier on 1/22/07.
 *  Copyright 2007 frederic Vernier All rights reserved.
 *
 */
#ifndef ASTAR_H
#define ASTAR_H

#include <stdio.h>
#include <stdlib.h>
#include <kazlib/list.h>
#include "newcol.h"
#include <SDL/SDL.h>

/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif

typedef struct _etile etile;

struct _etile {
  tile *location;
  int f;
  int g;
  int h;
  etile *parent;
};

// theses pointers have no guarentee to point on something. It is there for debug purpose;
extern list_t    *foundPath;
extern list_t    *openList;
extern list_t    *closedList;
extern char      *errorMessage;
extern SDL_mutex *astarmut;
void testNext(etile *current, const int dx, const int dy);
list_t *astarSearch (const int startX, const int startY, const int destX, const int destY,  unit *u);
void clean ();
lnode_t *getLowestOpenETile();

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#endif

