/*
 *  initialization.h
 *  NewCol
 *
 *  Created by frédéric Vernier on 2/10/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef INITIALIZATION_H
#define INITIALIZATION_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <kazlib/list.h>

#include "newcol.h"
#include "typenewcol.h"
#include "binarytree.h"
#include "astar.h"
#include "cityview.h"
#include "minimap.h"
#include "unitview.h"
#include "popup.h"
#include "initialization.h"
#include "improvedPerlinNoise.h"

#ifdef __cplusplus
extern "C" {
#endif

extern char isRobinsonTransfo;

void initBonuses(int percentage);
void initLostCityRumors(int percentage);
void initGround();
void initForests();
void initWorldRivers();
void initDebugCitiesAndUnits();
void initBonuses(int);
void initEurope();
void initNatives();
void initFrance();
void initEngland();
void initSpain();
void initPortugal();
void initHolland();
void initItaly();
void initGermany();
void initRussia();

void initIroquois();
void initApache();
void initAztek();

int linkCitiesWithRoad(const char* cname1, const char* cname2);
void initGroundsFromBitmap(const char* bitmapName, int ratioX, int ratioY, char isRobinsonTransfo);
void initTiles(int w, int h);
int mapTransfo(const double longitude_Arg, const double latitude_Arg);

#ifdef __cplusplus
}
#endif

#endif

