/*
 *  Minimap.c
 *  NewCol
 *
 *  Created by fredericVernier on 2/28/07.
 *  Copyright 2007 Frederic Vernier. All rights reserved.
 *
 */

#include "minimap.h"
#pragma warning ( disable : 4996 )

SDL_Surface *miniworld            = NULL;
SDL_Surface *minimap              = NULL;
SDL_Surface *minimapWindow        = NULL;
SDL_Rect    *minimapRect          = NULL;
SDL_Rect    *miniposRect          = NULL;
SDL_Rect    *minimapShadowRect    = NULL;
SDL_Surface *minimapshadowbuffer  = NULL;

int          updateZoom           = 16;  //they are a/16th
int          minimapZoom          = 16;  //they are a/16th
int          minimapNation        = -1;
int          mouseXMM             = 0;
int          mouseYMM             = 0;
int          offsetXMM            = 0;
int          offsetYMM            = 0;
int          offsetGrabXMM        = 0;
int          offsetGrabYMM        = 0;

SDL_Color   *cols[GROUND_NUMBER];

/**
 * display the minimap
 */
void displayMiniMap() {
  minimapRect->w =minimapWindow->w;
  minimapRect->h =minimapWindow->h;
  printf("displayMiniMap() %i, %i    %i*%i on %i*%i   at zoom %d/16\n", offsetXMM, offsetYMM, minimap->w, minimap->h, minimapWindow->w, minimapWindow->h, minimapZoom);
  SDL_Rect *innerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *outerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *rect      = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *worldRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  innerRect->x = offsetXMM;
  innerRect->y = offsetYMM;
  innerRect->w = minimapRect->w-33;
  innerRect->h = minimapRect->h-TITLE_BAR_HEIGHT-22;
  outerRect->x = 0;
  outerRect->y = TITLE_BAR_HEIGHT;
  outerRect->w = minimapRect->w;
  outerRect->h = minimapRect->h-TITLE_BAR_HEIGHT;
  worldRect->x = 2*minimapRect->w/3;
  worldRect->y = 2*minimapRect->h/3;
  worldRect->w = minimapRect->w/3;
  worldRect->h = minimapRect->h/3;
  
  rect->x = 0;
  rect->y = 2*minimapRect->h/3;
  rect->w = 2*minimapRect->w/3;
  rect->h = 1*minimapRect->h/3+1;
  SDL_FillRect(minimapWindow, rect, 0x00000000);
  rect->x = 2*minimapRect->w/3;
  rect->y = 0;
  rect->w = minimapRect->w/3+1;
  rect->h = 2*minimapRect->h/3;
  SDL_FillRect(minimapWindow, rect, 0x00000000);  
  //boxRGBA(minimapWindow, 0, 2*minimapRect->h/3, 2*minimapRect->w/3, minimapRect->h,     0, 0, 0, 0);
  //boxRGBA(minimapWindow, 2*minimapRect->w/3, 0, minimapRect->w,     2*minimapRect->h/3, 0, 0, 0, 0);
  minimapRect->w = minimapWindow->w;
  minimapRect->h = minimapWindow->h;
  
  // display the shadow first
  if (minimapshadowbuffer!=NULL){
    minimapShadowRect->w = minimapRect->w+2*SHADOW_SIZE;
    minimapShadowRect->h = minimapRect->h+2*SHADOW_SIZE;
    minimapShadowRect->x = minimapRect->x-SHADOW_SIZE;
    minimapShadowRect->y = minimapRect->y-SHADOW_SIZE;
    SDL_BlitSurface(minimapshadowbuffer, 0, screen, minimapShadowRect);
  }
  // then display the minimap !
  SDL_BlitSurface(minimap,   innerRect, minimapWindow, outerRect);
  
  // little world
  SDL_BlitSurface(miniworld, NULL, minimapWindow, worldRect);
  // red rectangle on the world 
  int x1 = 2*minimapWindow->w/3+offsetXMM*miniworld->w/minimap->w;
  int y1 = 2*minimapWindow->h/3+offsetYMM*miniworld->h/minimap->h;
  int x2 = 2*minimapWindow->w/3+(offsetXMM+2*minimapWindow->w/3)*miniworld->w/minimap->w;
  int y2 = 2*minimapWindow->h/3+(offsetYMM+2*minimapWindow->h/3)*miniworld->h/minimap->h;
  rectangleRGBA(minimapWindow, x1, y1, x2, y2, 255, 64,64, 255);

  // make the cities blink slowly
  if (minimapNation>=FIRST_NATION && minimapNation<=LAST_NATION) {
    list_t *cl = nations[minimapNation-FIRST_NATION]->cityList;
    lnode_t *ln = list_first(cl);
    while (ln!=NULL && ln!=&cl->list_nilnode){
      city* c = (city *)ln->list_data;
      int x = c->location->posX*minimapZoom/16-offsetXMM+outerRect->x;
      int y = c->location->posY*minimapZoom/16-offsetYMM+outerRect->y;
      if (x>=0 && y>=0 && x<2*minimapWindow->w/3 && y<2*minimapWindow->h/3){
        Uint32 *pixelsrc = (Uint32 *) minimapWindow->pixels + (y)*minimapWindow->w + x;
        if (animID%16<8)
          *pixelsrc = 0xFFFFFFFF;
        else
          *pixelsrc = 0xFF000000;

      }
      ln = ln->list_next;
    }
  }

  // make the visible units blink fast
  if (minimapNation>=FIRST_NATION && minimapNation<=LAST_NATION) {
    list_t *ul = nations[minimapNation-FIRST_NATION]->unitList;
    lnode_t *ln = list_first(ul);
    while (ln!=NULL && ln!=&ul->list_nilnode){
      unit* u = (unit *)ln->list_data;
      if (u->location!=NULL) {
        int x = u->location->posX*minimapZoom/16-offsetXMM+outerRect->x;
        int y = u->location->posY*minimapZoom/16-offsetYMM+outerRect->y;
        if (x>=0 && y>=0 && x<2*minimapWindow->w/3 && y<2*minimapWindow->h/3){
          Uint32 *pixelsrc = (Uint32 *) minimapWindow->pixels + (y)*minimapWindow->w + x;
          if (animID%2<1)
            *pixelsrc = 0xFFCCCCCC;
          else
            *pixelsrc = 0xFF333333;
        }
      }
      ln = ln->list_next;
    }
  }


  hlineRGBA(screen, minimapRect->x,                  minimapRect->x+minimapRect->w-1-33, minimapRect->y-1,                255, 250, 150, 255);
  vlineRGBA(screen, minimapRect->x-1,                minimapRect->y,                     minimapRect->y+minimapRect->h-1-22, 255, 250, 150, 255);
  hlineRGBA(screen, minimapRect->x,                  minimapRect->x+minimapRect->w-1-33, minimapRect->y+minimapRect->h-22,   255, 250, 150, 255);
  vlineRGBA(screen, minimapRect->x+minimapRect->w-33,   minimapRect->y,                  minimapRect->y+minimapRect->h-1-22, 255, 250, 150, 255);

  miniposRect->x = (int)(firstVisibleTileX*minimapZoom/16)-offsetXMM;
  miniposRect->y = (int)(firstVisibleTileY*minimapZoom/16)-offsetYMM;
  miniposRect->w = (int)((screen->w/TILESIZE)*minimapZoom/16);
  miniposRect->h = (int)((screen->h/TILESIZE)*minimapZoom/16);
  
  SDL_Color *col = NULL;
  if (gamemode==EDIT && minimapNation!=-1)
    col =nationColors[minimapNation-FIRST_NATION];
  else if (gamemode==PLAY && currentPlayerElement!=NULL) {
    minimapNation = ((player*)currentPlayerElement->list_data)->nation;
    col =nationColors[minimapNation-FIRST_NATION];
  }
  else {
    col = &GREY;
    minimapNation = -1;
  }
  assert(col!=NULL);
  // display title bar
  // title bar colors
  int r1 = (int)(col->r*0.75);if (r1>255) r1=255;
  int g1 = (int)(col->g*0.75);if (g1>255) g1=255;
  int b1 = (int)(col->b*0.75);if (b1>255) b1=255;

  int r2 = (int)(col->r*1.25);if (r2>255) r2=255;
  int g2 = (int)(col->g*1.25);if (g2>255) g2=255;
  int b2 = (int)(col->b*1.25);if (b2>255) b2=255;

  // title bar position
  rect->x = 0;
  rect->y = 0;
  rect->w = minimapRect->w-33;
  //printf("title bar width = %d\n", minimapRect->w);
  rect->h = TITLE_BAR_HEIGHT;
  SDL_FillRect(minimapWindow, rect, 0x000000FF);
  vgradientboxRGBA(minimapWindow, rect->x, rect->y,           rect->w-1, rect->h/2,           r1, g1, b1, 255, r2, g2, b2, 255);
  vgradientboxRGBA(minimapWindow, rect->x, rect->y+rect->h/2, rect->w-1, rect->h/2,           r2, g2, b2, 255, r1, g1, b1, 255);
  // SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, col->r, col->g, col->b ));

  r1 = (int)(col->r*0.75);if (r1>255) r1=255;
  g1 = (int)(col->g*0.75);if (g1>255) g1=255;
  b1 = (int)(col->b*0.75);if (b1>255) b1=255;
  r2 = (int)(col->r*0.5);if (r2>255) r2=255;
  g2 = (int)(col->g*0.5);if (g2>255) g2=255;
  b2 = (int)(col->b*0.5);if (b2>255) b2=255;

  boxRGBA(minimapWindow, miniposRect->x-GRAB_WING, miniposRect->y-GRAB_WING+TITLE_BAR_HEIGHT,
          miniposRect->x+miniposRect->w, miniposRect->y+TITLE_BAR_HEIGHT,
          r1, g1, b1, 192);
  boxRGBA(minimapWindow, miniposRect->x+miniposRect->w, miniposRect->y-GRAB_WING+TITLE_BAR_HEIGHT,
          miniposRect->x+miniposRect->w+GRAB_WING, miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT,
          r2, g2, b2, 192);
  boxRGBA(minimapWindow, miniposRect->x-GRAB_WING, miniposRect->y+TITLE_BAR_HEIGHT,
          miniposRect->x, miniposRect->y+miniposRect->h+GRAB_WING+TITLE_BAR_HEIGHT,
          r2, g2, b2, 192);
  boxRGBA(minimapWindow, miniposRect->x, miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT,
          miniposRect->x+miniposRect->w+GRAB_WING, miniposRect->y+miniposRect->h+GRAB_WING+TITLE_BAR_HEIGHT,
          r1, g1, b1, 192);

  hlineRGBA(minimapWindow, miniposRect->x,   miniposRect->x+miniposRect->w,                 miniposRect->y+TITLE_BAR_HEIGHT,                   150, 250, 255, 255);
  vlineRGBA(minimapWindow, miniposRect->x,   miniposRect->y+TITLE_BAR_HEIGHT,                  miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT, 150, 250, 255, 255);
  hlineRGBA(minimapWindow, miniposRect->x,   miniposRect->x+miniposRect->w,                 miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT,    150, 250, 255, 255);
  vlineRGBA(minimapWindow, miniposRect->x+miniposRect->w, miniposRect->y+TITLE_BAR_HEIGHT,     miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT, 150, 250, 255, 255);

  // flags and colony name
  if (minimapNation>=0) {
    SDL_Surface *miniflag = nationMiniFlags[minimapNation-FIRST_NATION];
    rect->x+=0;
    SDL_BlitSurface(miniflag, 0, minimapWindow, rect);
    rect->x+=minimapWindow->w-33-miniflag->w;
    SDL_BlitSurface(miniflag, 0, minimapWindow, rect);
    SDL_Color c = {r2, g2, b2};
    TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
    char* txt = getNationText(minimapNation);
    SDL_Surface *imgText = renderTextShadowed_Blended(fonts[14], txt, WHITE, c);
    rect->x = miniflag->w+ (minimapWindow->w-imgText->w-2*miniflag->w-33)/2;
    rect->y = 0;
    SDL_BlitSurface(imgText, 0, minimapWindow, rect);
    TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
    SDL_FreeSurface(imgText);
  }
  
  // rebuild the shadow if necessary
  if (minimapshadowbuffer==NULL) {
    minimapshadowbuffer = createShadow(minimapWindow, 255, 0x000000FF); // black shadow
    if (minimapShadowRect==NULL)
      minimapShadowRect = (SDL_Rect*)malloc(sizeof(SDL_Rect));
  }
  
  SDL_BlitSurface(minimapWindow, NULL, screen, minimapRect);

  free(rect);
  free(innerRect);
  free(outerRect);
} // displayMap() --------------------------------------------------------------------


/**
 * return if a position is over the map view
 */
int isInMinimapView(int x, int y) {
  //printf("%i < %i < %i\n", minimapRect->x, x, minimapRect->x+minimapRect->w);
  //printf("%i < %i < %i\n", minimapRect->y, y, minimapRect->y+minimapRect->h);
  return (x>=minimapRect->x && y>=minimapRect->y &&
          x<=minimapRect->x+minimapRect->w && y<=minimapRect->y+minimapRect->h);
}// isInMapView() --------------------------------------------------------------------


/**
 * return if a position is over the draggable rectangle called MiniPos
 */
int isInMiniPosView(int x, int y) {
  return (x>=miniposRect->x-GRAB_WING && x<=miniposRect->x+miniposRect->w+GRAB_WING &&
          y>=miniposRect->y+TITLE_BAR_HEIGHT-GRAB_WING && y<=miniposRect->y+miniposRect->h+TITLE_BAR_HEIGHT+GRAB_WING);
}// isInMiniPosView() --------------------------------------------------------------------

/**
 * return if a position is over the very little world
 */
int isInWorldView(int x, int y) {
  return (x>=2*minimapWindow->w/3 && y>=2*minimapWindow->h/3);
}// isInWorldView()

/**
 * return if a position is over the biggest map
 */
int isInMapView(int x, int y) {
  return (y>=TITLE_BAR_HEIGHT && x<minimapWindow->w-33 && y<minimapWindow->h-22 && !isInWorldView(x, y));
}// isInMapView()


/**
 * update the minimap in cache
 */
void updateMiniMap() {
  //if (minimap!=NULL)
  //  printf("updateMiniMap(%i, %i*%i, %i*%i)\n", minimapZoom, minimap->w, minimap->h, minimapRect->w, minimapRect->h);

  int i, j;
  unsigned char r, g, b;
  //initialize window if necessary
  if (minimapWindow==NULL){
    for (i=0; i<GROUND_NUMBER; i++)
      cols[i] = getColorforTexture(FIRST_GROUND+i);

    minimapRect->w = TILESIZE*4;//(int)(MapWidth*minimapZoom/16);
    minimapRect->h = TILESIZE*2+TITLE_BAR_HEIGHT;//(int)(MapHeight*minimapZoom/16)+TITLE_BAR_HEIGHT;

    minimapWindow = SDL_CreateRGBSurface(SDL_HWSURFACE, minimapRect->w, minimapRect->h, screen->format->BitsPerPixel,
                                   screen->format->Rmask,  screen->format->Gmask, screen->format->Bmask, 0xFF000000);
    miniworld     = SDL_CreateRGBSurface(SDL_HWSURFACE, minimapRect->w/3, minimapRect->h/3, screen->format->BitsPerPixel,
                                   screen->format->Rmask,  screen->format->Gmask, screen->format->Bmask, screen->format->Amask);

    if (minimapRect->x <0 || minimapRect->y<0 || minimapRect->x+minimapRect->w>screen->w || minimapRect->y+minimapRect->h>screen->h) {
      minimapRect->x = screen->w-20-minimapRect->w;
      minimapRect->y = screen->h-20-minimapRect->h;
    }
    if (minimapshadowbuffer!=NULL) {
      SDL_FreeSurface(minimapshadowbuffer);
      minimapshadowbuffer = NULL;
    }

  }

  //initialize map if necessary
  if ((minimap==NULL || updateZoom != minimapZoom)&& MapWidth!=0 /*|| minimap->h != TITLE_BAR_HEIGHT+(int)(MapHeight*minimapZoom/16)*/){
    
    /*if (minimap!=NULL)
      printf("  creating surface because %i != %i (minimapZoom=%d/16)\n", minimap->h, TITLE_BAR_HEIGHT+(int)(MapHeight*minimapZoom/16), minimapZoom);
    else
      printf("  creating surface because minimap==NULL  updateZoom=%i/16 minimapZoom=%i/16 MapWidth=%i MapHeight=%i\n", updateZoom, minimapZoom, MapWidth, MapHeight);
    */
    updateZoom = minimapZoom;

    minimap = SDL_CreateRGBSurface(SDL_HWSURFACE, MapWidth*minimapZoom/16, MapHeight*minimapZoom/16, screen->format->BitsPerPixel,
                                   screen->format->Rmask,  screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
    //printf("  creating surface for minimap view %i*%i ... masks=%x %x %x %x\n", minimap->w, minimap->h, minimap->format->Rmask, minimap->format->Gmask, minimap->format->Bmask, minimap->format->Amask);
  }

  SDL_Color *col = (SDL_Color *)malloc(sizeof(SDL_Color));
  //float ratio = 16.0f/minimapZoom ;
  for (i=0; i<minimap->w; i++) {
    for (j=0; j<minimap->h; j++){
      Uint32 *pixelsrc = (Uint32 *) minimap->pixels + (j)*minimap->w + i;
      int offset0 = ((int)(i*16/minimapZoom)+MapWidth*(int)((j)*16/minimapZoom));

      if (map[offset0].lastExplored<0 && gamemode == PLAY) {
        *pixelsrc = 0x80000000;
        continue;
      }

      int offset1 = ((int)((i+1)*16/minimapZoom)+MapWidth*(int)((j+0)*16/minimapZoom));
      int offset2 = ((int)((i+1)*16/minimapZoom)+MapWidth*(int)((j+1)*16/minimapZoom));
      int offset3 = ((int)((i+0)*16/minimapZoom)+MapWidth*(int)((j+1)*16/minimapZoom));

      float px = (i*16.0/minimapZoom)-(int)(i*16/minimapZoom);
      float py = (j*16.0/minimapZoom)-(int)(j*16/minimapZoom);

      getColorForTile(offset0, col);
      if (i==minimap->w-1 || j==minimap->h-1){
        r = (unsigned char)(col->r);
        g = (unsigned char)(col->g);
        b = (unsigned char)(col->b);
        *pixelsrc = r<<minimap->format->Rshift | g<<minimap->format->Gshift | b<<minimap->format->Bshift ;
        continue;
      }

      //col->r = 255;col->g = 255;col->b = 0;
      r = (unsigned char)(col->r*(1-px)*(1-py));
      g = (unsigned char)(col->g*(1-px)*(1-py));
      b = (unsigned char)(col->b*(1-px)*(1-py));
      getColorForTile(offset1, col);
      r += (unsigned char)(col->r*(px)*(1-py));
      g += (unsigned char)(col->g*(px)*(1-py));
      b += (unsigned char)(col->b*(px)*(1-py));
      getColorForTile(offset2, col);
      r += (unsigned char)(col->r*(px)*(py));
      g += (unsigned char)(col->g*(px)*(py));
      b += (unsigned char)(col->b*(px)*(py));
      getColorForTile(offset3, col);
      r += (unsigned char)(col->r*(1-px)*(py));
      g += (unsigned char)(col->g*(1-px)*(py));
      b += (unsigned char)(col->b*(1-px)*(py));

      *pixelsrc = r<<minimap->format->Rshift | g<<minimap->format->Gshift | b<<minimap->format->Bshift ;
    }
  }
  
  // update miniworld
  for (i=0; i<miniworld->w; i++) {
    for (j=0; j<miniworld->h; j++){
      Uint32 *pixelsrc = (Uint32 *) miniworld->pixels + (j)*miniworld->w + i;
      int offset0 = ((int)(i*MapWidth/miniworld->w)+MapWidth*(int)(j*MapHeight/miniworld->h));

      if (map[offset0].lastExplored<0 && gamemode == PLAY && GameDifficulty>EXPLORER) {
        *pixelsrc = 0x80000000;
        continue;
      }

      int offset1 = ((int)((i+1)*MapWidth/miniworld->w)+MapWidth*(int)((j+0)*MapHeight/miniworld->h));
      int offset2 = ((int)((i+1)*MapWidth/miniworld->w)+MapWidth*(int)((j+1)*MapHeight/miniworld->h));
      int offset3 = ((int)((i+0)*MapWidth/miniworld->w)+MapWidth*(int)((j+1)*MapHeight/miniworld->h));

      float px = (i)-(int)(i);
      float py = (j)-(int)(j);

      getColorForTile(offset0, col);
      if (i==miniworld->w-1 || j==miniworld->h-1){
        r = (unsigned char)(col->r);
        g = (unsigned char)(col->g);
        b = (unsigned char)(col->b);
        *pixelsrc = (r/2)<<miniworld->format->Rshift | (g/2)<<miniworld->format->Gshift | (b/2)<<miniworld->format->Bshift ;
        continue;
      }

      //col->r = 255;col->g = 255;col->b = 0;
      r = (unsigned char)(col->r*(1-px)*(1-py));
      g = (unsigned char)(col->g*(1-px)*(1-py));
      b = (unsigned char)(col->b*(1-px)*(1-py));
      getColorForTile(offset1, col);
      r += (unsigned char)(col->r*(px)*(1-py));
      g += (unsigned char)(col->g*(px)*(1-py));
      b += (unsigned char)(col->b*(px)*(1-py));
      getColorForTile(offset2, col);
      r += (unsigned char)(col->r*(px)*(py));
      g += (unsigned char)(col->g*(px)*(py));
      b += (unsigned char)(col->b*(px)*(py));
      getColorForTile(offset3, col);
      r += (unsigned char)(col->r*(1-px)*(py));
      g += (unsigned char)(col->g*(1-px)*(py));
      b += (unsigned char)(col->b*(1-px)*(py));
      if (i==0 || j==0){
        r /=2;
        g /=2;
        b /=2;
      }
      
      *pixelsrc = r<<miniworld->format->Rshift | g<<miniworld->format->Gshift | b<<miniworld->format->Bshift ;
    }
  }
} // updateMiniMap() --------------------------------------------------------------------


/**
 * return the color representing the given tile
 */
void getColorForTile(int offset, SDL_Color *col){
  if (map[offset].elevation==HIGHMOUNTAIN){
    col->r = 0xFF; col->g = 0xFF; col->b = 0xFF;
  }else if (map[offset].elevation==MOUNTAIN){
    col->r = 0xAA; col->g = 0xAA; col->b = 0xAA; // lol
  }else if (map[offset].elevation==HIGHHILL){
    col->r = 0xFF; col->g = 0xAA; col->b = 0x88;
  }else if (map[offset].elevation==HILL){
    col->r = 0xAA; col->g = 0xAA; col->b = 0x99;
  }else if (map[offset].elevation==OCEAN0){
    col->r = 0x22; col->g = 0x22; col->b = 0xCC;
  }else if (map[offset].elevation==OCEAN1){
    col->r = 0x00; col->g = 0x00; col->b = 0xAA;
  }else if (map[offset].ground>=DESERT && map[offset].ground<=HILLROCK && map[offset].ground>=FIRST_GROUND && map[offset].ground<=LAST_GROUND){
    //SDL_Color *col = getColorforTexture(map[i+MapWidth*(j)].ground);
    col->r = cols[map[offset].ground-FIRST_GROUND]->r;
    col->g = cols[map[offset].ground-FIRST_GROUND]->g;
    col->b = cols[map[offset].ground-FIRST_GROUND]->b;
  }else {
    col->r = 0xFF; col->g = 0x44; col->b = 0x44;
  }

  if (map[offset].vegetation<=WOOD){
    col->r = 0x00; col->g = 0xBB; col->b = 0x00;
  }

  //return col;
  //*pixelsrc = r<<minimap->format->Rshift | g<<minimap->format->Gshift | b<<minimap->format->Bshift ;
}

/**
 * center map on the given point
 */
void centerMap(int x, int y) {
  //printf("\ncenterMap %i, %i (old pffset =%i, %i)\n", x, y, offsetXMM, offsetYMM);
  offsetXMM = (x)*minimapZoom/16-minimapWindow->w/2;
  offsetYMM = (y)*minimapZoom/16-minimapWindow->h/2+TITLE_BAR_HEIGHT/2;
  if (offsetXMM<0) offsetXMM = 0;
  if (offsetXMM+minimapWindow->w-33 > minimap->w) offsetXMM = minimap->w-minimapWindow->w+33;
  if (offsetYMM<0) offsetYMM = 0;
  if (offsetYMM+minimapWindow->h-22 > minimap->h+TITLE_BAR_HEIGHT) offsetYMM = minimap->h-minimapWindow->h+22+TITLE_BAR_HEIGHT;
}// centerMap()


/**
 * mouse press callback
 */
void mousePressedMM(int mouseX, int mouseY, int button, int nbClick){
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  //printf("\nmousePressedMM (%i, %i) < x%i\n", mouseX, mouseY, nbClick);

  // initialization for Drag&Drop
  mouseXMM = mouseX;
  mouseYMM = mouseY;

  rect->x = 0;
  rect->y = 0;
  rect->w = minimapRect->w;
  rect->h = minimapRect->h;

  // double click recenter the map
  if (nbClick==2 && button==SDL_BUTTON_LEFT && isInMapView(mouseX, mouseY)) {
    miniposRect->x = mouseX-miniposRect->w/2+offsetXMM;
    miniposRect->y = mouseY-TITLE_BAR_HEIGHT-miniposRect->h/2+offsetYMM;
    if (miniposRect->x+miniposRect->w >= minimap->w)
      miniposRect->x = minimap->w-miniposRect->w;
    if (miniposRect->y+miniposRect->h >= minimap->h)
      miniposRect->y = minimap->h-miniposRect->h;

    //printf("   miniposRect  (%i, %i)\n", miniposRect->x, miniposRect->y);
    int newCenterX = (int)((miniposRect->x+miniposRect->w/2)*16/minimapZoom);
    int newCenterY = (int)((miniposRect->y+miniposRect->h/2)*16/minimapZoom);
    //printf("   newfirstVisibleTile  (%i, %i)\n", newfirstVisibleTileX, newfirstVisibleTileY);
    panToCenter(&map[newCenterX+MapWidth*(newCenterY)]);
  
  // dbl click point of view in the minimap
  } else if (nbClick==2 && button==SDL_BUTTON_LEFT && isInWorldView(mouseX, mouseY)) {
    offsetXMM = (mouseX-2*minimapWindow->w/3)*(minimap->w)/(minimapWindow->w/3)-minimapWindow->w/3;
    offsetYMM = (mouseY-2*minimapWindow->h/3)*(minimap->h)/(minimapWindow->h/3)-minimapWindow->h/3;
    if (offsetXMM<0) offsetXMM = 0;
    if (offsetXMM+minimapWindow->w-33 > minimap->w) offsetXMM = minimap->w-minimapWindow->w+33;
    if (offsetYMM<0) offsetYMM = 0;
    if (offsetYMM+minimapWindow->h-22 > minimap->h+TITLE_BAR_HEIGHT) offsetYMM = minimap->h-minimapWindow->h+22+TITLE_BAR_HEIGHT;
  } else if (isInMiniPosView(mouseX, mouseY) && button==SDL_BUTTON_LEFT && isInMapView(mouseX, mouseY)) {
    //innitialDragPosX = miniposRect->x;
    //innitialDragPosY = miniposRect->y;
    innitialDragPosX = (int)(firstVisibleTileX*minimapZoom/16);
    innitialDragPosY = (int)(firstVisibleTileY*minimapZoom/16);
    //printf("  innitialDragPos (%i, %i)\n", innitialDragPosX, innitialDragPosY);
    isDrag = MINIPOS;
  } else if (button==SDL_BUTTON_WHEELUP && isInMapView(mouseX, mouseY)) {
    //int oldminimapZoom = minimapZoom;
    innitialDragPosX = (minimapWindow->w/2+offsetXMM)*16/minimapZoom;
    innitialDragPosY = ((minimapWindow->h-TITLE_BAR_HEIGHT)/2+offsetYMM)*16/minimapZoom;
    if (minimapZoom<128)
      minimapZoom++;

    updateMiniMap();
    offsetXMM = (innitialDragPosX)*minimapZoom/16-minimapWindow->w/2;
    offsetYMM = (innitialDragPosY)*minimapZoom/16-minimapWindow->h/2+TITLE_BAR_HEIGHT/2;

    if (offsetXMM<0) offsetXMM = 0;
    if (offsetXMM+minimapWindow->w-33 > minimap->w) offsetXMM = minimap->w-minimapWindow->w+33;
    if (offsetYMM<0) offsetYMM = 0;
    if (offsetYMM+minimapWindow->h-22 > minimap->h+TITLE_BAR_HEIGHT) offsetYMM = minimap->h-minimapWindow->h+22+TITLE_BAR_HEIGHT;
    
    miniposRect->x = (int)(firstVisibleTileX*minimapZoom/16);
    miniposRect->y = (int)(firstVisibleTileY*minimapZoom/16);
    miniposRect->w = (int)((screen->w/TILESIZE)*minimapZoom/16);
    miniposRect->h = (int)((screen->h/TILESIZE)*minimapZoom/16); 
    miniposRect->x=MIN(MAX(offsetXMM, miniposRect->x), offsetXMM+minimapWindow->w-33-miniposRect->w );
    miniposRect->y=MIN(MAX(offsetYMM, miniposRect->y), offsetYMM+minimapWindow->h-22-miniposRect->h-TITLE_BAR_HEIGHT);
    int newfirstVisibleTileX = (int)(miniposRect->x*16/minimapZoom);
    int newfirstVisibleTileY = (int)(miniposRect->y*16/minimapZoom);
    //printf("   newfirstVisibleTile  (%i, %i)\n", newfirstVisibleTileX, newfirstVisibleTileY);
    panMap(newfirstVisibleTileX, newfirstVisibleTileY);  

    //printf("  minimapZoom (%i)\n", minimapZoom);
  } else if (button==SDL_BUTTON_WHEELDOWN && isInMapView(mouseX, mouseY)) {
    //float oldminimapZoom = minimapZoom;
    innitialDragPosX = (minimapWindow->w/2+offsetXMM)*16/minimapZoom;
    innitialDragPosY = ((minimapWindow->h-TITLE_BAR_HEIGHT)/2+offsetYMM)*16/minimapZoom;

    if (minimapZoom>1)
      minimapZoom--;
    updateMiniMap();
    if (minimap->w<minimapWindow->w-33)  {
      minimapZoom++;
      updateMiniMap();
    }

    //printf("  minimapZoom =%i  (%i / %i)\n", minimapZoom, minimap->w, minimapWindow->w);
    offsetXMM = (innitialDragPosX)*minimapZoom/16-minimapWindow->w/2;
    offsetYMM = (innitialDragPosY)*minimapZoom/16-minimapWindow->h/2+TITLE_BAR_HEIGHT/2;

    if (offsetXMM<0) offsetXMM = 0;
    if (offsetXMM+minimapWindow->w-33 > minimap->w) offsetXMM = minimap->w-minimapWindow->w+33;
    if (offsetYMM<0) offsetYMM = 0;
    if (offsetYMM+minimapWindow->h-22 > minimap->h+TITLE_BAR_HEIGHT) offsetYMM = minimap->h-minimapWindow->h+22+TITLE_BAR_HEIGHT;
 
    miniposRect->x = (int)(firstVisibleTileX*minimapZoom/16);
    miniposRect->y = (int)(firstVisibleTileY*minimapZoom/16);
    miniposRect->w = (int)((screen->w/TILESIZE)*minimapZoom/16);
    miniposRect->h = (int)((screen->h/TILESIZE)*minimapZoom/16); 
    miniposRect->x=MIN(MAX(offsetXMM, miniposRect->x), offsetXMM+minimapWindow->w-33-miniposRect->w );
    miniposRect->y=MIN(MAX(offsetYMM, miniposRect->y), offsetYMM+minimapWindow->h-22-miniposRect->h-TITLE_BAR_HEIGHT);
    int newfirstVisibleTileX = (int)(miniposRect->x*16/minimapZoom);
    int newfirstVisibleTileY = (int)(miniposRect->y*16/minimapZoom);
    //printf("   newfirstVisibleTile  (%i, %i)\n", newfirstVisibleTileX, newfirstVisibleTileY);
    panMap(newfirstVisibleTileX, newfirstVisibleTileY);
    
  // drag the minimap window
  } else if (mouseY<TITLE_BAR_HEIGHT && button==SDL_BUTTON_LEFT && mouseX<minimapWindow->w-33) {
    innitialDragPosX = minimapRect->x;
    innitialDragPosY = minimapRect->y;
    isDrag = MINIMAP;
    //SDL_SetAlpha  (minimap, SDL_SRCALPHA, 192);
  } else if (nbClick==1 && button==SDL_BUTTON_LEFT && isInMapView(mouseX, mouseY)) {
    isDrag = DRAGMAP;
    offsetGrabXMM = offsetXMM;
    offsetGrabYMM = offsetYMM;
  }
  free(rect);
  //printf("mousePressedMM (%i, %i) < %i/16\n", mouseX, mouseY, minimapZoom);
}// mousePressedMM()


/**
 * mouse drag callback
 */
void mouseDraggedMM(int mouseX, int mouseY, int button, int nbClick){
  if (isDrag == MINIPOS) {
    //printf("\nmouseDraggedMM (%i, %i) < x%i\n", mouseX, mouseY, nbClick);
    //printf("   mouseMM (%i, %i) \n", mouseXMM, mouseYMM);
    //printf("   innitialDragPos (%i, %i)\n", innitialDragPosX, innitialDragPosY);
    //printf("   dec  (%i, %i)\n", (mouseXMM-mouseX), (mouseYMM-mouseY));

    miniposRect->x = innitialDragPosX-(mouseXMM-mouseX);
    miniposRect->y = innitialDragPosY-(mouseYMM-mouseY);
    //printf("   miniposRect  (%i, %i) %i*%1\n", miniposRect->x, miniposRect->y, miniposRect->w, miniposRect->h);
    //printf("   minimap = %d * %d\n", minimap->w, minimap->h);  
    miniposRect->x=MIN(MAX(offsetXMM, miniposRect->x), offsetXMM+minimapWindow->w-33-miniposRect->w );
    miniposRect->y=MIN(MAX(offsetYMM, miniposRect->y), offsetYMM+minimapWindow->h-22-miniposRect->h-TITLE_BAR_HEIGHT);

    //printf("   miniposRect  (%i, %i)\n", miniposRect->x, miniposRect->y);

    int newfirstVisibleTileX = (int)(miniposRect->x*16/minimapZoom);
    int newfirstVisibleTileY = (int)(miniposRect->y*16/minimapZoom);
    //printf("   newfirstVisibleTile  (%i, %i)\n", newfirstVisibleTileX, newfirstVisibleTileY);
    panMap(newfirstVisibleTileX, newfirstVisibleTileY);
  } else if (isDrag == DRAGMAP){
    offsetXMM = offsetGrabXMM+mouseXMM-mouseX;
    offsetYMM = offsetGrabYMM+mouseYMM-mouseY;

    if (offsetXMM<0) offsetXMM = 0;
    if (offsetXMM+minimapWindow->w-33 > minimap->w) offsetXMM = minimap->w-minimapWindow->w+33;
    if (offsetYMM<0) offsetYMM = 0;
    if (offsetYMM+minimapWindow->h-22 > minimap->h+TITLE_BAR_HEIGHT) offsetYMM = minimap->h+TITLE_BAR_HEIGHT-minimapWindow->h+22;
  }
}// mouseDragged()


/**
 * mouse release callback
 */
void mouseReleasedMM(int mouseX, int mouseY, int button, int nbClick) {
  //SDL_SetAlpha  (minimap, SDL_SRCALPHA, 255);
}// mouseReleasedMM()


