/*
 *  Minimap.h
 *  NewCol
 *
 *  Created by fredericVernier on 2/28/07.
 *  Copyright 2007 Frederic Vernier. All rights reserved.
 *
 */


#ifndef MINIMAP_H
#define MINIMAP_H

#include "extragraphics.h"
#include <kazlib/list.h>
#include "newcol.h"
#include "SDL.h"
#include <assert.h>

#ifdef __cplusplus
extern "C" {
#endif

extern SDL_Surface *minimap;
extern SDL_Rect    *minimapRect;
extern SDL_Rect    *miniposRect;
extern int        minimapZoom;

void displayMiniMap();
void updateMiniMap();
int isInMinimapView(int x, int y);
int isInMiniPosView(int x, int y);
void centerMap(int x, int y);

void mousePressedMM(int mouseX, int mouseY, int button, int nbClick);
void mouseDraggedMM(int mouseX, int mouseY, int button, int nbClick);
void mouseReleasedMM(int mouseX, int mouseY, int button, int nbClick);
void getColorForTile(int offset, SDL_Color *col);

#ifdef __cplusplus
}
#endif
#endif

