/*
 *  popup.cpp
 *  NewCol
 *
 *  Created by fredericVernier on 3/21/07.
 *  Copyright 2007 Frederic Vernier. All rights reserved.
 *
 */

#include "popup.h"
#pragma warning ( disable : 4996 )
#include "SDL_gfx/SDL_gfxPrimitives.h"
// popup variables
list_t       *popupOptionList      = NULL;
int           popupType            = NONE;
char         *popuptext            = NULL;
int           popuptextcursor      = 0;
list_t       *popupUnitList        = NULL;
SDL_Rect     *popupRect            = NULL;
SDL_Rect     *popupShadowRect      = NULL;
option       *selectedOption       = NULL;
int           innerspace           = 0;
SDL_Surface  *popupbuffer          = NULL;
SDL_Surface  *popupshadowbuffer    = NULL;
SDL_Surface  *popupDecoration      = NULL;
int           popupneedUpdate      = FALSE;
int           fisheyeMenuShrink    = 0;
int           popupMouseX          = 0;
int           popupMouseY          = 0;
/**
 * reset the text in the popup dialog
 */
void resetPopupText(char* txt) {
  if (popuptext!=NULL)
    free(popuptext);
  popuptext = (char*)malloc(256*sizeof(char));
  sprintf(popuptext ,"%s", txt);
}// resetPopupText()


/**
 * pre-select the middle option that should be under the mouse cursor
 */
void preSelectMiddleOptionPopup() {
  if (popupOptionList==NULL || list_count(popupOptionList)==0)
    return;

  lnode_t *ln = list_first(popupOptionList);
  int i=0;
  while (ln!=NULL && ln!=&popupOptionList->list_nilnode && i<list_count(popupOptionList)/2) {
    i++;
    ln = ln->list_next;
  }
  if (i>=list_count(popupOptionList)/2&&list_count(popupOptionList)%2==0) {
    i--;
    ln = ln->list_prev;
  }
  if (ln!=NULL && ln!=&popupOptionList->list_nilnode)
  selectedOption = (option *)ln->list_data;
}// preSelectMiddleOptionPopup()


/**
 * add an option to the selected menu
 */
void addPopupOption(char *name, void (*acttodo)(list_t *, char *)){
  if (popupOptionList==NULL)
    popupOptionList = list_create(LISTCOUNT_T_MAX);

  option *o = (option *)malloc(sizeof(option));
  o->text   = (char*)malloc(1+strlen(name)*sizeof(char));
  o->act    = acttodo;
  strcpy(o->text, name);
  o->text[strlen(name)] = '\0';
  list_append(popupOptionList, lnode_create(o));
  //printf("  addPopupOption() %s %p\n", o->text, o->act);
  popupneedUpdate = TRUE;
}// addOption()


/**
 * activate the selected option
 */
void activatePopup() {
  //printf("  activatePopup() %i %s %i %p %p\n", popupType, popuptext, list_count(popupOptionList), selectedOption, popuptext);

  list_t *ul2 = list_create(LISTCOUNT_T_MAX);
  if (popupUnitList!=NULL) {
    lnode_t *ln = list_first(popupUnitList);
    while (ln!=NULL && ln!=&popupUnitList->list_nilnode){
      unit *u = (unit*)ln->list_data;
      list_append(ul2, lnode_create(u));
      ln = ln->list_next;
    }
  }

  if (popupOptionList!=NULL && selectedOption==NULL) {
    lnode_t *ln = list_first(popupOptionList);
    while (ln!=&popupOptionList->list_nilnode) {
      option * o = (option *)ln->list_data;
      if (o->act !=NULL && o->act != doNothing) {
        selectedOption = o;
        break;
      }
      ln = ln->list_next;
    }
  }

  if (popupOptionList==NULL || list_count(popupOptionList)==0 || selectedOption==NULL)
    return;

  void (*acthere)(list_t *, char *) = selectedOption->act;
  char *popuptext2 = NULL;
  if (popuptext!=NULL) {
    popuptext2 = (char *)malloc((1+strlen(popuptext))*sizeof(char));
    strcpy(popuptext2, popuptext);
    popuptext2[strlen(popuptext)] = '\0';
  } else {
    popuptext2 = (char *)malloc((1+strlen(selectedOption->text))*sizeof(char));
    strcpy(popuptext2, selectedOption->text);
    popuptext2[strlen(selectedOption->text)] = '\0';
  }

  discardPopup();
  acthere(ul2, popuptext2);
  //printf("    %i\n", popupType);
  if (popuptext2!=NULL)
    free(popuptext2);
  popuptext2 = NULL;
  list_destroy_nodes(ul2);
  list_destroy(ul2);
}// activatePopup() 


/**
 * change the img decorating the popup message (not availbale for menus) 
 */
void setPopupDecoration(SDL_Surface *img){
  if (popupDecoration!=NULL)
    SDL_FreeSurface(popupDecoration);
  popupDecoration = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, img->w, img->h, img->format->BitsPerPixel,
                                         img->format->Rmask, img->format->Gmask, img->format->Bmask, img->format->Amask);
  //boxRGBA(popupDecoration, 0, 0, img->w, img->h, 255, 255, 255, 255);
  SDL_BlitSurfaceRGBA(img, NULL, popupDecoration, NULL);
}// setPopupDecoration()


/**
 * clean everything and hide any visible popup
 */
void discardPopup(){
  if (popuptext!=NULL)
    free(popuptext);
  popuptext = NULL;

  popuptextcursor = 0;
  selectedOption  = NULL;

  if (popupOptionList!=NULL) {
    lnode_t *ln = list_first(popupOptionList);
    popupRect->w=0; popupRect->h=0;
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode){
      option *o = (option*)ln->list_data;
      if (o!=NULL && o->text!=NULL){
        free(o->text);
        o->text=NULL;
      }
      if (o!=NULL)
        free(o);
      ln->list_data = NULL;
      ln = ln->list_next;
    }
    list_destroy_nodes(popupOptionList);
    list_destroy(popupOptionList);
    popupOptionList     = NULL;
    selectedOption      = NULL;
    popupUnitList       = NULL;
  }
  if (popupUnitList!=NULL) {
    list_destroy_nodes(popupUnitList);
    list_destroy(popupUnitList);
    popupUnitList = NULL;
  }
  popupDecoration = NULL;
  popupType = NONE;
}// discardPopup()


/**
 * retrieve the icon corresponding to this id
 */
SDL_Surface *getIMGforID(int id) {
  if (id>=FIRST_GOOD && id<=LAST_GOOD) {
    return goodsImages[id-FIRST_GOOD];
  } else if (id>=FIRST_UNIT && id<=LAST_UNIT) {
    return unitsImages[id-FIRST_UNIT];
  } else if (id>=FIRST_NATION && id<=LAST_NATION) {
    return     nationMiniFlags[id-FIRST_NATION];
  } else if (id>=FIRST_BUILDING && id<=LAST_BUILDING) {
    return buildingIconImages[id-FIRST_BUILDING];
  } else if (id>=FIRST_BONUS && id<=LAST_BONUS) {
    return bonusImages[id-FIRST_BONUS];
  }
  return NULL;
}// getIMGforID()


/**
 * compute popupRect->w and popupRect->h and innerspace
 */
void computePopupSize() {
  //printf("computePopupSize()\n");
  if (popupShadowRect==NULL)
    popupShadowRect = (SDL_Rect*)malloc(sizeof(SDL_Rect));
  if (popupRect==NULL)
    popupRect = (SDL_Rect*)malloc(sizeof(SDL_Rect));  
  
  int id         = -1;
  char * txt     = (char*)malloc(256*sizeof(char));
  //printf ("malloc txt=%p\n", txt);
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  if (popupType&POPUP_ISMENU) {
    lnode_t *ln = list_first(popupOptionList);
    popupRect->w=0; 
    popupRect->h=0;

    while (ln!=NULL && ln!=&popupOptionList->list_nilnode){
      option *o = (option*)ln->list_data;
      int w1 = 0;
      int h1 = 0;

      if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
        char *ptr = strstr(o->text, "[[");
        //printf("  we are between %p and %p => %i\n", ptr, strstr(o->text, "]]"), (strstr(o->text, "]]") - ptr-2));
        strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
        txt[strstr(o->text, "]]") - ptr-2] = '\0';
        id = atoi(txt);
        //printf("  we reckon %i from %s\n", id, txt);
        //printf("  we are between %p and %p => %i\n", o->text, ptr, (ptr-o->text));
        strncpy(txt, o->text, ptr-o->text);
        txt[ptr-o->text] = '\0';
      } else {
        strcpy(txt, o->text);
        id = -1;
      }

      //printf("\n we have {%s}=>{%s}=>{%i*%i}\n", o->text, txt, w, h);
      TTF_SizeText(fonts[12], txt, &w1, &h1);
      SDL_Surface *img = getIMGforID(id);
      if (img!=NULL) {
        // sum of widths
        w1 += img->w+2;
        // max of height
        if  (img->h > h1) h1 = img->h;
      }

      // max of widths
      if (w1>popupRect->w)
        popupRect->w=w1;
      // sum of heights
      popupRect->h += h1;
      ln = ln->list_next;
    }
    popupRect->w = popupRect->w +10;
    popupRect->h = popupRect->h +2;
    
    if (popupRect->h>screen->h) {
      fisheyeMenuShrink = popupRect->h-screen->h;
      popupRect->h      = screen->h;
    }
  } else {
    popupRect->w=0; 
    popupRect->h=0;    
    lnode_t *ln = list_first(popupOptionList);
    option *o = (option*)ln->list_data;
    //printf("\ncompute size = %s first=%p\n", o->text, ln);fflush(stdout);
    int w1 = 0;
    int h1 = 0;
    int optionh = 0;
    
    char *message = (char*)malloc((1+strlen(o->text))*sizeof(char));
    strcpy(message, o->text);
    char * pch = strtok (message, "\n");
    while (pch != NULL) {
      //printf("  tok = %s\n", pch);
      TTF_SizeText(fonts[14],pch, &w1, &h1);
      if (w1>popupRect->w) popupRect->w = w1;
      popupRect->h += h1+3;
      pch = strtok (NULL, "\n");
    }
    free(message);
    /*{
    TTF_SizeText(fonts[14], o->text, &w, &h);
    popupRect->w = w;
    popupRect->h = h;
    }*/
    
    //printf("  before l next %p\n", ln);fflush(stdout);
    ln = ln->list_next;
    int maxw=0;
    //popupRect->h=h;
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode){
      option *o = (option*)ln->list_data;
      //printf ("o->text before %p [%s]\n", o->text, o->text);
      if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
        char *ptr = strstr(o->text, "[[");
        //printf("  we are between %p and %p => %i\n", ptr, strstr(o->text, "]]"), (strstr(o->text, "]]") - ptr-2));
        strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
        txt[strstr(o->text, "]]") - ptr-2] = '\0';
        id = atoi(txt);
        //printf("  we reckon %i from %s\n", id, txt);
        //printf("  we are between %p and %p => %i\n", o->text, ptr, (ptr-o->text));
        strncpy(txt, o->text, ptr-o->text);
        txt[ptr-o->text] = '\0';
      } else {
        strcpy(txt, o->text);
        id = -1;
      }
      /*printf ("o->text after %p [%s]\n", o->text, o->text);
      printf ("txt=%p\n", txt);
      printf ("w1=%p\n", &w1);
      printf ("h1=%p\n", &h1);
      printf ("fonts[14]=%p\n", fonts[14]);*/
      TTF_SizeText(fonts[14], txt, &w1, &h1);//XXX TO DEBUG
      SDL_Surface *img = getIMGforID(id);
      if (img!=NULL) {
        // sum of widths
        w1 += img->w+2;
        // max of height
        if  (img->h+2 > h1) h1 = img->h+2;
      }

      if (h1>optionh) optionh=h1;
      maxw += w1+15;
      ln = ln->list_next;
      //printf("  maxw = %i\n", maxw);
    }
    if (maxw>popupRect->w) popupRect->w = maxw;
    popupRect->w += 10;
    popupRect->h += optionh+20;
    if (popupType&POPUP_TEXT) 
      popupRect->h +=25;
    if (popupDecoration!=NULL) {
      popupRect->h += popupDecoration->h+10;
      if (popupDecoration->w+10>popupRect->w)
        popupRect->w = popupDecoration->w+10;
    }
    innerspace = (popupRect->w-maxw)/(list_count(popupOptionList));
    if (innerspace<5) innerspace = 5;
    // printf("  computePopupSize innerspace=%i popupRect->w=%i maxw=%i\n", innerspace, popupRect->w, maxw);
  }
  
  free(txt);
  free(rect);
}// computePopupSize()


/**
 * display the eventual popup
 */
void displayPopup() {
  //if (selectedOption!=NULL) printf("displayPopup(%s)%i\n", selectedOption->text, popupneedUpdate);

  computePopupSize();
  //printf(" computePopupSize() =%i*%i\n", popupRect->w, popupRect->h);
  if (popupOptionList==NULL || list_count(popupOptionList)==0)
    return ;

  if (popupbuffer!=NULL && (popupRect->w!=popupbuffer->w || popupRect->h!=popupbuffer->h)){
    SDL_FreeSurface(popupbuffer);
    popupbuffer = NULL;
  }
    
  if (popupbuffer==NULL){
    popupbuffer       = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, popupRect->w, popupRect->h, screen->format->BitsPerPixel,
                                             screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0xFF000000);
    if (popupshadowbuffer!=NULL) {
      SDL_FreeSurface(popupshadowbuffer);
      popupshadowbuffer = NULL;
    }
    //printf("creating surface for popup view ... size=%i*%i\n", popupbuffer->w, popupbuffer->h);
    popupneedUpdate = TRUE;
  }

  if (popupneedUpdate || popupType&POPUP_TEXT) {
    SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
    char     *txt  = (char*)malloc(256*sizeof(char));
    int       id   = -1;
    int       w, h;

    if (popupType&POPUP_ISMENU) {
      popupRect->x = mousePressedX-popupRect->w/2;
      popupRect->y = mousePressedY-popupRect->h/2;
      if (popupRect->x<0) popupRect->x=0;
      else if (popupRect->x+popupRect->w>=screen->w) popupRect->y=screen->w-popupRect->w-1;
      if (popupRect->y<0) popupRect->y=0;
      else if (popupRect->y+popupRect->h>=screen->h) popupRect->y=screen->h-popupRect->h-1;
      
      boxRGBA(popupbuffer, 1, 1, popupRect->w-2, popupRect->h-2, 32, 64, 64, 255);
      lnode_t *ln = list_first(popupOptionList);
      int acth = 0;
      while (ln!=NULL && ln!=&popupOptionList->list_nilnode){
        option *o = (option*)ln->list_data;
        int w = 0;
        int h = 0;

        if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
          char *ptr = strstr(o->text, "[[");
          //printf("\n we have %s\n", o->text);
          //printf("  we are between %p and %p => %i\n", ptr, strstr(o->text, "]]"), (strstr(o->text, "]]") - ptr-2));
          strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
          txt[strstr(o->text, "]]") - ptr-2] = '\0';
          id = atoi(txt);
          //printf("  we reckon %i from %s\n", id, txt);
          strncpy(txt, o->text, ptr-o->text);
          txt[ptr-o->text] = '\0';
        } else {
          strcpy(txt, o->text);
          id = -1;
        }

        TTF_SizeText(fonts[12], txt, &w, &h);
        SDL_Surface *img = getIMGforID(id);
        if (img!=NULL) {
          // sum of widths
          w += img->w+2;
          // max of height
          if  (img->h > h) h = img->h;
        }
        if (fisheyeMenuShrink>0 && abs(acth+h/2-popupMouseY)>40)
          h-= fisheyeMenuShrink/(list_count(popupOptionList)-10);
        /*rect->x = mousePressedX-popupRect->w/2;

        rect->y = /*mousePressedY-popupRect->h/2+*/
        rect->y = acth;
        rect->x = 0;
        /*if (rect->x<0) rect->x=0;
        if (rect->x+rect->w>=screen->w) rect->y=screen->w-rect->w-1;
        if (rect->y<0) rect->y=0;
        if (rect->y+rect->h>=screen->h) rect->y=screen->h-rect->h-1;*/
        rect->w = popupRect->w;
        rect->h = h;
        //printf("  we use acth= %i \n", acth);

        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], txt, WHITE);
        if (o==selectedOption)
          d1gradientboxRGBA(popupbuffer, rect->x, rect->y, rect->w, rect->h, 96, 96, 32, 255, 192, 192, 32, 255);
        else
          vgradientboxRGBA(popupbuffer, rect->x, rect->y, rect->w, rect->h, 64, 64, 32, 255, 32, 32, 16, 255);

        rect->x+=5;
        if (img!=NULL) {
          //w += goodsImages[id-FIRST_GOOD]->w+2;
          rect->x += imgText->w+2;
          rect->y += imgText->h/2-img->h/2+1;
          SDL_BlitSurface(img, 0, popupbuffer, rect);
          rect->x -= imgText->w+2;
          rect->y -= imgText->h/2-img->h/2-1;
        }

        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        SDL_FreeSurface(imgText);
        acth += h;

        ln = ln->list_next;
      }
      //printf("  finish drawing ... %i,%i     %i*%i\n", popupRect->x, popupRect->h, popupRect->w, popupRect->h);

      rectangleRGBA(popupbuffer, 0, 0, popupRect->w-1, popupRect->h-1, 255, 250, 150, 255);
    } else {
      popupRect->x = (screen->w-popupRect->w)/2;
      popupRect->y = (screen->h-popupRect->h)/2;      
      lnode_t *ln = list_first(popupOptionList);
      option *o = (option*)ln->list_data;

      boxRGBA(popupbuffer, 1, 1, popupRect->w-2, popupRect->h-2, 255, 224, 244, 255);
      char *message = (char*)malloc((1+strlen(o->text))*sizeof(char));
      strcpy(message, o->text);
      char * pch = strtok (message, "\n");
      rect->y = 0;
      while (pch != NULL) {
        //printf("  tok = %s\n", pch);
        TTF_SizeText(fonts[14],pch, &w, &h);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[14], pch, WHITE);
        rect->x = (popupRect->w-imgText->w)/2;
        rect->y += 3;
        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        rect->x--;rect->y--;
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[14], pch, BLACK);
        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        rect->y += imgText->h;
        SDL_FreeSurface(imgText);

        pch = strtok (NULL, "\n");
      }
      free(message);
      ln = ln->list_next;
      rect->y += 5;

      if (popupDecoration!=NULL){
        rect->y += 5;
        rect->x = (popupRect->w-popupDecoration->w)/2;
        SDL_BlitSurface(popupDecoration, 0, popupbuffer, rect);
        rect->y += popupDecoration->h;
        rect->y += 5;
      }

      if (popupType&POPUP_TEXT) {
        rect->x = 5;
        rect->w = popupRect->w-10;
        rect->h = 20;
        boxRGBA(popupbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 255, 255, 255, 255);
        rectangleRGBA(popupbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 0, 0, 0, 255);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[14], popuptext, BLACK);
        rect->x+=5;
        rect->w-=5;
        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        SDL_FreeSurface(imgText);

        char* subtext = (char*)malloc(256*sizeof(char));
        sprintf(subtext, "");
        strncat(subtext, popuptext, popuptextcursor);
        //printf("cursor at chars %i on %i [%s]\n", popuptextcursor, strlen(popuptext), subtext);
        TTF_SizeText(fonts[14], subtext, &w, &h);
        if (animID%20<10)
          vlineRGBA(popupbuffer, 10+w, rect->y+2, rect->y+rect->h-2, 192, 64, 64, 255);
        free(subtext);
      }

      int maxw=0;
      id = -1;
      while (ln!=NULL && ln!=&popupOptionList->list_nilnode){
        maxw += innerspace;
        o = (option*)ln->list_data;

        if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
          char *ptr = strstr(o->text, "[[");
          strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
          txt[strstr(o->text, "]]") - ptr-2] = '\0';
          id = atoi(txt);
          strncpy(txt, o->text, ptr-o->text);
          txt[ptr-o->text] = '\0';
        } else {
          strcpy(txt, o->text);
          id = -1;
        }

        TTF_SizeText(fonts[14], txt, &w, &h);
        SDL_Surface *img = getIMGforID(id);
        if (img!=NULL) {
          // sum of widths
          w += img->w+2;
          // max of height
          if  (img->h+2 > h) h = img->h+2;
        }

        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[14], txt, BLACK);
        rect->x = 5+maxw;
        rect->y = popupRect->h-30;
        rect->w = w+10;
        rect->h = h;
        if (o==selectedOption)
          d1gradientboxRGBA(popupbuffer, rect->x+1, rect->y+1, rect->w-2, rect->h-2, 96, 96, 32, 255, 192, 192, 32, 255);
        else
          vgradientboxRGBA(popupbuffer, rect->x+1, rect->y+1, rect->w-2, rect->h-2, 64, 64, 32, 255, 32, 32, 16, 255);
        
        //rectangleRGBA(popupbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 0, 0, 0, 255);
        lineRGBA(popupbuffer, rect->x+3,       rect->y,         rect->x+rect->w-3, rect->y,           0, 0, 0, 255);
        lineRGBA(popupbuffer, rect->x,         rect->y+3,       rect->x,           rect->y+rect->h-3, 0, 0, 0, 255);
        lineRGBA(popupbuffer, rect->x+3,       rect->y+rect->h, rect->x+rect->w-3, rect->y+rect->h,   0, 0, 0, 255);
        lineRGBA(popupbuffer, rect->x+rect->w, rect->y+3,       rect->x+rect->w,   rect->y+rect->h-3, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+1, rect->y+2, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+2, rect->y+1, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+rect->w-1, rect->y+2, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+rect->w-2, rect->y+1, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+1, rect->y+rect->h-2, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+2, rect->y+rect->h-1, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+rect->w-1, rect->y+rect->h-2, 0, 0, 0, 255);
        pixelRGBA(popupbuffer, rect->x+rect->w-2, rect->y+rect->h-1, 0, 0, 0, 255);
        
        rect->x+=5;
        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        rect->x--;rect->y--;
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[14], txt, WHITE);
        SDL_BlitSurface(imgText, 0, popupbuffer, rect);
        rect->x+=imgText->w+2;
        rect->y+=2;
        SDL_FreeSurface(imgText);
        if (img !=NULL)
          SDL_BlitSurface(img, 0, popupbuffer, rect);
        rect->y-=2;
        maxw += w+10;
        ln = ln->list_next;
        //printf("  maxw2 = %i\n", maxw);
      }

      lineRGBA(popupbuffer, 0, 3, 0, popupRect->h-4, 255, 250, 150, 255);
      lineRGBA(popupbuffer, 3, 0, popupRect->w-4, 0, 255, 250, 150, 255);
      lineRGBA(popupbuffer, 3, popupRect->h-1, popupRect->w-4, popupRect->h-1, 255, 250, 150, 255);
      lineRGBA(popupbuffer, popupRect->w-1, 3, popupRect->w-1, popupRect->h-4, 255, 250, 150, 255);
      //pixelRGBA(popupbuffer, 1, 1, 0, 0, 0, 0);
    }
    
    free(rect);
    free(txt);
    popupneedUpdate = FALSE;
  }
  
  // rebuild the shadow
  if (popupshadowbuffer==NULL) {
    popupshadowbuffer = createShadow(popupbuffer, 192, 0x00000000); // black shadow
    popupShadowRect->w = popupRect->w+2*SHADOW_SIZE;
    popupShadowRect->h = popupRect->h+2*SHADOW_SIZE;
  }
  popupShadowRect->x = popupRect->x-SHADOW_SIZE;
  popupShadowRect->y = popupRect->y-SHADOW_SIZE;
  
  // display the shadow first
  SDL_BlitSurface(popupshadowbuffer, 0, screen, popupShadowRect);
  // then display the popup !
  //printf(" disp buffer =%i*%i\n", popupbuffer->w, popupbuffer->h);
  //printf(" disp rect   =%i*%i\n", popupRect->w, popupRect->h);
  SDL_BlitSurface(popupbuffer, 0, screen, popupRect);
}// displayPopup() --------------------------------------------------------------------


/**
 * mouse moved callback to know which option highlight
 */
void mouseMovedPopup(int x, int y){
  //printf("mouseMovedPopup()\n");
  
  popupMouseX = x;
  popupMouseY = y;
  char * txt = (char*)malloc(256*sizeof(char));
  option *oldSelectedOption = selectedOption;
  
  if (!(popupType&POPUP_ISMENU)) {
    lnode_t *ln = list_first(popupOptionList);
    option *o = (option*)ln->list_data;
    int w = 0;
    int h = 0;
    
    char *message = (char*)malloc((1+strlen(o->text))*sizeof(char));
    strcpy(message, o->text);
    char * pch = strtok (message, "\n");
    while (pch != NULL) {
      int h0, w0;
      TTF_SizeText(fonts[14],pch, &w0, &h0);
      h+=h0+3;
      pch = strtok (NULL, "\n");    
    }
    free(message);
    ln = ln->list_next;
    
    //TTF_SizeText(fonts[14], o->text, &w, &h);
    //popupRect->w = w;
    //popupRect->h = h;
    int maxw=0;
    int id = -1;
    int optionh = 0;
    selectedOption=NULL;
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode) {
      option *o = (option*)ln->list_data;
      if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
        char *ptr = strstr(o->text, "[[");
        strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
        txt[strstr(o->text, "]]") - ptr-2] = '\0';
        id = atoi(txt);
        strncpy(txt, o->text, ptr-o->text);
        txt[ptr-o->text] = '\0';
      } else {
        strcpy(txt, o->text);
        id = -1;
      }

      TTF_SizeText(fonts[14], txt, &w, &h);
      SDL_Surface *img = getIMGforID(id);
      if (img!=NULL) {
        // sum of widths
        w += img->w+2;
        // max of height
        if  (img->h+2 > h) h = img->h+2;
      }
      if (h>optionh)
        optionh=h;
      maxw += w+15;
     //printf("   maxw=%i\n", maxw);      
      ln = ln->list_next;
    }
    //if (maxw>popupRect->w)
    //  popupRect->w = maxw;
    //popupRect->w += 10;
    //popupRect->h += optionh+20;
    //if (popupType&POPUP_TEXT) {
    //  popupRect->h +=25;
    // }
    int innerspace = (popupRect->w-maxw)/(list_count(popupOptionList));
    if (innerspace<5) innerspace = 5;
    //printf("mouseMovedPopup innerspace=%i popupRect->w=%i maxw=%i\n", innerspace, popupRect->w, maxw);

    maxw=0;
    id = -1;

    ln = list_first(popupOptionList)->list_next;
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode) {
      maxw += innerspace;
      option *o = (option*)ln->list_data;
      if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
        char *ptr = strstr(o->text, "[[");
        strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
        txt[strstr(o->text, "]]") - ptr-2] = '\0';
        id = atoi(txt);
        strncpy(txt, o->text, ptr-o->text);
        txt[ptr-o->text] = '\0';
      } else {
        strcpy(txt, o->text);
        id = -1;
      }

      TTF_SizeText(fonts[14], txt, &w, &h);
      SDL_Surface *img = getIMGforID(id);
      if (img!=NULL) {
        // sum of widths
        w += img->w+2;
        // max of height
        if  (img->h+2 > h) h = img->h+2;
      }

      if (selectedOption != o && x>=5+maxw && x<=5+maxw+w+10 && y>=popupRect->h-30 && y<=popupRect->h-30+h){
        selectedOption = o;
      }

      maxw += w+10;
      ln = ln->list_next;
    }
  } else {
    int acth =0;
    lnode_t *ln = list_first(popupOptionList);
    selectedOption=NULL;
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode) {
      option *o = (option*)ln->list_data;
      int w = 0;
      int h = 0;
      int id = -1;
      if (strstr(o->text, "[[")!=NULL && strstr(o->text, "]]")!=NULL && strstr(o->text, "[[") < strstr(o->text, "]]")) {
        char *ptr = strstr(o->text, "[[");

        //printf("  we are between %p and %p => %i\n", ptr, strstr(o->text, "]]"), (strstr(o->text, "]]") - ptr-2));
        strncpy(txt, ptr+2, strstr(o->text, "]]") - ptr-2);
        txt[strstr(o->text, "]]") - ptr-2] = '\0';
        id = atoi(txt);
        //printf("  we reckon %i from %s\n", id, txt);
        //printf("  we are between %p and %p => %i\n", o->text, ptr, (ptr-o->text));
        strncpy(txt, o->text, ptr-o->text);
        txt[ptr-o->text] = '\0';
      } else
        strcpy(txt, o->text);

      TTF_SizeText(fonts[12], txt, &w, &h);
      //printf("\n we have {%s}=>{%s}=>{%i*%i}\n", o->text, txt, w, h);

      SDL_Surface *img = getIMGforID(id);
      if (img!=NULL) {
        // sum of widths
        w += img->w+2;
        // max of height
        if  (img->h > h) h = img->h;
      }
      if (fisheyeMenuShrink>0 && abs(acth+h/2-popupMouseY)>40)
        h-= fisheyeMenuShrink/(list_count(popupOptionList)-10);

     // printf("  we search acth= %i \n", acth);
      if (selectedOption != o && x>=0 && x<=popupRect->w && y>=acth && y<=acth+h){
        selectedOption = o;
      }
      acth += h;
      ln = ln->list_next;
    }
  }
  free(txt);
  
  if (oldSelectedOption != selectedOption)
    popupneedUpdate = TRUE;
    
}// mouseMovedPopup()
