/*
 *  unitview.c
 *  NewCol
 *
 *  Created by fredericVernier on 2/28/07.
 *  Copyright 2007 Frederic Vernier. All rights reserved.
 *
 */

#include "unitview.h"
#pragma warning ( disable : 4996 )
int          uvDrag            = NONE;
int          uvisMousePressed  = 0;
Uint32       uvlastMouseDown   = 0;
Uint32       uvlastMouseUp     = 0;
int          uvmouseX          = 0;
int          uvmouseY          = 0;
list_t      *unitViews         = NULL;
int          lastuvmouseX      = 0;
int          lastuvmouseY      = 0;

/**
 * create a well initialiazed unit view
 **/
unitview *createUnitView(){
  unitview *uv     = (unitview *)malloc(sizeof(unitview));
  uv->rect         = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  uv->rect->w      = TILESIZE*2;
  uv->rect->h      = TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT+TILESIZE;
  uv->rect->x      = screen->w-uv->rect->w-20;
  uv->rect->y      = 1*(screen->h-uv->rect->h)/2;

  if (unitSelectionList != NULL && !list_isempty(unitSelectionList)) {
    unit *u        = (unit *)list_first(unitSelectionList)->list_data;
    uv->ul         = copylist(unitSelectionList);
    uv->t          = u->location;
  } else {
    uv->ul         = NULL;
    uv->t          = &map[MapWidth/2+MapWidth*(MapHeight/2)];
  }
  uv->opponentl      = NULL;
  uv->lastUl         = NULL;
  uv->needUpdate     = TRUE;
  uv->uvshadowbuffer = NULL;
  uv->shadowrect     = NULL;
  uv->uvbuffer       = NULL;
  return uv;
}// createUnitView()


/**
 * compute popupRect->w and popupRect->h and innerspace
 */
void computeUVSize(unitview* uv) {
  int w           = TILESIZE*2;
  int h           = UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT;

  tile *loc       = NULL;
  //building *buil  = NULL;
  unit *uni       = NULL;
  list_t *friends = NULL;
  unit *opponent  = NULL;
  list_t *foes    = NULL;

  if (uv->ul!=NULL && list_count(uv->ul)>0 && ((unit*)list_first(uv->ul)->list_data)->location != NULL){
    uni = (unit *)list_first(uv->ul)->list_data;
    loc = uni->location;
    friends = uv->ul;
    //printf("  showing unit in uv : %i\n", uni->owner->nation);
  } else if (uv->t!=NULL){
    loc = uv->t;
    uni = NULL;
    friends = NULL;
  }
  if (uv->opponentl!=NULL && list_count(uv->opponentl)>0){
    opponent = (unit *)list_first(uv->opponentl)->list_data;
    foes = uv->opponentl;
    //printf("  showing opponent in uv : %i\n", opponent->owner->nation);
  } else if (uv->t!=NULL){
    opponent = NULL;
    foes = NULL;
  }
  if (uni==NULL && opponent==NULL) {
    uv->rect->w = w;
    uv->rect->h = h+TILESIZE;
    return;
  }

  //printf("  maxload = %u\n", uni->maxLoad);
  int maxLoadForWidth = w/(TILESIZE/2);
  if (uni->maxLoad>0)
    h += (TILESIZE/2)*(1+uni->maxLoad/maxLoadForWidth);
  int topul = 0;
  if (uv->ul!=NULL && list_count(uv->ul)>1)
    topul = 1+(list_count(uv->ul)-1)*(TILESIZE/2);
  if (uv->opponentl!=NULL && list_count(uv->opponentl)>1 && (list_count(uv->opponentl)-1)*(TILESIZE/2)>topul)
    topul = 1+(list_count(uv->opponentl)-1)*(TILESIZE/2);
  //printf("  topul = %i\n", topul);
  uv->rect->w = w;
  uv->rect->h = h+topul;
}//computeUVSize()


/**
 * display the unit view
 **/
void displayUnitView(unitview* uv) {
  /*if (uv->ul==NULL)
    printf(" displayUnitView with only a tile %p\n", uv->t);
  else if ((unit *)list_first(uv->ul)->list_data!=NULL)
    printf(" displayUnitView %p %i where first is UNIT#%i \n", uv->ul, list_count(uv->ul), ((unit *)list_first(uv->ul)->list_data)->type);
  else
    printf(" displayUnitView %p %i where first is not working ! \n", uv->ul, list_count(uv->ul));*/

  if (uv->ul==NULL && uv->t==NULL)
    return;
  computeUVSize(uv);
  if (uv->uvbuffer!=NULL && (uv->rect->w!=uv->uvbuffer->w || uv->rect->h!=uv->uvbuffer->h)){
    SDL_FreeSurface(uv->uvbuffer);
    uv->uvbuffer = NULL;
  }

  if (uv->uvbuffer==NULL){
    // printf("create uv surface =%p %i*%i\n", uv, uv->rect->w, uv->rect->h);
    uv->uvbuffer   = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, uv->rect->w, uv->rect->h, screen->format->BitsPerPixel,
                                          screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0xFF000000);
    uv->needUpdate = TRUE;
    //printf("creating surface for unit view ... masks=%x %x %x %x\n", uv->uvbuffer->format->Rmask, uv->uvbuffer->format->Gmask, uv->uvbuffer->format->Bmask, uv->uvbuffer->format->Amask);
  }

  int topul = 0;
  if (uv->ul!=NULL && list_count(uv->ul)>1)
    topul = (list_count(uv->ul)-1)*(TILESIZE/2);
  if (uv->opponentl!=NULL && list_count(uv->opponentl)>1 && (list_count(uv->opponentl)-1)*(TILESIZE/2)>topul)
    topul = (list_count(uv->opponentl)-1)*(TILESIZE/2);

  SDL_Rect *innerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  innerRect->x = 0;
  innerRect->y = topul;
  innerRect->w = uv->rect->w;
  innerRect->h = uv->rect->h;
  SDL_Rect *rect      = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *rect2     = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  if (uv->needUpdate) {
    if (uv->uvshadowbuffer!=NULL) {
      SDL_FreeSurface(uv->uvshadowbuffer);
      uv->uvshadowbuffer = NULL;
    }

    char* text = (char*)malloc(50);
    SDL_Surface *imgText;
    SDL_Color *col;

    // clean everything
    rect->x = innerRect->x;
    rect->y = innerRect->y+UNIT_BAR_HEIGHT;
    rect->w = innerRect->w+1;
    rect->h = TITLE_BAR_HEIGHT;
    vgradientboxRGBA(uv->uvbuffer, innerRect->x, innerRect->y, innerRect->w, innerRect->h, 0, 0 ,0 , 0, 0, 0 ,0 , 0);

    /////////////////////////////////////
    // tile under and unit image above //
    /////////////////////////////////////
    tile *loc          = NULL;
    //building *buil  = NULL;
    unit *uni          = NULL;
    list_t *friends    = NULL;
    unit *opponent     = NULL;
    list_t *foes       = NULL;
    //unit *oppcivilians = list_create(LISTCOUNT_T_MAX);

    if (uv->ul!=NULL && list_count(uv->ul)>0 && ((unit*)list_first(uv->ul)->list_data)->location != NULL){
      uni = (unit *)list_first(uv->ul)->list_data;
      loc = uni->location;
      friends = uv->ul;
      //printf("  showing unit in uv : %i\n", uni->owner->nation);
    } else if (uv->t!=NULL){
      loc = uv->t;
      uni = NULL;
      friends = NULL;
    }

    if (uv->opponentl!=NULL && list_count(uv->opponentl)>0){
      opponent = (unit *)list_first(uv->opponentl)->list_data;
      foes = uv->opponentl;
      //printf("  showing opponent in uv : %i\n", opponent->owner->nation);
    } else if (uv->t!=NULL){
      opponent = NULL;
      foes = NULL;
    }
    /*if (opponent!=NULL){
      list_t   *list = loc->unitList;
      lnode_t *ln = list_first(list);
      while (ln!=NULL && ln != &list->list_nilnode) {
        unit *u = (unit *)ln->list_data;
        ln = ln->list_next;
        // not in the friends already
        if (list_find(foes, u, *straightCompare) ==NULL){
          list_append(frcivilian, <#lnode_t * #>lnode_create(u));
        }
      }
    }*/
    updatesImageTile(loc->posX, loc->posY, helperTile, FALSE);

    rect->x = innerRect->x+(innerRect->w-TILESIZE)/2;
    rect->y = innerRect->y;
    d1gradientboxRGBA(uv->uvbuffer, rect->x, rect->y, TILESIZE, TILESIZE, 255, 255, 128, 255, 255, 200, 200, 255);

    hlineRGBA(uv->uvbuffer, innerRect->x+innerRect->w/2-TILESIZE/2, innerRect->x+innerRect->w/2+TILESIZE/2, innerRect->y, 255, 250, 150, 255);
    vlineRGBA(uv->uvbuffer, innerRect->x+innerRect->w/2-TILESIZE/2, innerRect->y, innerRect->y+TILESIZE, 255, 250, 150, 255);
    vlineRGBA(uv->uvbuffer, innerRect->x+innerRect->w/2+TILESIZE/2, innerRect->y, innerRect->y+TILESIZE, 255, 250, 150, 255);

    // tile background
    rect->x = innerRect->x;
    rect->y = innerRect->y+TILESIZE;
    rect->w = innerRect->w;
    rect->h = UNIT_BAR_HEIGHT-TILESIZE;

    // trapezoid
    vtextureIsoTrapezoidRGBA(uv->uvbuffer, rect->x, rect->y, TILESIZE, rect->w-1, rect->h-1, helperTile);
    //vgradientIsoTrapezoidRGBA(uv->uvbuffer, rect->x, rect->y, TILESIZE, rect->w, rect->h, 91, 124, 115, 255, 202, 164, 115, 255);
    lineRGBA(uv->uvbuffer, rect->x,         rect->y+rect->h, rect->x+(rect->w-TILESIZE)/2, rect->y, 255, 250, 150, 255);
    lineRGBA(uv->uvbuffer, rect->x+rect->w, rect->y+rect->h, rect->x+rect->w-(rect->w-TILESIZE)/2, rect->y, 255, 250, 150, 255);

    if (uni) {
      SDL_Surface *img1 = getUnitImage(uni);
      rect->x = innerRect->x+(innerRect->w-TILESIZE)/3;
      rect->y = innerRect->y+UNIT_BAR_HEIGHT-img1->h-TILESIZE/2;
      SDL_BlitSurfaceColW(img1, 0, uv->uvbuffer, rect, 255, FALSE, nationColors[uni->owner->nation-FIRST_NATION]);
      SDL_BlitSurface(img1, 0, uv->uvbuffer, rect);
      rect->y = innerRect->y+UNIT_BAR_HEIGHT-TILESIZE/2;
      SDL_BlitSurfaceMirrorV(img1, 0, uv->uvbuffer, rect, TILESIZE);
    }
    if (opponent){
      SDL_Surface *img1 = getUnitImage(opponent);
      rect->x = innerRect->x+3*(innerRect->w-TILESIZE)/3;
      rect->y = innerRect->y+UNIT_BAR_HEIGHT-img1->h-TILESIZE/4;
      SDL_BlitSurfaceColW(img1, 0, uv->uvbuffer, rect, 500, TRUE, nationColors[opponent->owner->nation-FIRST_NATION]);
      SDL_BlitSurfaceMirrorH(img1, 0, uv->uvbuffer, rect, 0);
      rect->y = innerRect->y+UNIT_BAR_HEIGHT-TILESIZE/4;
      SDL_BlitSurfaceMirrorHV(img1, 0, uv->uvbuffer, rect, TILESIZE);
    }


    // title bar (background, flags and text)
    if (uni!=NULL)
      col = nationColors[uni->owner->nation-FIRST_NATION];
    else
      col = &GREY;
    int r1 = (int)(col->r*0.75f);
    int g1 = (int)(col->g*0.75f);
    int b1 = (int)(col->b*0.75f);
    int r2 = (int)(col->r*1.25f);
    if (r2>255) r2=255;
    int g2 = (int)(col->g*1.25f);
    if (g2>255) g2=255;
    int b2 = (int)(col->b*1.25f);
    if (b2>255) b2=255;
    rect->x = innerRect->x;
    rect->y = innerRect->y+UNIT_BAR_HEIGHT;
    rect->w = innerRect->w+1;
    rect->h = TITLE_BAR_HEIGHT;
    vgradientboxRGBA(uv->uvbuffer, rect->x, rect->y, rect->w, rect->h/2,           r1, g1, b1, 255, r2, g2, b2, 255);
    vgradientboxRGBA(uv->uvbuffer, rect->x, rect->y+rect->h/2, rect->w, rect->h/2, r2, g2, b2, 255, r1, g1, b1, 255);
    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT;
    rect->w = innerRect->w;
    rect->h = TILESIZE;
    // color under goods
    SDL_FillRect(uv->uvbuffer, rect, SDL_MapRGB( uv->uvbuffer->format, 32, 20, 25));
    // title
    char *text2 = NULL; 
    if (uni!=NULL)
      text2 = getUnitText(uni);
    else
      text2 = getGroundText(loc);
    // Display title with shadow
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
    imgText = TTF_RenderText_Blended(fonts[12], text2, BLACK);
    rect->x = innerRect->x+(innerRect->w-imgText->w)/2;
    rect->y = innerRect->y+1+UNIT_BAR_HEIGHT;
    SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect); // (3)
    SDL_FreeSurface(imgText); //(4)
    imgText = TTF_RenderText_Blended(fonts[12], text2, WHITE);
    rect->x = innerRect->x+(innerRect->w-imgText->w)/2;
    rect->y = innerRect->y+UNIT_BAR_HEIGHT;
    SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
    SDL_FreeSurface(imgText);

    // equipment
    rect->x = innerRect->x+2;
    rect->y = innerRect->y+UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT+2;
    if (uni!=NULL && uni->tools>0) {
      SDL_Surface *s = goodsImages[TOOL-FIRST_GOOD];
      rect2->x = rect->x+5;
      rect2->y = rect->y;
      SDL_BlitSurface(s, 0, uv->uvbuffer, rect2);
      sprintf(text, "%i", uni->tools);
      TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
      rect->x--;rect->y--;
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      rect->x++;rect->y++;
      SDL_FreeSurface(imgText);
      rect->x +=38;
    }
    if (uni!=NULL && uni->horses>0){
      SDL_Surface *s = goodsImages[HORSE-FIRST_GOOD];
      rect2->x = rect->x+5;
      rect2->y = rect->y;
      SDL_BlitSurface(s, 0, uv->uvbuffer, rect2);
      sprintf(text, "%i", uni->horses);
      TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
      rect->x--;rect->y--;
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      rect->x++;rect->y++;
      SDL_FreeSurface(imgText);
      rect->x +=38;
    }
    if (uni!=NULL && uni->muskets>0){
      SDL_Surface *s = goodsImages[MUSKET-FIRST_GOOD];
      rect2->x = rect->x+5;
      rect2->y = rect->y;
      SDL_BlitSurface(s, 0, uv->uvbuffer, rect2);
      sprintf(text, "%i", uni->muskets);
      TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
      rect->x--;rect->y--;
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      rect->x++;rect->y++;
      SDL_FreeSurface(imgText);
      rect->x +=38;
    }

    //tile info
    rect->y = innerRect->y+UNIT_BAR_HEIGHT-30;
    if (uni==NULL) {
      rect->y = innerRect->y+UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT;
      if (loc->bonus>0){
        int bn = getBonusForTile(loc);
        if (bn!=NONE) {
          SDL_Surface *bon = bonusImages[bn-FIRST_BONUS];
          SDL_BlitSurface(bon, 0, uv->uvbuffer, rect);
          rect->x += bon->w;
          TTF_SetFontStyle(fonts[11], TTF_STYLE_NORMAL);
          SDL_Surface *imgText = TTF_RenderText_Blended(fonts[11], getBonusText(loc), DARKGREY);
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          SDL_FreeSurface(imgText);
          imgText = TTF_RenderText_Blended(fonts[11], getBonusText(loc), WHITE);
          rect->x--;rect->y--;
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          rect->x++;rect->y++;
          SDL_FreeSurface(imgText);
          rect->y += 15;

          float bp = getBaseProduction(loc, getGoodForBonus(bn));
          sprintf(text, "%2.1f per turn", bp);
          imgText = TTF_RenderText_Blended(fonts[11], text, DARKGREY);
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          SDL_FreeSurface(imgText);
          imgText = TTF_RenderText_Blended(fonts[11], text, WHITE);
          rect->x--;rect->y--;
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          rect->x++;rect->y++;
          SDL_FreeSurface(imgText);
        }
      }
      if (loc->river_elem!=NULL){
        int *riversize = (int*)loc->river_elem->metadata;
        if (*riversize>=BIG_RIVER_MIN_SIZE)
          sprintf(text, "Major River");
        else
          sprintf(text, "Minor River");
        rect->y += 15;
        rect->x = innerRect->y+3;
        imgText = TTF_RenderText_Blended(fonts[12], text, DARKGREY);
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
        rect->y --;
        rect->x --;
        imgText = TTF_RenderText_Blended(fonts[12], text, LIGHTBLUE);
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
      }
      if (loc->vegetation!=0){
        if (loc->vegetation>=IRRIGATION)
          sprintf(text, "Irrigated Fields");
        else if (loc->vegetation>=PLOWED)
          sprintf(text, "Fields");
        else if (loc->vegetation<=FOREST)
          sprintf(text, "Dense Forest");
        else if (loc->vegetation<=WOOD)
          sprintf(text, "Woods");
        rect->y += 15;
        rect->x = innerRect->y+3;
        imgText = TTF_RenderText_Blended(fonts[12], text, DARKGREY);
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
        rect->y --;
        rect->x --;
        imgText = TTF_RenderText_Blended(fonts[12], text, LIGHTGREEN);
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
      }
    }

    int nb = 0;
    // display friends behind me
    if (friends!=NULL &&list_count(friends)>1) {
      lnode_t *ln = list_first(friends);
      while (ln != &friends->list_nilnode) {
        unit *u = (unit *)ln->list_data;
        ln = ln->list_next;
        if (u==uni)
          continue;
        nb++;
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        rect->x = innerRect->x+TILESIZE/2;
        rect->y = innerRect->y-(TILESIZE/2)*nb;
        SDL_Color *col = nationColors[u->owner->nation-FIRST_NATION];
        d1gradientboxRGBA(uv->uvbuffer, rect->x, rect->y, rect->w, rect->h, col->r, col->g, col->b, 255, 82, 70, 75, 255);
        SDL_Surface *img = getUnitGoodImage(u);
        SDL_BlitSurface(img, 0, uv->uvbuffer, rect);
      }
    }

    // display opponents behind their leader
    nb = 0;
    if (foes!=NULL &&list_count(foes)>1) {
      lnode_t *ln = list_first(foes);
      while (ln != &foes->list_nilnode) {
        unit *u = (unit *)ln->list_data;
        ln = ln->list_next;
        if (u==opponent)
          continue;
        nb++;
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        rect->x = innerRect->x+TILESIZE;
        rect->y = innerRect->y-(TILESIZE/2)*nb;
        SDL_Color *col = nationColors[u->owner->nation-FIRST_NATION];
        d1gradientboxRGBA(uv->uvbuffer, rect->x, rect->y, rect->w, rect->h, col->r, col->g, col->b, 255, 82, 70, 75, 255);
        SDL_Surface *img = getUnitGoodImage(u);
        SDL_BlitSurfaceMirrorH(img, 0, uv->uvbuffer, rect, 0);
      }
    }


    // display goods if unit is a transport
    if (uni!=NULL && uni->maxLoad>0) {
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2*(uni->maxLoad/2);
      rect->x = innerRect->x;
      rect->y = innerRect->y+TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT;
      int dx;
      int maxLoadForWidth = innerRect->w/(TILESIZE/2);
      for (dx=0; dx<uni->maxLoad; dx++) {
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        rect->x = innerRect->x+(dx%maxLoadForWidth)*(TILESIZE/2);
        rect->y = innerRect->y+TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT+(dx/maxLoadForWidth)*(TILESIZE/2);
        d1gradientboxRGBA(uv->uvbuffer, rect->x, rect->y, rect->w, rect->h, 128, 20, 25, 255, 82, 70, 75, 255);
        if (uni->goods[dx].quantity==0)
          continue;
        good *g = &uni->goods[dx];
        SDL_Surface *imgGood = getGoodImage(&uni->goods[dx]);

        if (dragGood!=NULL && g==dragGood)
          SDL_BlitSurfaceBW(imgGood, 0, uv->uvbuffer, rect, 196, FALSE);
        else
          SDL_BlitSurface(imgGood, 0, uv->uvbuffer, rect);

        if (uni->goods[dx].type>=FIRST_GOOD && uni->goods[dx].type<=LAST_GOOD) {
          sprintf(text, "%i", uni->goods[dx].quantity);
          TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
          rect->x+=3;
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          SDL_FreeSurface(imgText);
          imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
          rect->x--;rect->y--;
          SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
          SDL_FreeSurface(imgText);
          rect->x-=2;rect->y++;
        }

        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        hlineRGBA(uv->uvbuffer, rect->x, rect->x+rect->w-1, rect->y, 192, 192, 192, 255);
        hlineRGBA(uv->uvbuffer, rect->x, rect->x+rect->w-1, rect->y+rect->h-1, 64, 64, 64, 255);
        vlineRGBA(uv->uvbuffer, rect->x,         rect->y,   rect->y+rect->h-1, 192, 192, 192, 255);
        vlineRGBA(uv->uvbuffer, rect->x+rect->w-1, rect->y, rect->y+rect->h-1, 64, 64, 64, 255);
      }
      //rect->y = UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT+TILESIZE/2;
    }

    // health points
    if (uni!=NULL) {
      rect->x = innerRect->x;
      rect->y = innerRect->y+UNIT_BAR_HEIGHT;
      hgradientboxRGBA(uv->uvbuffer, rect->x+3, rect->y-uni->maxHealth/2, 6, uni->maxHealth/2, 0, 0, 0, 255, 64, 64, 64, 255);
      hgradientboxRGBA(uv->uvbuffer, rect->x+9, rect->y-uni->maxHealth/2, 6, uni->maxHealth/2, 64, 64, 64, 255, 32, 32, 32, 255);
      hgradientboxRGBA(uv->uvbuffer, rect->x+3, rect->y-uni->health/2, 12,   uni->health/2, 255, 64, 64, 255, 200, 0, 0, 255);

      sprintf(text, "%i", uni->health);
      TTF_SetFontStyle(fonts[11], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[11], text, BLACK);
      rect->x += 2;
      rect->y += 1;
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[11], text, RED);
      rect->x -= 1;
      rect->y -= 1;
      SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
      SDL_FreeSurface(imgText);

      rect->x = innerRect->x+innerRect->w;
      rect->y = innerRect->y+UNIT_BAR_HEIGHT;
      // move points if no opponent. opponent health points otherwise
      if (opponent!=NULL) {
        hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-opponent->maxHealth/2, 6, opponent->maxHealth/2, 0, 0, 0, 255, 64, 64, 64, 255);
        hgradientboxRGBA(uv->uvbuffer, rect->x-9,  rect->y-opponent->maxHealth/2, 6, opponent->maxHealth/2, 64, 64, 64, 255, 32, 32, 32, 255);
        hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-opponent->health/2, 12,   opponent->health/2, 255, 64, 64, 255, 200, 0, 0, 255);
        sprintf(text, "%i", opponent->health);
        TTF_SetFontStyle(fonts[11], TTF_STYLE_BOLD);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[11], text, BLACK);
        rect->x += 2;
        rect->y += 1;
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[11], text, RED);
        rect->x -= 1;
        rect->y -= 1;
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
      } else {
        hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-uni->maxMovement/2, 6, uni->maxMovement/2, 0, 0, 0, 255, 64, 64, 64, 255);
        hgradientboxRGBA(uv->uvbuffer, rect->x-9,  rect->y-uni->maxMovement/2, 6, uni->maxMovement/2, 64, 64, 64, 255, 32, 32, 32, 255);
        int r = 96;
        int g = 200;
        int b = 64;
        if (isNaval(uni)){
          g = 96;
          r = 64;
          b = 255;
        }
        int barheight = uni->movement/2;
        if ((barheight/10)%2)
          hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-barheight, 12, barheight%10, r*3/4, g*3/4, b*3/4, 255, r, g, b, 255);
        else
          hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-barheight, 12, barheight%10, r, g, b, 255, r*3/4, g*3/4, b*3/4, 255);
        //boxRGBA(uv->uvbuffer, rect->x+3, rect->y+TILESIZE-3-uni->maxMovement/3*2, rect->x+9, rect->y+TILESIZE-3, 0, 0, 0, 255);
        //boxRGBA(uv->uvbuffer, rect->x+3, rect->y+TILESIZE-3-uni->movement/3*2,    rect->x+9, rect->y+TILESIZE-3, 0, 200, 0, 255);
        int raff = barheight/10;
        barheight -= barheight%10;
        int i;
        for (i=0; i<raff; i++)
          if ((i+raff)%2)
            hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-barheight+i*10, 12, 10, r, g, b, 255, r*3/4, g*3/4, b*3/4, 255);
          else
            hgradientboxRGBA(uv->uvbuffer, rect->x-15, rect->y-barheight+i*10, 12, 10, r*3/4, g*3/4, b*3/4, 255, r, g, b, 255);
        sprintf(text, "%i", uni->movement);
        TTF_SetFontStyle(fonts[11], TTF_STYLE_BOLD);
        imgText = TTF_RenderText_Blended(fonts[11], text, BLACK);
        rect->x -= imgText->w+2;
        rect->x += 1;
        //rect->y += (TILESIZE-28)/2;
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[11], text, GREEN);
        rect->x -= 1;
        rect->y -= 1;
        SDL_BlitSurface(imgText, 0, uv->uvbuffer, rect);
        SDL_FreeSurface(imgText);
      }
    }
    free(text);

    if (uni!=NULL) {
      //printf("  uni=%p-%i(%i)\n", uni, uni->type, uni->experience);
      rect->x = innerRect->x+innerRect->w;
      rect->y = innerRect->y+UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT-9;
      int k;
      for (k=0; k<uni->experience; k++){
        boxRGBA(uv->uvbuffer, rect->x+3+k*9, rect->y+TILESIZE-3,    rect->x+TILESIZE-2, rect->y+TILESIZE-3-k*9-6, 0, 0, 200, 255);
        filledCircleRGBA(uv->uvbuffer , rect->x+TILESIZE-5, rect->y+TILESIZE-6-k*9, 2, 255, 255, 0, 255);
      }
    }
  }

  TTF_SetFontStyle(fonts[10], TTF_STYLE_NORMAL);
  TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);

  if (uv->uvshadowbuffer==NULL) {
    uv->uvshadowbuffer = createShadow(uv->uvbuffer, 192, 0x00000000); // black shadow
    if (uv->shadowrect==NULL)
      uv->shadowrect = (SDL_Rect*)malloc(sizeof(SDL_Rect));

    uv->shadowrect->w = uv->rect->w+2*SHADOW_SIZE;
    uv->shadowrect->h = uv->rect->h+2*SHADOW_SIZE;
  } else if (uv->lastUl != uv->ul){
    updateShadow(uv->uvbuffer, uv->uvshadowbuffer, 192, 0x00000000);
  }

  // bottom borders
  vlineRGBA(uv->uvbuffer, innerRect->x,                  innerRect->y+UNIT_BAR_HEIGHT, innerRect->y+innerRect->h-1, 255, 250, 150, 255);
  hlineRGBA(uv->uvbuffer, innerRect->x,                  innerRect->x+innerRect->w-1,  innerRect->h-1, 255, 250, 150, 255);
  vlineRGBA(uv->uvbuffer, innerRect->x+innerRect->w-1,   innerRect->y+UNIT_BAR_HEIGHT, innerRect->y+innerRect->h-1, 255, 250, 150, 255);

  uv->lastUl   = uv->ul;
  uv->needUpdate = FALSE;

  uv->shadowrect->x = uv->rect->x-SHADOW_SIZE;
  uv->shadowrect->y = uv->rect->y-SHADOW_SIZE;
  // display the shadow first
  SDL_BlitSurface(uv->uvshadowbuffer, 0, screen, uv->shadowrect);
  // then display the unitview !
  SDL_BlitSurface(uv->uvbuffer, 0, screen, uv->rect);

  // free locally used memory
  free(rect);
  free(rect2);
  free(innerRect);
}// displayUnitView() --------------------------------------------------------------------


/**
 * return if the given unit is really a transport and if ih has a free cargo 
 */
good *getFreeCargo(unit *u){
  int i;
  if (isNaval(u) || u->type==WAGON)
    for (i=0; i<u->maxLoad; i++){
      if (u->goods[i].quantity==0){
        return &u->goods[i];
      }
    }
  return NULL;
}// getFreeCargo()


/**
 * mouse drop callback from a unit view
**/
void mouseDropUV(unitview *uv, city *c, int uvmouseX, int uvmouseY) {

  tile *loc       = NULL;
  building *buil  = NULL;
  unit *uni       = NULL;
  list_t *friends = NULL;
  unit *opponent  = NULL;
  list_t *foes    = NULL;

  if (uv->ul!=NULL && list_count(uv->ul)>0 && ((unit*)list_first(uv->ul)->list_data)->location != NULL){
    uni = (unit *)list_first(uv->ul)->list_data;
    loc = uni->location;
    friends = uv->ul;
  } else if (uv->ul==NULL && uv->t!=NULL){
    loc = uv->t;
    uni = NULL;
    friends = NULL;
  }

  if (cvDrag == OUTWORKER && isNaval(uni)) {
    int range = getRangeForSize(c->size);
    good *g= getFreeCargo(uni);
    if (g!=NULL) {
      g->type              = dragUnit->type;
      g->quantity          = 1;
      g->passenger         = dragUnit;
      g->passenger->status = ONBOARD;
      c->dependencies[(cvOutY+range)*(range*2+1)+cvOutX+range] = NULL;
      uv->needUpdate     = TRUE;
      cvneedUpdate       = TRUE;
      dragGood           = NULL;
    }
  } else if (cvDrag == NEWCOMER && isNaval(uni)) {
    good *g= getFreeCargo(uni);
    if (g!=NULL) {
      g->type              = dragUnit->type;
      g->quantity          = 1;
      g->passenger         = dragUnit;
      g->passenger->status = ONBOARD;
      lnode_t *ln = list_find(map[c->location->posX+MapWidth*(c->location->posY)].unitList, dragUnit, straightCompare);
      list_delete(map[c->location->posX+MapWidth*(c->location->posY)].unitList, ln);
      free(ln);
      dragUnit->location = NULL;
      uv->needUpdate     = TRUE;
      cvneedUpdate       = TRUE;
      dragGood           = NULL;
    }
  } else if (cvDrag == INWORKER && isNaval(uni)) {
    good *g = getFreeCargo(uni);
    if (g!=NULL) {
      g->type              = dragUnit->type;
      g->quantity          = 1;
      g->passenger         = dragUnit;
      g->passenger->status = ONBOARD;
      lnode_t *ln = list_find(dragUnit->lastBuilding->workers, dragUnit, straightCompare);
      list_delete(dragUnit->lastBuilding->workers, ln);
      // here we get a new pilgrim from an european dock !
      if (dragUnit->owner != uni->owner) {
        dragUnit->owner = uni->owner;
      }
      free(ln);
      dragUnit->location = NULL;
      uv->needUpdate     = TRUE;
      cvneedUpdate       = TRUE;
      dragGood           = NULL;
    }
  } else if (cvDrag == GOODS && dragGood!=NULL && dragGood->type>=FIRST_GOOD && dragGood->type<=LAST_GOOD && uni->location == c->location && uni->owner==c->owner) {
    int i;
    for (i=0; i<uni->maxLoad; i++){
      // free space
      if (uni->goods[i].quantity==0 ||(uni->goods[i].type==dragGood->type && uni->goods[i].quantity<100)){

        int q = dragGood->quantity;
        if (uni->goods[i].quantity+dragGood->quantity>100)
          q  = 100-uni->goods[i].quantity;

        uni->goods[i].quantity += q;
        uni->goods[i].type = dragGood->type;
        dragGood->quantity -= q;
        uv->needUpdate     = TRUE;
        dragGood           = NULL;
        break;
      }
    }
  //trade
  } else if (cvDrag == GOODS && dragGood!=NULL && dragGood->type>=FIRST_GOOD && dragGood->type<=LAST_GOOD && uni->location == c->location && uni->owner!=c->owner) {
    int i;
    int price          = getSellPriceFor(dragGood->type, c, uni->owner);
    for (i=0; i<uni->maxLoad; i++){
      // free space
      if (uni->goods[i].quantity==0 ||(uni->goods[i].type==dragGood->type && uni->goods[i].quantity<100)){

        int q = dragGood->quantity;
        if (uni->goods[i].quantity+dragGood->quantity>100)
          q  = 100-uni->goods[i].quantity;
        if (price*q>uni->owner->money)
          q = uni->owner->money/price;

        c->owner->money += (price*q);
        uni->owner->money -= (price*q);   
          char *msg = (char *)malloc(512);
          sprintf(msg, "TRADE: %02d/%4d: buy %d %s at %dp to %s in the city of %s. Total: -%dp", 1+apptime%12, 
                  1492+apptime/12, q, getGoodText(dragGood), price, c->owner->name, c->name, (price*q));
          addMsg(msg);
          free(msg);             
        uni->goods[i].quantity += q;
        uni->goods[i].type = dragGood->type;
        dragGood->quantity -= q;
        uv->needUpdate     = TRUE;
        dragGood           = NULL;
        break;
      }
    }
    cvneedUpdate       = TRUE;
  }  
  
  cvDrag = NONE;
  cvneedUpdate       = TRUE;
}// mouseDropUV() --------------------------------------------------------------------


/**
 * mouse drag callback from a unit view
**/
void mouseDragUV(unitview *uv, city *c, int uvmouseX, int uvmouseY) {

}// mouseDragUV() --------------------------------------------------------------------


/**
 * mouse drag callback
**/
void mouseDraggedUV(unitview* uv, int uvmouseX, int uvmouseY) {
  lastuvmouseX = uvmouseX;
  lastuvmouseY = uvmouseY;
}// mouseDraggedUV() --------------------------------------------------------------------


/**
 * mouse press callback
**/
void mousePressedUV(unitview* uv, int uvmouseX, int uvmouseY) {

  tile *loc       = NULL;
  //building *buil  = NULL;
  unit *uni       = NULL;
  list_t *friends = NULL;
  //unit *opponent  = NULL;
  //list_t *foes    = NULL;
  if (uv->ul!=NULL && list_count(uv->ul)>0 && ((unit*)list_first(uv->ul)->list_data)->location != NULL){
    uni = (unit *)list_first(uv->ul)->list_data;
    loc = uni->location;
    friends = uv->ul;
  } else if (uv->ul==NULL && uv->t!=NULL){
    loc = uv->t;
    uni = NULL;
    friends = NULL;
  }

  int topul = 0;
  if (uv->ul!=NULL && list_count(uv->ul)>1)
    topul = (list_count(uv->ul)-1)*(TILESIZE/2);
  if (uv->opponentl!=NULL && list_count(uv->opponentl)>1 && (list_count(uv->opponentl)-1)*(TILESIZE/2)>topul)
    topul = (list_count(uv->opponentl)-1)*(TILESIZE/2);

  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *innerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  innerRect->x     = 0;
  innerRect->y     = 0;
  innerRect->w     = uv->rect->w;
  innerRect->h     = uv->rect->h;
  uv->needUpdate   = TRUE;
  Uint32 now       = SDL_GetTicks();
  uvlastMouseDown  = now;
  uvisMousePressed = 1;

  //printf("%i < %i < %i\n", UNIT_BAR_HEIGHT, uvmouseY, UNIT_BAR_HEIGHT+TITLE_BAR_HEIGHT);
  if (uni!=NULL && uni->maxLoad>0 && uvmouseY>TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT+topul) {
    int dx;
    int maxLoadForWidth = innerRect->w/(TILESIZE/2);
    for (dx=0; dx<uni->maxLoad; dx++) {
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2;
      rect->x = innerRect->x+(dx%maxLoadForWidth)*(TILESIZE/2);
      rect->y = innerRect->y+topul+TITLE_BAR_HEIGHT+UNIT_BAR_HEIGHT+(dx/maxLoadForWidth)*(TILESIZE/2);
      //good *g = &uni->goods[dx];
      if (uni->goods[dx].quantity>0 && uvmouseX>=rect->x && uvmouseY>=rect->y && uvmouseX<=rect->x+rect->w && uvmouseY<=rect->y+rect->h) {
        mousedX  = uvmouseX-rect->x;
        mousedY  = uvmouseY-rect->y;
        uvDrag   = GOODS;
        dragGood = &uni->goods[dx];
        isDrag   = INNERUNITVIEW;
      }
    }
  } else if (isOpaquePixel(uv->uvbuffer, uvmouseX, uvmouseY)) {
    SDL_SetAlpha(uv->uvbuffer, SDL_SRCALPHA, 192);
    isDrag = UNITVIEW;
    innitialDragPosX = uv->rect->x;
    innitialDragPosY = uv->rect->y;
  } else
  lastuvmouseX = uvmouseX;
  lastuvmouseY = uvmouseY;
  free(rect);
  free(innerRect);
}// mousePressedUV() --------------------------------------------------------------------


/**
 * mouse release callback
**/
void mouseReleasedUV(unitview* uv, int uvmouseX, int uvmouseY) {
  uv->needUpdate   = TRUE;
  Uint32 now       = SDL_GetTicks();
  uvisMousePressed = 0;
  uvlastMouseUp    = now;
  //SDL_Rect *rect   = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  dragGood         = NULL;
  uvDrag           = NONE;
  SDL_SetAlpha(uv->uvbuffer, SDL_SRCALPHA, 255);
  //free(rect);
}// mouseReleasedUV()


/**
 * return if a position is over one of the unit views
 */
int isInAnyUnitView(int x, int y) {
  lnode_t *ln = list_first(unitViews);
  while (ln!=NULL && ln != &unitViews->list_nilnode) {
    unitview *uv = (unitview *)ln->list_data;
    if (isInUnitView(uv, x, y))
      return TRUE;
    ln = ln->list_next;
  }
  return FALSE;
}// isInAnyUnitView() --------------------------------------------------------------------


/**
 * return if a position is over a given unit view
 */
int isInUnitView(unitview* uv, int x, int y) {
  if (x>=uv->rect->x && y>=uv->rect->y && x<=uv->rect->x+uv->rect->w && y<=uv->rect->y+uv->rect->h && isOpaquePixel(uv->uvbuffer, x-uv->rect->x, y-uv->rect->y))
    return 1;
  else
   return 0;
}// isInUnitView() --------------------------------------------------------------------


/**
 * return the unit view at a given position. NULL if no.
 */
unitview *getUnitView(int x, int y) {
  lnode_t *ln = list_first(unitViews);
  while (ln != &unitViews->list_nilnode) {
    unitview *uv = (unitview *)ln->list_data;
    if (x>=uv->rect->x && y>=uv->rect->y && x<=uv->rect->x+uv->rect->w && y<=uv->rect->y+uv->rect->h)
      return uv;
    ln = ln->list_next;
  }
  return NULL;
}// getUnitView() --------------------------------------------------------------------



