/*
 *  cityview.cpp
 *  VisBoardGame
 *
 *  Created by frederic Vernier on 2/15/07.
 *  Copyright 2007 Frederic Vernier. All rights reserved.
 *
 */

#include "cityview.h"
#pragma warning ( disable : 4996 )

int          cvDrag            = NONE;
int          cvisMousePressed  = 0;
Uint32       cvlastMouseDown   = 0;
Uint32       cvlastMouseUp     = 0;
int          cvmouseX          = 0;
int          cvmouseY          = 0;
SDL_Rect    *cityViewRect      = NULL;
SDL_Rect    *cityShadowRect    = NULL;
SDL_Surface *cvbuffer          = NULL;
SDL_Surface *cvshadowbuffer    = NULL;
int          cvneedUpdate      = FALSE;
city        *selectedCity      = NULL;

int          lastcvmouseX;
int          lastcvmouseY;

int          cvOutX;
int          cvOutY;
building    *inbuilding       = NULL;
int          selectedGood     = LUMBER-FIRST_GOOD;

int          isAboutToChangeConstruction = FALSE;


/**
 * create a building with the given parameters
 */
building *createBuilding(int type, city *c) {
  building* building0           = (building*)malloc(sizeof(building));
  if (building0==NULL)
    exit(555);

  building0->constructionDate   = apptime;
  building0->workers            = list_create(LISTCOUNT_T_MAX);
  building0->homecity           = c;
  building0->type               = type;
  building0->typeGoodsIn1       = NONE;
  building0->typeGoodsOut1      = NONE;
  building0->typeGoodsIn2       = NONE;
  building0->typeGoodsIn3       = NONE;
  building0->helper             = NONE;
  building0->extends            = NONE;
  building0->slots              = 2;
  building0->baseProduction1    = 4;
  building0->minSize            = 1;
  building0->buildingHammers    = 52;
  building0->buildingTools      = 0;

  switch (type) {
  case NEW_WORLD_OFFICE     :
    building0->minSize = 10;
    building0->typeGoodsIn1=CROSS;
    building0->typeGoodsIn2=MONEY;
    building0->typeGoodsIn2=MORALE;
    building0->typeGoodsOut1=NONE;
    building0->slots = 12;
    building0->baseProduction1    = -8;
    break;
    
  case ARMOURY              :
    building0->typeGoodsIn1       = TOOL;
    building0->typeGoodsOut1      = MUSKET;
    building0->baseProduction1    = 4;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 0;
    building0->minSize            = 1;
    break;
  case MAGAZINE             :
    building0->typeGoodsIn1       = TOOL;
    building0->typeGoodsOut1      = MUSKET;
    building0->baseProduction1    = 8;
    building0->buildingHammers    = 120;
    building0->buildingTools      = 50;
    building0->minSize            = 8;
    building0->extends            = ARMOURY;
    break;
  case ARSENAL              :
    building0->typeGoodsIn1       = TOOL;
    building0->typeGoodsOut1      = MUSKET;
    building0->baseProduction1    = 12;
    building0->buildingHammers    = 240;
    building0->buildingTools      = 100;
    building0->minSize            = 8;
    building0->extends=MAGAZINE;
    break;

  case TOBACCONIST_HOUSE    :
    building0->typeGoodsIn1       = TOBACCO;
    building0->typeGoodsOut1      = CIGAR;
    building0->minSize            = 1;
    break;
  case TOBACCONIST_SHOP     :
    building0->typeGoodsIn1       = TOBACCO;
    building0->typeGoodsOut1      = CIGAR;
    building0->baseProduction1    = 8;
    building0->extends            = TOBACCONIST_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    building0->minSize            = 1;
    break;
  case CIGAR_FACTORY        :
    building0->typeGoodsIn1       = TOBACCO;
    building0->typeGoodsOut1      = CIGAR;
    building0->baseProduction1    = 12;
    building0->extends            = TOBACCONIST_SHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 100;
    building0->minSize            = 8;
    break;

  case CARPENTRY_SHOP       :
    building0->typeGoodsIn1       = LUMBER;
    building0->typeGoodsOut1      = HAMMER;
    break;
  case WORKSHOP             :
    building0->typeGoodsIn1       = LUMBER;
    building0->typeGoodsOut1      = HAMMER;
    building0->extends            = CARPENTRY_SHOP;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 50;
    building0->baseProduction1    = 8;
    building0->minSize            = 4;
    break;
  case CONSTRUCTION_YARD    :
    building0->typeGoodsIn1       = LUMBER;
    building0->typeGoodsOut1      = HAMMER;
    building0->baseProduction1    = 12;
    building0->extends            = WORKSHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 100;
    building0->minSize            = 6;
    break;
  case SAWMILL              :
    building0->typeGoodsIn1       = LUMBER;
    building0->typeGoodsOut1      = HAMMER;
    building0->baseProduction1    = 8;
    building0->helper             = CONSTRUCTION_YARD;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 50;
    building0->minSize            = 3;
    break;


  case DISTILLER_HOUSE      :
    building0->typeGoodsIn1       = SUGAR;
    building0->typeGoodsOut1      = RUM;
    break;
  case DISTILLER_SHOP       :
    building0->typeGoodsIn1       = SUGAR;
    building0->typeGoodsOut1      = RUM;
    building0->baseProduction1    = 8;
    building0->extends            = DISTILLER_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    break;
  case RUM_FACTORY          :
    building0->typeGoodsIn1       = SUGAR;
    building0->typeGoodsOut1      = RUM;
    building0->baseProduction1    = 12;
    building0->extends            = DISTILLER_SHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 100;
    building0->minSize            = 8;
    break;

  case SMITHY               :
    building0->typeGoodsIn1    = ORE;
    building0->typeGoodsOut1   = TOOL;
    break;
  case FORGE                :
    building0->typeGoodsIn1    = ORE;
    building0->typeGoodsOut1   = TOOL;
    building0->baseProduction1 = 8;
    building0->extends         = SMITHY;
    building0->buildingHammers = 64;
    building0->buildingTools   = 20;
    building0->minSize         = 4;
    break;
  case IRONWORKS            :
    building0->typeGoodsIn1    = ORE;
    building0->typeGoodsOut1   = TOOL;
    building0->typeGoodsIn2    = COAL;
    building0->extends         = IRONWORKS;
    building0->baseProduction1 = 12;
    building0->buildingHammers = 160;
    building0->buildingTools   = 100;
    building0->minSize         = 8;
    break;

  case WEAVER_HOUSE         :
    building0->typeGoodsIn1         = COTTON;
    building0->typeGoodsOut1        = TEXTILE;
    break;
  case WEAVER_SHOP          :
    building0->typeGoodsIn1         = COTTON;
    building0->typeGoodsOut1        = TEXTILE;
    building0->baseProduction1      = 8;
    building0->extends              = WEAVER_HOUSE;
    building0->buildingHammers      = 64;
    building0->buildingTools        = 20;
    break;
  case TEXTILE_FACTORY      :
    building0->typeGoodsIn1         = COTTON;
    building0->typeGoodsOut1        = TEXTILE;
    building0->baseProduction1      = 12;
    building0->extends              = WEAVER_SHOP;
    building0->buildingHammers      = 160;
    building0->buildingTools        = 100;
    building0->minSize              = 8;
    break;    
    
  case TAILOR_HOUSE         :
    building0->typeGoodsIn1     = TEXTILE;
    building0->typeGoodsOut1    = CLOTH;
    building0->buildingHammers  = 52;
    building0->buildingTools    = 20;    
    building0->minSize          = 4;
    break;
  case TAILOR_SHOP          :
    building0->typeGoodsIn1     = TEXTILE;
    building0->typeGoodsOut1    = CLOTH;
    building0->baseProduction1  = 8;
    building0->extends          = TAILOR_HOUSE;
    building0->buildingHammers  = 120;
    building0->buildingTools    = 50;
    building0->minSize          = 7;
    break;
  case CLOTH_FACTORY        :
    building0->typeGoodsIn1     = TEXTILE;
    building0->typeGoodsOut1    = CLOTH;
    building0->baseProduction1  = 12;
    building0->extends          = TAILOR_SHOP;
    building0->buildingHammers  = 240;
    building0->buildingTools    = 100;
    building0->minSize          = 10;
    break;

  case FUR_WORKER_HOUSE :
    building0->typeGoodsIn1     = FUR;
    building0->typeGoodsOut1    = LEATHER;
    break;
  case FUR_WORKER_SHOP  :
    building0->typeGoodsIn1     = FUR;
    building0->typeGoodsOut1    = LEATHER;
    building0->baseProduction1  = 8;
    building0->extends          = FUR_WORKER_HOUSE;
    building0->buildingHammers  = 64;
    building0->buildingTools    = 20;
    break;
  case FUR_FACTORY      :
    building0->typeGoodsIn1     = FUR;
    building0->typeGoodsOut1    = LEATHER;
    building0->baseProduction1  = 12;
    building0->extends          = FUR_WORKER_SHOP;
    building0->buildingHammers  = 160;
    building0->buildingTools    = 100;
    building0->minSize          = 8;
    break;

  case COAT_TRADER_HOUSE    :
    building0->typeGoodsIn1=LEATHER;
    building0->typeGoodsOut1=COAT;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 20;
    building0->minSize            = 4;
    break;
  case COAT_TRADER_SHOP     :
    building0->typeGoodsIn1       = LEATHER;
    building0->typeGoodsOut1      = COAT;
    building0->baseProduction1    = 8;
    building0->extends            = COAT_TRADER_HOUSE;
    building0->buildingHammers    = 120;
    building0->buildingTools      = 50;
    building0->minSize            = 7;
    break;
  case COAT_FACTORY         :
    building0->typeGoodsIn1       = LEATHER;
    building0->typeGoodsOut1      = COAT;
    building0->baseProduction1    = 12;
    building0->extends            = COAT_TRADER_SHOP;
    building0->buildingHammers    = 240;
    building0->buildingTools      = 100;
    building0->minSize            = 10;
    break;

  case JEWELLER_HOUSE       :
    building0->typeGoodsIn1       = GEM;
    building0->typeGoodsOut1      = JEWEL;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 0;    
    break;
  case JEWELLER_SHOP        :
    building0->typeGoodsIn1       = GEM;
    building0->typeGoodsOut1      = JEWEL;
    building0->baseProduction1    = 8;
    building0->extends            = JEWELLER_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 50;
    building0->minSize            = 4;
    break;
  case JEWELWORKS           :
    building0->typeGoodsIn1       = GEM;
    building0->typeGoodsOut1      = JEWEL;
    building0->baseProduction1    = 12;
    building0->extends            = JEWELLER_SHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 100;
    building0->minSize            = 8;
    break;

  case ROPE_BINDER_HOUSE    :
    building0->typeGoodsIn1       = HEMP;
    building0->typeGoodsOut1      = ROPE;
    building0->buildingHammers    = 52;
    building0->buildingTools      = 0;       
    break;
  case ROPE_BINDER_SHOP     :
    building0->typeGoodsIn1       = HEMP;
    building0->typeGoodsOut1      = ROPE;
    building0->baseProduction1    = 8;
    building0->extends            = ROPE_BINDER_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    building0->minSize            = 4;
    break;
  case ROPE_FACTORY         :
    building0->typeGoodsIn1       = HEMP;
    building0->typeGoodsOut1      = ROPE;
    building0->baseProduction1    = 12;
    building0->extends            = ROPE_BINDER_SHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 50;
    building0->minSize            = 8;
    break;

  case WINE_HOUSE           :
    building0->typeGoodsIn1       = GRAPE;
    building0->typeGoodsOut1      = WINE;
    break;
  case WINE_SHOP            :
    building0->typeGoodsIn1       = GRAPE;
    building0->typeGoodsOut1      = WINE;
    building0->extends            = WINE_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    building0->baseProduction1    = 8;
    building0->minSize            = 4;    
    break;
  case WINE_FACTORY         :
    building0->typeGoodsIn1       = GRAPE;
    building0->typeGoodsOut1      = WINE;
    building0->extends            = WINE_SHOP;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 50;
    building0->baseProduction1    = 12;
    building0->minSize            = 8;
    break;

  case ALCHEMIST_HOUSE      :
    building0->typeGoodsIn1       = SALTPETRE;
    building0->typeGoodsIn1       = COAL;
    building0->typeGoodsOut1      = GUNPOWDER;
    building0->minSize            = 4;
    break;
  case ALCHEMIST_SHOP       :
    building0->typeGoodsIn1       = SALTPETRE;
    building0->typeGoodsIn1       = COAL;
    building0->baseProduction1    = 8;
    building0->typeGoodsOut1      = GUNPOWDER;
    building0->extends            = ALCHEMIST_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    building0->minSize            = 7;
    break;
  case GUNPOWDER_FACTORY    : 
    building0->typeGoodsIn1       = SALTPETRE;
    building0->typeGoodsIn1       = COAL;
    building0->baseProduction1    = 12;
    building0->typeGoodsOut1      = GUNPOWDER;
    building0->extends            = ALCHEMIST_SHOP;
    building0->minSize            = 10;
    building0->buildingHammers    = 160;
    building0->buildingTools      = 50;
    break;

  case SCHOOLHOUSE          :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = KNOWLEDGE;
    break;
  case COLLEGE              :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = KNOWLEDGE;
    building0->baseProduction1    = 8;
    building0->extends            = SCHOOLHOUSE;
    break;
  case UNIVERSITY           :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = KNOWLEDGE;
    building0->baseProduction1    = 12;
    building0->extends            = COLLEGE;
    break;

  case PHARMACIST_HOUSE     :
    building0->typeGoodsIn1       = HERBS;
    building0->typeGoodsOut1      = MEDECINE;
    break;
  case PHARMACIST_SHOP      :
    building0->typeGoodsIn1       = HERBS;
    building0->typeGoodsOut1      = MEDECINE;
    building0->baseProduction1    = 8;
    building0->extends            = PHARMACIST_HOUSE;
    building0->buildingHammers    = 64;
    building0->buildingTools      = 20;
    break;
  case DRUGSTORE            :
    building0->typeGoodsIn1       = HERBS;
    building0->typeGoodsOut1      = MEDECINE;
    building0->baseProduction1    = 12;
    building0->extends            = PHARMACIST_SHOP;
    building0->minSize            = 8;
    building0->buildingTools      = 100;
    building0->buildingHammers    = 160;
    break;

  case TOWN_HALL1           :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = LIBERTYBELL;
    building0->slots              = 1;
    break;
  case TOWN_HALL2           :
    building0->extends            = TOWN_HALL1;
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = LIBERTYBELL;
    building0->baseProduction1    = 8;
    building0->slots              = 2;
    building0->minSize            = 9;
    break;
  case TOWN_HALL3           :
    building0->extends            = TOWN_HALL2;
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = LIBERTYBELL;
    building0->baseProduction1    = 8;
    building0->slots              = 2;
    building0->minSize            = 9;
    break;

  case PRINTING_PRESS       :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=NONE;
    building0->slots              = 0;
    building0->helper = TOWN_HALL1;
    building0->baseProduction1    = 2;
    building0->buildingHammers    = 80;
    building0->minSize = 4;
    break;
  case NEWSPAPER            :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = NONE;
    building0->slots              = 0;
    building0->helper             = TOWN_HALL2;
    building0->baseProduction1    = 3;
    building0->buildingHammers    = 120;
    building0->minSize            = 8;
    building0->buildingTools      = 50;
    building0->extends            = PRINTING_PRESS;
    break;
  case CONGRESS_HALL        :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=LIBERTYBELL;
    building0->minSize            = 12;
    break;
    
  case GROCERY              :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = MONEY;
    building0->slots              = 4;
    building0->baseProduction1    = 8;
    building0->buildingHammers    = 52;
    building0->minSize            = 3;
    building0->buildingTools      = 0;
    break;
  case MARKETPLACE          :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = MONEY;
    building0->extends            = GROCERY;
    building0->baseProduction1    = 16;
    building0->buildingHammers    = 120;
    building0->minSize            = 8;
    building0->buildingTools      = 30;
    break;
  case CUSTOM_HOUSE         :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = MONEY;
    building0->extends            = MARKETPLACE;
    building0->baseProduction1    = 32;
    building0->buildingHammers    = 200;
    building0->minSize            = 10;
    building0->buildingTools      = 60;
    break;

  case TOWN_STATUE          :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=MORALE;
    building0->slots              = 0;
    building0->minSize = 5;
    break;
  case BANK                 :
    building0->typeGoodsOut1=MONEY;
    building0->slots = 0;
    building0->minSize            = 12;
    break;
  case STOCK_EXCHANGE                 :
    building0->typeGoodsOut1=MONEY;
    building0->slots = 0;
    building0->minSize            = 12;
    break;
    
  case GRANARY              :
    building0->slots = 0;
    building0->minSize            = 3;
    break;
  case WIND_MILL            :
    building0->slots = 0;
    building0->minSize            = 7;
    break;
  case TAVERN               :
    building0->typeGoodsIn1=RUM;
    building0->typeGoodsIn1=WINE;
    break;
    
  case WAREHOUSE1           :
    building0->buildingHammers = 80;
    building0->buildingTools   = 0;
    break;
  case WAREHOUSE2           :
    building0->buildingHammers = 160;
    building0->buildingTools   = 20;
    building0->extends         = WAREHOUSE1;
    break;
  case WAREHOUSE3           :
    building0->buildingHammers = 240;
    building0->buildingTools   = 50;
    building0->extends         = WAREHOUSE2;
    break;
    
  case WELL                 :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=NONE;
    break;  
  case WATER_TOWER          :
    building0->typeGoodsIn1  = NONE;
    building0->typeGoodsOut1 = HEALTH;
    break;
  case WATER_STORAGE        :
    building0->extends       = WATER_TOWER;
    building0->typeGoodsIn1  = NONE;
    building0->typeGoodsOut1 = HEALTH;
    break;

  case BARRACKS             :
    building0->slots = 0;
    building0->minSize            = 6;
    break;
  case WATCH_TOWER          :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=NONE;
    break;
  case WEAPON_STORAGE       :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=NONE;
    break;
  case WAR_ACADEMY          :
    building0->typeGoodsIn1=NONE;
    building0->typeGoodsOut1=NONE;
    break;
  case COMMAND_POST         :
    building0->typeGoodsIn1=NONE;
    break;
  case STABLE               :
    building0->typeGoodsIn1=CORN;
    building0->typeGoodsOut1=HORSE;
    break;
    

  case DRY_DOCK             :
    building0->typeGoodsIn1=HAMMER;
    building0->typeGoodsIn2=TOOL;
    building0->typeGoodsIn3=ROPE;
    building0->slots        = 1;
    break;
  case SHIPYARD             :
    building0->typeGoodsIn1 = HAMMER;
    building0->typeGoodsIn2 = TOOL;
    building0->typeGoodsIn3 = ROPE;
    building0->extends      = DRY_DOCK;
    building0->slots        = 2;
    break;
  case PORT                 :
    building0->typeGoodsIn1 = HAMMER;
    building0->typeGoodsIn2 = TOOL;
    building0->typeGoodsIn3 = ROPE;
    building0->extends      = SHIPYARD;
    building0->slots        = 4;
    break;

  case DOCK                 :
    building0->typeGoodsIn1 = FISH;
    building0->slots        = 0;
    break;
  case LIGHTHOUSE           :
    building0->typeGoodsIn1 = FISH;
    building0->helper       = DOCK;
    building0->slots        = 0;
    break;
  case HARBOUR              :
    building0->typeGoodsIn1 = WHALE;
    building0->extends      = DOCK;
    building0->slots        = 0;
    break;

  case CHURCH               :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = CROSS;
    building0->minSize            = 3;
    building0->buildingHammers    = 80;
    building0->buildingTools      = 0;
    building0->baseProduction1    = 3;
    break;
  case JESUIT_CHAPEL        :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = CROSS;
    building0->baseProduction1    = 8;
    building0->slots              = 2;
    building0->buildingHammers    = 120;
    building0->buildingTools      = 60;    
    building0->extends            = CHURCH;
    break;
  case CATHEDRAL            :
    building0->typeGoodsIn1       = NONE;
    building0->typeGoodsOut1      = CROSS;
    building0->baseProduction1    = 12;
    building0->slots              = 3;
    building0->buildingHammers    = 300;
    building0->buildingTools      = 100;     
    building0->extends            = JESUIT_CHAPEL;
    break;
    
  case STOCKADE                 :
    building0->typeGoodsIn1 = NONE;
    building0->slots        = 0;
    break;
  case FORT           :
    building0->extends      = STOCKADE;
    building0->slots        = 0;
    break;
  case FORTRESS              :
    building0->extends      = FORT;
    building0->slots        = 0;
    break;    
    
  default                   :
    break;
  }
  if (c!=NULL)
    list_append(c->buildings, lnode_create(building0));
  if (building0->extends != NONE && c!=NULL){
    lnode_t *ln = list_find(c->buildings, &building0->extends, compareBuildingType);
    if (ln!=NULL) {
      building* oldbuilding = (building*)ln->list_data;
      list_destroy(building0->workers);
      building0->workers = oldbuilding->workers;
      free(oldbuilding);
      list_delete(c->buildings, ln);
    }
  }
  return building0;
}// createBuilding() --------------------------------------------------------------------


/**
 * change the owner of a city (invasion or exchange !)
 */
void changeCityOwner(city *c, player *newOwner){
  player * oldowner = c->owner;
  c->owner          = newOwner;
  lnode_t *ln3      = list_find(oldowner->cityList, c, straightCompare);
  list_delete(oldowner->cityList, ln3);
  list_append(newOwner->cityList, lnode_create(c));
  
  int range = getRangeForSize(c->size);
  int dx, dy;
  for (dx=-range; dx<=range; dx++) {
    for (dy=-range; dy<=range; dy++) {
      float d = sqrt((float)(dx*dx+dy*dy));
      if (d<=range && (dx!=0 ||dy!=0) && c->dependencies[(dy+range)*(range*2+1)+dx+range] != NULL) {
        unit *u  = c->dependencies[(dy+range)*(range*2+1)+dx+range];
        if (u!=NULL) {
          ln3       = list_find(u->owner->unitList, u, straightCompare);
          u->owner = newOwner;
          if (ln3!=NULL) {
            list_delete(oldowner->unitList, ln3);
            list_append(newOwner->unitList, lnode_create(u));
          }
        }
      }
    }
  }
  
  lnode_t *ln = list_first(c->buildings);
  while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
    building *b = (building *)ln->list_data;
    lnode_t *ln2 = list_first(b->workers);
    while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
      unit *u = (unit *)ln2->list_data;
      u->owner = newOwner;
      ln3      = list_find(oldowner->unitList, u, straightCompare);
      list_delete(oldowner->unitList, ln3);
      list_append(newOwner->unitList, lnode_create(u));
      
      ln2 = ln2->list_next;
    }
    ln = ln->list_next;
  }
      
}// changeCityOwner()


/**
 * create a lost city rumor to be explored. Seed will tell the content
 */
city *createLostCityRumor (tile* location) {
  //printf("createLostCityRumor(%d, %d)\n", location->posX, location->posY);fflush(stdout);
  if (location->construction !=NULL){
    fprintf(stderr, "***ERROR***: It is impossible to create a lost city rumor in %d, %d \n", location->posX, location->posY);
    return NULL;  
  }
  
  city* city0             = (city*)malloc(sizeof(city));
  city0->location         = location;
  location->construction  = city0;
  city0->size             = -1;
  city0->seed             = rand();
  // TODO prefer the closest indian nation !
  int in = rand()%(LAST_INDIAN_NATION-FIRST_INDIAN_NATION+1);
  city0->owner            = nations[FIRST_INDIAN_NATION-FIRST_NATION+in];
  //printf("created LostCityRumor(%d, %d) for indian %d \n", location->posX, location->posY, FIRST_INDIAN_NATION+in);fflush(stdout);
  //printf("  %s\n", getNationText(FIRST_INDIAN_NATION+in));fflush(stdout);
}//createLostCityRumor()
  

/**
 * get a score for installing a city at the given tile
 */
int getCityLocationScore(int x, int y){
  int i, j, score = 0;
  if (map[x+MapWidth*(y)].elevation<SEALEVEL ||map[x+MapWidth*(y)].elevation>MOUNTAIN || map[x+MapWidth*(y)].construction!=NULL)
    return -1;
  if (map[x+MapWidth*(y)].ground==DESERT || map[x+MapWidth*(y)].ground==SWAMP || map[x+MapWidth*(y)].ground==TUNDRA)
    score = 10;
  else if (map[x+MapWidth*(y)].ground==PLAIN)
    score = 50;
  else score = 25;
  for (i=-1; i<2; i++)
    for (j=-1; j<2; j++){
      score += 10*(map[x+i+MapWidth*(y+j)].bonus);
    }
  
  // check presence of forests, rivers, coast, etc.
  return score;
}// getCityLocationScore()


/**
 * create a city with the given parameters
 */
city *createCity (int size, char* name, tile* location, player* owner) {
  int i, j;
  if (strlen(name)>MAXNAMELENGTH-2) {
    fprintf(stderr, "***ERROR***: It is impossible to create the city %s in %d, %d with such a long name!\n", name, location->posX, location->posY);fflush(stderr);
    return NULL;
  }
      
  tile *location0 = location;
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX+1+MapWidth*(location->posY)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX+1+MapWidth*(location->posY+1)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX+MapWidth*(location->posY+1)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX-1+MapWidth*(location->posY+1)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX-1+MapWidth*(location->posY)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX-1+MapWidth*(location->posY)-1];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX+MapWidth*(location->posY-1)];
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN || location0->construction!=NULL)
    location0 = &map[location->posX+1+MapWidth*(location->posY-1)];  
  if (location0->elevation<=OCEAN0 || location0->elevation>MOUNTAIN  || location0->construction!=NULL){
    fprintf(stderr, "***ERROR***: It is impossible to create the city %s in seas, mountains, on top of other city, etc. %d, %d!\n", name, location->posX, location->posY);fflush(stderr);
    if (location->elevation<=OCEAN0){
      createUnitAt(PRIVATEER, nations[PORTUGAL-FIRST_NATION], location->posX, location->posY);
    }
    return NULL;
  }

  //TODO: only show foreign cities after few months ... !
  for (i=-8; i<=8; i++)
    for (j=-8; j<=8; j++) {
      int d =(int)hypot((float)i, (float)j);
      if(!isIndian(owner) && d<=8 && location0->posX+i>=0 && location0->posY+j>=0 && location0->posX+i<MapWidth && location0->posY+j<MapHeight &&
           map[location0->posX+i+MapWidth*(location0->posY+j)].lastExplored<0){
        map[location0->posX+i+MapWidth*(location0->posY+j)].lastExplored=15;
      }
    }
  
  city* city0             = (city*)malloc(sizeof(city));
  if (city0==NULL)
    exit(666);
    
  char *filename = (char*)malloc(256);
  sprintf (filename, "images/flags/%s.png", name);
  char *ptr = strchr(filename, ' ');
  while (ptr!=NULL){
    *ptr='_';
    ptr = strchr(filename, ' ');
  }
  FILE *f = fopen(filename, "r");
  if (!f) {
    city0->flagImage  = NULL;
  } else {
    SDL_Surface *tmp  = IMG_LoadAndFormatAlpha(filename);
    double zoom = 1;
    if (tmp->w > TILESIZE || tmp->h > TILESIZE)
      zoom = ((double)TILESIZE) / max(tmp->w,  tmp->h);
    else if (tmp->w < TILESIZE && tmp->h < TILESIZE)
      zoom = ((double)TILESIZE) / max(tmp->w,  tmp->h);

    city0->flagImage = zoomSurface(tmp, zoom, zoom, 1);
    lastLoadedImage =city0->flagImage;
    SDL_FreeSurface(tmp);
  }
  free(filename);

  city0->name             = (char*)malloc(MAXNAMELENGTH*sizeof(char));
  strcpy(city0->name, name);
  city0->name[strlen(name)] = '\0';
  city0->location         = location0;
  location0->construction = city0;
  city0->owner            = owner;
  city0->size             = size;
  city0->walls            = 0;
  city0->type             = 0;
  city0->seed             = rand();
  city0->buildings        = list_create(LISTCOUNT_T_MAX);
  city0->connectedCities  = list_create(LISTCOUNT_T_MAX);
  city0->stocks           = (good *)malloc (GOODS_NUMBER*sizeof(good));
  city0->prod             = (good *)malloc (GOODS_NUMBER*sizeof(good));
  city0->construction     = NONE;
  for (i=0; i<GOODS_NUMBER; i++) {
    city0->stocks[i].type        = FIRST_GOOD+i;
    city0->stocks[i].quantity    = 0;
    city0->prod[i].type          = FIRST_GOOD+i;
    city0->prod[i].quantity      = 0;
  }
  list_append(owner->cityList, lnode_create(city0));
  int range = getRangeForSize(size);
  city0->dependencies    = (unit**)malloc ((2*range+1)*(2*range+1)*sizeof (unit*));
  for (i=0; i<2*range+1; i++)
    for (j=0; j<2*range+1; j++)
      city0->dependencies[j*(2*range+1)+i] = NULL;

  srand(city0->seed);
  city0->stocks[LUMBER-FIRST_GOOD].quantity = -1*location0->vegetation;
  location0->vegetation = NONE;
  if (!isIndian(owner) && size>1){
    int i;
    for (i=0; i<2+size; i++) {
      int attempt = 0, dx = 0, dy = 0;
      int bx=9, by=0, bs=size;
      int score = 0;
      do {
        attempt++;
        dx = (rand()%(range*2+1))-range;
        dy = (rand()%(range*2+1))-range;
        
        
        if  (map[location0->posX+dx+(MapWidth)*(location0->posY+dy)].elevation<SEALEVEL ||
             map[location0->posX+dx+(MapWidth)*(location0->posY+dy)].elevation>HILL ) 
          score = 0;
        else
          score = size*2-abs(dx)-abs(dy);
        if (map[location0->posX+dx+(MapWidth)*(location0->posY+dy)].river_elem!=NULL)
          score+=1;
          score += map[location0->posX+dx+(MapWidth)*(location0->posY+dy)].bonus;
        if (score>bs) {
          bs = score;
          bx = dx;
          by = dy;
        }
      } while (attempt<10);
      
      if (score>0)
        map[location0->posX+bx+(MapWidth)*(location0->posY+by)].vegetation = PLOWED;
    }
  }

  // initial buildings
  building *b;
  if (!isIndian(owner)) {
    b = createBuilding (TOWN_HALL1, city0);
    b = createBuilding (CARPENTRY_SHOP, city0);
    b = createBuilding (SMITHY, city0);
    b = createBuilding (TOBACCONIST_HOUSE, city0);
    b = createBuilding (WEAVER_HOUSE, city0);
    b = createBuilding (DISTILLER_HOUSE, city0);
    b = createBuilding (FUR_WORKER_HOUSE, city0);
  }
  //b = createBuilding (CHURCH, city0);

  return city0;
}// createCity() --------------------------------------------------------------------


/**
 * return how many tiles around a city of the given size can be exploited by the citizen of the city
 */
int getRangeForSize(int size) {
  int range = 1+(size/4);
  if (range>MAX_CITY_RADIUS)
    range=MAX_CITY_RADIUS;

  return range;
}// getRangeForSize() --------------------------------------------------------------------


/**
 * return what is the specialist making this good
 */
int getSpecialistForGood(int goodtype) {
  switch (goodtype) {
  case  WHEAT      :
  case  RICE       :
  case  CORN       :
    return FARMER;
  case  ORE      :
    return OREMINER;
  case  SILVER      :
    return SILVERMINER;
  case  GOLD       :
    return SILVERMINER;
  case  LUMBER       :
    return LUMBERJACK;
  case  SUGAR       :
    return SUGARPLANTER;
  case  COTTON      :
    return COTTONPLANTER;
  case  TOBACCO      :
    return TOBACCOPLANTER;
  case  RUM       :
    return DISTILLER;
  case  CIGAR      :
    return TOBACCONIST;
  case  CLOTH      :
    return WEAVER;
  case  COAT       :
    return FURTRADDER;
  case  TOOL       :
    return BLACKSMITH;
  case  MUSKET     :
    return GUNSMITH;
  case  HORSE      :
    return NONE; //COWBOY;
  case  GUNPOWDER  :
    return GUNSMITH;
  case  HAMMER     :
    return CARPENTER;
  case  CROSS      :
    return PREACHER;
  case  LIBERTYBELL:
    return STATEMAN;
  }
  return NONE;
}// getSpecialistForGood() --------------------------------------------------------------------


/**
 * find what the next building to build could be to optimize city developement
 * TODO: explore tiles to know what could be best to develop. check ore/tool production (none, little, plenty)  check if player is at war.
 */
int findBestNextConstruction(city *c) {
  int constr        = NONE;
  int bestHeuristic = 0;
  int i;
  for (i=FIRST_BUILDING; i<LAST_BUILDING; i++) {
    // to take into account
    if (!list_find(c->buildings, &i, compareBuildingType) &&
        (extensionTable[i-FIRST_BUILDING]==0 || list_find(c->buildings, &extensionTable[i-FIRST_BUILDING], compareBuildingType))&&
        c->size >= minSizeTable[i-FIRST_BUILDING]) {
      int heuristic = 1;
      // not built yet ?!?!? it is the most important improvement
      if (i==SAWMILL)
        heuristic = 500;
      if (heuristic>bestHeuristic) {
        bestHeuristic = heuristic;
        constr = i;
      }
    }
  }
  return constr;
}// findBestNextConstruction() --------------------------------------------------------------------


/**
 * update the stock of goods in the city and send to trash what cannot be stored.
 */
void updateCityStock(city *c) {
  int i;
  for (i=0; i<GOODS_NUMBER; i++) {
    int maxq = getMaxQuantity(c, FIRST_GOOD+i);
    if (c->stocks[i].quantity > maxq) {
      c->stocks[i].quantity = maxq;
      // TODO alert the user here
    }
  }

}// updateCityStock() --------------------------------------------------------------------


/**
* update the building if the workers of the sawmill produced enough hammers, etc.
 */
void updateCityConstruction(city *c) {

  /*printf("updateCityConstruction(%s)\n", c->name);
  printf("  building %i (%s)\n", c->construction, getBuildingTextFromType(c->construction));
  printf("    hammers %i / %i\n",  c->stocks[HAMMER-FIRST_GOOD].quantity, hammerTable[c->construction-FIRST_BUILDING]);
  printf("    tools %i / %i\n",  c->stocks[TOOL-FIRST_GOOD].quantity, toolsTable[c->construction-FIRST_BUILDING]);
  printf("    required size %i / %i\n",  c->size, minSizeTable[c->construction-FIRST_BUILDING]);
  printf("    will extend %i (%s)\n",  extensionTable[c->construction-FIRST_BUILDING], getBuildingTextFromType(extensionTable[c->construction-FIRST_BUILDING]));
  */

  if (c->construction !=NONE &&
      (extensionTable[c->construction-FIRST_BUILDING]==NONE || list_find(c->buildings, &extensionTable[c->construction-FIRST_BUILDING], compareBuildingType)) &&
      c->size >= minSizeTable[c->construction-FIRST_BUILDING] &&
      c->stocks[HAMMER-FIRST_GOOD].quantity>=hammerTable[c->construction-FIRST_BUILDING] &&
      c->stocks[TOOL-FIRST_GOOD].quantity  >=toolsTable [c->construction-FIRST_BUILDING]) {

    //printf("   BUILD IT!\n\n");
    c->stocks[TOOL-FIRST_GOOD].quantity-=toolsTable[c->construction-FIRST_BUILDING];
    c->stocks[HAMMER-FIRST_GOOD].quantity-=hammerTable[c->construction-FIRST_BUILDING];
    building *b = createBuilding(c->construction, c);
    if (extensionTable[c->construction-FIRST_BUILDING]!=NONE) {
      lnode_t *ln = list_find(c->buildings, &extensionTable[c->construction-FIRST_BUILDING], compareBuildingType);
      building *b2 = (building*)ln->list_data;
      lnode_t *ln2 = list_first(b2->workers);
      while (ln2!=NULL && ln2 !=&b2->workers->list_nilnode) {
        unit *u = (unit*)ln2->list_data;
        u->lastBuilding = b;
        list_append(b->workers, lnode_create(u));
        ln2 = ln2->list_next;
      }
      list_destroy_nodes(b2->workers);
      list_destroy(b2->workers);
      b2->workers = NULL;
      list_delete(c->buildings, ln);
      free(b2);
      c->construction = findBestNextConstruction(c);
      // TODO alert the user here
    }
  }
}// updateCityConstruction() --------------------------------------------------------------------


/**
* find what city can have such a awful name (or return otherwise)
 */
city *findCity(char *name){
  lnode_t *ln = list_first(playerList);
  while (ln!=NULL && ln!=&playerList->list_nilnode) {
    player *p = (player*)ln->list_data;
    lnode_t *cl = list_first(p->cityList);
    while (cl!=NULL &&cl!=&(p->cityList)->list_nilnode) {
      city *c = (city*)cl->list_data;
      if (strcmp(c->name, name) == 0)
        return c;
      cl=cl->list_next;
    }

    ln = ln->list_next;
  }
  return NULL;
}// findCity()


/**
 * find a job in this city for the given unit
 */
int findBestJob(unit *u, city *c) {
  if (u->location!=NULL && u->location != c->location)
    return 0;

  //if (strstr(c->name, "Royal")>0) {
    //printf(" findBestJob() find a good job for %s in %s\n", getUnitText(u), c->name);
  //}
  
  int dx, dy, g, theg;
  int range = getRangeForSize(c->size);
  //int availableRawGoods = 4*range+2;
  //if (availableRawGoods>RAW_GOODS_NUMBER)
  //  availableRawGoods=RAW_GOODS_NUMBER;

  int maxprod = 0;
  int loc     = -1;
  int status  = -1;

  for (dx=-range; dx<=range; dx++) {
    for (dy=-range; dy<=range; dy++) {
      float d = sqrt((float)(dx*dx+dy*dy));
      if (d<=range && (dx!=0 ||dy!=0) && c->dependencies[(dy+range)*(range*2+1)+dx+range] == NULL) {
        for (g=FIRST_RAW_GOOD; g<=FIRST_RAW_GOOD+RAW_GOODS_NUMBER; g++) {
          if (isGoodAvailable(g, c)) {
            int prod = computeValuableProduction(c, u, g, c->location->posX+dx, c->location->posY+dy);

            if (prod>maxprod && prod>0){
              status = getStatusForGood(g);
              maxprod = prod;
              loc = (dy+range)*(range*2+1)+dx+range;
              theg = g;
            }
          }
        }
      }
    }
  }

  if (strstr(c->name, "Royal")>0) {
    //char *txt =(char*)malloc(256);
    //char *txt2 =(char*)malloc(256);
    //getUnitText(u, txt);
    //getGoodText(theg, txt2);
    //printf("    for %s there is something good=%s status=%i (prod=%i)at %i,%i\n", txt, txt2, status, maxprod, loc%(range*2+1), loc/(range*2+1));
    //free(txt);
    //free(txt2);
  }

  if (loc>=0) {
    c->dependencies[loc] = u;
    u->lastCity = c;
    //setOutsideJob(c, u, dx, dy);
    if (u->horses>0) {
      c->stocks[TOOL-FIRST_GOOD].quantity+=u->tools;
      u->tools = 0;
    }
    if (u->muskets>0) {
      c->stocks[MUSKET-FIRST_GOOD].quantity+=u->muskets;
      u->muskets = 0;
    }
    if (u->horses>0) {
      c->stocks[HORSE-FIRST_GOOD].quantity+=u->horses;
      dragUnit->horses = 0;
    }
    u->status = status;
    if (u->location!=NULL && c->location->unitList!=NULL) {
      lnode_t *ln = list_find(c->location->unitList, u, straightCompare);
      list_delete(c->location->unitList, ln);
    }
    return 1;
  }
  return 0;
}// findBestJob()


/**
 * compute how much goods are produced by one guy
 */
int computeInsideProduction(city *c, unit *u, building *b) {
  //printf("computeInsideProduction(%s, %i, %i)=>", c->name, u->type, b->type);
  int baseProduction = 0;
  //lnode_t *ln2 = list_first(b->workers);
  //while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
  //  unit *u = (unit *)ln2->list_data;
  if (u->type==CRIMINAL)
    baseProduction += b->baseProduction1-2;
  if (u->type==SERVANT)
    baseProduction += b->baseProduction1-1;
  if (u->type==getSpecialistForGood(b->typeGoodsOut1))
    baseProduction += b->baseProduction1*2;
  else
    baseProduction += b->baseProduction1;
  //  ln2 = ln2->list_next;
  //}

  // TODO Here handle city production with sons of liberty percentage
  int range    = getRangeForSize(c->size);
  if (range>3 && c->stocks[LIBERTYBELL-FIRST_GOOD].quantity<20){
    // penalty apply here
  }
  //printf("  %i\n", baseProduction);
  return baseProduction;
}// computeInsideProduction() --------------------------------------------------------------------


/**
 * return the base production of good type g for the given tile. base production mean without man activity (specialty, roads, etc.)
 */
float getBaseProduction(tile *t, int g) {
  float baseProduction = 0;
  switch (t->ground) {
  case PLAIN:
    baseProduction=5;
    break;
  case DESERT:
    baseProduction=1;
    break;
  case GRASSLAND:
    baseProduction=4;
    break;
  case PRAIRIE:
    baseProduction=4;
    break;
  case SAVANNAH:
    baseProduction=4;
    break;
  case MARSH:
    baseProduction=2;
    break;
  case SWAMP:
    baseProduction=1;
    break;
  case TUNDRA:
    baseProduction=1;
    break;
  case ARCTIC:
    baseProduction=0;
    break;
  default :
    baseProduction=0;
    break;
  }
  
  switch (g) {
  case WHEAT :
  case RICE :
  case CORN :
    if (t->elevation>HILL || t->elevation<SEALEVEL)
      baseProduction=0;
    else if (t->ground==PLAIN)
      baseProduction=4;
    else if (t->ground==PRAIRIE || t->ground==GRASSLAND || t->ground==SAVANNAH)
      baseProduction=3;
    
    break;
  case FISH :
  case CLAMS :
    if (t->elevation>=SEALEVEL)
      baseProduction=0;
    else if (t->elevation==OCEAN0)
      baseProduction=6;
    else if (t->elevation==OCEAN1)
      baseProduction=8;
    break;
  case WHALE :
    if (t->elevation==OCEAN1)
      baseProduction=1;
    else
      baseProduction=0;
    break;
  case PEARL :
    if (t->elevation==OCEAN0)
      baseProduction=1;
    else
      baseProduction=0;
    break;
  case TOBACCO :
    if (t->elevation<SEALEVEL || t->elevation>HILL)
      baseProduction=0;
    else if (t->ground==GRASSLAND)
      baseProduction=4;
    else if (t->ground==PLAIN)
      baseProduction=3;
    else if (t->ground==PRAIRIE || t->ground==SAVANNAH)
      baseProduction=2;
    else
      baseProduction=1;
    break;
  case COTTON :
    if (t->elevation<SEALEVEL || t->elevation>HILL)
      baseProduction=0;
    else if (t->ground==PRAIRIE)
      baseProduction=4;
    else if (t->ground==PLAIN)
      baseProduction=3;
    else if (t->ground==GRASSLAND || t->ground==SAVANNAH)
      baseProduction=2;
    else
      baseProduction=1;
    break;
  case SUGAR :
    if (t->elevation<SEALEVEL || t->elevation>HILL)
      baseProduction=0;
    else if (t->ground==SAVANNAH)
      baseProduction=4;
    else if (t->ground==PLAIN)
      baseProduction=3;
    else if (t->ground==PRAIRIE || t->ground==GRASSLAND)
      baseProduction=2;
    else
      baseProduction=1;
    break;
  case ORE :
    if (t->elevation<SEALEVEL)
      baseProduction=0;
    else if (t->elevation==SEALEVEL)
      baseProduction=1;
    else if (t->elevation==HILL)
      baseProduction=2;
    else if (t->elevation==HIGHHILL)
      baseProduction=4;
    else if (t->elevation==MOUNTAIN)
      baseProduction=2;
    else if (t->elevation==HIGHMOUNTAIN)
      baseProduction=1;
    break;
  case COAL :
    if (t->elevation<SEALEVEL)
      baseProduction=0;
    else if (t->elevation==SEALEVEL)
      baseProduction=2;
    else if (t->elevation==HILL)
      baseProduction=4;
    else if (t->elevation==HIGHHILL)
      baseProduction=2;
    else if (t->elevation==MOUNTAIN)
      baseProduction=0;
    else if (t->elevation==HIGHMOUNTAIN)
      baseProduction=0;
    break;
  case SILVER :
    if (t->elevation<=HILL)
      baseProduction=0;
    else if (t->elevation==HIGHHILL)
      baseProduction=1;
    else if (t->elevation==MOUNTAIN)
      baseProduction=3;
    else if (t->elevation==HIGHMOUNTAIN)
      baseProduction=1;
    break;
  case GOLD :
    if (t->elevation<=HIGHHILL)
      baseProduction=0;
    else if (t->elevation==MOUNTAIN)
      baseProduction=1;
    else if (t->elevation==HIGHMOUNTAIN)
      baseProduction=2;
    break;
  case LUMBER :
    if (t->elevation<SEALEVEL)
      baseProduction=0;    
    else if (t->vegetation>=0 && (t->ground==PRAIRIE || t->ground==GRASSLAND || t->ground==SAVANNAH))
      baseProduction = 1;
    else if (t->vegetation>=0 && t->ground==PLAIN)
      baseProduction = 2;
    else if (t->vegetation<0)
      baseProduction = (float)(-t->vegetation/5);
    break;
  case FUR :
    if (t->vegetation>=0 || t->elevation<SEALEVEL || t->elevation>HILL)
      baseProduction = 0;
    else if (t->vegetation<WOOD)
      baseProduction = (-t->vegetation/15.0f);
    else
      baseProduction = (2.0f*-t->vegetation/5.0f);
    break;
  }

  // goods improved by watering
  if (t->river_elem!=NULL && (g==RICE || g==WHEAT || g==CORN || g==TOBACCO || g==COTTON ||
                              g==SUGAR ||g==CLAMS || g==FISH)) // TODO CHECK THE IRRIGATION LEVEL
    baseProduction = baseProduction*1.5f;
  if (t->river_elem!=NULL && (g==SILVER || g==GOLD) && baseProduction!=0)
    baseProduction = baseProduction+1;
  // river help bringing it back. TODO->check if the river goes to the city !
  if (t->river_elem!=NULL && (g==COAL || g==ORE || g==LUMBER))
    baseProduction = baseProduction*1.3f;
  if (t->river_elem&& (g==FUR))
    baseProduction = baseProduction*2.0f;

  int bn = getBonusForTile(t);
  int g2 = getGoodForBonus(bn);
  if (g==g2 && t->bonus==1)
    baseProduction = baseProduction*1.3f;
  else if (g==g2 && t->bonus==2)
    baseProduction = baseProduction*1.5f;

  return baseProduction;
}// getBaseProduction() --------------------------------------------------------------------


/**
 * compute how important a good production is for a given city,unit,good,location
 */
int computeValuableProduction(city *c, unit *u, int g, int x, int y){
  int prod = computeOutsideProduction(c, u, g, x, y);
  
  //char *text = (char*)malloc(50);
  //getGoodText(g, text) ;
  //printf("  for %i, %i he could harvest %i %s\n", x, y, prod, text);
  //free(text);
  
  //TO DO take into account values of goods, diversity of production, etc.
  
  if (c->stocks[g-FIRST_GOOD].quantity+prod>=getMaxQuantity(c, g))
    prod = getMaxQuantity(c, g)-c->stocks[g-FIRST_GOOD].quantity;
  
  // very urgent, we need food !
  if (c->stocks[CORN-FIRST_GOOD].quantity+c->stocks[WHEAT-FIRST_GOOD].quantity+c->stocks[RICE-FIRST_GOOD].quantity<10 && prod>0 && (g==CORN || g==WHEAT || g==RICE))
    prod = prod*100;
  
  return prod;
}// computeValuableProduction()


/**
 * compute how much goods of type g are produced by one guy u in a city  at the given outside location (0, 0 not allowed)
 */
int computeOutsideProduction(city *c, unit *u, int g, int x, int y) {
  float baseProduction = getBaseProduction(&map[x+MapWidth*(y)], g);
  
  int bid0 = DOCK;
  int bid1 = HARBOUR;
  int bid2 = LIGHTHOUSE;
  if ((g==FISH || g==WHALE || g==CLAMS)&&(!list_find(c->buildings, &bid0, compareBuildingType))&&(!list_find(c->buildings, &bid1, compareBuildingType)))
    baseProduction=0;
  if ((g==FISH || g==WHALE || g==CLAMS)&&(list_find(c->buildings, &bid2, compareBuildingType)))
     baseProduction = baseProduction*1.5;
  
  //TODO take into account how far from the city it is, colony size, etc.
 // int range    = getRangeForSize(c->size);

  switch (g) {
  case TOBACCO :
    if (map[x+MapWidth*(y)].vegetation>0)
      baseProduction = baseProduction*(1+map[x+MapWidth*(y)].vegetation/20);

    if (u->type==TOBACCOPLANTER)
      baseProduction = baseProduction*2;
    else if (u->type==FARMER || u->type==COTTONPLANTER || u->type==SUGARPLANTER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case COTTON :
    if (map[x+MapWidth*(y)].vegetation>0)
      baseProduction = baseProduction*(1+map[x+MapWidth*(y)].vegetation/20);

    if (u->type==COTTONPLANTER)
      baseProduction = baseProduction*2;
    else if (u->type==FARMER || u->type==TOBACCOPLANTER || u->type==SUGARPLANTER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case SUGAR :
    if (map[x+MapWidth*(y)].vegetation>0)
      baseProduction = baseProduction*(1+map[x+MapWidth*(y)].vegetation/20);

    if (u->type==SUGARPLANTER)
      baseProduction = baseProduction*2;
    else if (u->type==FARMER || u->type==TOBACCOPLANTER || u->type==COTTONPLANTER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case CORN :
  case RICE :
  case WHEAT :
    if (map[x+MapWidth*(y)].vegetation>0)
      baseProduction = baseProduction*(1+map[x+MapWidth*(y)].vegetation/20);

    if (u->type==FARMER || u->type==TOBACCOPLANTER || u->type==COTTONPLANTER || u->type==SUGARPLANTER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case CLAMS :
    baseProduction += getConnectedToCoast(x, y);

    if (u->type==FISHERMAN)
      baseProduction = baseProduction*1.2f;
      return (int)baseProduction;

  case FISH :
    baseProduction += getConnectedToCoast(x, y);

    if (u->type==FISHERMAN)
      baseProduction = baseProduction*1.5f;
      return (int)baseProduction;

  case WHALE :
    if (getConnectedToCoast(x, y)) //CHECK WATER TEMPERATURE
      baseProduction = 0;

    if (u->type==FISHERMAN)
      baseProduction = baseProduction*2.0f;
      return (int)baseProduction;

  case PEARL :
    if(!getConnectedToCoast(x, y) || map[x+MapWidth*(y)].river_elem==NULL)
      baseProduction = 0;
    
    if (u->type==FISHERMAN)
      baseProduction = baseProduction*2.0f;
      return (int)baseProduction;    
    
  case ORE :
    if (map[x+MapWidth*(y)].road>=ROAD)
      baseProduction = baseProduction*1.5f;

    if (u->type==OREMINER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case COAL :
    if (map[x+MapWidth*(y)].road>=ROAD)
      baseProduction = baseProduction*1.5f;

    if (u->type==OREMINER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case SILVER :
    if (map[x+MapWidth*(y)].road>=ROAD && baseProduction>0)
      baseProduction = baseProduction+1;

    if (u->type==SILVERMINER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case GOLD :
    if (map[x+MapWidth*(y)].road>=ROAD && baseProduction>0)
      baseProduction = baseProduction+1;

    if (u->type==SILVERMINER)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case LUMBER :
    if (map[x+MapWidth*(y)].road>=ROAD && map[x+MapWidth*(y)].vegetation<0)
      baseProduction+=2;

    if (u->type==LUMBERJACK)
      baseProduction = baseProduction*1.5f;
    return (int)baseProduction;

  case FUR :
    if (map[x+MapWidth*(y)].road>=ROAD && baseProduction>0)
      baseProduction+=1;

    if (u->type==FURTRAPPER)
      baseProduction = baseProduction*1.5f;

    return (int)baseProduction;
  }
  return NONE;
}// computeOutsideProduction() --------------------------------------------------------------------


/**
 * return what status would produce such good
 */
int getStatusForGood(int goodtype) {
  switch (goodtype) {
    case  CORN    :
      return CORNING;
    case  FISH    :
      return FISHING;      
    case  TOBACCO    :
      return TOBACCOTING;
    case  COTTON    :
      return COTTONING;
    case  SUGAR    :
      return SUGARING;
    case  FUR    :
      return FURING;
    case  LUMBER    :
      return LUMBERJACKING;
    case  ORE    :
      return OREING;
    case  COAL    :
      return COALING;
    case  SILVER    :
      return SILVERING;
    case  GOLD    :
      return GOLDING;
    case GRAPE:
      return GRAPEING;
    case HERBS:
      return HERBING;
    case SPICE:
      return SPICING;
    case SALTPETRE:
      return SALTPETERING;
    case GEM:
      return GEMING;
    case OIL:
      return OILING;
    case RICE:
      return RICING;
    case HEMP:
      return HEMPING;
    case STONE:
      return STONING;
    case WHEAT:
      return WHEATING;
    case WHALE:
      return WHALEING;
    case CLAMS:
      return CLAMSING;
    case PEARL:
      return PEARLING;   
    case PIG:
      return PIGING;
    case COW:
      return COWING;
    case BUFFALO:
      return BUFFALOING;
    case SHEEP:
      return SHEEPING;         
  }
  return PRODUCING;
}//getStatusForGood()


/**
 * return the goods produced by the given activity
 **/
int getGoodsForStatus(int status) {
  switch (status) {
  case FISHING:
    return FISH;
  case CORNING:
    return CORN;
  case TOBACCOTING:
    return TOBACCO;
  case COTTONING:
    return COTTON;
  case SUGARING:
    return SUGAR;
  case FURING:
    return FUR;
  case LUMBERJACKING:
    return LUMBER;
  case OREING:
    return ORE;
  case COALING:
    return COAL;
  case SILVERING:
    return SILVER;
  case GOLDING:
    return GOLD;
  case GRAPEING:
    return GRAPE;
  case HERBING:
    return HERBS;
  case SPICING:
    return SPICE;
  case SALTPETERING:
    return SALTPETRE;
  case GEMING:
    return GEM;
  case OILING:
    return OIL;
  case RICING:
    return RICE;
  case HEMPING:
    return HEMP;
  case STONING:
    return STONE;
  case WHEATING:
    return WHEAT;
  case WHALEING:
    return WHALE;
  case CLAMSING:
    return CLAMS;
  case PEARLING:
    return PEARL;
  case PIGING:
    return PIG;
  case COWING:
    return COW;
  case BUFFALOING:
    return BUFFALO;
  case SHEEPING:
    return SHEEP;    
  }
  return NONE;
}// getGoodsForStatus() --------------------------------------------------------------------


/**
 * return the goods produced by harversting the given bonus
 **/
int getGoodForBonus(int bt) {
  switch (bt) {
  case PUREGOLD     :
    return GOLD;
  case PURESILVER   :
    return SILVER;
  case PRIMEFUR     :
    return FUR;
  case PRIMELUMBER  :
    return LUMBER;
  case PUREORE      :
    return ORE;
  case PURECOAL     :
    return COAL;
  case PRIMECORN    :
    return CORN;
  case PRIMETOBACCO :
    return TOBACCO;
  case PRIMECOTTON  :
    return COTTON;
  case PRIMESUGAR   :
    return SUGAR;
  case PRIMEOIL     :
    return OIL;
  case PRIMEFISH    :
    return FISH;
  case PRIMEWHALE    :
    return WHALE;
  case PRIMECLAMS    :
    return CLAMS;
  }
  return NONE;
}// getGoodForBonus() --------------------------------------------------------------------


/**
 * cities hold few numbers that can be recalculated (population, etc.)
 */
void updateCityNumbers(city *c){
  //printf("updateCityNumbers (%s)\n", c->name);
  int dx, dy, i=0, si=0;
  int range    = getRangeForSize(c->size);

  for (i=0; i<GOODS_NUMBER; i++)
    c->prod[i].quantity = 0;
  
  // go through the units working outside
  for (dx=-range; dx<=range; dx++) {
    for (dy=-range; dy<=range; dy++) {
      unit *u = c->dependencies[(dy+range)*(range*2+1)+(dx+range)];
      if (u!=NULL) {
        si++;
        int goodtype = getGoodsForStatus(u->status);
        if (goodtype!=NONE)
          c->prod[goodtype-FIRST_GOOD].quantity += computeOutsideProduction(c, u, goodtype, c->location->posX+dx, c->location->posY+dy);
      }
    }
  }
  
  int haveToEat = c->size*2;
  int consume = -1;
  // people need to eat !
  //printf("%i of %s haveToEat %i  \n", c->size, c->name, haveToEat);fflush(stdout);
  while (haveToEat>0 && consume!=0) {
    if (c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[WHEAT-FIRST_GOOD].quantity >=haveToEat){
        c->prod[WHEAT-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      } else {
        consume =  c->stocks[WHEAT-FIRST_GOOD].quantity;
        c->prod[WHEAT-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[CORN-FIRST_GOOD].quantity >=haveToEat){
        c->prod[CORN-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[CORN-FIRST_GOOD].quantity;
        c->prod[CORN-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[FISH-FIRST_GOOD].quantity >=haveToEat){
        c->prod[FISH-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[FISH-FIRST_GOOD].quantity;
        c->prod[FISH-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }        
    if (haveToEat>0 && 
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[CLAMS-FIRST_GOOD].quantity >=haveToEat){
        c->prod[CLAMS-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[CLAMS-FIRST_GOOD].quantity;
        c->prod[CLAMS-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }            
    if (haveToEat>0 && 
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[COW-FIRST_GOOD].quantity >=haveToEat){
        c->prod[COW-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[COW-FIRST_GOOD].quantity;
        c->prod[COW-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[SHEEP-FIRST_GOOD].quantity >=haveToEat){
        c->prod[SHEEP-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[SHEEP-FIRST_GOOD].quantity;
        c->prod[SHEEP-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[PIG-FIRST_GOOD].quantity >=haveToEat){
        c->prod[PIG-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[PIG-FIRST_GOOD].quantity;
        c->prod[PIG-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity){
      if (c->stocks[BUFFALO-FIRST_GOOD].quantity >=haveToEat){
        c->prod[BUFFALO-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[BUFFALO-FIRST_GOOD].quantity;
        c->prod[BUFFALO-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }        
  }

  lnode_t *ln = list_first(c->buildings);
  while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
    building *b = (building *)ln->list_data;
    lnode_t *ln2 = list_first(b->workers);
    while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
      unit *u = (unit *)ln2->list_data;
      si ++;
      if ( b->typeGoodsIn1==NONE || b->typeGoodsIn2==NONE || b->typeGoodsIn3==NONE) {
        int prod = computeInsideProduction(c, u, b);
        //printf("computeInsideProduction %i -> %i -> %i\n", b->type, prod, b->typeGoodsOut1);
        if (b->typeGoodsIn1!=NONE)
          c->prod[b->typeGoodsIn1-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsIn2!=NONE)
          c->prod[b->typeGoodsIn2-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsIn3!=NONE)
          c->prod[b->typeGoodsIn3-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsOut1!=NONE)
          c->prod[b->typeGoodsOut1-FIRST_GOOD].quantity+=prod;
      }
      ln2 = ln2->list_next;
    }
    ln = ln->list_next;
  }
  c->stocks[POPULATION-FIRST_GOOD].quantity = si;
}//updateCityNumbers()


/**
 * return if such building of the given type already exists in a given city
 */
building *isBuildingExist(city *c, int buildingType) {
  lnode_t *ln = list_first(c->buildings);
  while (ln!= NULL && ln!=&c->buildings->list_nilnode) {
    building *b = (building*)ln->list_data;
    if (b->type==buildingType) {
      return b;
    }
    ln = ln->list_next;
  }

  return NULL;
}// isBuildingExist() --------------------------------------------------------------------


/**
 * according to city type return if the given city
 */
int isGoodAvailable(int good, city *c){
  //printf("isGoodAvailable (%i, %s)\n", good, c->name);
  // all cities need stone and wood to be built .. and food to survive
  if (good==LUMBER || good==STONE || good==ORE || good==COAL || good==CORN || good==WHEAT || good==RICE || good==HEMP ||
      good==HORSE || good==MUSKET || good==TOOL || good==TEXTILE || good==LEATHER || good==GUNPOWDER || good==ROPE || good==BUILDING_STONE)
    return TRUE;

  if (c->type&AGRICULTURE_CITY &&
            (good==TOBACCO || good==COTTON || good==SUGAR || good==GRAPE||
             good==CIGAR   || good==CLOTH  || good==RUM   || good==WINE))
    return TRUE;

  if (c->type&FOREST_CITY &&
            (good==FUR  || good==SALTPETRE || good==HERBS    || good==SPICE ||
             good==COAT || good==GUNPOWDER || good==MEDECINE || good==DYES))
    return TRUE;

  if (c->type&MINE_CITY &&
            (good==OIL || good==SILVER || good==GOLD || good==GEM))
    return TRUE;

  if (c->type&FISHING_CITY &&
            (good==FISH || good==WHALE || good==CLAMS || good==PEARL))
    return TRUE;

  if (c->type&RAISING_CITY &&
            (good==COW || good==SHEEP || good==PIG || good==BUFFALO))
    return TRUE;

  return FALSE;
}// isGoodAvailable()


/**
 * update city production by computing how much work every worker do, starting with outside worker
 * At the same time we update the size number of the city
 */
void updateCityProduction(city *c) {
  int dx, dy;
  int range    = getRangeForSize(c->size);
  int si       = 0;
  cvneedUpdate = TRUE;

  updateCityConstruction(c);
  updateCityNumbers(c);

  // every city of he new world produces religion crosses
  c->stocks[CROSS-FIRST_GOOD].quantity += 1;

  //center tile always produce food
  // todo produce best other good
  c->stocks[CORN-FIRST_GOOD].quantity +=computeOutsideProduction(c, unitSample, CORN, c->location->posX, c->location->posY);
  
  // go through the units working outside
  for (dx=-range; dx<=range; dx++) {
    for (dy=-range; dy<=range; dy++) {
      unit *u = c->dependencies[(dy+range)*(range*2+1)+(dx+range)];
      if (u!=NULL) {
        si++;
        int goodtype = getGoodsForStatus(u->status);
        //printf("compute Outside Production %i -> %i in %s\n", u->status, goodtype, c->name);

        if (goodtype!=NONE)
          c->stocks[goodtype-FIRST_GOOD].quantity += computeOutsideProduction(c, u, goodtype, c->location->posX+dx, c->location->posY+dy);
      }
    }
  }

  lnode_t *ln = list_first(c->buildings);
  while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
    building *b = (building *)ln->list_data;
    lnode_t *ln2 = list_first(b->workers);
    while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
      unit *u = (unit *)ln2->list_data;
      si ++;
      if (b->typeGoodsIn1==NONE || b->typeGoodsIn2==NONE || b->typeGoodsIn3==NONE) {
        int prod = computeInsideProduction(c, u, b);
        if (b->typeGoodsIn1!=NONE && prod>c->stocks[b->typeGoodsIn1-FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn1-FIRST_GOOD].quantity;
        if ( b->typeGoodsIn2!=NONE && prod>c->stocks[b->typeGoodsIn2-FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn2-FIRST_GOOD].quantity;
        if (b->typeGoodsIn3!=NONE && prod>c->stocks[b->typeGoodsIn3-FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn3-FIRST_GOOD].quantity;
        if ( b->typeGoodsOut1!=NONE && c->stocks[b->typeGoodsOut1-FIRST_GOOD].quantity+prod > getMaxQuantity(c, b->typeGoodsOut1))
          prod = getMaxQuantity(c, b->typeGoodsOut1)-c->stocks[b->typeGoodsOut1-FIRST_GOOD].quantity+prod;
        
        //printf("computeInsideProduction %i -> %i -> %i\n", b->type, prod, b->typeGoodsOut1);
        if (b->typeGoodsIn1!=NONE)
          c->stocks[b->typeGoodsIn1-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsIn2!=NONE)
          c->stocks[b->typeGoodsIn2-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsIn3!=NONE)
          c->stocks[b->typeGoodsIn3-FIRST_GOOD].quantity-=prod;
        if (b->typeGoodsOut1!=NONE)
          c->stocks[b->typeGoodsOut1-FIRST_GOOD].quantity+=prod;
      }

      ln2 = ln2->list_next;
    }
    ln = ln->list_next;
  }

  if (si>c->size) {
    unit **olddep = c->dependencies;
    int range = getRangeForSize(si);
    int oldrange = getRangeForSize(c->size);
    c->dependencies    = (unit**)malloc ((2*range+1)*(2*range+1)*sizeof (unit*));
    int i, j;
    for (i=0; i<2*range+1; i++)
      for (j=0; j<2*range+1; j++)
        c->dependencies[j*(2*range+1)+i] = NULL;

    for (i=0; i<2*oldrange+1; i++)
      for (j=0; j<2*oldrange+1; j++) {
        int i2 = i+range-oldrange;
        int j2 = j+range-oldrange;
        c->dependencies[j2*(2*range+1)+i2] = olddep[j*(2*oldrange+1)+i];
      }
    c->size = si;
    free(olddep);
  }
  if (si<c->size){
    list_t *ul2 = list_create(LISTCOUNT_T_MAX);

    unit **olddep = c->dependencies;
    int range = getRangeForSize(si);
    int oldrange = getRangeForSize(c->size);
    c->dependencies    = (unit**)malloc ((2*range+1)*(2*range+1)*sizeof (unit*));
    int i, j;
    for (i=0; i<2*range+1; i++)
      for (j=0; j<2*range+1; j++)
        c->dependencies[j*(2*range+1)+i] = NULL;

    for (i=0; i<2*oldrange+1; i++)
      for (j=0; j<2*oldrange+1; j++) {
        int i2 = i+range-oldrange;
        int j2 = j+range-oldrange;
        if (olddep[j*(2*oldrange+1)+i]!=NULL && j2>=0 && j2<2*range+1 && i2>=0 && i2<2*range+1) {
          c->dependencies[j2*(2*range+1)+i2] = olddep[j*(2*oldrange+1)+i];
        } else if (olddep[j*(2*oldrange+1)+i]!=NULL)
          list_append(ul2, lnode_create(olddep[j*(2*oldrange+1)+i]));
      }
    c->size = si;
    free(olddep);
    if (list_count(ul2)>0) {
      printf(" TODO: move %i unit not in the new city range to an other building or tile of %s\n", list_count(ul2), c->name);
      lnode_t *ln = list_first(ul2);
      while (ln !=  &ul2->list_nilnode) {
        unit *u = (unit *)ln->list_data;
        int res = findBestJob(u, c);
        if (!res) {
          if (map[c->location->posX+MapWidth*(c->location->posY)].unitList==NULL)
            map[c->location->posX+MapWidth*(c->location->posY)].unitList = list_create(LISTCOUNT_T_MAX);
          list_append(map[c->location->posX+MapWidth*(c->location->posY)].unitList, lnode_create(u));
          u->location = &map[c->location->posX+MapWidth*(c->location->posY)];
          u ->status = WAITING;
        }
        ln = ln->list_next;
      }
    }
  }
  updateCityConstruction(c);
  
  // national market
  ln = list_first(c->connectedCities);
  while (ln!=NULL && ln !=  &c->connectedCities->list_nilnode) {
    city *c2 = (city *)ln->list_data;
    for (dx=0; dx<GOODS_NUMBER; dx++) {
      if (isGoodAvailable(FIRST_GOOD+dx, c) && isGoodAvailable(FIRST_GOOD+dx, c2)){
        int maxc1 = getMaxQuantity(c, FIRST_GOOD+dx);
        int maxc2 = getMaxQuantity(c2, FIRST_GOOD+dx);
        if (FIRST_GOOD+dx==LUMBER && c->owner==currentPlayerElement->list_data && c2->owner==currentPlayerElement->list_data)
          printf("%s and %s could  exchange %s   %i/%i(+%i) - %i/%i(+%i) \n", c->name, c2->name, getGoodText(&c->stocks[dx]), c->stocks[dx].quantity, maxc1, c->prod[dx].quantity, c2->stocks[dx].quantity, maxc2, c2->prod[dx].quantity);fflush(stdout);
        if (c->owner==c2->owner && c->stocks[dx].quantity<20 && c->prod[dx].quantity<0 && c2->stocks[dx].quantity>=60) {
          printf("   AND exchanged %s \n", getGoodText(&c->stocks[dx]));fflush(stdout);
          c->stocks[dx].quantity += 20;
          c2->stocks[dx].quantity -= 20;
        }
      }
    }
    
    ln = ln->list_next;
  }
  
  updateCityStock(c);  
  
  int haveToEat = c->size*2;
  int consume = -1;
  // people need to eat !
  //printf("%i of %s haveToEat %i  \n", c->size, c->name, haveToEat);fflush(stdout);
  while (haveToEat>0 && consume!=0) {
    if (c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[WHEAT-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[WHEAT-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[WHEAT-FIRST_GOOD].quantity -=haveToEat;
        c->prod[WHEAT-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      } else {
        consume =  c->stocks[WHEAT-FIRST_GOOD].quantity;
        c->stocks[WHEAT-FIRST_GOOD].quantity = 0;
        c->prod[WHEAT-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[CORN-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[CORN-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[CORN-FIRST_GOOD].quantity -=haveToEat;
        c->prod[CORN-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[CORN-FIRST_GOOD].quantity;
        c->stocks[CORN-FIRST_GOOD].quantity = 0;
        c->prod[CORN-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[FISH-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[FISH-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[FISH-FIRST_GOOD].quantity -=haveToEat;
        c->prod[FISH-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[FISH-FIRST_GOOD].quantity;
        c->stocks[FISH-FIRST_GOOD].quantity = 0;
        c->prod[FISH-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }        
    if (haveToEat>0 && 
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[CLAMS-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[CLAMS-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[CLAMS-FIRST_GOOD].quantity -=haveToEat;
        c->prod[CLAMS-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[CLAMS-FIRST_GOOD].quantity;
        c->stocks[CLAMS-FIRST_GOOD].quantity = 0;
        c->prod[CLAMS-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }            
    if (haveToEat>0 && 
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[COW-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[COW-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[COW-FIRST_GOOD].quantity -=haveToEat;
        c->prod[COW-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[COW-FIRST_GOOD].quantity;
        c->stocks[COW-FIRST_GOOD].quantity = 0;
        c->prod[COW-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[SHEEP-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[SHEEP-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[SHEEP-FIRST_GOOD].quantity -=haveToEat;
        c->prod[SHEEP-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[SHEEP-FIRST_GOOD].quantity;
        c->stocks[SHEEP-FIRST_GOOD].quantity = 0;
        c->prod[SHEEP-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity &&
        c->stocks[PIG-FIRST_GOOD].quantity >= c->stocks[BUFFALO-FIRST_GOOD].quantity){
      if (c->stocks[PIG-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[PIG-FIRST_GOOD].quantity -=haveToEat;
        c->prod[PIG-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[PIG-FIRST_GOOD].quantity;
        c->stocks[PIG-FIRST_GOOD].quantity = 0;
        c->prod[PIG-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }
    if (haveToEat>0 && 
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[WHEAT-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[CORN-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[FISH-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[CLAMS-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[SHEEP-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[PIG-FIRST_GOOD].quantity &&
        c->stocks[BUFFALO-FIRST_GOOD].quantity >= c->stocks[COW-FIRST_GOOD].quantity){
      if (c->stocks[BUFFALO-FIRST_GOOD].quantity >=haveToEat){
        c->stocks[BUFFALO-FIRST_GOOD].quantity -=haveToEat;
        c->prod[BUFFALO-FIRST_GOOD].quantity -=haveToEat;
        consume   = haveToEat;
        haveToEat = 0;
      }else {
        consume =  c->stocks[BUFFALO-FIRST_GOOD].quantity;
        c->stocks[BUFFALO-FIRST_GOOD].quantity = 0;
        c->prod[BUFFALO-FIRST_GOOD].quantity -=consume;
        haveToEat-=consume;
      }
    }        
    
        
  }
}// updateCityProduction() --------------------------------------------------------------------


/**
 * return the text in english for the given building
 */
char *getBuildingTextFromType(int type) {
  if (type>=FIRST_BUILDING && type<=LAST_BUILDING)
    return buildingTexts[type-FIRST_BUILDING];
  else
    return NULL;  
}// getBuildingTextFromType() --------------------------------------------------------------------


/**
 * return the text in english for the given building
 */
char *getBuildingText(building *b) {
  return getBuildingTextFromType(b->type);
}// getBuildingText() --------------------------------------------------------------------


/**
 * open the city view panel on the given city
 */
void openCityView(city *c){
  //unitSelectionList    = defaultSelectionList;
  //list_destroy_nodes(unitSelectionList);

  int range = getRangeForSize(c->size);

  if (c->location->posX-range<=firstVisibleTileX ||
      c->location->posX-range>firstVisibleTileX+screen->w/TILESIZE ||
      c->location->posY-range<=firstVisibleTileY ||
      c->location->posY-range>firstVisibleTileY+screen->h/TILESIZE)
    panToCenter(c->location);

  updateCityNumbers(c);
  cityViewRect->w = (2+2*range)*TILESIZE;
  cityViewRect->h = (1+2*range)*TILESIZE+BUILDING_BAR_HEIGHT+RAW_GOODS_BAR_HEIGHT+REFINED_GOOGD_BAR_HEIGHT+TITLE_BAR_HEIGHT;
  cityViewRect->x = (c->location->posX - range-firstVisibleTileX)*TILESIZE;
  cityViewRect->y = (c->location->posY - range-firstVisibleTileY)*TILESIZE;
  if (cityViewRect->x<0)
    cityViewRect->x = 0;
  if (cityViewRect->y<0)
    cityViewRect->y = 0;
  if (cityViewRect->x+cityViewRect->w>=screen->w)
    cityViewRect->x = screen->w-cityViewRect->w;
  if (cityViewRect->y+cityViewRect->h>=screen->h)
    cityViewRect->y = screen->h-cityViewRect->h;
  selectedCity = c;
  cvneedUpdate = TRUE;
}// openCityView()


/**
 * display the city view
 **/
void displayCityView(city* c) {
  //printf("\ndisplayCityView %p %p   %i*%i\n", cvbuffer, cvshadowbuffer, cityViewRect->w, cityViewRect->h);
  SDL_Color *col = nationColors[c->owner->nation-FIRST_NATION];
  int r1 = (int)(col->r*0.75);
  if (r1>255) r1=255;
  int g1 = (int)(col->g*0.75);
  if (g1>255) g1=255;
  int b1 = (int)(col->b*0.75);
  if (b1>255) b1=255;

  int r2 = (int)(col->r*1.25);
  if (r2>255) r2=255;
  int g2 = (int)(col->g*1.25);
  if (g2>255) g2=255;
  int b2 = (int)(col->b*1.25);
  if (b2>255) b2=255;

  if (cvbuffer!=NULL && (cityViewRect->w!=cvbuffer->w || cityViewRect->h!=cvbuffer->h)){
    //printf("  test %i / %i or %i / %i\n", cityViewRect->w,cvbuffer->w ,cityViewRect->h,cvbuffer->h);
    SDL_FreeSurface(cvbuffer);
    cvbuffer = NULL;
  }

  if (cvbuffer==NULL){
    cvbuffer       = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, cityViewRect->w, cityViewRect->h, screen->format->BitsPerPixel,
                                          screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0xFF000000);
    if (cvshadowbuffer!=NULL) {
      SDL_FreeSurface(cvshadowbuffer);
      cvshadowbuffer = NULL;
    }
    //printf("creating surface for city view ... masks=%x %x %x %x\n", cvbuffer->format->Rmask, cvbuffer->format->Gmask, cvbuffer->format->Bmask, cvbuffer->format->Amask);
    cvneedUpdate = TRUE;
  }
  //printf(" after %p %p\n", cvbuffer, cvshadowbuffer);
  //int a0 = FALSE;
  //int b0 = FALSE;
  //int c0 = FALSE;
  //int d0 = FALSE;
  // manhattan line
  //if ((c->location->posX-firstVisibleTileX)*TILESIZE<cityViewRect->x || (c->location->posX-firstVisibleTileX)*TILESIZE>cityViewRect->x+cityViewRect->w ||
  //    (c->location->posY-firstVisibleTileY)*TILESIZE<cityViewRect->y || (c->location->posY-firstVisibleTileY)*TILESIZE>cityViewRect->y+cityViewRect->h) {
  //  a0 = TRUE;
    aalineRGBA(screen, cityViewRect->x, cityViewRect->y, (c->location->posX-firstVisibleTileX)*TILESIZE, (c->location->posY-firstVisibleTileY)*TILESIZE, 255, 250, 150, 255);
  //}
  //if ((c->location->posX-firstVisibleTileX+1)*TILESIZE<cityViewRect->x || (c->location->posX-firstVisibleTileX+1)*TILESIZE>cityViewRect->x+cityViewRect->w ||
  //    (c->location->posY-firstVisibleTileY)*TILESIZE<cityViewRect->y || (c->location->posY-firstVisibleTileY)*TILESIZE>cityViewRect->y+cityViewRect->h) {
  //  b0 = TRUE;
    aalineRGBA(screen, cityViewRect->x+cityViewRect->w, cityViewRect->y, (c->location->posX-firstVisibleTileX+1)*TILESIZE, (c->location->posY-firstVisibleTileY)*TILESIZE, 255, 250, 150, 255);
  //}
  //if ((c->location->posX-firstVisibleTileX)*TILESIZE<cityViewRect->x || (c->location->posX-firstVisibleTileX)*TILESIZE>cityViewRect->x+cityViewRect->w ||
  //    (c->location->posY-firstVisibleTileY+1)*TILESIZE<cityViewRect->y || (c->location->posY-firstVisibleTileY+1)*TILESIZE>cityViewRect->y+cityViewRect->h) {
  //  c0 = TRUE;
    aalineRGBA(screen, cityViewRect->x, cityViewRect->y+cityViewRect->h, (c->location->posX-firstVisibleTileX)*TILESIZE, (c->location->posY-firstVisibleTileY+1)*TILESIZE, 255, 250, 150, 255);
  //}
  //if ((c->location->posX-firstVisibleTileX+1)*TILESIZE<cityViewRect->x || (c->location->posX-firstVisibleTileX+1)*TILESIZE>cityViewRect->x+cityViewRect->w ||
  //    (c->location->posY-firstVisibleTileY+1)*TILESIZE<cityViewRect->y || (c->location->posY-firstVisibleTileY+1)*TILESIZE>cityViewRect->y+cityViewRect->h) {
  //  d0 = true;
    aalineRGBA(screen, cityViewRect->x+cityViewRect->w, cityViewRect->y+cityViewRect->h, (c->location->posX-firstVisibleTileX+1)*TILESIZE, (c->location->posY-firstVisibleTileY+1)*TILESIZE, 255, 250, 150, 255);
  //}
  Sint16 vx[4];
  Sint16 vy[4];
  //if (a0&&b0) {
    vx[0]= cityViewRect->x;
    vy[0]= cityViewRect->y;
    vx[1]= (c->location->posX-firstVisibleTileX)*TILESIZE;
    vy[1]= (c->location->posY-firstVisibleTileY)*TILESIZE;
    vx[2]= (c->location->posX-firstVisibleTileX+1)*TILESIZE;
    vy[2]= (c->location->posY-firstVisibleTileY)*TILESIZE;
    vx[3]= cityViewRect->x+cityViewRect->w;
    vy[3]= cityViewRect->y;
    filledPolygonRGBA(screen, vx, vy, 4, r2, g2, b2, 96);
  //}
  //if (a0&&c0) {
    vx[0]= cityViewRect->x;
    vy[0]= cityViewRect->y;
    vx[1]= (c->location->posX-firstVisibleTileX)*TILESIZE;
    vy[1]= (c->location->posY-firstVisibleTileY)*TILESIZE;
    vx[2]= (c->location->posX-firstVisibleTileX)*TILESIZE;
    vy[2]= (c->location->posY-firstVisibleTileY+1)*TILESIZE;
    vx[3]= cityViewRect->x;
    vy[3]= cityViewRect->y+cityViewRect->h;
    filledPolygonRGBA(screen, vx, vy, 4, r2, g2, b2, 96);
  //}
  //if (c0&&d0) {
    vx[0]= cityViewRect->x;
    vy[0]= cityViewRect->y+cityViewRect->h;
    vx[1]= (c->location->posX-firstVisibleTileX)*TILESIZE;
    vy[1]= (c->location->posY-firstVisibleTileY+1)*TILESIZE;
    vx[2]= (c->location->posX-firstVisibleTileX+1)*TILESIZE;
    vy[2]= (c->location->posY-firstVisibleTileY+1)*TILESIZE;
    vx[3]= cityViewRect->x+cityViewRect->w;
    vy[3]= cityViewRect->y+cityViewRect->h;
    filledPolygonRGBA(screen, vx, vy, 4, r2, g2, b2, 96);
  //}
  //if (b0&&d0) {
    vx[0]= cityViewRect->x+cityViewRect->w;
    vy[0]= cityViewRect->y;
    vx[1]= (c->location->posX-firstVisibleTileX+1)*TILESIZE;
    vy[1]= (c->location->posY-firstVisibleTileY)*TILESIZE;
    vx[2]= (c->location->posX-firstVisibleTileX+1)*TILESIZE;
    vy[2]= (c->location->posY-firstVisibleTileY+1)*TILESIZE;
    vx[3]= cityViewRect->x+cityViewRect->w;
    vy[3]= cityViewRect->y+cityViewRect->h;
    filledPolygonRGBA(screen, vx, vy, 4, r2, g2, b2, 96);
  //}

  SDL_Rect *innerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  innerRect->x = 0;
  innerRect->y = 0;
  innerRect->w = cityViewRect->w;
  innerRect->h = cityViewRect->h;
  SDL_Rect *rect      = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *rect2     = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  if (cvneedUpdate) {
    SDL_FillRect(cvbuffer, innerRect, 0x00000000);
    int range = getRangeForSize(c->size);
    int x = c->location->posX;
    int y = c->location->posY;
    int dx, dy;
    char* text = (char*)malloc(50);
    int k;

    //boxRGBA(cvbuffer, 0, 0, cityViewRect->w, cityViewRect->h, 32, 20, 25, 255);

    // tiles
    //circleColor(cvbuffer, innerRect->x+((2*range+1)*TILESIZE)/2+TILESIZE/2, TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)/2, range*TILESIZE, 0x666666);
    for (dx=-range; dx<=range; dx++) {
      for (dy=-range; dy<=range; dy++){
        float d = sqrt((float)(dx*dx+dy*dy))-0.5;
        rect->w = TILESIZE;
        rect->h = TILESIZE;
        rect->x = innerRect->x+((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
        rect->y = innerRect->y+TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;
        if (d<=range && y+dy>=0 &&x+dx>=0 && x+dx<MapWidth && y+dy<MapWidth){
          //SDL_FillRect(cvbuffer, rect, SDL_MapRGB(cvbuffer->format, 255, 255, 255));
          // this tile is not actually displayed on the map !
          if (x+dx<firstVisibleTileX || x+dx>=firstVisibleTileX+screen->w/TILESIZE || y+dy<firstVisibleTileY || y+dy>=firstVisibleTileY+screen->h/TILESIZE) {
            updatesImageTile(x+dx, y+dy, helperTile, TRUE);
            SDL_BlitSurface(helperTile, 0, cvbuffer, rect);
          } else {
            SDL_Surface *tc = getTileCache(x+dx,y+dy);
            if (c->dependencies[(dy+range)*(range*2+1)+(dx+range)]!=NULL)
              SDL_BlitSurface(tc, 0, cvbuffer, rect);
            else
              SDL_BlitSurfacePastel(tc, 0, cvbuffer, rect, 64); 
          }
        }
      }
    }
    // grid
    for (dx=-range; dx<=range; dx++) {
      for (dy=-range; dy<=range; dy++){
        float d = sqrt((float)(dx*dx+dy*dy))-0.5;
        rect->w = TILESIZE;
        rect->h = TILESIZE;
        rect->x = innerRect->x+((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
        rect->y = TITLE_BAR_HEIGHT+innerRect->y+((range)*TILESIZE)+dy*TILESIZE;
        if (d<=range && y+dy>=0 &&x+dx>=0 && x+dx<MapWidth && y+dy<MapWidth){
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y, 192, 192, 192, 255);
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y+rect->h-1, 64, 64, 64, 255);
          vlineRGBA(cvbuffer, rect->x,         rect->y,   rect->y+rect->h-1, 192, 192, 192, 255);
          vlineRGBA(cvbuffer, rect->x+rect->w-1, rect->y, rect->y+rect->h-1, 64, 64, 64, 255);
        }
      }
    }        

    // title bar
    rect->x = innerRect->x;
    rect->y = innerRect->y;
    rect->w = innerRect->w;
    rect->h = TITLE_BAR_HEIGHT;
    vgradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h/2,           r1, g1, b1, 255, r2, g2, b2, 255);
    vgradientboxRGBA(cvbuffer, rect->x, rect->y+rect->h/2, rect->w, rect->h/2, r2, g2, b2, 255, r1, g1, b1, 255);
    // SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, col->r, col->g, col->b ));

    SDL_Surface *miniflag = nationMiniFlags[c->owner->nation-FIRST_NATION];
    if (miniflag!=NULL){
      rect->x+=1;
      SDL_BlitSurface(miniflag, 0, cvbuffer, rect);
      rect->x+=cvbuffer->w-miniflag->w-2;
      SDL_BlitSurface(miniflag, 0, cvbuffer, rect);
    }
    // background
    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+1;
    rect->w = innerRect->w;
    rect->h = BUILDING_BAR_HEIGHT/4;
    //SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, 135, 206, 250));
    vgradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 135, 206, 250, 255, 220, 220, 255, 255);

    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT/4;
    rect->w = innerRect->w;
    rect->h = 3*BUILDING_BAR_HEIGHT/4;
    vgradientboxRGBANoise(cvbuffer, rect->x, rect->y, rect->w, rect->h, 202, 184, 155, 255, 180, 144, 95, 255, 10);
    //SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, 222, 184, 135));

    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE;
    rect->w = innerRect->w;
    rect->h = TILESIZE/2;
    SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, 32, 20, 25));
    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT;
    rect->w = innerRect->w;
    rect->h = TILESIZE/2;
    SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, 32, 20, 25));

    // ground grid in pseudo perspective
    for (dx=1; dx<=(innerRect->w+6*BUILDING_BAR_HEIGHT/4)/GRIDSPACE; dx++)
      lineRGBA(cvbuffer , innerRect->x+dx*GRIDSPACE,                         innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT/4,
                          innerRect->x+dx*GRIDSPACE-6*BUILDING_BAR_HEIGHT/4, innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT, 76, 103, 125, 255);
    for (dx=-(6*BUILDING_BAR_HEIGHT/4)/GRIDSPACE; dx<=innerRect->w/GRIDSPACE; dx++)
      lineRGBA(cvbuffer , innerRect->x+dx*GRIDSPACE,                         innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT/4,
                          innerRect->x+dx*GRIDSPACE+6*BUILDING_BAR_HEIGHT/4, innerRect->y+TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT, 76, 103, 125, 255);

    // few trees in the background to decorate
    srand(map[c->location->posX+MapWidth*(c->location->posY)].seed);
    for (dx=1; dx<innerRect->w; dx+=8){
      int i = rand()%TREE_NUMBER;
      rect->x = innerRect->x+dx;
      rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2+BUILDING_BAR_HEIGHT/4+3-treeImages[i]->h;      
      SDL_BlitSurface(treeImages[i] , 0, cvbuffer, rect);
    }
    
    // display raw goods coming from outside the city
    //int availableRawGoods = 4*range+2;
    int innerSpace = 0;
    //if (availableRawGoods>RAW_GOODS_NUMBER) {
    //  availableRawGoods=RAW_GOODS_NUMBER;
    //  innerSpace = (innerRect->w - availableRawGoods*TILESIZE/2)/RAW_GOODS_NUMBER;
    //}
    rect->x = innerRect->x;
    for (dx=0; dx<RAW_GOODS_NUMBER; dx++) {
      rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE);
      //printf("isGoodAvailable %i => %i\n", FIRST_RAW_GOOD+dx, isGoodAvailable(FIRST_RAW_GOOD+dx, c));
      if (isGoodAvailable(FIRST_RAW_GOOD+dx, c)){
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        // highlight selected goods
        if (dx==selectedGood){
          boxRGBA(cvbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 128, 128, 0, 255);
          //vgradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 192, 192, 255, 255, 128, 128, 0, 255);
          diamondRGBA(cvbuffer, rect->x, rect->y-GRIDSPACE/4, GRIDSPACE, GRIDSPACE/2, 128, 128, 0, 255);
          diamondRGBA(cvbuffer, rect->x, rect->y+TILESIZE/2-GRIDSPACE/4, GRIDSPACE, GRIDSPACE/2, 128, 128, 0, 255);
        } else
          d1gradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);

        if (dragGood!=NULL && dx==dragGood->type-FIRST_GOOD)
          SDL_BlitSurfaceBW(goodsImages[dx], 0, cvbuffer, rect, 196, FALSE);
        else
          SDL_BlitSurface(goodsImages[dx], 0, cvbuffer, rect);
        sprintf(text, "%i", c->stocks[dx].quantity);
        TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x+=3;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
        rect->x--;
        rect->y--;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        rect->x-=2;
        rect->y++;
        SDL_FreeSurface(imgText);
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        if (dx!=selectedGood) {
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w, rect->y, 192, 192, 192, 128);
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w, rect->y+rect->h, 64, 64, 64, 128);
          vlineRGBA(cvbuffer, rect->x,         rect->y,   rect->y+rect->h, 192, 192, 192, 128);
          vlineRGBA(cvbuffer, rect->x+rect->w, rect->y, rect->y+rect->h, 64, 64, 64, 128);
        }
        
        player *player0 = (player*)currentPlayerElement->list_data;        
        if ((c->owner==player0 || gamemode==EDIT)) {
          SDL_Color *color = &GREEN;
          if (c->prod[dx].quantity>0) {
            int prod = c->prod[dx].quantity;
            if (c->stocks[dx].quantity+c->prod[dx].quantity>getMaxQuantity(c, FIRST_GOOD+dx)) {
              prod = getMaxQuantity(c, FIRST_GOOD+dx) - c->stocks[dx].quantity;
              color = &ORANGE;
            }
            if (prod==0) color=&RED;
            sprintf(text, "+%i", prod);
          }
          else if (c->prod[dx].quantity<0) {
            int prod = c->prod[dx].quantity;
            if (c->stocks[dx].quantity+c->prod[dx].quantity<0){
              prod = -c->stocks[dx].quantity;
              color = &ORANGE;
            }
            if (prod==0) color=&RED;
            sprintf(text, "-%i", abs(prod));
          }
          
          if (c->prod[dx].quantity!=0){
            TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
            imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
            rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
            rect->x += TILESIZE/2-imgText->w-2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x+=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y+=2;
            SDL_FreeSurface(imgText);
            rect->x--;
            rect->y--;
            imgText = TTF_RenderText_Blended(fonts[10], text, *color);
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x -= TILESIZE/2-imgText->w-2-1;
            SDL_FreeSurface(imgText);
          }
        } else if (player0->diplomaticRelations[c->owner->nation-FIRST_NATION]<=UPSET){
          // display prices for buy and sell stuff in this city
          int pr = getBuyPriceFor(FIRST_GOOD+dx, c, player0);
          if (pr>0)
            sprintf(text, "%i", pr);
          else
            sprintf(text, "-");
          
          TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
          //rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
          rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2-11;
          rect->x += TILESIZE/2-imgText->w-2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x+=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y+=2;
          SDL_FreeSurface(imgText);
          rect->x--;
          rect->y--;
          imgText = TTF_RenderText_Blended(fonts[10], text, YELLOW);
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x -= TILESIZE/2-imgText->w-2-1;
          SDL_FreeSurface(imgText);
          
          pr = getSellPriceFor(FIRST_GOOD+dx, c, player0);
          if (pr>0)
            sprintf(text, "%i", pr);
          else
            sprintf(text, "-");
          
          TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
          //rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
          rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2-22;
          rect->x += TILESIZE/2-imgText->w-2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x+=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y+=2;
          SDL_FreeSurface(imgText);
          rect->x--;
          rect->y--;
          imgText = TTF_RenderText_Blended(fonts[10], text, RED);
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x -= TILESIZE/2-imgText->w-2-1;
          SDL_FreeSurface(imgText);          
        }
        rect->x += TILESIZE/2;
      }
    }

    // display relevant buildings available in this city
    lnode_t *ln = list_first(c->buildings);
    rect->x = innerRect->x;
    rect->y = TITLE_BAR_HEIGHT+TILESIZE/2+innerRect->y+((2*range+1)*TILESIZE);
    while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
      building *b = (building *)ln->list_data;
      //printf("building %s = %i:%i:%i\n", text, b->typeGoodsIn1, b->typeGoodsIn2, b->typeGoodsIn3);
      if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
          b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood) {
        SDL_Surface *buildingImg = getBuildingImage(b);
        int dy = BUILDING_BAR_HEIGHT-GRIDSPACE/2-buildingImg->h;
        if (b->slots==0)
          dy = BUILDING_BAR_HEIGHT-buildingImg->h;
        if (b->typeGoodsIn1==FISH || b->typeGoodsIn2==FISH || b->typeGoodsIn3==FISH)
          rect->x = innerRect->x+innerRect->w-buildingImg->w;
        rect->y += dy;
        SDL_BlitSurface(buildingImg, 0, cvbuffer, rect);
        rect->y -= dy;
        // display unit slots where user can drop workers
        for (k=0; k<b->slots; k++) {
          if (k<list_count(b->workers))
            diamondRGBA(cvbuffer, rect->x+k*GRIDSPACE+GRIDSPACE/2, rect->y-2+BUILDING_BAR_HEIGHT-GRIDSPACE/2+3, GRIDSPACE, GRIDSPACE/2, 255, 50, 50, 255);
          else if (cvDrag == NEWCOMER || cvDrag == OUTWORKER || cvDrag == INWORKER)
            diamondRGBA(cvbuffer, rect->x+k*GRIDSPACE+GRIDSPACE/2, rect->y-2+BUILDING_BAR_HEIGHT-GRIDSPACE/2+3, GRIDSPACE, GRIDSPACE/2, 50, 255, 50, 255);
          else
            diamondRGBA(cvbuffer, rect->x+k*GRIDSPACE+GRIDSPACE/2, rect->y-2+BUILDING_BAR_HEIGHT-GRIDSPACE/2+3, GRIDSPACE, GRIDSPACE/2, 50, 50, 255, 255);
        }
        TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[14], getBuildingText(b), BLACK);
        rect->x+=2;
        rect->y+=2;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[14], getBuildingText(b), WHITE);
        rect->x-=1;
        rect->y-=1;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        rect->x-=1;
        rect->y-=1;
        SDL_FreeSurface(imgText);

        int prod = 0;
        // display units working in their building
        lnode_t *ln2 = list_last(b->workers);
        rect2->x = rect->x+list_count(b->workers)*GRIDSPACE+GRIDSPACE/2;
        while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
          rect2->x -= GRIDSPACE;
          unit *u = (unit *)ln2->list_data;
          prod += computeInsideProduction(c, u, b);
          SDL_Surface *unitImg = getUnitImage(u);
          rect2->y = rect->y+BUILDING_BAR_HEIGHT-unitImg->h-2;
          if (u==dragUnit)
            SDL_BlitSurfaceBW(unitImg, 0, cvbuffer, rect2, 196, FALSE);
          else
            SDL_BlitSurface(unitImg, 0, cvbuffer, rect2);
          ln2 = ln2->list_prev;
        }
        
        // limited production !
        if (b->typeGoodsIn1!=NONE && prod > c->stocks[b->typeGoodsIn1-FIRST_GOOD].quantity+c->prod[b->typeGoodsIn1-FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn1-FIRST_GOOD].quantity;
        if (b->typeGoodsIn2!=NONE && prod>c->stocks[b->typeGoodsIn2-FIRST_GOOD].quantity+c->prod[b->typeGoodsIn2-FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn2-FIRST_GOOD].quantity;
        if (b->typeGoodsIn3!=NONE && prod>c->stocks[b->typeGoodsIn3-FIRST_GOOD].quantity+c->prod[b->typeGoodsIn3 -FIRST_GOOD].quantity)
          prod = c->stocks[b->typeGoodsIn3-FIRST_GOOD].quantity;
        if (b->typeGoodsOut1!=NONE && prod+c->stocks[b->typeGoodsOut1-FIRST_GOOD].quantity>getMaxQuantity(c,b->typeGoodsOut1))
          prod = getMaxQuantity(c,b->typeGoodsOut1)-c->stocks[b->typeGoodsOut1-FIRST_GOOD].quantity;
        
        SDL_Surface *goodImg = goodsImages[b->typeGoodsOut1-FIRST_GOOD];
        if (b->typeGoodsOut1!=NONE) {
          rect2->x = rect->x+b->slots*GRIDSPACE;
          rect2->y = rect->y+BUILDING_BAR_HEIGHT-goodImg->h-2;
          int k;

          // building production
          float rem = (float)(BUILDING_BAR_HEIGHT - goodImg->h)/prod;
          if (rem>5) rem=5;
          for (k=0; k<prod; k++) {
            rect2->y = rect->y+BUILDING_BAR_HEIGHT-goodImg->h-2-(int)(rem*k);
            SDL_BlitSurface(goodImg, 0, cvbuffer, rect2);
            rect2->x -=(k%2)*16-8;
          }
          rect2->y = rect->y+BUILDING_BAR_HEIGHT-goodImg->h-2;
          if (list_count(b->workers)>0) {
            sprintf(text, "+%i", prod);
            TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
            imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
            rect2->x += goodImg->w/2-imgText->w/2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect2);
            SDL_FreeSurface(imgText);
            rect2->x--;
            rect2->y--;
            imgText = TTF_RenderText_Blended(fonts[12], text, YELLOW);
            SDL_BlitSurface(imgText, 0, cvbuffer, rect2);
            rect2->x -= goodImg->w/2-imgText->w/2-1;
            rect2->y++;
            SDL_FreeSurface(imgText);
          }
        }

        // building making buildings
        if (b->typeGoodsOut1==HAMMER) {
          rect2->x = rect->x+2;
          rect2->y = rect->y+32;
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {
            //SDL_Surface *s = buildingImages[c->construction-FIRST_BUILDING];
            //SDL_BlitSurface(s, 0, cvbuffer, rect);
            strcpy(text, getBuildingTextFromType(c->construction));
          } else {
            sprintf(text, "NOTHING");
          }
          TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
          rect2->w = imgText->w+4;
          rect2->h = imgText->h+4;
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {//
            rect2->w += buildingIconImages[c->construction-FIRST_BUILDING]->w+2; //
            if (buildingIconImages[c->construction-FIRST_BUILDING]->h > rect2->h)
              rect2->h = buildingIconImages[c->construction-FIRST_BUILDING]->h+4; 
          }

          /*if (isAboutToChangeConstruction)
            boxRGBA(cvbuffer, rect2->x, rect2->y, rect2->x+rect2->w, rect2->y+rect2->h, 255, 64, 32, 255);
          else
            boxRGBA(cvbuffer, rect2->x, rect2->y, rect2->x+rect2->w, rect2->y+rect2->h, 64, 64, 32, 255);*/
          if (isAboutToChangeConstruction)
            d1gradientboxRGBA(cvbuffer, rect2->x, rect2->y, rect2->w, rect2->h, 96, 96, 32, 255, 192, 192, 32, 255);
          else
            vgradientboxRGBA(cvbuffer, rect2->x, rect2->y, rect2->w, rect2->h, 64, 64, 32, 255, 32, 32, 16, 255);
          
          rectangleRGBA(cvbuffer, rect2->x, rect2->y, rect2->x+rect2->w, rect2->y+rect2->h, 255, 250, 150, 255);
          rect2->x++;
          rect2->y-=2;
          SDL_BlitSurface(imgText, NULL, cvbuffer, rect2);
          SDL_FreeSurface(imgText);

          imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
          SDL_BlitSurface(imgText, NULL, cvbuffer, rect2);

          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {
            rect2->x+=imgText->w+2;
            rect2->y+=4;
            SDL_BlitSurface(buildingIconImages[c->construction-FIRST_BUILDING], NULL, cvbuffer, rect2); 
            rect2->x-=imgText->w+2;
            rect2->y-=4;
          }
          SDL_FreeSurface(imgText);
          if (c->construction!=NONE && hammerTable[c->construction-FIRST_BUILDING]!=0) {
            //printf("%i / %i \n", c->stocks[HAMMER-FIRST_GOOD].quantity, hammerTable[c->construction-FIRST_BUILDING]);
            float ratio = (float)c->stocks[HAMMER-FIRST_GOOD].quantity/hammerTable[c->construction-FIRST_BUILDING];
            boxRGBA(cvbuffer, rect2->x, rect2->y+rect2->h-5, (int)(rect2->x+(rect2->w*ratio)), rect2->y+rect2->h+3, 32, 128, 32, 255);
          }
        }
        rect->x += buildingImg->w;
      }
      ln = ln->list_next;
    }

    // display refined goods coming from buildings
    //int availableRefinedGoods = 4*range+2;
    innerSpace = 0;
    //if (availableRefinedGoods>REFINED_GOODS_NUMBER) {
    //  availableRefinedGoods=REFINED_GOODS_NUMBER;
    //  innerSpace = (innerRect->w - availableRefinedGoods*TILESIZE/2)/REFINED_GOODS_NUMBER;
    //}
    rect->x = innerRect->x;
    for (dx=0; dx<REFINED_GOODS_NUMBER; dx++) {
      rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2+BUILDING_BAR_HEIGHT;
      if (isGoodAvailable(FIRST_REFINED_GOOD+dx, c)){
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        // highlight selected goods
        if (RAW_GOODS_NUMBER+dx==selectedGood){
          boxRGBA(cvbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 128, 128, 0, 255);
          diamondRGBA(cvbuffer, rect->x, rect->y-GRIDSPACE/4, GRIDSPACE, GRIDSPACE/2, 128, 128, 0, 255);
        }else
          d1gradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);

        if (dragGood!=NULL && RAW_GOODS_NUMBER+dx==dragGood->type-FIRST_GOOD)
          SDL_BlitSurfaceBW(goodsImages[RAW_GOODS_NUMBER+dx], 0, cvbuffer, rect, 196, FALSE);
        else
          SDL_BlitSurface(goodsImages[RAW_GOODS_NUMBER+dx], 0, cvbuffer, rect);
        
        sprintf(text, "%i", c->stocks[RAW_GOODS_NUMBER+dx].quantity);
        TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x+=3;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
        rect->x--;
        rect->y--;
        SDL_BlitSurface(imgText, 0, cvbuffer, rect);
        rect->x-=2;
        rect->y++;;
        SDL_FreeSurface(imgText);
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        
        if (RAW_GOODS_NUMBER+dx!=selectedGood) {
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w, rect->y, 192, 192, 192, 128);
          hlineRGBA(cvbuffer, rect->x, rect->x+rect->w, rect->y+rect->h, 64, 64, 64, 128);
          vlineRGBA(cvbuffer, rect->x,         rect->y,   rect->y+rect->h, 192, 192, 192, 128);
          vlineRGBA(cvbuffer, rect->x+rect->w, rect->y, rect->y+rect->h, 64, 64, 64, 128);
        }
        
        player *player0 = (player*)currentPlayerElement->list_data;
        // display prodution of owned cities
        if ((c->owner==player0 || gamemode==EDIT)){
          SDL_Color *color = &GREEN;
          //if (FIRST_GOOD+RAW_GOODS_NUMBER+dx==ORE)
          //  printf(" prod ore %i \n", c->prod[RAW_GOODS_NUMBER+dx].quantity);
          if (c->prod[RAW_GOODS_NUMBER+dx].quantity>0) {
            int prod = c->prod[RAW_GOODS_NUMBER+dx].quantity;
            if (c->stocks[RAW_GOODS_NUMBER+dx].quantity+c->prod[RAW_GOODS_NUMBER+dx].quantity>getMaxQuantity(c, FIRST_GOOD+RAW_GOODS_NUMBER+dx)) {
              prod = getMaxQuantity(c, FIRST_GOOD+RAW_GOODS_NUMBER+dx) - c->stocks[RAW_GOODS_NUMBER+dx].quantity;
              color = &ORANGE;
            }
            if (prod==0) color=&RED;
            sprintf(text, "+%i", prod);
          }
          else if (c->prod[RAW_GOODS_NUMBER+dx].quantity<0) {
            int prod = c->prod[RAW_GOODS_NUMBER+dx].quantity;
            if (c->stocks[RAW_GOODS_NUMBER+dx].quantity+c->prod[RAW_GOODS_NUMBER+dx].quantity<0){
              prod = -c->stocks[RAW_GOODS_NUMBER+dx].quantity;
              color = &ORANGE;
            }
            if (prod==0) color=&RED;
            sprintf(text, "-%i", abs(prod));
          }
          
          if (c->prod[RAW_GOODS_NUMBER+dx].quantity!=0){
            TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
            imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
            //rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
            rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE+BUILDING_BAR_HEIGHT-12;
            rect->x += TILESIZE/2-imgText->w-2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x+=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y+=2;
            SDL_FreeSurface(imgText);
            rect->x--;
            rect->y--;
            imgText = TTF_RenderText_Blended(fonts[10], text, *color);
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x -= TILESIZE/2-imgText->w-2-1;
            SDL_FreeSurface(imgText);
          }
        } else if (player0->diplomaticRelations[c->owner->nation-FIRST_NATION]<=UPSET){
          // display prices for buy and sell stuff in this city
          int pr = getBuyPriceFor(FIRST_GOOD+RAW_GOODS_NUMBER+dx, c, player0);
          if (pr>0)
            sprintf(text, "%i", pr);
          else
            sprintf(text, "-");
          
          TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
          //rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
          rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE+BUILDING_BAR_HEIGHT-12;
          rect->x += TILESIZE/2-imgText->w-2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x+=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y+=2;
          SDL_FreeSurface(imgText);
          rect->x--;
          rect->y--;
          imgText = TTF_RenderText_Blended(fonts[10], text, YELLOW);
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x -= TILESIZE/2-imgText->w-2-1;
          SDL_FreeSurface(imgText);
          
          pr = getSellPriceFor(FIRST_GOOD+RAW_GOODS_NUMBER+dx, c, player0);
          if (pr>0)
            sprintf(text, "%i", pr);
          else
            sprintf(text, "-");
          
          TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
          imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
          //rect->y = TITLE_BAR_HEIGHT+innerRect->y+((2*range+1)*TILESIZE)+TILESIZE/2-12;
          rect->y = innerRect->y+TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE+BUILDING_BAR_HEIGHT-24;
          rect->x += TILESIZE/2-imgText->w-2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y-=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x+=2;
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->y+=2;
          SDL_FreeSurface(imgText);
          rect->x--;
          rect->y--;
          imgText = TTF_RenderText_Blended(fonts[10], text, RED);
          SDL_BlitSurface(imgText, 0, cvbuffer, rect);
          rect->x -= TILESIZE/2-imgText->w-2-1;
          SDL_FreeSurface(imgText);          
        }
        
        rect->x += TILESIZE/2;
      }
    }

    // display virtual goods (crosses, bells and hammers)
    innerSpace = (2*range+1)*TILESIZE-(VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+innerSpace/2;
    rect->w = TILESIZE/2;
    rect->h = (VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
    SDL_FillRect(cvbuffer, rect, SDL_MapRGB( cvbuffer->format, 32, 20, 25));
    for (dy=0; dy<VIRTUAL_GOODS_NUMBER/2; dy++) {
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2;
      rect->x = innerRect->x;
      rect->y = innerRect->y+TITLE_BAR_HEIGHT+innerSpace/2+dy*TILESIZE/2;
      // highlight selected goods
      if (RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy==selectedGood){
        boxRGBA(cvbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 128, 128, 0, 255);
        diamondRGBA(cvbuffer, rect->x+TILESIZE/2-GRIDSPACE/4, rect->y, GRIDSPACE/2, GRIDSPACE, 128, 128, 0, 255);
      } else
        d1gradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);

      if (dragGood!=NULL && RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy==dragGood->type-FIRST_GOOD)
        SDL_BlitSurfaceBW(goodsImages[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy], 0, cvbuffer, rect, 196, FALSE);
      else
        SDL_BlitSurface(goodsImages[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy], 0, cvbuffer, rect);
      sprintf(text, "%i", c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity);

      TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x+=3;
      SDL_BlitSurface(imgText, 0, cvbuffer, rect);
      imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
      rect->x--;
      rect->y--;
      SDL_BlitSurface(imgText, 0, cvbuffer, rect);
      rect->x-=2;
      rect->y++;;
      SDL_FreeSurface(imgText);
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2;
      hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y,        192, 192, 192, 128);
      hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y+rect->h-1, 64, 64, 64, 128);
      vlineRGBA(cvbuffer, rect->x,         rect->y,   rect->y+rect->h-1, 192, 192, 192, 128);
      vlineRGBA(cvbuffer, rect->x+rect->w-1, rect->y, rect->y+rect->h-1, 64, 64, 64, 128);
    }
    rect->x = innerRect->x;
    rect->y = innerRect->y+TITLE_BAR_HEIGHT+innerSpace/2;
    rect->w = TILESIZE/2;
    rect->h = (VIRTUAL_GOODS_NUMBER-VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
    for (dy=VIRTUAL_GOODS_NUMBER/2; dy<VIRTUAL_GOODS_NUMBER; dy++) {
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2;
      rect->x = innerRect->x+innerRect->w-TILESIZE/2;
      rect->y = innerRect->y+TITLE_BAR_HEIGHT+innerSpace/2+(dy-VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
      // highlight selected goods
      if (RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy==selectedGood){
        boxRGBA(cvbuffer, rect->x, rect->y, rect->x+rect->w, rect->y+rect->h, 128, 128, 0, 255);
        diamondRGBA(cvbuffer, rect->x-GRIDSPACE/4, rect->y, GRIDSPACE/2, GRIDSPACE, 128, 128, 0, 255);
      } else
        d1gradientboxRGBA(cvbuffer, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);

      if (dragGood!=NULL && RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy==dragGood->type-FIRST_GOOD)
        SDL_BlitSurfaceBW(goodsImages[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy], 0, cvbuffer, rect, 196, FALSE);
      else
        SDL_BlitSurface(goodsImages[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy], 0, cvbuffer, rect);
      sprintf(text, "%i", c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity);

      TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x+=3;
      SDL_BlitSurface(imgText, 0, cvbuffer, rect);
      imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
      rect->x--;
      rect->y--;
      SDL_BlitSurface(imgText, 0, cvbuffer, rect);
      rect->x-=2;
      rect->y++;;
      SDL_FreeSurface(imgText);
      rect->w = TILESIZE/2;
      rect->h = TILESIZE/2;
      hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y,        192, 192, 192, 128);
      hlineRGBA(cvbuffer, rect->x, rect->x+rect->w-1, rect->y+rect->h-1, 64, 64, 64, 128);
      vlineRGBA(cvbuffer, rect->x,         rect->y,   rect->y+rect->h-1, 192, 192, 192, 128);
      vlineRGBA(cvbuffer, rect->x+rect->w-1, rect->y, rect->y+rect->h-1, 64, 64, 64, 128);
    }

    // title
    sprintf(text, "%s [%i]", c->name, c->size);
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
    SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
    rect->x = innerRect->x+(innerRect->w-imgText->w)/2;
    rect->y = innerRect->y+1;
    SDL_BlitSurface(imgText, 0, cvbuffer, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
    rect->x = innerRect->x+(innerRect->w-imgText->w)/2;
    rect->y = innerRect->y;
    SDL_BlitSurface(imgText, 0, cvbuffer, rect);
    SDL_FreeSurface(imgText);
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);

    // display the units available just outside the city, waiting to work here (BUT NOT THE TRANSPORTS)
    list_t  *unitList = c->location->unitList;

    rect->x = innerRect->x+((range)*TILESIZE)+TILESIZE/2;
    rect->y = TITLE_BAR_HEIGHT+innerRect->y+((range)*TILESIZE);
    if (unitList!=NULL) {
      //printf ("  units outside %s are %i \n", c->name, list_count(unitList));
      lnode_t *ln = list_first(unitList);
      while (ln!=NULL && ln !=  &unitList->list_nilnode) {
        unit *unitNoi = (unit *)ln->list_data;

        // not foreigners in visit or transports
        if (unitNoi->owner==c->owner && unitNoi->maxLoad==0) {
          SDL_Surface *img1 = getUnitImage(unitNoi);
          rect->y-=(img1->h-TILESIZE);
          if (unitNoi==dragUnit)
            SDL_BlitSurfaceBW(img1, 0, cvbuffer, rect, 196, FALSE);
          else
            SDL_BlitSurface(img1, 0, cvbuffer, rect);
          rect->y+=(img1->h-TILESIZE);
        }
        ln = ln->list_next;
      }
    }

    // display the unit working outside
    for (dx=-range; dx<=range; dx++)
      for (dy=-range; dy<=range; dy++){
        unit *u = c->dependencies[(dy+range)*(range*2+1)+(dx+range)];
        rect->w = TILESIZE;
        rect->h = TILESIZE;
        rect->x = innerRect->x+((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
        rect->y = innerRect->y+TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;

        if (u!=NULL) {
          SDL_Surface *img1 = getUnitImage(u);
          rect->y-=(img1->h-TILESIZE);
          if (u==dragUnit)
            SDL_BlitSurfaceBW(img1, 0, cvbuffer, rect, 196, FALSE);
          else
            SDL_BlitSurface(img1, 0, cvbuffer, rect);
          rect->y+=(img1->h-TILESIZE);

          int goodtype = getGoodsForStatus(u->status);
          if (goodtype!=0) {
            SDL_Surface *img = goodsImages[goodtype-FIRST_GOOD];
            int q = computeOutsideProduction(c, u, goodtype, c->location->posX+dx, c->location->posY+dy);

            float rem = (float)(TILESIZE - img->h)/q;
            if (rem>5) rem=5;
            rect->x-=(img->w-TILESIZE)+8;
            rect->y-=(img->h-TILESIZE);
            for (k=0; k<q; k++) {
              rect->y = innerRect->y+TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE+TILESIZE-img->h-(int)(rem*k);
              SDL_BlitSurface(img, 0, cvbuffer, rect);
              rect->x -=(k%2)*16-8;
            }
            rect->y = innerRect->y+TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE+TILESIZE-img->h;
            sprintf(text, "+%i", q);
            TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
            SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
            //rect->x += img->w/2-imgText->w/2;
            rect->x = innerRect->x+((range)*TILESIZE)+dx*TILESIZE+TILESIZE/*-imgText->w*/;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y-=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x+=2;
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->y+=2;
            SDL_FreeSurface(imgText);
            rect->x--;
            rect->y--;
            imgText = TTF_RenderText_Blended(fonts[12], text, YELLOW);
            SDL_BlitSurface(imgText, 0, cvbuffer, rect);
            rect->x -= img->w/2-imgText->w/2-1;
            rect->y++;
            SDL_FreeSurface(imgText);
            rect->x+=(img->w-TILESIZE);
            rect->y+=(img->h-TILESIZE);
          }
        }
      }
    free(text);
    cvneedUpdate = FALSE;
  }

  //printf("surface for shadow of city view %p  %i*%i\n", cvshadowbuffer, cityViewRect->w, cityViewRect->h);
  // rebuild the shadow
  if (cvshadowbuffer==NULL) {
    cvshadowbuffer = createShadow(cvbuffer, 192, 0x00000000); // black shadow
    if (cityShadowRect==NULL)
      cityShadowRect = (SDL_Rect*)malloc(sizeof(SDL_Rect));
    cityShadowRect->w = cityViewRect->w+2*SHADOW_SIZE;
    cityShadowRect->h = cityViewRect->h+2*SHADOW_SIZE;
  }
  cityShadowRect->x = cityViewRect->x-SHADOW_SIZE;
  cityShadowRect->y = cityViewRect->y-SHADOW_SIZE;
  //printf("  creating surface %p for shadow of city view ... amask=%x %x %x %x\n", cvshadowbuffer, cvshadowbuffer->format->Rmask, cvshadowbuffer->format->Gmask, cvshadowbuffer->format->Bmask, cvshadowbuffer->format->Amask);

  // display the shadow first
  SDL_BlitSurface(cvshadowbuffer, 0, screen, cityShadowRect);
  // then display the city !
  SDL_BlitSurface(cvbuffer, 0, screen, cityViewRect);
  //printf("  surface %p     %i*%i\n", cvshadowbuffer, cityViewRect->w, cityViewRect->h);

  /*SDL_Surface *texhill  = textures[HILLROCK-100];
  SDL_SetAlpha(texhill, SDL_SRCALPHA, 128);
  rect->x = cityViewRect->x;
  rect->y = cityViewRect->y;
  SDL_BlitSurface(texhill, 0, screen, rect);
  */
  TTF_SetFontStyle(fonts[10], TTF_STYLE_NORMAL);
  TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);

  // borders
  hlineRGBA(screen, cityViewRect->x,                  cityViewRect->x+cityViewRect->w-1, cityViewRect->y-1,                 255, 250, 150, 255);
  vlineRGBA(screen, cityViewRect->x-1,                cityViewRect->y,                   cityViewRect->y+cityViewRect->h-1, 255, 250, 150, 255);
  hlineRGBA(screen, cityViewRect->x,                  cityViewRect->x+cityViewRect->w-1, cityViewRect->y+cityViewRect->h,   255, 250, 150, 255);
  vlineRGBA(screen, cityViewRect->x+cityViewRect->w,  cityViewRect->y,                   cityViewRect->y+cityViewRect->h-1, 255, 250, 150, 255);

  // free locally used memory
  free(rect);
  free(rect2);
  free(innerRect);
}// displayCityView() --------------------------------------------------------------------


/**
 * return if a position is over the city view
 */
int isInCityView(int x, int y) {
  if (x>=cityViewRect->x && y>=cityViewRect->y && x<=cityViewRect->x+cityViewRect->w && y<=cityViewRect->y+cityViewRect->h)
    return 1;
  else
    return 0;
}// isInCityView() --------------------------------------------------------------------


/**
 * find the best job for a given unit at a given tile position around a city
 */
void setOutsideJob(city *c, unit *u, int dx, int dy) {
  int maxprod = 0;
  int good, g = NONE;
  for (g=FIRST_RAW_GOOD; g<=FIRST_RAW_GOOD+RAW_GOODS_NUMBER; g++) {
    if (isGoodAvailable(g, c)) {
      int prod = computeValuableProduction(c, u, g, c->location->posX+dx, c->location->posY+dy);
      if (prod>maxprod) {
        maxprod = prod;
        good = g;
      }
    }
  }
  u ->status = getStatusForGood(good);
  updateCityNumbers(c);
}// setOutsideJob() --------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the search algorithm of the building types
 */
int compareBuildingType(const void *a, const void *b) {
  building *b0 = (building*)a;
  int *type = (int*)b;
  return (b0->type != *type);
}// compareBuildingType() --------------------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the search algorithm of city names
 */
int compareCityName(const void *a, const void *b) {
  city *c0 = (city*)a;
  char *name = (char*)b;
  return strcmp(c0->name, name);
}// compareCityName() --------------------------------------------------------------------------------


/**
 * return the max quantity of a given good a city can hold
 */
int getMaxQuantity(city *c, int goodType) {
  //printf("  getMaxQuantity( %i)\n", goodType);
  unsigned int n = 200;
  int bid = WAREHOUSE1;
  if (list_find(c->buildings, &bid, compareBuildingType))
    n = 400;
  bid = WAREHOUSE2;
  if (list_find(c->buildings, &bid, compareBuildingType))
    n = 800;
  bid = WAREHOUSE3;
  if (list_find(c->buildings, &bid, compareBuildingType))
    n = 2000;
  if (goodType>=FIRST_VIRTUAL_GOOD&&goodType<=LAST_GOOD)
    n = INT_MAX;
  return n;
}// getMaxQuantity() --------------------------------------------------------------------------------


/**
 * mouse drag callback
**/
void mouseDraggedCV(city *c, int cvmouseX, int cvmouseY){
  lastcvmouseX = cvmouseX;
  lastcvmouseY = cvmouseY;
  //printf("mouseDraggedCV (%i,%i) on %s\n", cvmouseX, cvmouseX, c->name);
}// mouseDraggedCV() --------------------------------------------------------------------------------


/**
 * mouse move callback
 **/
void mouseMovedCV(city *c, int cvmouseX, int cvmouseY) {
  //printf("mouseMovedCV (%i,%i) on %s\n", cvmouseX, cvmouseX, c->name);
  lastcvmouseX = cvmouseX;
  lastcvmouseY = cvmouseY;
  int range    = getRangeForSize(c->size);
  SDL_Rect *rect      = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *rect2     = (SDL_Rect *)malloc(sizeof(SDL_Rect));
 
  if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2 &&
      cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT)) {
    lnode_t *ln = list_first(c->buildings);
    rect->x = 0;
    rect->y = TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2;
    while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
      building *b = (building *)ln->list_data;
      SDL_Surface *buildingImg = getBuildingImage(b);
      if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
          b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood) {
        if (b->typeGoodsOut1==HAMMER && (c->owner==currentPlayerElement->list_data || gamemode==EDIT)) {
          rect2->x = rect->x+2;
          rect2->y = rect->y+32;
          char *text = (char*)malloc(256);
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {
            //SDL_Surface *s = buildingImages[c->construction-FIRST_BUILDING];
            //SDL_BlitSurface(s, 0, cvbuffer, rect);
            strcpy(text, getBuildingTextFromType(c->construction));
          } else {
            sprintf(text, "NOTHING");
          }
          TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
          SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
          rect2->w = imgText->w+4;
          rect2->h = imgText->h+4;
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {//
            rect2->w += buildingIconImages[c->construction-FIRST_BUILDING]->w+2; //
            if (buildingIconImages[c->construction-FIRST_BUILDING]->h > rect2->h)
              rect2->h = buildingIconImages[c->construction-FIRST_BUILDING]->h+4; 
          }          
          free(text);
          SDL_FreeSurface(imgText);
          
          // want to change the construction ?
          if (cvmouseX>=rect2->x && cvmouseX<=rect2->x+rect2->w && cvmouseY>=rect2->y  && 
              cvmouseY<=rect2->y+rect2->h &&!list_isempty(b->workers)) {
            isAboutToChangeConstruction = TRUE;
          } else
            isAboutToChangeConstruction = FALSE;
          cvneedUpdate = TRUE;
        } else
          isAboutToChangeConstruction = FALSE;
        //rect->x += buildingImg->w;
        
        lnode_t *ln2 = list_last(b->workers);
        rect2->x = rect->x+list_count(b->workers)*GRIDSPACE;
        rect->x += buildingImg->w;
      }
      ln = ln->list_next;
    }
  }
  free(rect);
  free(rect2);
}// mouseMovedCV()


/**
 * mouse drag callback (from a unit view)
**/
void mouseDragCV(city *c, unitview *uv, int x, int y){
  lastcvmouseX = cvmouseX;
  lastcvmouseY = cvmouseY;
  //printf("mouseDragCV (%i,%i) on %s\n", x, y, c->name);
  int goodtype = dragGood->type-FIRST_GOOD;
  int range    = getRangeForSize(c->size);
  int availableRawGoods = 4*range+2;
  if (availableRawGoods>RAW_GOODS_NUMBER)
    availableRawGoods=RAW_GOODS_NUMBER;
  //printf("\n\n%i %i %i\n", 0, goodtype, availableRawGoods);
  //printf("%i %i %i\n", RAW_GOODS_NUMBER, goodtype, RAW_GOODS_NUMBER+availableRawGoods);
  //printf(" => %i %i \n", !(goodtype>=RAW_GOODS_NUMBER && goodtype<RAW_GOODS_NUMBER+availableRawGoods), !(goodtype>=0 && goodtype<availableRawGoods));
  if (!(goodtype>=RAW_GOODS_NUMBER && goodtype<RAW_GOODS_NUMBER+availableRawGoods) &&
      !(goodtype>=0 && goodtype<availableRawGoods) && goodtype>=0 && goodtype<GOODS_NUMBER) {
    //dragGood            = NULL;
    //printf(" CANCELLED\n");
  } else  {
    selectedGood = goodtype;
    uv->needUpdate     = TRUE;
    cvneedUpdate       = TRUE;
  }
}// mouseDraggedCV() --------------------------------------------------------------------------------


/**
 * mouse drop callback (from a unit view)
**/
void mouseDropCV(city* c, unitview *uv, int x, int y){
  //printf("\nmouseDropCV()\n");
  int goodtype = dragGood->type-FIRST_GOOD;
  int range    = getRangeForSize(c->size);
  //int availableRawGoods = 4*range+2;
  unit *u = (unit*)list_first(uv->ul)->list_data;
  //if (availableRawGoods>RAW_GOODS_NUMBER)
  //  availableRawGoods=RAW_GOODS_NUMBER;
  //printf("  %i %i %i\n", 0, goodtype, availableRawGoods);
  //printf("  %i %i %i\n", RAW_GOODS_NUMBER, goodtype, RAW_GOODS_NUMBER+availableRawGoods);
  //printf("  => %i %i \n", !(goodtype>=RAW_GOODS_NUMBER && goodtype<RAW_GOODS_NUMBER+availableRawGoods), !(goodtype>=0 && goodtype<availableRawGoods));
  //printf("  unit %p %i from %i units\n", u, u->type, list_count(uv->ul));
  //printf("  isGoodAvailable? %d\n", isGoodAvailable(dragGood, c));
  
  if (!isGoodAvailable(dragGood->type, c)) {
    dragGood            = NULL;
    //printf(" CANCELLED\n");
  } else if (goodtype>=0 && goodtype<GOODS_NUMBER && u!=NULL && u->location == c->location && u->owner==c->owner){
    int i;  
    for (i=0; i<u->maxLoad; i++){
      if (&u->goods[i]==dragGood){
        int q = dragGood->quantity;
        if (c->stocks[goodtype].quantity+dragGood->quantity>getMaxQuantity(c, dragGood->type-FIRST_GOOD))
          q = getMaxQuantity(c, dragGood->type-FIRST_GOOD)-c->stocks[goodtype].quantity;
        c->stocks[goodtype].quantity += q;
        dragGood->quantity -= q;
        uv->needUpdate     = TRUE;
        cvneedUpdate       = TRUE;
        dragGood           = NULL;
      }
    }
  // trade goods with a city
  } else if (goodtype>=0 && goodtype<GOODS_NUMBER && u!=NULL && u->location == c->location && u->owner!=c->owner){
    int i;
    for (i=0; i<u->maxLoad; i++){
      if (&u->goods[i]==dragGood){
        
        int q = dragGood->quantity;
        if (c->stocks[goodtype].quantity+dragGood->quantity>getMaxQuantity(c, dragGood->type-FIRST_GOOD))
          q = getMaxQuantity(c, dragGood->type-FIRST_GOOD)-c->stocks[goodtype].quantity;
        int price          = getBuyPriceFor(dragGood->type, c, u->owner);
        //printf("TRADE? %d %d\n", q, price);
        if (price>0 && q>0 && c->owner->money>=price*q){
          c->stocks[goodtype].quantity += q;
          dragGood->quantity -= q;
          uv->needUpdate     = TRUE;
          c->owner->money -= (price*q);
          u->owner->money += (price*q);
          char *msg = (char*)malloc(512);
          sprintf(msg, "TRADE: %02d/%4d: sell %d %s at %dp to %s in the city of %s. Total: +%dp", 1+apptime%12, 1492+apptime/12, q, getGoodText(&c->stocks[goodtype]), price, c->owner->name, c->name, (price*q));
          addMsg(msg);
          free(msg);
        }
        dragGood           = NULL;
        cvneedUpdate       = TRUE;        
      }
    }
  //unboard some units
  } else if (u!=NULL && u->location == c->location){
    int i;
    for (i=0; i<u->maxLoad; i++){
      if (&u->goods[i]==dragGood && u->goods[i].passenger!=NULL){
        u->goods[i].passenger->location = c->location;
        if (c->location->unitList==NULL)
          c->location->unitList = list_create(LISTCOUNT_T_MAX);
        list_append(c->location->unitList, lnode_create(u->goods[i].passenger));
        dragGood->quantity  = 0;
        dragGood->passenger = NULL;
        uv->needUpdate      = TRUE;
        cvneedUpdate        = TRUE;
        dragGood            = NULL;
      }
    }
  }
  uvDrag = NONE;
}// mouseDropCV() --------------------------------------------------------------------


/**
 * mouse press callback
 */
void mousePressedCV(city *c, int cvmouseX, int cvmouseY, int button, int nbClick){
  cvneedUpdate = true;
  Uint32 now   = SDL_GetTicks();
  int dx, dy;
  cvlastMouseDown = now;
  cvisMousePressed = 1;
  int innerSpace = BUILDING_BAR_HEIGHT-VIRTUAL_GOODS_NUMBER*TILESIZE/2;

  SDL_Rect *rect      = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *rect2     = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  SDL_Rect *innerRect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  innerRect->x = 0;
  innerRect->y = 0;
  innerRect->w = cityViewRect->w;
  innerRect->h = cityViewRect->h;

  int range = getRangeForSize(c->size);
  //printf("mousePressedCV(%s, %i, %i) %i\n", c->name, cvmouseX, cvmouseY, nbClick);
  rect->x = ((range)*TILESIZE)+TILESIZE/2;
  rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE);
  rect->w = TILESIZE;
  rect->h = TILESIZE;

  if (cvmouseY<TITLE_BAR_HEIGHT) {
    //printf("mousePressedCV(%s, %i, %i)  %i+%i\n", c->name, cvmouseX, cvmouseY, cityViewRect->y,TITLE_BAR_HEIGHT);
    //SDL_SetAlpha  (cvbuffer, SDL_SRCALPHA, 192);
    isDrag = CITYVIEW;
    innitialDragPosX = cityViewRect->x;
    innitialDragPosY = cityViewRect->y;

  // look for in the center first (newcomers)
  } else if ((c->owner==currentPlayerElement->list_data||gamemode==EDIT) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h &&
             c->location->unitList!=NULL && list_count(c->location->unitList)>0 && ((unit *)list_first(c->location->unitList)->list_data)){

    lnode_t *ln = list_last(c->location->unitList);
    while (ln!=&c->location->unitList->list_nilnode && ((unit *)ln->list_data)->maxLoad>0)
      ln = ln->list_prev;
    if (ln!=&c->location->unitList->list_nilnode && ((unit *)ln->list_data)->maxLoad==0 && button==SDL_BUTTON_LEFT && nbClick==2){
      unit *u = (unit *)ln->list_data;
      findBestJob(u, c);
    }else if (ln!=&c->location->unitList->list_nilnode && ((unit *)ln->list_data)->maxLoad==0 && button==SDL_BUTTON_LEFT) {
      dragUnit = (unit *)ln->list_data;
      cvDrag   = NEWCOMER;
      isDrag   = INNERCITYVIEW;
      rect->y-=(getUnitImage(dragUnit)->h-TILESIZE);
      if (isOpaquePixel(getUnitImage(dragUnit), cvmouseX-rect->x, cvmouseY-rect->y)) {
        mousedX  = cvmouseX-rect->x;
        mousedY  = cvmouseY-rect->y;
      } else {
        mousedX  = getUnitImage(dragUnit)->w/2;
        mousedY  = getUnitImage(dragUnit)->h/2;
      };
    } else if (ln!=&c->location->unitList->list_nilnode && ((unit *)ln->list_data)->maxLoad==0 && ((unit *)ln->list_data)!=NULL && button==SDL_BUTTON_RIGHT) {
      discardPopup();

      popupType     = POPUP_MENU;
      popupUnitList = list_create(LISTCOUNT_T_MAX);
      unit *u = (unit *)ln->list_data;
      list_append(popupUnitList, lnode_create(u));

      char *txt = (char*)malloc(50);
      if (u->tools<100  && c->stocks[TOOL-FIRST_GOOD].quantity>=20) {
        sprintf(txt, "Equip with tools [[%i]]", TOOL);
        addPopupOption(txt, doEquipTools);
      }
      if (u->tools>0)
        addPopupOption("Remove tools", doUnequipTools);
      //----------------

      if (u->horses<100 && c->stocks[HORSE-FIRST_GOOD].quantity>=50) {
        sprintf(txt, "Equip with horses [[%i]]", HORSE);
        addPopupOption(txt, doEquipHorses);
      }
      if (u->horses>0)
        addPopupOption("Remove horses", doUnequipHorses);
      //----------------

      if (u->muskets<100  && c->stocks[MUSKET-FIRST_GOOD].quantity>=50) {
        sprintf(txt, "Equip with muskets [[%i]]", MUSKET);
        addPopupOption(txt, doEquipMuskets);
      }
      if (u->muskets>0)
        addPopupOption("Remove muskets", doUnequipMuskets);
      //----------------

      char *text = (char *)malloc(64);
      sprintf(text, "Work outside [[%s]]", c->name);
      addPopupOption(text, doFindBestJob);
      free(text);

      free(txt);
      if (popupOptionList == NULL || list_count(popupOptionList)==0)
        discardPopup();
      else
        preSelectMiddleOptionPopup();
    }

    // look for raw goods
  } else if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE) && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2) {
    //int availableRawGoods = 4*range+2;
    innerSpace = 0;
    //if (availableRawGoods>RAW_GOODS_NUMBER) {
    //  availableRawGoods=RAW_GOODS_NUMBER;
    //  innerSpace = (cityViewRect->w - availableRawGoods*TILESIZE/2)/RAW_GOODS_NUMBER;
    //}
    rect->x = 0;
    for (dx=0; dx<RAW_GOODS_NUMBER; dx++) {
      //printf("isGoodAvailable %i(%i) => %i\n", FIRST_RAW_GOOD+dx, rect->x, isGoodAvailable(FIRST_RAW_GOOD+dx, c));
      if (isGoodAvailable(dx+FIRST_RAW_GOOD, c)){
        if (cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && nbClick==2 && button==SDL_BUTTON_LEFT)
          selectedGood=dx;
        else if (gamemode==EDIT && cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && button==SDL_BUTTON_WHEELDOWN) {
          c->stocks[dx].quantity-=10;
          if (c->stocks[dx].quantity<0)
            c->stocks[dx].quantity = 0;
          cvneedUpdate = TRUE;
        } else if (gamemode==EDIT && cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && button==SDL_BUTTON_WHEELUP) {
          c->stocks[dx].quantity+=10;
          if (c->stocks[dx].quantity > getMaxQuantity(c, FIRST_GOOD+dx))
            c->stocks[dx].quantity = getMaxQuantity(c, FIRST_GOOD+dx);
          cvneedUpdate = TRUE;
        } else if (cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && c->stocks[dx].quantity>0){
          cvDrag   = GOODS;
          isDrag   = INNERCITYVIEW;
          dragGood = &c->stocks[dx];
          mousedX  = cvmouseX-rect->x;
          mousedY  = cvmouseY-TITLE_BAR_HEIGHT-((2*range+1)*TILESIZE);
          break;
        }
        rect->x += TILESIZE/2;
      }
    }
  } else if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2+BUILDING_BAR_HEIGHT && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2+BUILDING_BAR_HEIGHT+TILESIZE/2) {
    // look for refined goods coming from buildings
    //int availableRefinedGoods = 4*range+2;
    //innerSpace = 0;
    //if (availableRefinedGoods>REFINED_GOODS_NUMBER) {
    //  availableRefinedGoods=REFINED_GOODS_NUMBER;
    //  innerSpace = ( cityViewRect->w - availableRefinedGoods*TILESIZE/2)/REFINED_GOODS_NUMBER;
    //}
    rect->x = 0;
    for (dx=0; dx<REFINED_GOODS_NUMBER; dx++) {
      if (isGoodAvailable(dx+FIRST_REFINED_GOOD, c)){
        if (cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && nbClick==2 && button==SDL_BUTTON_LEFT)
          selectedGood=RAW_GOODS_NUMBER+dx;
        else if (gamemode==EDIT && cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && button==SDL_BUTTON_WHEELDOWN) {
          c->stocks[RAW_GOODS_NUMBER+dx].quantity-=10;
          if (c->stocks[RAW_GOODS_NUMBER+dx].quantity<0)
            c->stocks[RAW_GOODS_NUMBER+dx].quantity = 0;
          cvneedUpdate = TRUE;
        } else if (gamemode==EDIT && cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && button==SDL_BUTTON_WHEELUP) {
          c->stocks[RAW_GOODS_NUMBER+dx].quantity+=10;
          if (c->stocks[RAW_GOODS_NUMBER+dx].quantity>getMaxQuantity(c, FIRST_REFINED_GOOD+dx))
            c->stocks[RAW_GOODS_NUMBER+dx].quantity = getMaxQuantity(c, FIRST_REFINED_GOOD+dx);
          cvneedUpdate = TRUE;
        } else if (cvmouseX>=rect->x && cvmouseX<rect->x+TILESIZE/2 && c->stocks[RAW_GOODS_NUMBER+dx].quantity>0 && button==SDL_BUTTON_LEFT){
          cvDrag   = GOODS;
          isDrag   = INNERCITYVIEW;
          dragGood = &c->stocks[RAW_GOODS_NUMBER+dx];
          mousedX  = cvmouseX-rect->x;
          mousedY  = cvmouseY-(TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2+BUILDING_BAR_HEIGHT);
          break;
        }
        rect->x += TILESIZE/2;
      }
    }

    // look for virtual goods (crosses, bells and hammers)
  } else if (cvmouseY>=TITLE_BAR_HEIGHT+innerSpace/2 &&
             cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)-innerSpace/2 && cvmouseX<TILESIZE/2) {
    innerSpace = ((2*range+1)*TILESIZE)-(VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
    rect->y = TITLE_BAR_HEIGHT+(2*range+1)*TILESIZE+TILESIZE/2+innerSpace/2;
    for (dy=0; dy<VIRTUAL_GOODS_NUMBER/2; dy++) {
      rect->y = TITLE_BAR_HEIGHT+innerSpace/2+dy*TILESIZE/2;
      //printf("  innerSpace=%i \n", innerSpace);
      //printf("  range=%i \n", range);
      //printf("  vgoods? %i = (%i <-> %i)  but=%i/%i\n", cvmouseY, rect->y, rect->y+TILESIZE/2, button, SDL_BUTTON_WHEELUP);
      if (cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && nbClick==2 && button==SDL_BUTTON_LEFT)
        selectedGood=RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy;
      else if (gamemode==EDIT && cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && button==SDL_BUTTON_WHEELDOWN) {
        c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity-=10;
        if (c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity<0)
          c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity = 0;
        cvneedUpdate = TRUE;
      } else if (gamemode==EDIT && cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && button==SDL_BUTTON_WHEELUP) {
        c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity+=10;
        if (c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity>getMaxQuantity(c, FIRST_VIRTUAL_GOOD+dy))
          c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity = getMaxQuantity(c, FIRST_VIRTUAL_GOOD+dy);
        cvneedUpdate = TRUE;
      }

    }
  } else if (cvmouseY>=TITLE_BAR_HEIGHT+innerSpace/2 &&
             cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)-innerSpace/2 && cvmouseX>=cityViewRect->w-TILESIZE/2) {
    innerSpace = ((2*range+1)*TILESIZE)-(VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
    rect->y = TITLE_BAR_HEIGHT+innerSpace/2;
    for (dy=VIRTUAL_GOODS_NUMBER/2; dy<VIRTUAL_GOODS_NUMBER; dy++) {
      rect->y = TITLE_BAR_HEIGHT+innerSpace/2+(dy-VIRTUAL_GOODS_NUMBER/2)*TILESIZE/2;
      if (cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && nbClick==2 && button==SDL_BUTTON_LEFT)
        selectedGood=RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy;
      else if (gamemode==EDIT && cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && button==SDL_BUTTON_WHEELDOWN) {
        c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity-=10;
        if (c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity<0)
          c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity = 0;
        cvneedUpdate = TRUE;
      } else if (gamemode==EDIT && cvmouseY>=rect->y && cvmouseY<rect->y+TILESIZE/2 && button==SDL_BUTTON_WHEELUP) {
        c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity+=10;
        if (c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity>getMaxQuantity(c, FIRST_VIRTUAL_GOOD+dy))
          c->stocks[RAW_GOODS_NUMBER+REFINED_GOODS_NUMBER+dy].quantity = getMaxQuantity(c, FIRST_VIRTUAL_GOOD+dy);
        cvneedUpdate = TRUE;
      }
    }

    //search building worker that could be dragged
  } else if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2 &&
             cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT)) {
    lnode_t *ln = list_first(c->buildings);
    rect->x = 0;
    rect->y = TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2;
    while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
      building *b = (building *)ln->list_data;
      SDL_Surface *buildingImg = getBuildingImage(b);
      if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
          b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood) {
        if (b->typeGoodsOut1==HAMMER && (c->owner==currentPlayerElement->list_data || gamemode==EDIT)) {
          rect2->x = rect->x+2;
          rect2->y = rect->y+32;
          char *text = (char*)malloc(256);
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {
            //SDL_Surface *s = buildingImages[c->construction-FIRST_BUILDING];
            //SDL_BlitSurface(s, 0, cvbuffer, rect);
            strcpy(text, getBuildingTextFromType(c->construction));
          } else {
            sprintf(text, "NOTHING");
          }
          TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
          SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
          rect2->w = imgText->w+4;
          rect2->h = imgText->h+4;
          if (c->construction>=FIRST_BUILDING && c->construction<=LAST_BUILDING) {//
            rect2->w += buildingIconImages[c->construction-FIRST_BUILDING]->w+2; //
            if (buildingIconImages[c->construction-FIRST_BUILDING]->h > rect2->h)
              rect2->h = buildingIconImages[c->construction-FIRST_BUILDING]->h+4; 
          }          
          free(text);
          SDL_FreeSurface(imgText);

          // want to change the construction ?
          if (cvmouseX>=rect2->x && cvmouseX<=rect2->x+rect2->w && cvmouseY>=rect2->y  && cvmouseY<=rect2->y+rect2->h &&!list_isempty(b->workers)) {
            //isAboutToChangeConstruction = TRUE;
            unit *u = (unit*)list_first(b->workers)->list_data;
            //printf("dx=%i, dy=%i => %p\n", dx, dy, u);
            if (u!=NULL) {
              discardPopup();
              popupType     = POPUP_MENU;
              popupUnitList = list_create(LISTCOUNT_T_MAX);
              list_append(popupUnitList, lnode_create(u));
              //printf("SET popupUnitList %i =>%i\n", list_count(popupUnitList), u->type);
              popupOptionList = list_create(LISTCOUNT_T_MAX);
              isAboutToChangeConstruction = FALSE;
              addPopupOption("NOTHING", doChangeConstruction);

              int i;
              char *text = (char*)malloc(256);
              for (i=FIRST_BUILDING; i<LAST_BUILDING; i++) {
                if (!list_find(c->buildings, &i, compareBuildingType) &&
                    (extensionTable[i-FIRST_BUILDING]==0 || list_find(c->buildings, &extensionTable[i-FIRST_BUILDING], compareBuildingType))&&
                    c->size >= minSizeTable[i-FIRST_BUILDING]) {
                  sprintf(text, "%s (%i) [[%i]]", getBuildingTextFromType(i), hammerTable[i-FIRST_BUILDING], i);
                  addPopupOption(text, doChangeConstruction);
                }
              }
              free(text);
              preSelectMiddleOptionPopup();
            }
          } //else
            //isAboutToChangeConstruction = FALSE;
          cvneedUpdate = TRUE;
        } //else
          //isAboutToChangeConstruction = FALSE;
        //rect->x += buildingImg->w;

        lnode_t *ln2 = list_last(b->workers);
        rect2->x = rect->x+list_count(b->workers)*GRIDSPACE+GRIDSPACE/2;
        while (ln2!=NULL && ln2!=&b->workers->list_nilnode) {
          rect2->x -= GRIDSPACE;
          unit *u = (unit *)ln2->list_data;
          SDL_Surface *unitImg = getUnitImage(u);
          rect2->y = rect->y+BUILDING_BAR_HEIGHT-unitImg->h-2;
          //printf("It is not working in %s : %i %i %i => %i\n", c->name, b->type,
          //  ((player*)currentPlayerElement->list_data)->nation,
          //  c->owner->nation, isColonyOf(((player*)currentPlayerElement->list_data)->nation, c->owner->nation));
          if (cvmouseX>=rect2->x && cvmouseX<rect2->x+GRIDSPACE && cvmouseY>=rect2->y &&
              (c->owner==(player*)(currentPlayerElement->list_data) ||
               gamemode==EDIT ||
               (b->type==NEW_WORLD_OFFICE && isColonyOf(((player*)currentPlayerElement->list_data)->nation, c->owner->nation)))){
            dragUnit   = u;
            if (dragUnit!=NULL) {
              rect->y-=(getUnitImage(u)->h-TILESIZE);
              if (isOpaquePixel(getUnitImage(dragUnit), cvmouseX-rect2->x, cvmouseY-rect2->y)) {
                cvDrag     = INWORKER;
                isDrag     = INNERCITYVIEW;
                mousedX    = cvmouseX-rect2->x;
                mousedY    = cvmouseY-rect2->y;
                inbuilding = b;
              } else
                dragUnit = NULL;
              rect->y+=(getUnitImage(u)->h-TILESIZE);
            }
          }
          ln2 = ln2->list_prev;
        }
        rect->x += buildingImg->w;
      }
      ln = ln->list_next;
    }

    // search the other tiles around (unit working outside of the city)
  } else if ((c->owner==currentPlayerElement->list_data||gamemode==EDIT) && cvmouseY>=TITLE_BAR_HEIGHT && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)){
    int dx, dy;
    for (dx=-range; dx<=range; dx++)
      for (dy=-range; dy<=range; dy++) {
        float d = sqrt((float)(dx*dx+dy*dy))-0.5;
        rect->w = TILESIZE;
        rect->h = TILESIZE;
        rect->x = ((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
        rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;
        if (d<=range && (dx!=0 ||dy!=0) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h && button==SDL_BUTTON_RIGHT){
          unit *u = c->dependencies[(dy+range)*(range*2+1)+dx+range];
          //printf(" rclick  dx=%i, dy=%i => %p\n", dx, dy, u);
          //fflush(stdout);
          if (u!=NULL) {
            discardPopup();
            popupType     = POPUP_MENU;

            popupUnitList = list_create(LISTCOUNT_T_MAX);
            list_append(popupUnitList, lnode_create(u));
            //printf("SET popupUnitList %i =>%i\n", list_count(popupUnitList), u->type);
            //fflush(stdout);

            popupOptionList = list_create(LISTCOUNT_T_MAX);
            char *text   = (char*)malloc(256*sizeof(char));

            int gt;
            for (gt=FIRST_RAW_GOOD; gt<=LAST_RAW_GOOD; gt++){
              int prod =  computeOutsideProduction(c, u, gt, c->location->posX+dx, c->location->posY+dy);
              if (isGoodAvailable(gt, c) && prod>0){
                sprintf(text, "%s +%i[[%i]]", getStatusText(getStatusForGood(gt)), prod, gt);
                addPopupOption(text, doWorkOutside);    
              }
            }
            //printf("options created %i\n", list_count(popupOptionList));
            //fflush(stdout);
            preSelectMiddleOptionPopup();          }
        } else if (d<=range && (dx!=0 ||dy!=0) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h) {
          unit *u = c->dependencies[(dy+range)*(range*2+1)+dx+range];
          if (u!=NULL) {
            dragUnit = u;
            rect->y-=(getUnitImage(u)->h-TILESIZE);
            cvDrag   = OUTWORKER;
            isDrag   = INNERCITYVIEW;
            cvOutX   = dx;
            cvOutY   = dy;
            if (isOpaquePixel(getUnitImage(dragUnit), cvmouseX-rect->x, cvmouseY-rect->y)) {
              mousedX  = cvmouseX-rect->x;
              mousedY  = cvmouseY-rect->y;
            } else {
              mousedX  = getUnitImage(dragUnit)->w/2;
              mousedY  = getUnitImage(dragUnit)->h/2;
            }
            rect->y+=(getUnitImage(u)->h-TILESIZE);

            break;
          }
        }
      }
  }
  lastcvmouseX = cvmouseX;
  lastcvmouseY = cvmouseY;
  updateCityNumbers(c);
  free(rect);
  free(rect2);
  free(innerRect);
}// mousePressedCV() --------------------------------------------------------------------


/**
 * mouse release callback
 */
void mouseReleasedCV(city *c, int cvmouseX, int cvmouseY, int button, int nbClick) {
  cvneedUpdate = true;
  Uint32 now = SDL_GetTicks();
  cvisMousePressed = 0;
  cvlastMouseUp = now;
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  int range = getRangeForSize(c->size);
  //SDL_SetAlpha  (cvbuffer, SDL_SRCALPHA, 255);

  if (cvDrag == NEWCOMER) {
    // look for displayed buildings if dropped there
    if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2 && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT)) {
      lnode_t *ln = list_first(c->buildings);
      rect->x = 0;
      rect->y = TITLE_BAR_HEIGHT+TILESIZE/2+((2*range+1)*TILESIZE);
      while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
        building *b = (building *)ln->list_data;
        SDL_Surface *buildingImg = getBuildingImage(b);
        if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
            b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood ) {
          //printf("look for %i>=%i , %i<=%i %i>%i\n", cvmouseX, rect->x, cvmouseX, rect->x+buildingImg->w, b->slots,list_count(b->workers));
          if (cvmouseX>=rect->x && cvmouseX<rect->x+buildingImg->w && b->slots>list_count(b->workers)){
            list_append(b->workers, lnode_create(dragUnit));
            lnode_t *ln2 = list_find(map[c->location->posX+MapWidth*(c->location->posY)].unitList, dragUnit, straightCompare);
            list_delete(map[c->location->posX+MapWidth*(c->location->posY)].unitList, ln2);
            dragUnit->location     = NULL;
            //printf("  IN %p\n", ln2);
            free(ln2);

            if (dragUnit->tools>0) {
              c->stocks[TOOL-FIRST_GOOD].quantity+=dragUnit->tools;
              dragUnit->tools = 0;
            }
            if (dragUnit->muskets>0) {
              c->stocks[MUSKET-FIRST_GOOD].quantity+=dragUnit->muskets;
              dragUnit->muskets = 0;
            }
            if (dragUnit->horses>0) {
              c->stocks[HORSE-FIRST_GOOD].quantity+=dragUnit->horses;
              removeHorses(dragUnit);
            }
            dragUnit->status       = PRODUCING;
            dragUnit->lastBuilding = b;
            dragUnit->lastCity     = c;
            updateCityNumbers(c);
          }
          rect->x += buildingImg->w;
        }
        ln = ln->list_next;
      }
    }

    // look in the grid if drop there
    int dx, dy;
    for (dx=-range; dx<=range; dx++)
      for (dy=-range; dy<=range; dy++) {
        float d = sqrt((float)(dx*dx+dy*dy))-0.5;
        rect->w = TILESIZE;
        rect->h = TILESIZE;
        rect->x = ((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
        rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;
        if (d<=range && (dx!=0 ||dy!=0) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h &&
            c->location->posY+dy>=0 &&c->location->posX+dx>=0 && c->location->posX+dx<MapWidth &&
            c->location->posY+dy<MapWidth && c->dependencies[(dy+range)*(range*2+1)+dx+range]==NULL){

          c->dependencies[(dy+range)*(range*2+1)+dx+range] = dragUnit;
          dragUnit->lastCity = c;
          dragUnit->lastWorkingTile = (dy+range)*(range*2+1)+dx+range;
          lnode_t *ln = list_find(map[c->location->posX+MapWidth*(c->location->posY)].unitList, dragUnit, straightCompare);
          list_delete(map[c->location->posX+MapWidth*(c->location->posY)].unitList, ln);
          dragUnit->location     = NULL;
          if (dragUnit->tools>0) {
            c->stocks[TOOL-FIRST_GOOD].quantity+=dragUnit->tools;
            dragUnit->tools = 0;
          }
          if (dragUnit->muskets>0) {
            c->stocks[MUSKET-FIRST_GOOD].quantity+=dragUnit->muskets;
            dragUnit->muskets = 0;
          }
          if (dragUnit->horses>0) {
            c->stocks[HORSE-FIRST_GOOD].quantity+=dragUnit->horses;
            removeHorses(dragUnit);
          }

          setOutsideJob(c, dragUnit, dx, dy);
          free(ln);
        }
      }
  } else if (cvDrag == OUTWORKER) {
    rect->x = ((range)*TILESIZE)+TILESIZE/2;
    rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE);
    rect->w = TILESIZE;
    rect->h = TILESIZE;

    // look for exit
    if (cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h) {
      if (map[c->location->posX+MapWidth*(c->location->posY)].unitList==NULL)
        map[c->location->posX+MapWidth*(c->location->posY)].unitList = list_create(LISTCOUNT_T_MAX);
      list_append(map[c->location->posX+MapWidth*(c->location->posY)].unitList, lnode_create(dragUnit));
      dragUnit->location = &map[c->location->posX+MapWidth*(c->location->posY)];
      dragUnit->status = WAITING;
      c->dependencies[(cvOutY+range)*(range*2+1)+cvOutX+range] = NULL;
      updateCityNumbers(c);
      // look for displayed buildings if dropped there
    } else if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE) && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT)) {
      lnode_t *ln = list_first(c->buildings);
      rect->x = 0;
      rect->y = TITLE_BAR_HEIGHT+TILESIZE/2+((2*range+1)*TILESIZE);
      while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
        building *b = (building *)ln->list_data;
        SDL_Surface *buildingImg = getBuildingImage(b);
        if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
            b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood) {
          if (cvmouseX>=rect->x && cvmouseX<rect->x+buildingImg->w && b->slots>list_count(b->workers)){
            list_append(b->workers, lnode_create(dragUnit));
            c->dependencies[(cvOutY+range)*(range*2+1)+cvOutX+range] = NULL;
            dragUnit->status       = PRODUCING;
            dragUnit->lastBuilding = b;
            dragUnit->lastCity     = c;
            updateCityNumbers(c);
          }
          rect->x += buildingImg->w;
        }
        ln = ln->list_next;
      }
    } else {
      // look in the grid if drop there
      int dx, dy;
      for (dx=-range; dx<=range; dx++)
        for (dy=-range; dy<=range; dy++) {
          float d = sqrt((float)(dx*dx+dy*dy))-0.5;
          rect->x = ((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
          rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;
          if (d<=range && (dx!=0 ||dy!=0) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h&&
              c->location->posY+dy>=0 &&c->location->posX+dx>=0 && c->location->posX+dx<MapWidth && c->location->posY+dy<MapWidth){

            unit *repl = c->dependencies[(dy+range)*(range*2+1)+dx+range];
            c->dependencies[(cvOutY+range)*(range*2+1)+cvOutX+range] = repl;
            c->dependencies[(dy+range)*(range*2+1)+dx+range] = dragUnit;
            dragUnit->lastCity = c;
            dragUnit->lastWorkingTile = (dy+range)*(range*2+1)+dx+range;
            setOutsideJob(c, dragUnit, dx, dy);
            // the drag unit replaced someone
            if (repl!=NULL)
              setOutsideJob(c, repl, cvOutX, cvOutY);
          }
        }
    }
  } else if (cvDrag == INWORKER) {
    rect->x = ((range)*TILESIZE)+TILESIZE/2;
    rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE);
    rect->w = TILESIZE;
    rect->h = TILESIZE;

    // look for exit
    if (cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h) {
      if (map[c->location->posX+MapWidth*(c->location->posY)].unitList==NULL)
        map[c->location->posX+MapWidth*(c->location->posY)].unitList = list_create(LISTCOUNT_T_MAX);
      list_append(map[c->location->posX+MapWidth*(c->location->posY)].unitList, lnode_create(dragUnit));
      dragUnit->location = &map[c->location->posX+MapWidth*(c->location->posY)];
      dragUnit ->status = WAITING;
      lnode_t *ln = list_find(inbuilding->workers, dragUnit, straightCompare);
      list_delete(inbuilding->workers, ln);
      free(ln);
      updateCityNumbers(c);
      // look for displayed buildings if dropped there
    } else if (cvmouseY>=TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE)+TILESIZE/2 && cvmouseY<TITLE_BAR_HEIGHT+((2*range+1)*TILESIZE+TILESIZE/2+BUILDING_BAR_HEIGHT)) {
      lnode_t *ln = list_first(c->buildings);
      rect->x = 0;
      rect->y = TITLE_BAR_HEIGHT+TILESIZE/2+((2*range+1)*TILESIZE);
      while (ln!=NULL && ln!=&c->buildings->list_nilnode) {
        building *b = (building *)ln->list_data;
        SDL_Surface *buildingImg = getBuildingImage(b);
        if (b->typeGoodsIn1==FIRST_GOOD+selectedGood || b->typeGoodsIn2==FIRST_GOOD+selectedGood ||
            b->typeGoodsIn3==FIRST_GOOD+selectedGood || b->typeGoodsOut1==FIRST_GOOD+selectedGood) {
          if (cvmouseX>=rect->x && cvmouseX<rect->x+buildingImg->w && b->slots>list_count(b->workers)){
            list_append(b->workers, lnode_create(dragUnit));
            lnode_t *ln2 = list_find(inbuilding->workers, dragUnit, straightCompare);
            list_delete(inbuilding->workers, ln2);
            free(ln2);
            dragUnit ->status      = PRODUCING;
            dragUnit->lastBuilding = b;
            dragUnit->lastCity     = c;
            updateCityNumbers(c);
          }
          rect->x += buildingImg->w;
        }
        ln = ln->list_next;
      }
    } else  {
      // look in the grid if drop there
      int dx, dy;
      for (dx=-range; dx<=range; dx++) {
        for (dy=-range; dy<=range; dy++) {
          float d = sqrt((float)(dx*dx+dy*dy))-0.5;
          rect->x = ((range)*TILESIZE)+dx*TILESIZE+TILESIZE/2;
          rect->y = TITLE_BAR_HEIGHT+((range)*TILESIZE)+dy*TILESIZE;
          if (d<=range && (dx!=0 ||dy!=0) && cvmouseX>=rect->x && cvmouseY>=rect->y && cvmouseX<rect->x+rect->w && cvmouseY<rect->y+rect->h&&
              c->location->posY+dy>=0 &&c->location->posX+dx>=0 && c->location->posX+dx<MapWidth && c->location->posY+dy<MapWidth &&
              c->dependencies[(dy+range)*(range*2+1)+dx+range]==NULL){
            //printf("reaffect %i \n", map[c->location->posX+MapWidth*(c->location->posY)].vegetation);
            c->dependencies[(dy+range)*(range*2+1)+dx+range] = dragUnit;
            dragUnit->lastCity = c;
            dragUnit->lastWorkingTile = (dy+range)*(range*2+1)+dx+range;
            setOutsideJob(c, dragUnit, dx, dy);
            lnode_t *ln = list_find(inbuilding->workers, dragUnit, straightCompare);
            list_delete(inbuilding->workers, ln);
            free(ln);
          }
        }
      }
    }
  } else if (cvDrag == GOODS) {
    dragGood = NULL;
  }
  dragUnit = NULL;
  cvDrag   = NONE;
  updateCityNumbers(c);

  free(rect);
}// mouseReleasedCV() --------------------------------------------------------------------


/**
 * find a good job for this unit
 */
void doFindBestJob (list_t *ul, char *order) {
  //printf("doFindBestJob %s\n", order);

  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;

    char* text = strstr(order, "[[");
    text+=2;
    char* text2 = (char *)malloc(64);
    strncpy(text2, text, strstr(order, "]]")-strstr(order, "[[")-2);
    text2[strstr(order, "]]")-strstr(order, "[[")-2] = '\0';
    city *c = findCity(text2);
    //printf("found |||%s|||\n", text2);
    free(text2);
    if (c!= NULL)
      findBestJob(u, c);
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doFindBestJob()


/**
* ask the given unit list to farm food
 */
void doWorkOutside(list_t *ul, char *order) {
  char* text = strstr(order, "[[");
  text+=2;
  char* text2 = (char *)malloc(64);
  strncpy(text2, text, strstr(order, "]]")-strstr(order, "[[")-2);
  text2[strstr(order, "]]")-strstr(order, "[[")-2] = '\0';
  int gt = atoi(text2);
  free(text2);
  
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    u->status = getStatusForGood(gt);
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doWorkOutside() --------------------------------------------------------------------


/**
 * ask the given unit to catch tools in the city
*/
void doEquipTools(list_t *ul, char *order) {
  //printf("doEquipTools (%i)\n", list_count(ul));
  doUnequipMuskets(ul, NULL);

  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    //printf("guy is %p , %s, %i, %i, %i\n", u->location, u->location->construction->name, u->location->construction->stocks[TOOL-FIRST_GOOD].quantity, u->tools, u->type);
    if (u->location!=NULL && u->location->construction!=NULL && u->location->construction->stocks[TOOL-FIRST_GOOD].quantity>=20 && u->tools<=80 && u->type>=COLONIST && u->type<=CONVERT) {
      //printf("equip a %i\n", u->type);
      int tt = 100-u->tools;
      if (u->location->construction->stocks[TOOL-FIRST_GOOD].quantity<tt)
        tt = (u->location->construction->stocks[TOOL-FIRST_GOOD].quantity/20)*20;
      u->tools += tt;
      u->location->construction->stocks[TOOL-FIRST_GOOD].quantity -=tt;
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doEquipTools() --------------------------------------------------------------------


/**
 * ask the given unit to drop tools in the city
 */
void doUnequipTools(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    if (u->location!=NULL && u->location->construction!=NULL && u->tools>0 && u->type>=COLONIST && u->type<=CONVERT) {
      u->location->construction->stocks[TOOL-FIRST_GOOD].quantity +=u->tools;
      u->tools = 0;
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doUnequipTools() --------------------------------------------------------------------


/**
 * ask the given unit to catch horses in the city
*/
void doEquipHorses(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    //printf("doEquipHorses %i @ %p=>%i / %i\n", u->type, u->location, u->horses, u->location->construction->stocks[HORSE-FIRST_GOOD].quantity);

    if (u->location!=NULL && u->location->construction!=NULL && u->location->construction->stocks[HORSE-FIRST_GOOD].quantity>=50 && u->horses==0 && u->type>=COLONIST && u->type<=CONVERT) {
      //printf("  DONE\n");
      addHorses(u);
      u->location->construction->stocks[HORSE-FIRST_GOOD].quantity -=50;
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doEquipHorses() --------------------------------------------------------------------


/**
 * ask the given unit to drop horses in the city
 */
void doUnequipHorses(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  //printf("doUnequipHorses %p\n", unitelem);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    //printf("   %p\n", u->location);
    if (u->location!=NULL && u->location->construction!=NULL && u->horses>0 && u->type>=COLONIST && u->type<=CONVERT) {
      u->location->construction->stocks[HORSE-FIRST_GOOD].quantity +=u->horses;
      removeHorses(u);
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doUnequipHorses() --------------------------------------------------------------------


/**
 * ask the given unit to catch muskets in the city
*/
void doEquipMuskets(list_t *ul, char *order) {
  doUnequipTools(ul, NULL);
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    if (u->location!=NULL && u->location->construction!=NULL && u->location->construction->stocks[MUSKET-FIRST_GOOD].quantity>=50 && u->muskets==0 && u->type>=COLONIST && u->type<=CONVERT) {
      u->muskets += 50;
      u->location->construction->stocks[MUSKET-FIRST_GOOD].quantity -=50;
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doEquipMuskets() --------------------------------------------------------------------


/**
 * ask the given unit to drop muskets in the city
 */
void doUnequipMuskets(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL) return;
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    if (u->location!=NULL && u->location->construction!=NULL && u->muskets>0 && u->type>=COLONIST && u->type<=CONVERT) {
      u->location->construction->stocks[MUSKET-FIRST_GOOD].quantity +=u->muskets;
      u->muskets = 0;
    }
    unitelem = unitelem->list_next;
  }
  cvneedUpdate = true;
}// doUnequipMuskets() --------------------------------------------------------------------


/**
 * ask the given unit (carpenter like) to change construction
*/
void doChangeConstruction(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  char *text   = (char*)malloc(256*sizeof(char));
  if (unitelem==NULL) return;
  unit *u     = (unit *)unitelem->list_data;
  //building *b = u->lastBuilding;
  city *c     = u->lastCity;
  int i;
  c->construction = NONE;
  for (i=FIRST_BUILDING; i<=LAST_BUILDING; i++) {
    //printf(" |%s|(%p) // |%s|(%p)  => %p // %p\n", getBuildingTextFromType(i), getBuildingTextFromType(i), order, order, strstr(order, getBuildingTextFromType(i)), getBuildingTextFromType(i));
    if (strstr(order, getBuildingTextFromType(i))==order){
      c->construction = i;
      cvneedUpdate = TRUE;
    }
  }
  free(text);
}// doChangeConstruction() --------------------------------------------------------------------

