/**
 * NewCol is a 2D game developed by Frederic Vernier inspired from a old game called colonization
 * developed by Sid Myers (Microprose 1995). It is written in C but but a C++ compiler to take
 * advantage of C++ conveniences. See http://newcol.free.fr (or http://newcol.fr) for more informations
 * All right reserved
 */


#include "newcol.h"
//#include <crtdbg.h>
#pragma warning ( disable : 4996 )
// global variable of the app
SDL_Surface   *screen               = NULL;
SDL_Surface   *helperTile           = NULL;
SDL_Surface   *fieldTile            = NULL;
SDL_Surface   *maskTiles[3][3];

SDL_Surface   *forest20Imgs[16];
SDL_Surface   *forest40Imgs[16];
double         refreshrate          = 0;
int            gamemode             = PLAY;
int            editmode             = E_UNIT;
tile          *copytile             = NULL;
int            apptime              = 0;
int            done                 = 0;
int            initcpt              = 0;
//char          *initmsg              = NULL;
char          *lastinitmsg          = NULL;
int            lastUpdate           = 0;
char          *title                = NULL;
char         **nationTexts          = NULL;
unsigned int   gameSeed             = 0;

//int           forestgraphics        = 4;
//int           fieldgraphics         = 1;

TTF_Font      *fonts[LAST_FONT];

long           elapsedTime          = 0;
long           lastRefreshInfo      = 0;
int            isMousePressed       = 0;
int            mousePressedX        = 0;
int            mousePressedY        = 0;
int            mouseMovedX          = 0;
int            mouseMovedY          = 0;
Uint32         lastMouseDownTime    = 0;
Uint32         lastMouseUpTime      = 0;
Uint32         lastMouseDownLocX    = 0;
Uint32         lastMouseDownLocY    = 0;
Uint32         lastMouseUpLocX      = 0;
Uint32         lastMouseUpLocY      = 0;

Uint32         nbClick              = 1;
int            isDrag               = NONE;
int            uiPaintNb            = 0;

int            mouseX               = 0;
int            mouseY               = 0;
int            innitialDragPosX     = 0;
int            innitialDragPosY     = 0;

int            mousedX              = 0;
int            mousedY              = 0;
int            animID               = 0;

int            soundID              = NONE;
int            noSound              = FALSE;
Mix_Chunk     *natureSounds[NATURE_SOUND_NUMBER];
int            ambianceChannel0      = 0;
int            ambianceChannel1      = 1;
int            ambianceChannelID     = 0;
SDL_TimerID    press_timer_id        = NULL;


int            FVTx, FVTy;
SDLMod         modifier;
int            debug                = FALSE;

// global variables of the game
int            MapWidth            = 0;
int            MapHeight           = 0;
tile          *map                  = NULL;
list_t        *riverList            = NULL;
SDL_Surface  **tilecache            = NULL;
unsigned char *movecache            = NULL;
int            cacheNeedUpdate      = FALSE;
list_t        *messageList          = NULL;

// declare the global variable used to calculate altitude
unsigned char zbuf[TILESIZE][TILESIZE];

unitview     *inspector            = NULL;
unitview     *druv                 = NULL;
int           extensionTable[BUILDING_NUMBER];
int           minSizeTable[BUILDING_NUMBER];
int           hammerTable[BUILDING_NUMBER];
int           toolsTable[BUILDING_NUMBER];
int           isDisplayGrid        = FALSE;
int           isDisplayMiniMap     = FALSE;
int           isDisplayAStar       = FALSE;
int           isDisplayOnlyTerrain = FALSE;

// dragging stuff is general as it can be dragged between views
good         *dragGood;
unit         *dragUnit;

list_t       *playerList             = NULL;
player       *nations[NATION_NUMBER];
lnode_t      *currentPlayerElement   = NULL;
SDL_Rect     *rectSelection          = NULL;
list_t       *displayedItinerary     = NULL;
unit         *unitSample             = NULL;
int          Mapsize                 = 0;
int          GameDifficulty          = 0;

int           firstVisibleTileX      = 0;
int           firstVisibleTileY      = 0;

list_t       *unitSelectionList      = NULL;
list_t       *defaultSelectionList   = NULL;


SDL_Surface *iconImage               = NULL;
SDL_Surface *coinImage, *crossImage  = NULL;

SDL_Surface *pathFootImage,      *pathHorseImage,     *pathNavalImage,     *pathWagonImage;
SDL_Surface *pathFootNTImage,    *pathHorseNTImage,   *pathNavalNTImage,   *pathWagonNTImage;
SDL_Surface *cloudImage;

SDL_Surface *fieldImages[FIELD_NUMBER];
SDL_Surface *treeImages[TREE_NUMBER];
SDL_Surface *forestImages[FOREST_NUMBER];
SDL_Surface *bonusImages[BONUS_NUMBER];
SDL_Surface *messageImages[MESSAGE_NUMBER];
SDL_Surface *unitsImages[300]; // 50*6
SDL_Surface *goodsImages[347];  //47+50*6
SDL_Surface *buildingImages[BUILDING_NUMBER];
//SDL_Surface *miniBuildingImages[BUILDING_NUMBER];
SDL_Surface *buildingIconImages[BUILDING_NUMBER];

SDL_Color BLACK          = {0, 0, 0};
SDL_Color WHITE          = {255, 255, 255};
SDL_Color RED            = {255, 0, 0};
SDL_Color LIGHTRED       = {255, 127, 127};
SDL_Color GREEN          = {0, 255, 0};
SDL_Color LIGHTGREEN     = {127, 255, 127};
SDL_Color BLUE           = {0, 0, 255};
SDL_Color LIGHTBLUE      = {127, 127, 255};
SDL_Color YELLOW         = {255, 255, 0};
SDL_Color DARKGREY       = {63, 63, 63};
SDL_Color GREY           = {127, 127, 127};
SDL_Color LIGHTGREY      = {195, 195, 195};
SDL_Color ORANGE         = {255, 128, 0};

SDL_Color NEW_FRANCEOR   = {63, 63, 255};
SDL_Color NEW_SPAINOR    = {195, 195, 0};
SDL_Color NEW_ENGLANDOR  = {195, 0, 0};
SDL_Color NEW_HOLLANDOR  = {255, 215, 0};
SDL_Color ITALY_COLOR    = {0, 195, 0};
SDL_Color GERMANY_COLOR  = {0, 195, 195};
SDL_Color RUSSIA_COLOR   = {195, 0, 195};
SDL_Color PORTUGAL_COLOR = {184, 134, 11};

SDL_Color AZTEC_COLOR    = {184, 134, 255};
SDL_Color OLMEC_COLOR    = {184, 134, 255};
SDL_Color INCA_COLOR     = {184, 134, 255};
SDL_Color APACHE_COLOR   = {184, 134, 255};
SDL_Color HURON_COLOR    = {184, 134, 255};
SDL_Color CHEROKEE_COLOR = {184, 134, 255};
SDL_Color IROQUOIS_COLOR = {184, 134, 255};
SDL_Color SIOUX_COLOR     = {184, 134, 255};
SDL_Color TUPI_COLOR     = {184, 134, 255};
SDL_Color ARAWAK_COLOR   = {184, 134, 255};
SDL_Color CHINOOK_COLOR  = {184, 134, 255};
SDL_Color INUIT_COLOR    = {184, 134, 255};

char buildingTexts[BUILDING_NUMBER][256] = {"New World Office", "Alchemist House", "Alchemist Shop", "Armoury", "Arsenal",
  "Bank", "Barracks", "Carpentry Shop", "Church", "Cigar Factory", "Textile Factory", "Fur Factory", "College",
  "Command Post", "Congress Hall", "Construction Yard", "Custom House", "Distiller House", "Distiller Shop", "Dock", "Drugstore",
  "Forge", "Fur Worker House", "Fur Worker Shop", "Granary", "Grocery", "Gunpowder Factory", "Ironworks",
  "Jeweller House", "Jeweller Shop", "Jewelworks", "Coat Factory", "Coat Tradder House", "Coat Tradder Shop", "Lighthouse",
  "Magazine", "Marketplace", "Newspaper", "Pharmacist House", "Pharmacist Shop", "Printing Press", "Rope Binder House",
  "Rope Binder Shop", "Rope Factory", "Rum Factory", "Sawmill", "Schoolhouse", "Smithy", "Stable", "Tailor House",
  "Tailor Shop", "Tavern", "Cloth Factory", "Tobbaconist House", "Tobbaconist Shop", "Town Hall l1",
  "Town Hall l2",  "Town Hall l3", "Town Statue", "Trade Condominium", "University", "War Academy", "Warehouse l1",
  "Warehouse l2", "Watch Tower", "Water Storage", "Water Tower", "Weapon Storage", "Weaver House",
  "Weaver Shop", "Well", "Wind Mill", "Wine Factory", "Wine House", "Wine Shop", "Workshop", "Shipyard", "DryDock",
  "Port", "Harbour", "Jesuit Chapel", "Cathedral", "Warehouse l3", "Stock Exchange", "Stockade", "Fort", "Fortress"};

char statusTexts[STATUS_NUMBER][256] = {"Waiting", "Going To", "Plowing", "Building Road", "Digging Mine", "Fortifying", "Sentry", "Mixed Status",
  "On Board", "Producing", "Teaching", "Farming Corn", "Fishing", "Farming Tobacco", "Farming Cotton", "Farming Sugar", "Trapping Furs", "Lumberjacking", "Mining Ore",
  "Mining Coal", "Mining Silver", "Mining Gold", "Farming Grape", "Gardening Herbs", "Gardening Spices", "Gardening Saltpeter", "Mining Gems", "Mining Oil", "Farming Rice", "Gardening Hemp", "Minig Stone",
  "Farming Wheat", "Hunting Whales", "Harvesting Clams", "Diving for Pearls", "Raising Cows", "Raising Sheep", "Raising Pigs", "Hunting Buffalo"};

char goodTexts[GOODS_NUMBER][256] = {"Corn", "Sugar", "Tobacco", "Cotton", "Furs", "Lumbers", "Ore", "Coal", "Silver", "Gold", "Grape", "Salpetre",
  "Rice", "Hemp", "Herbs", "Gem", "Stone", "Wheat", "Spice", "Fish", "Whale", "Clams", "Pearl", "Cow", "Sheep", "Oil", "Pig", "Buffalo", "Rum",
  "Cigar", "Textile", "Leather", "Horse", "Tool", "Musket", "Cloth", "Coat", "Wine", "Gun powder", "Rope", "Medecine", "Jewel", "Dyes", "Stone",
  "Liberty bell", "Cross", "Hammer", "Population", "Money", "Knowledge", "Morale", "Health"};

char bonusTexts[BONUS_NUMBER][256] = {"Pure Silver", "Prime Corn", "Prime Tobacco", "Prime Cotton", "Prime Sugar", "Prime Fish", "Pure Ore", "Prime Furs", "Prime Lumbers", "Prime Oil",
  "Prime Games", "Prime Cow", "Prime Pig", "Prime Sheep", "Prime Buffalo", "Pure Coal", "Pure Gold", "Prime Whale", "Prime Clams", "Prime Gem", "Prime Hemp", "Prime Dyes", "Prime saltpetre"};


char unitTexts[UNIT_NUMBER][256] = {"Colonist", "Farmer", "Fisherman", "Fur Trapper", "Silver Miner", "Lumberjack", "Ore Miner", "Sugar Planter", "Cotton Planter", "Tobacco Planter",
  "Preacher", "Stateman", "Carpenter", "Distiller", "Weaver", "Tobacconist", "Fur Tradder", "Blacksmith", "Gunsmith", "Scout", "Pioneer", "Soldier",
  "Servant", "Criminal", "Convert", "Colonial", "Indian", "Regular", "Caravel", "Frigate", "Galleon", "Man-O-War", "Merchantman", "Privateer", "Artillery",
  "Damaged Artillery", "Treasure Train", "Wagon", "Milkmaid", "Mormon", "Robber", "Pirate", "Poor", "Missionnary"};

char elevationTexts[ELEVATION_NUMBER][256] = {"Deep Ocean", "Seas", "Plains", "Hills", "High Hills", "Mountains", "High Mountains"};
char groundTexts[GROUND_NUMBER][256] = {"Desert", "Rock Desert", "Plain", "Grassland", "Prairie", "Savannah", "Marsh", "Swamp", "Tundra", "Ocean", "Sealane", "Rock", "Rock2", "ForestTree", "HillRock", "Arctic"};


SDL_Color   *nationColors[NATION_NUMBER] = {&NEW_FRANCEOR, &NEW_SPAINOR, &NEW_ENGLANDOR, &NEW_HOLLANDOR, &ITALY_COLOR, &GERMANY_COLOR,  &RUSSIA_COLOR,   &PORTUGAL_COLOR,
                                            &NEW_FRANCEOR, &NEW_SPAINOR, &NEW_ENGLANDOR, &NEW_HOLLANDOR, &ITALY_COLOR, &GERMANY_COLOR,  &RUSSIA_COLOR,   &PORTUGAL_COLOR,
  &AZTEC_COLOR , &OLMEC_COLOR  , &INCA_COLOR,  &APACHE_COLOR , &HURON_COLOR, &CHEROKEE_COLOR, &IROQUOIS_COLOR, &SIOUX_COLOR, &TUPI_COLOR, &ARAWAK_COLOR, &CHINOOK_COLOR, &INUIT_COLOR};

SDL_Surface *nationFlags[NATION_NUMBER];
SDL_Surface *nationMiniFlags[NATION_NUMBER];

/**
 * snap the dragging rectangle to the closest tile of the map
 */
void alignRect(SDL_Rect *rect) {
  if (rect->x%TILESIZE>TILESIZE/2)
    rect->x = rect->x-(rect->x%TILESIZE)+TILESIZE;
  else
    rect->x = rect->x-(rect->x%TILESIZE);

  if (rect->y%TILESIZE>TILESIZE/2)
    rect->y = rect->y-(rect->y%TILESIZE)+TILESIZE;
  else
    rect->y = rect->y-(rect->y%TILESIZE);
}// alignRect() --------------------------------------------------------------------


/**
 * copy function (duplicate the nodes in a new list)
 */
list_t *copylist(list_t *src) {
  list_t *dst = list_create(LISTCOUNT_T_MAX);
  lnode_t *ln = list_first(src);
  while (ln!=NULL && ln != &src->list_nilnode){
    void *data = ln->list_data;
    list_prepend(dst, lnode_create(data));
    ln = ln->list_next;
  }
  return dst;
}// copylist() --------------------------------------------------------------------------------


/**
 * copy function (duplicate the nodes)
 */
void copylistTo(list_t *src, list_t *dst) {
  lnode_t *ln = list_first(src);
  while (ln!=NULL && ln != &src->list_nilnode){
    void *data = ln->list_data;
    list_append(dst, lnode_create(data));
    ln = ln->list_next;
  }
}// copylistTo() --------------------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the search algorithm of the list data structure
 */
int straightCompare(const void *a, const void *b) {
  //tile *ea = ((unit*)a)->location;
  return (a != b);
}// straightCompare() --------------------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the search algorithm of the river list data structure
 */
int compareItinerary(const void *a, const void *b) {
  binarytree_t *bt = ((river*)a)->itinerary;
  //printf("compare %p and %p\n", bt->root, b);
  return (bt->root != b);
}// compareItinerary() --------------------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the sort algorithm before saving unit lists
 */
int cargoCompare(const void *a, const void *b) {
  int ca = ((unit*)a)->maxLoad;
  int cb = ((unit*)b)->maxLoad;
  return (cb-ca);
}// cargoCompare() --------------------------------------------------------------------------------


/**
 * comparizon function which pointer is given to the search algorithm of the list data structure
 */
int tileCompare(const void *a, const void *b) {
  tile *ta = (tile*)a;
  tile *tb = (tile*)b;

  int d1 = ta->posX;
  if (d1>MapWidth-1-ta->posX)
    d1 = MapWidth-1-ta->posX;
  if (d1>ta->posY)
    d1 = ta->posY;
  if (d1>MapHeight-1-ta->posY)
    d1 = MapHeight-1-ta->posY;

  int d2 = tb->posX;
  if (d2>MapWidth-1-tb->posX)
    d2 = MapWidth-1-tb->posX;
  if (d2>tb->posY)
    d2 = tb->posY;
  if (d2>MapHeight-1-tb->posY)
    d2 = MapHeight-1-tb->posY;

  return d1-d2;
}// tileCompare() --------------------------------------------------------------------------------


/**
 * unit groupped have a pointer of the list representing the group. this function undo all that and free the memory
 */
void resetGroup(list_t *group) {
  //printf("resetGroup (%p)\n", group);
  lnode_t *ln = list_first(group);
  while (ln != &group->list_nilnode) {
    unit *u = (unit*)ln->list_data;
    u->group = NULL;
    ln = ln->list_next;
  }
  list_destroy_nodes(group);
  list_destroy(group);
}// resetGroup();


/**
 * test if a unit can move
 */
int canMove(unit* u) {
  //printf("canMove %d    %d,%d ?\n", u->type, u->location->posX, u->location->posY);
  //fflush(stdout);
  if (u->location==NULL)
    return FALSE;

  int i, j, diff;
  for (i=u->location->posX-1; i<=u->location->posX+1; i++)
    for (j=u->location->posY-1; j<=u->location->posY+1; j++){
      diff = computeDifficulty(u->location, &map[i+MapWidth*(j)], u);
      //printf("diff %d / %d\n", diff, u->movement);
      //fflush(stdout);
      if (diff<u->movement)
        return TRUE;
    }
  return FALSE;
}// canMove()


/**
 * return if a list of unit contains an ennemy with weapons
 */
int isEnnemyIn(list_t *ul){
  lnode_t *ln = list_first(ul);
  int nation = ((player *)currentPlayerElement->list_data)->nation;
  while(ln!=NULL && ln!=&ul->list_nilnode) {
    unit *u = (unit*)ln->list_data;
    if (u->owner!=currentPlayerElement->list_data && u->owner->diplomaticRelations[nation-FIRST_NATION] >= COLD_WAR)
      return TRUE;
    ln = ln->list_next;
  }
  return FALSE;
}// isEnnemyIn()


/**
 * compute the difficuly to go from a given tile to another adjacent one
 */
int computeDifficulty(tile *start, tile *dest, unit* u) {
  //if (u!=NULL && dest->posX==164 && dest->posY==64)
  //  printf("computeDifficulty(%i) %i,%i -> %i,%i ?\n", u->type, start->posX, start->posY, dest->posX, dest->posY);
  int diff = 0;
  int dx = dest->posX - start->posX;
  int dy = dest->posY - start->posY;

  //if (u!=NULL && dest->posX==164 && dest->posY==64)
  //  printf("  isnaval?(%i) / %i / %i -> %i \n", isNaval(u), dest->elevation, map[start->posX+MapWidth*(start->posY)].elevation, map[dest->posX+MapWidth*(dest->posY)].elevation);
  // not adjacent or impossible tile to reach
  if (dx<-1 || dx>1 || dy<-1 || dy>1)
    return 1001;

  int dz = dest->elevation - start->elevation;
  if (dz<0)
    dz = dz*-1;

  if ((start->lastExplored<0 || dest->lastExplored<0) && gamemode==PLAY) {
    if (u!=NULL && isNaval(u) && (dx==0 || dy==0))
      return 2;
    else if (u!=NULL && isNaval(u))
      return 3;
    else if (dx==0 || dy==0)
      return 10;
    else
      return 14;
  }

  // boarding without using a port. possible for some units
  if (u!=NULL && !isNaval(u) && dest->elevation<=OCEAN0 && isFreeBoarding(dest, u))
    return u->maxMovement;

  //  impossible tile to reach
  if      (u!=NULL && u->horses!=-101 && !isNaval(u) && (dest->elevation>=HIGHMOUNTAIN || dest->elevation<=OCEAN0))
    return 1002;
  // cannot do such diagonal movement because we decided the sea would occupy the space in between !
  else if (u!=NULL && u->horses!=-101 && !isNaval(u) && dest->posX!=start->posX && dest->posY!=start->posY &&
           map[start->posX+MapWidth*(dest->posY)].elevation<=OCEAN0 && map[dest->posX+MapWidth*(start->posY)].elevation<=OCEAN0)
    return 1003;
  else if (u!=NULL && u->horses!=-101 && isNaval(u)==1 && (dest->elevation>=SEALEVEL && dest->construction==NULL && dest->irrigation<BIG_RIVER))
    return 1004;
  else if (u!=NULL && u->horses!=-101 && isNaval(u)==2 && (dest->elevation>=SEALEVEL && dest->construction==NULL))
    return 1005;

  if (u!=NULL && u->horses==-101){
    //this unit explores where a river can go
    if (dest->elevation < start->elevation)
      return 1006;
    else
      return dest->elevation-start->elevation+1;
  }

  // straight movement
  if (dx==0 || dy==0) {
    float p = (dz/10.0f);
    float da = p/0.1f*(1.1f/0.7f);
    if (dest->elevation - start->elevation<0)
      da = da/2.0f;
    diff = (int)(10+10*da);
    if (u!=NULL && isNaval(u) && start->elevation<SEALEVEL && dest->elevation<SEALEVEL)
      diff = 2;

  // diagonal movement
  } else {
    tile *diag1 = &map[start->posX+dx+MapWidth*(start->posY)];
    tile *diag2 = &map[start->posX+MapWidth*(start->posY+dy)];
    float passLevelDiag     = (diag1->elevation+diag2->elevation)/2.0f;
    float passLevelStraight = (start->elevation+dest->elevation)/2.0f;
    float passLevel         = (passLevelDiag+passLevelStraight)/2.0f;
    float dz1 = passLevel-start->elevation;
    if (dz1<0)
      dz1 = dz1*-1;
    float dz2 = dest->elevation-passLevel;
    if (dz2<0)
      dz2 = dz2*-1;

    float p1 = (dz1/7.0f);
    float da1 = p1/0.1f*1.1f;
    if (passLevel - start->elevation<0)
      da1 = da1/2.0f;
    float p2 = (dz2/7.0);
    float da2 = p2/0.1f*1.1f;
    if (dest->elevation - passLevel<0)
      da2 = da2/2.0f;

    diff = 14+(int)(7.0f*da1+7.0f*da2);
    if (u!=NULL && isNaval(u) && start->elevation<SEALEVEL && dest->elevation<SEALEVEL)
      diff = 3;
  }

  // check if unit!=NULL otherwise is is is a computation to display snake variations on roads or rivers
  // roads help movements
  if (u!=NULL && start->road>0 && dest->road>0)
    diff = (int)(diff/(1.0f+(start->road+dest->road)/40));

  // rivers help movements
  else if (u!=NULL && start->river_elem !=NULL && dest->river_elem !=NULL) {
    if (start->river_elem->left==dest->river_elem || start->river_elem->right==dest->river_elem || start->river_elem->father==dest->river_elem)
      diff = diff*2/3;
  }

  return diff;
}// computeDifficulty() --------------------------------------------------------------------


/**
 * return the month's name according to a given game-time
 */
char* getMonthForTime(int time) {
  char *text = (char *)malloc(256*sizeof(char));
  switch (time%12) {
  case 0  :
    sprintf(text, "January");
    break;
  case 1  :
    sprintf(text, "Febuary");
    break;
  case 2  :
    sprintf(text, "March");
    break;
  case 3  :
    sprintf(text, "April");
    break;
  case 4  :
    sprintf(text, "May");
    break;
  case 5  :
    sprintf(text, "June");
    break;
  case 6  :
    sprintf(text, "July");
    break;
  case 7  :
    sprintf(text, "August");
    break;
  case 8  :
    sprintf(text, "September");
    break;
  case 9  :
    sprintf(text, "October");
    break;
  case 10 :
    sprintf(text, "November");
    break;
  case 11 :
    sprintf(text, "December");
    break;
  }
  return text;
}// getMonthForTime() --------------------------------------------------------------------


/**
 * find if a tile is connected to the irrigation network or to a river directly
 */
int isWaterAround(tile* t) {
  return 0;
}// isWaterAround() --------------------------------------------------------------------


/**
 * Pan the map to a new position of the first visible tile
 */
void panMap(int newfirstVisibleTileX, int newfirstVisibleTileY) {
  int i, j;
  int oldfirstVisibleTileX = firstVisibleTileX;
  int oldfirstVisibleTileY = firstVisibleTileY;
  if (newfirstVisibleTileX<0)
    newfirstVisibleTileX=0;
  if (newfirstVisibleTileX+screen->w/TILESIZE>MapWidth)
    newfirstVisibleTileX=MapWidth-screen->w/TILESIZE;
  if (newfirstVisibleTileY<0)
    newfirstVisibleTileY=0;
  if (newfirstVisibleTileY+screen->h/TILESIZE>MapHeight)
    newfirstVisibleTileY=MapHeight-screen->h/TILESIZE;

  if (newfirstVisibleTileX != oldfirstVisibleTileX || newfirstVisibleTileY != oldfirstVisibleTileY) {
    int w = screen->w/TILESIZE;
    int h = screen->h/TILESIZE;
    int x2 = newfirstVisibleTileX+w-1;
    int y2 = newfirstVisibleTileY+h-1;
    int x1 = newfirstVisibleTileX;
    if (oldfirstVisibleTileX>newfirstVisibleTileX)
      x1 = oldfirstVisibleTileX;
    else
      x2 = oldfirstVisibleTileX+w-1;
    int y1 = newfirstVisibleTileY;
    if (oldfirstVisibleTileY>newfirstVisibleTileY)
      y1 = oldfirstVisibleTileY;
    else
      y2 = oldfirstVisibleTileY+h-1;

    SDL_Surface ** tilecache2 = (SDL_Surface **)malloc(w*h*sizeof(SDL_Surface *));

    for (i=0; i<w; i++)
      for (j=0; j<h; j++)
        tilecache2[(j)*(w)+(i)] = NULL;

    for (i=0; i<w; i++)
      for (j=0; j<h; j++) {
        int i2 = i-newfirstVisibleTileX+oldfirstVisibleTileX;
        int j2 = j-newfirstVisibleTileY+oldfirstVisibleTileY;
        while (i2<0)
          i2+=w;
        while (i2>=w)
          i2-=w;
        while (j2<0)
          j2+=h;
        while (j2>=h)
          j2-=h;
        int u= (j)*(w)+(i);
        int v= (j2)*(w)+(i2);
        if (tilecache2[v]!=NULL)
          printf("  PROBLEM :   %i(%i, %i) <= %i(%i, %i)\n", v, i2, j2, u, i, j);

        tilecache2[v] = tilecache[u];
      }

    for (i=0; i<w; i++)
      for (j=0; j<h; j++)
        if (tilecache2[(j)*(w)+(i)] == NULL)
          printf("  BIG PROBLEM :   %i(%i, %i) \n", (j)*(w)+(i), i, j);

    free(tilecache);
    tilecache = tilecache2;
    firstVisibleTileX = newfirstVisibleTileX;
    firstVisibleTileY = newfirstVisibleTileY;
    updatesBackgroundInCache(x1, y1, x2, y2);
    //updatesFieldsInCache();
    //updatesVegetationShadowInCache();
    updatesVegetationInCache(x1, y1, x2, y2);
    //updatesFastVegetationInCache(x1, y1, x2, y2);
    //updatesInfluencesInCache();

    updatesCitiesInCache(x1, y1, x2, y2);
    updatesRiversInCache(x1, y1, x2, y2);
    updatesRoadsInCache(x1, y1, x2, y2);
    updatesBonusesInCache(x1, y1, x2, y2);
    //updatesCulturesInCache();
    //updatesCityNamesInCache();

    cacheNeedUpdate = TRUE;
    if (gamemode == PLAY)
      updatesFogOfWarInCache(x1, y1, x2, y2);
    //updatesCache(x1, y1, x2, y2);
  }
}// panMap() --------------------------------------------------------------------


/**
 * navigate to center a given position
 */
void panToCenter(tile* t) {
  int i, j;

  int newfirstVisibleTileX = t->posX-(screen->w/TILESIZE)/2;
  int newfirstVisibleTileY = t->posY-(screen->h/TILESIZE)/2;

  if (newfirstVisibleTileX<0)
    newfirstVisibleTileX = 0;
  if (newfirstVisibleTileY<0)
    newfirstVisibleTileY = 0;

  if (newfirstVisibleTileX+screen->w/TILESIZE>=MapWidth)
    newfirstVisibleTileX = MapWidth-screen->w/TILESIZE-1;
  if (newfirstVisibleTileY+screen->h/TILESIZE>=MapHeight)
    newfirstVisibleTileY = MapHeight-screen->w/TILESIZE-1;

  if (newfirstVisibleTileX != firstVisibleTileX || newfirstVisibleTileY != firstVisibleTileY) {
    int w = screen->w/TILESIZE;
    int h = screen->h/TILESIZE;
    int x2 = newfirstVisibleTileX+w-1;
    int y2 = newfirstVisibleTileY+h-1;
    int x1 = newfirstVisibleTileX;
    if (firstVisibleTileX>newfirstVisibleTileX)
      x1 = firstVisibleTileX;
    else
      x2 = firstVisibleTileX+w-1;
    int y1 = newfirstVisibleTileY;
    if (firstVisibleTileY>newfirstVisibleTileY)
      y1 = firstVisibleTileY;
    else
      y2 = firstVisibleTileY+h-1;

    /*for (j=0; j<h; j++) {
      for (i=0; i<w; i++) {
        int u= (j)*(w)+(i);
        if (tilecache[u]->pixels!=NULL)
          printf ("*");
        else
          printf (".");
      }
      printf ("\n");
    }*/

    SDL_Surface ** tilecache2 = (SDL_Surface **)malloc(w*h*sizeof(SDL_Surface *));
    for (j=0; j<h; j++) {
      for (i=0; i<w; i++) {
        int i2 = i-newfirstVisibleTileX+firstVisibleTileX;
        int j2 = j-newfirstVisibleTileY+firstVisibleTileY;
        while (i2<0)
          i2+=w;
        while (i2>=w)
          i2-=w;
        while (j2<0)
          j2+=h;
        while (j2>=h)
          j2-=h;
        int u= (j)*(w)+(i);
        int v= (j2)*(w)+(i2);
        tilecache2[v] = tilecache[u];
      }
    }
    free(tilecache);
    tilecache = tilecache2;

    /*printf ("\n");
    for (j=0; j<h; j++) {
      for (i=0; i<w; i++) {
        int u= (j)*(w)+(i);
        if (tilecache[u]->pixels!=NULL)
          printf ("*");
        else
          printf (".");
      }
      printf ("\n");
    }
    printf ("\n");
    printf ("\n");
    printf ("\n");*/

    firstVisibleTileX = newfirstVisibleTileX;
    firstVisibleTileY = newfirstVisibleTileY;
    centerMap(firstVisibleTileX+screen->h/TILESIZE/2, firstVisibleTileY+screen->h/TILESIZE/2);
    updatesCache(-1, -1, -1, -1);
  }
}// panToCenter() --------------------------------------------------------------------


/**
 * update the few (but visible) tiles in cache with all their layers
 */
void updatesCache(int x1, int y1, int x2, int y2){
  updatesBackgroundInCache(x1, y1, x2, y2);
  //updatesFieldsInCache();
  updatesVegetationShadowInCache(x1, y1, x2, y2);
  updatesVegetationInCache(x1, y1, x2, y2);
  //updatesInfluencesInCache();
  updatesCitiesInCache(x1, y1, x2, y2);
  updatesRiversInCache(x1, y1, x2, y2);
  updatesRoadsInCache(x1, y1, x2, y2);
  updatesBonusesInCache(x1, y1, x2, y2);
  updatesCulturesInCache();
  updatesCityNamesInCache();
  if (gamemode == PLAY)
    updatesFogOfWarInCache(x1, y1, x2, y2);
  cacheNeedUpdate = FALSE;
}// updatesCache()


/**
 * move an unit list to the given destination. Make all the tests first
 * return how many units could move
 */
int moveUnitList(list_t *unitList, int x, int y) {
  //printf("  moveUnitList() : %i  units at %d, %d\n", list_count(unitList), x, y);
  int nbUnits = 0;
  lnode_t *unitelem = list_first(unitList);
  unit *unitNoi = (unit *)unitelem->list_data;

  // out of map
  if (x<0 || x>=MapWidth || y<0 || y>=MapHeight)
    return 0;

  int destNation = unitNoi->owner->nation;
  if (map[x+MapWidth*(y)].construction!=NULL && map[x+MapWidth*(y)].construction->size>0)
    destNation = map[x+MapWidth*(y)].construction->owner->nation;
  else if (map[x+MapWidth*(y)].unitList!=NULL && list_count(map[x+MapWidth*(y)].unitList)>0)
    destNation = ((unit*)list_first(map[x+MapWidth*(y)].unitList)->list_data)->owner->nation;

  // let's board
  if (!isNaval(unitNoi) &&  map[x+MapWidth*(y)].elevation<SEALEVEL && isFreeBoarding(&map[x+MapWidth*(y)], unitNoi)){
  // impossible for this ground unit
  } else if (!isNaval(unitNoi) && (map[x+MapWidth*(y)].elevation>=HIGHMOUNTAIN || map[x+MapWidth*(y)].elevation<SEALEVEL))
    return 0;
  // impossible for this naval unit
  else if (isNaval(unitNoi)==1 && (map[x+MapWidth*(y)].elevation>=SEALEVEL && map[x+MapWidth*(y)].construction==NULL && map[x+MapWidth*(y)].irrigation<BIG_RIVER))
    return 0;
  else if (isNaval(unitNoi)==2 && (map[x+MapWidth*(y)].elevation>=SEALEVEL && map[x+MapWidth*(y)].construction==NULL))
    return 0;

//if (map[x+MapWidth*(y)].construction!=NULL)
//printf("visit city ? %d %d\n", map[x+MapWidth*(y)].construction->type, map[x+MapWidth*(y)].construction->type&KNOWN_CITY);
  // run into lost city rumor
  if (map[x+MapWidth*(y)].construction!=NULL && map[x+MapWidth*(y)].construction->size<0) {
    discardPopup();
    popupUnitList = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(unitSelectionList);
    while(ln!=NULL&&ln!=&unitSelectionList->list_nilnode) {
      unit *u = (unit*)ln->list_data;
      list_append(popupUnitList, lnode_create(u));
      ln = ln->list_next;
    }
    char* text = (char *)malloc(64*sizeof(char));
    sprintf(text, "Do you want to explore this strange area ?");
    addPopupOption(text, NULL);
    sprintf(text, "Yes [[l%i,%i]]", x, y);
    addPopupOption(text, doExplore);
    sprintf(text, "Cancel");
    addPopupOption(text, doNothing);
    popupType = POPUP_MESSAGE|POPUP_YESNO;
    free(text);
    return 0;

  // if the leader is an army and the destination a potential ennemy ...
  } else if ( unitNoi->owner->nation != destNation && isArmy(unitNoi) && 
              unitNoi->owner->diplomaticRelations[destNation-FIRST_NATION] >= ANGRY && 
              unitNoi->owner->diplomaticRelations[destNation-FIRST_NATION] < WAR) {
    discardPopup();
    popupUnitList = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(unitSelectionList);
    while(ln!=NULL&&ln!=&unitSelectionList->list_nilnode) {
      unit *u = (unit*)ln->list_data;
      list_append(popupUnitList, lnode_create(u));
      ln = ln->list_next;
    }
    char* text = (char *)malloc(64*sizeof(char));
    const char *ennemy = getNationText(destNation);
    sprintf(text, "Do you want to start a war against %s ?", ennemy);
    addPopupOption(text, NULL);
    sprintf(text, "Declare War to [[%i]] !", destNation);
    addPopupOption(text, doDeclareWar);
    sprintf(text, "Cancel [[l%i,%i]] !", x, y);
    addPopupOption(text, doMove);
    popupType = POPUP_MESSAGE|POPUP_YESNO;
    free(text);
    return 0;
  
  // enter an indian city 
  } else if ( unitNoi->owner->nation != destNation && destNation>=FIRST_INDIAN_NATION && 
              unitNoi->owner->diplomaticRelations[destNation-FIRST_NATION] < WAR &&
              destNation<=LAST_INDIAN_NATION && (map[x+MapWidth*(y)].construction->type&KNOWN_CITY)==0) { 
    discardPopup();
    popupUnitList = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(unitSelectionList);
    while(ln!=NULL&&ln!=&unitSelectionList->list_nilnode) {
      unit *u = (unit*)ln->list_data;
      list_append(popupUnitList, lnode_create(u));
      ln = ln->list_next;
    }
    char* text = (char *)malloc(64*sizeof(char));
    const char *ennemy = getNationText(destNation);
    sprintf(text, "Do you want to meet the chief of this tribe of %s?", getNationText(destNation));
    addPopupOption(text, NULL);
    sprintf(text, "Let's smoke peace pipe [[%i]] !", (int)(map[x+MapWidth*(y)].construction));
    addPopupOption(text, doVisitIndianTribe);
    sprintf(text, "Cancel [[l%i,%i]] !", x, y);
    addPopupOption(text, doMove);
    popupType = POPUP_MESSAGE|POPUP_YESNO;
    free(text);
    return 0;
    
  // if the leader is an army and the destination an ennemy ...
  } else if ( unitNoi->owner->nation != destNation && isArmy(unitNoi) && 
              unitNoi->owner->diplomaticRelations[destNation-FIRST_NATION] >= WAR) {
    if (inspector->opponentl!=NULL){
      list_destroy_nodes(inspector->opponentl);
      list_destroy(inspector->opponentl);
    }

    if (!isThereArmy(x, y) && map[x+MapWidth*(y)].construction!=NULL){
      discardPopup();
      char* text = (char *)malloc(64*sizeof(char));
      int nation = map[x+MapWidth*(y)].construction->owner->nation;
      popupUnitList = list_create(LISTCOUNT_T_MAX);
      lnode_t *ln = list_first(unitSelectionList);
      while(ln!=NULL&&ln!=&unitSelectionList->list_nilnode) {
        unit *u = (unit*)ln->list_data;
        list_append(popupUnitList, lnode_create(u));
        ln = ln->list_next;
      }
      sprintf(text, "Do you want to take %s to %s?", map[x+MapWidth*(y)].construction->name, getNationText(nation));
      addPopupOption(text, NULL);
      //printf("2 sizes %i %i\n", sizeof(int), sizeof(city*) );
      sprintf(text, "Invade %s[[%i]]", map[x+MapWidth*(y)].construction->name, (int)(map[x+MapWidth*(y)].construction));
      addPopupOption(text, doInvade);
      addPopupOption("Cancel", doNothing);
      popupType = POPUP_MESSAGE|POPUP_YESNO;
      free(text);
      return 0;
    }
    inspector->opponentl = copylist(map[x+MapWidth*(y)].unitList);

    showPopupBattle();
    return 0;
  }

  int updatesTiles = 0;
  while (unitelem != &unitList->list_nilnode) {
    tile *t = unitNoi->location;
    int cost = 0;
    if (t!=NULL)
      cost = computeDifficulty(&map[t->posX+MapWidth*(t->posY)], &map[x+MapWidth*(y)], unitNoi);

    if ((cost<=unitNoi->movement && gamemode==PLAY) || gamemode==EDIT) {
      unitNoi->location = &map[x+MapWidth*(y)];
      if (gamemode==PLAY)
        unitNoi->movement -= cost;
      nbUnits++;

      if (t!=NULL) {
        lnode_t * ln = list_find(t->unitList, unitNoi, *straightCompare);
        if (ln!=0) {
          list_delete(t->unitList, ln);
          if (list_count(t->unitList)==0) {
            list_destroy(t->unitList);
            t->unitList = NULL;
          }
        }
      }

      // embark
      if (unitNoi->status==GOINGTO && unitNoi->maxLoad==0 && map[x+MapWidth*(y)].elevation<SEALEVEL && isFreeBoarding(&map[x+MapWidth*(y)], unitNoi)){
        if (unitNoi->itinerary!=NULL){
          list_destroy_nodes(unitNoi->itinerary);
          list_destroy(unitNoi->itinerary);
          unitNoi->itinerary   = NULL;
          unitNoi->destination = NULL;
        }
        unit *transport = isFreeBoarding(&map[x+MapWidth*(y)], unitNoi);
        good *g         = getFreeCargo(transport);
        g->passenger    = unitNoi;
        g->quantity     = 1;
        g->type         = unitNoi->type;
        unitNoi->status = ONBOARD;
      } else {
        // move
        if (map[x+MapWidth*(y)].unitList==NULL)
          map[x+MapWidth*(y)].unitList = list_create(LISTCOUNT_T_MAX);
        list_append(map[x+MapWidth*(y)].unitList, lnode_create(unitNoi));
      }

      // Here we are where we wanted to be
      if (unitNoi->status==GOINGTO && unitNoi->itinerary!=NULL && unitNoi->destination!=NULL && unitNoi->destination->posX==x && unitNoi->destination->posY==y) {
        list_destroy_nodes(unitNoi->itinerary);
        list_destroy(unitNoi->itinerary);
        unitNoi->itinerary   = NULL;
        unitNoi->destination = NULL;
        unitNoi->status      = WAITING;
      }
      // update our itinerary
      else if (unitNoi->status == GOINGTO && unitNoi->itinerary != NULL) {
        list_del_first(unitNoi->itinerary);
      }
    }

    updatesTiles += updatesVisibleSurroundings(unitNoi);

    unitelem = unitelem->list_next;
    unitNoi  = (unit *)unitelem->list_data;
  }

  return nbUnits;
}// moveUnitList() --------------------------------------------------------------------


/**
 * display info about the upcoming battle
 */
void showPopupBattle() {
  discardPopup();
  battle *bat = prepareBattle();
  int yAtt = 0;

  unit *leader = (unit*)list_first(inspector->ul)->list_data;
  if(isNaval(leader))
    setPopupDecoration(messageImages[BATTLE_SHIPS1-FIRST_MESSAGE]);
  else if (leader->type==ARTILLERY || leader->type==DAM_ARTILLERY)
    setPopupDecoration(messageImages[BATTLE_ART_ATT-FIRST_MESSAGE]);
  else if (leader->horses>0)
    setPopupDecoration(messageImages[BATTLE_CAV_ATT-FIRST_MESSAGE]);
  else
    setPopupDecoration(messageImages[BATTLE_SOLDIER_ATT-FIRST_MESSAGE]);

  char* text = (char *)malloc(1024*sizeof(char));
  int nation = ((unit *)list_first(inspector->opponentl)->list_data)->owner->nation;
  popupUnitList = list_create(LISTCOUNT_T_MAX);
  lnode_t *ln = list_first(unitSelectionList);
  while(ln!=NULL && ln!=&unitSelectionList->list_nilnode) {
    list_append(popupUnitList, lnode_create(ln->list_data));
    ln = ln->list_next;
  }

  tile *loc      = leader->location;
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  rect->y = 5;
  int totA=0;
  if (inspector->ul!=NULL && list_count(inspector->ul)>0) {
    lnode_t *ln = list_first(inspector->ul);
    while (ln != &inspector->ul->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      ln = ln->list_next;
      rect->x = 5;
      SDL_Surface *imgunit = getUnitImage(uni);
      int strength = getBattleStrength(uni, loc, TRUE);
      sprintf(text, "%i x %i", strength, uni->health);

      SDL_Surface *img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[uni->owner->nation-FIRST_NATION]);
      SDL_Surface *img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
      SDL_BlitSurfaceColW(imgunit, NULL, popupDecoration, rect, 255, FALSE, nationColors[uni->owner->nation-FIRST_NATION]);
      SDL_BlitSurface(imgunit, NULL, popupDecoration, rect);
      rect->y += imgunit->h-img1->h+1;
      rect->x += imgunit->w+5;
      SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
      rect->y --;rect->x--;
      SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
      rect->x++;
      SDL_FreeSurface(img2);
      SDL_FreeSurface(img1);
      sprintf(text, "%i", strength*uni->health);
      totA += strength*uni->health;
      TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
      img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[uni->owner->nation-FIRST_NATION]);
      img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
      TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
      rect->x = popupDecoration->w/2-5-img1->w;
      SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
      rect->x --;rect->y --;
      SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
      rect->x ++;rect->y ++;
      rect->y += img1->h+5;
      SDL_FreeSurface(img2);
      SDL_FreeSurface(img1);
    }
  }
  yAtt = rect->y;

  leader = (unit *)list_first(inspector->opponentl)->list_data;
  loc    = leader->location;
  rect->y = 5;
  int totD=0;
  if (inspector->opponentl!=NULL &&list_count(inspector->opponentl)>0) {
    lnode_t *ln = list_first(inspector->opponentl);
    while (ln != &inspector->opponentl->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      ln = ln->list_next;
      rect->x = popupDecoration->w-5;
      SDL_Surface *imgunit = getUnitImage(uni);
      int strength = getBattleStrength(uni, loc, FALSE);
      sprintf(text, "%i x %i", strength, uni->health);
      SDL_Surface *img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[uni->owner->nation-FIRST_NATION]);
      SDL_Surface *img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
      rect->x -=imgunit->w;
      SDL_BlitSurfaceColW(imgunit, NULL, popupDecoration, rect, 255, FALSE, nationColors[uni->owner->nation-FIRST_NATION]);
      SDL_BlitSurface(imgunit, NULL, popupDecoration, rect);
      rect->y += imgunit->h-img1->h+1;
      rect->x -= img1->w+5;
      SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
      rect->y --;rect->x--;
      SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
      rect->x++;
      SDL_FreeSurface(img2);
      SDL_FreeSurface(img1);
      sprintf(text, "%i", strength*uni->health);
      totD += strength*uni->health;
      TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
      img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[uni->owner->nation-FIRST_NATION]);
      img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
      TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
      rect->x = popupDecoration->w/2+5;
      SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
      rect->x --;rect->y --;
      SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
      rect->x ++;rect->y ++;
      rect->x = 5;
      rect->y += img1->h+5;
      SDL_FreeSurface(img2);
      SDL_FreeSurface(img1);

    }
  }
  if (rect->y<yAtt)
    rect->y = yAtt;
  else
    yAtt = rect->y;

  // Attack summary
  leader = (unit*)list_first(inspector->ul)->list_data;
  loc    = leader->location;
  hlineRGBA(popupDecoration,5, popupDecoration->w/2-5, rect->y, 0, 0, 0, 255);
  rect->x = 15;
  sprintf(text, "Total");
  SDL_Surface *img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  SDL_Surface *img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
  rect->y += 5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->y --;rect->x--;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x++;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  sprintf(text, "%i", totA);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2-5-img1->w;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  rect->x = 15;
  sprintf(text, "Bonus");
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
  rect->y += 5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->y --;rect->x--;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x++;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  if (bat->attackBonusMalus>1)
    sprintf(text, "+%i%%", (int)((bat->attackBonusMalus-1)*100));
  else if (bat->attackBonusMalus<1)
    sprintf(text, "-%i%%", (int)((1-bat->attackBonusMalus)*100));
  else
    sprintf(text, "NONE");
  TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2-5-img1->w;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  hlineRGBA(popupDecoration, popupDecoration->w/4, popupDecoration->w/2-5, rect->y, 0, 0, 0, 255);
  sprintf(text, "%i", (int)(bat->attackStrength*bat->attackBonusMalus));
  TTF_SetFontStyle(fonts[16], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[16], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[16], text, BLACK);
  TTF_SetFontStyle(fonts[16], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2-5-img1->w;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);

  // Defense summary
  rect->y = yAtt;
  leader = (unit*)list_first(inspector->opponentl)->list_data;
  loc    = leader->location;
  hlineRGBA(popupDecoration, popupDecoration->w/2+5, popupDecoration->w-5, rect->y, 0, 0, 0, 255);
  sprintf(text, "Total");
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
  rect->x = popupDecoration->w-img1->w-15;
  rect->y += 5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->y --;rect->x--;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x++;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  sprintf(text, "%i", totD);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2+5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;  
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  sprintf(text, "Bonus");
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, WHITE);
  rect->x = popupDecoration->w-img1->w-15;
  rect->y += 5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->y --;rect->x--;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x++;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  if (bat->defenseBonusMalus>1)
    sprintf(text, "+%i%%", (int)((bat->defenseBonusMalus-1)*100));
  else if (bat->defenseBonusMalus<1)
    sprintf(text, "-%i%%", (int)((1-bat->defenseBonusMalus)*100));
  else
    sprintf(text, "NONE");
  TTF_SetFontStyle(fonts[14], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[14], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[14], text, BLACK);
  TTF_SetFontStyle(fonts[14], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2+5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;  
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);
  hlineRGBA(popupDecoration, popupDecoration->w/2+5, 3*popupDecoration->w/4, rect->y, 0, 0, 0, 255);
  sprintf(text, "%i", (int)(bat->defenseStrength*bat->defenseBonusMalus));
  TTF_SetFontStyle(fonts[16], TTF_STYLE_BOLD);
  img1 = TTF_RenderText_Blended(fonts[16], text, *nationColors[leader->owner->nation-FIRST_NATION]);
  img2 = TTF_RenderText_Blended(fonts[16], text, BLACK);
  TTF_SetFontStyle(fonts[16], TTF_STYLE_NORMAL);
  rect->x = popupDecoration->w/2+5;
  SDL_BlitSurfaceRGBAMul(img2, NULL, popupDecoration, rect);
  rect->x --;rect->y --;
  SDL_BlitSurfaceRGBAMul(img1, NULL, popupDecoration, rect);
  rect->x ++;rect->y ++;
  rect->y += img1->h+5;
  SDL_FreeSurface(img2);
  SDL_FreeSurface(img1);

  free(rect);
  list_destroy_nodes(bat->attackerlist);
  list_destroy(bat->attackerlist);
  list_destroy_nodes(bat->defenderlist);
  list_destroy(bat->defenderlist);
  free(bat->text);
  free(bat);

  sprintf(text, "Do you really want to fight %s?\n\nChance to win : %2.0f%%", getNationText(nation), 100.0f*(bat->attackBonusMalus*bat->attackStrength)/(bat->defenseBonusMalus*bat->defenseStrength+bat->attackBonusMalus*bat->attackStrength));
  addPopupOption(text, NULL);
  free(text);
  addPopupOption("FIGHT", doFight);
  addPopupOption("Cancel", doNothing);
  popupType = POPUP_MESSAGE|POPUP_YESNO;

  //printf("showPopupBattle(%p)\n", popupDecoration);
}// showPopupBattle()


/**
 * update the unit inspector to display the given list of units
 */
void updatesInspector(list_t *ul, list_t *oppl){
  if (inspector->ul!=NULL)
    list_destroy_nodes(inspector->ul);
  if (inspector->opponentl!=NULL)
    list_destroy_nodes(inspector->opponentl);

  if (ul!=NULL) {
    if (inspector->ul==NULL)
      inspector->ul = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(ul);
    while (ln != &ul->list_nilnode){
      unit *u = (unit *)ln->list_data;
      if (u->owner==currentPlayerElement->list_data)
        list_append(inspector->ul, lnode_create(u));
      ln = ln->list_next;
    }
  }
  if (oppl!=NULL) {
    if (inspector->opponentl==NULL)
      inspector->opponentl = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(oppl);
    while (ln != &oppl->list_nilnode){
      unit *u = (unit *)ln->list_data;
      if (u->owner!=currentPlayerElement->list_data)
        list_append(inspector->opponentl, lnode_create(u));
      ln = ln->list_next;
    }
  }
  inspector->needUpdate = TRUE;
}// updatesInspector()


/**
 * find the first waiting unit and select it
 */
int selectNextWaitingUnitWithoutFocusing() {
  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  list_t  *allUnitList   = currentPlayer->unitList;
  if (list_count(allUnitList)==0)
    return 0;
  lnode_t *unitelem;

  // nothing was selected previously, let's find the first unit of the current player
  if (list_count(unitSelectionList)==0) {
    unitelem      = list_first(allUnitList);
    unit *u = (unit *)unitelem->list_data;
    //printf(" test %p %p %d    mov=%d  => %d  move=%d!\n",  u, (u->location) , (u->status!=WAITING), u->movement, (u->location==NULL || u->status!=WAITING || !canMove(u)), u->status);
    //if (u->location!=NULL)
    //  printf("loc = %i, %i", u->location->posX, u->location->posY);

    while((unitelem !=  &allUnitList->list_nilnode) && (u->location==NULL || u->status!=WAITING || !canMove(u))) {
      unitelem=unitelem->list_next;
      //printf(" test %p %p %d    mov=%d  => %d  can move=%d!\n",  u, (u->location) , (u->status!=WAITING), u->movement, (u->location==NULL || u->status!=WAITING || !canMove(u)), u->status);
      //fflush(stdout);
      //if (u->location!=NULL)
        //printf("  %d\n", !canMove(u));

      if (unitelem !=  &allUnitList->list_nilnode)
        u = (unit *)unitelem->list_data;
    }
    //printf(" found %p %p %d    mov=%d  => %d!\n",  u, u->location , (u->status!=WAITING), u->movement, (u->location==NULL || u->status!=WAITING || !canMove(u)));
    if (unitelem ==  &allUnitList->list_nilnode)
      return 0;

    if(u && u->location!=NULL && u->status==WAITING) {
      unitSelectionList     = defaultSelectionList;
      list_append(unitSelectionList, lnode_create(u));
      /*printf("(...) %p !\n",  unitSelectionList);
      if (unitSelectionList!=NULL){
        printf("   %i !\n",  list_count(unitSelectionList));
        if (list_count(unitSelectionList)>0){
          printf("   %p !\n",  ((unit*)list_first(unitSelectionList)->list_data)->location);
          printf("   %i, %i !\n",  ((unit*)list_first(unitSelectionList)->list_data)->location->posX, ((unit*)list_first(unitSelectionList)->list_data)->location->posY);
        }
      }*/
      return 1;
    }
    return 0;
  }

  unitelem               = list_last(unitSelectionList);
  unit    *lastSelected  = (unit *)unitelem->list_data;
  player  *selectPlayer  = lastSelected->owner;
  allUnitList            = selectPlayer->unitList;

  lnode_t *ln            = list_find(allUnitList, lastSelected, *straightCompare);
  if (ln==NULL) {
    unitSelectionList      = defaultSelectionList;
    list_destroy_nodes(unitSelectionList);
    unit *u = (unit *)list_first(allUnitList)->list_data;
    list_append(unitSelectionList, lnode_create(u));
    /*if (inspector->ul!=NULL){
      list_destroy_nodes(inspector->ul);
      list_destroy(inspector->ul);
    }
    inspector->ul = copylist(unitSelectionList);
    inspector->t = u->location;
    inspector->needUpdate = TRUE;*/
    updatesInspector(unitSelectionList, NULL);
    return 0;
  }

  unit *unitNoi = (unit *)ln->list_data;

  // skip the current selection
  while (list_find(unitSelectionList, unitNoi, *straightCompare)!=0) {
    ln = ln->list_next;
    unitNoi = (unit *)ln->list_data;
  }
  unitNoi = (unit *)ln->list_data;

  while (ln !=  &allUnitList->list_nilnode) {
    unitNoi = (unit *)ln->list_data;

    if (unitNoi->status==WAITING && unitNoi->location!=NULL && canMove(unitNoi) && (selectPlayer==currentPlayer || unitNoi->location->lastExplored==0)) {
      unitSelectionList     = defaultSelectionList;
      list_destroy_nodes(unitSelectionList);
      list_append(unitSelectionList, lnode_create(unitNoi));
      if (unitNoi->location->posX<firstVisibleTileX || unitNoi->location->posY<firstVisibleTileY || unitNoi->location->posX>firstVisibleTileX+screen->w/TILESIZE ||
          unitNoi->location->posY>firstVisibleTileY+screen->h/TILESIZE) {
        panToCenter(unitNoi->location);
        updatesInspector(unitSelectionList, NULL);
      }
      return 1;
    }
    ln = ln->list_next;
  }
  ln = list_first(allUnitList);
  while (ln->list_data !=  lastSelected) {
    unit *unitNoi = (unit *)ln->list_data;
    if (unitNoi->status==WAITING && unitNoi->location!=NULL && canMove(unitNoi)) {
      unitSelectionList     = defaultSelectionList;
      list_destroy_nodes(unitSelectionList);
      list_append(unitSelectionList, lnode_create(unitNoi));
      if (unitNoi->location->posX<firstVisibleTileX || unitNoi->location->posY<firstVisibleTileY || unitNoi->location->posX>firstVisibleTileX+screen->w/TILESIZE ||
          unitNoi->location->posY>firstVisibleTileY+screen->h/TILESIZE) {
        panToCenter(unitNoi->location);
        updatesInspector(unitSelectionList, NULL);
      }
      return 1;
    }
    ln = ln->list_next;
  }

  unitelem = list_first(unitSelectionList);
  unit *u = (unit *)unitelem->list_data;
  if (u==NULL || u->location==NULL) {
    unitSelectionList     = defaultSelectionList;
    list_destroy_nodes(unitSelectionList);
    updatesInspector(NULL, NULL);
    return 0;
  }

  return 1;
}// selectNextWaitingUnitWithoutFocusing() --------------------------------------------------------------------


/**
 * find the first waiting unit, select it and pan the map if necessary
 */
int selectNextWaitingUnit() {
  if (currentPlayerElement==NULL)
    return 0;
  int r = selectNextWaitingUnitWithoutFocusing();
  if (list_count(unitSelectionList)==0)
    return 0;

  // let's be sure the selected units are on top of their tile
  lnode_t *unitelem = list_first(unitSelectionList);
  unit *u           = (unit*)unitelem->list_data;
  list_t *ul        = u->location->unitList;
  while  (unitelem!=NULL && unitelem!=&unitSelectionList->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    unitelem = unitelem->list_next;

    lnode_t *corres = list_find(ul, u, straightCompare);
    if (corres!=NULL) {
      list_delete(ul, corres);
      list_append(ul, corres);
    }
  }

  /*printf("selectNextWaitingUnit() %p !\n",  unitSelectionList);
  if (unitSelectionList!=NULL){
    printf("   %i !\n",  list_count(unitSelectionList));
    if (list_count(unitSelectionList)>0){
      unit* u0 = (unit*)(list_first(unitSelectionList)->list_data);
      printf("   %p !\n",  u0->location);
      printf("   %i, %i !\n",  u0->location->posX, u0->location->posY);
    }
  }  */

  if (unitSelectionList!=NULL && !list_isempty(unitSelectionList)) {
    if (inspector!=NULL)
      updatesInspector(unitSelectionList, NULL);

    //TODO only pan if too far from previous focus
    //TODO smooth pan !
    if (((unit *)list_first(unitSelectionList)->list_data)->location!=NULL) {
      panToCenter(((unit *)list_first(unitSelectionList)->list_data)->location);
    }
  }
  return r;
}// selectNextWaitingUnit() --------------------------------------------------------------------


/**
 * create a road between 2 cities
 */
int createRoadBetweenCities(const city *c1, const city *c2) {
  //printf("\n\n\ncreateRoadBetweenCities( %i, %i->%i, %i)\n", c1->location->posX, c1->location->posY, c2->location->posX, c2->location->posY);
  gamemode=EDIT;
  int nbtile = 0;
  unitSample->location = c1->location;
  list_t *roadItinerary = astarSearch(c1->location->posX, c1->location->posY, c2->location->posX, c2->location->posY, unitSample);
  if (roadItinerary!=NULL) {
    lnode_t *tileelem = list_first(roadItinerary);
    while (tileelem!=NULL && tileelem != &roadItinerary->list_nilnode) {
      nbtile ++;
      tile *t = (tile*)tileelem->list_data;
      t->road = ROAD;
      tileelem = tileelem->list_next;
    }
    list_destroy_nodes(roadItinerary);
    list_destroy(roadItinerary);
  }
  unitSample->location = NULL;
  //destroyUnit(u);
  c1->location->road = ROAD;
  gamemode=PLAY;
  return nbtile;
}// createRoadBetweenCities() --------------------------------------------------------------------


/**
 * extend river node by node to reach that other given point (from down to up only!)
 */
btnode_t *extendRiverNodes(river *river0, btnode_t *node, int x, int y) {
  gamemode          = EDIT;
  btnode_t *btnode0 = node;
  tile     *src     = (tile *)(node->elem);
  tile     *dst     = &map[x+MapWidth*y];
  //printf("extendRiverNodes( %i, %i->%i, %i)\n", src->posX, src->posY, dst->posX, dst->posY);
  if (src==dst)
    return node;

  unit *u;
  u = createUnitAt(SCOUT, NULL, src->posX, src->posY);
  if (u==NULL)
    return NULL;

  if (abs(src->posX-dst->posX)<2 && abs(src->posY-dst->posY)<2){
    if (btnode0->left==NULL)
      btnode0 = binarytree_ins_left(river0->itinerary, btnode0, btnode_create(dst));
    else if (btnode0->right==NULL)
      btnode0 = binarytree_ins_right(river0->itinerary, btnode0, btnode_create(dst));
    else return NULL;
    destroyUnit(u);
    return btnode0;
  }

  // this is a very particular case to indicate, this unit can only move up or go on flat land!
  u->horses = -101;
  list_t *riverItinerary = (list_t *)astarSearch(src->posX, src->posY, dst->posX, dst->posY, u);
  if (u->horses != -101)
    printf("ERROR: A* corrupted data !\n");

  if (riverItinerary!=NULL) {
    lnode_t *tileelem = list_first(riverItinerary);
    while (tileelem!=NULL && tileelem != &riverItinerary->list_nilnode) {
      tile *t = (tile*)tileelem->list_data;
      //printf("TRY adding tile %i, %i\n", t->posX, t->posY);
      if (t->river_elem!=NULL){
        //printf("  There is already a river here !\n");
        break;
      }
      if (btnode0->left==NULL)
        btnode0 = binarytree_ins_left(river0->itinerary, btnode0, btnode_create(t));
      else if (btnode0->right==NULL)
        btnode0 = binarytree_ins_right(river0->itinerary, btnode0, btnode_create(t));
      if (btnode0==NULL){
        printf("ERROR: Insertion didn't work !\n");
        break;
      }
      t->river_elem = btnode0;
      tileelem = tileelem->list_next;
    }
    list_destroy_nodes(riverItinerary);
    list_destroy(riverItinerary);
  } else {
    printf("\nERROR: A* didn't work to draw river path! we used a %s(%i horses)\n", getUnitText(u), u->horses);

  }

  destroyUnit(u);
  gamemode = PLAY;
  return btnode0;
}// extendRiverNodes() --------------------------------------------------------------------


/**
 * destroy a unit .. everywhere it is !
 */
void destroyUnit(unit *u) {
  //if (u->owner!=NULL)
  //  printf("destroyUnit(%s-%s   %p)\n", getUnitText(u), nationTexts[u->owner->nation-FIRST_NATION], u);fflush(stdout);

  if (u->itinerary!=NULL){
    list_destroy_nodes(u->itinerary);
    list_destroy(u->itinerary);
    u->itinerary = NULL;
  }

  if (u->group!=NULL) {
    lnode_t *ln = list_first(u->group);
    while (ln!=NULL && ln!=&u->group->list_nilnode){
      unit *expartner = (unit*)ln->list_data;
      if (expartner!=u){
        lnode_t *ln0 = list_find(expartner->group, u, straightCompare);
        if (ln0!=NULL)
          list_delete(expartner->group, ln0);
      }
      ln = ln->list_next;
    }
  }

  if (u->location!=NULL) {
    tile *t = &(map[u->location->posX+MapWidth*u->location->posY]);
    lnode_t *ln = list_find(t->unitList, u, straightCompare);
    if (ln != NULL)
      list_delete(map[u->location->posX+MapWidth*u->location->posY].unitList, ln);
  }

  if (u->lastBuilding!=NULL) {
    lnode_t *ln = list_find(u->lastBuilding->workers, u, straightCompare);
    if (ln!= NULL)
      list_delete(u->lastBuilding->workers, ln);
  }

  if (unitSelectionList!=NULL) {
    lnode_t *ln = list_find(unitSelectionList, u, straightCompare);
    if (ln!= NULL){
      list_delete(unitSelectionList, ln);
      //printf("...removed from selection %p \n", unitSelectionList);
    }
  }


  if (inspector!=NULL && inspector->ul!=NULL) {
    lnode_t *ln = list_find(inspector->ul, u, straightCompare);
    if (ln!= NULL)
      list_delete(inspector->ul, ln);
  }

  if (inspector!=NULL && inspector->opponentl!=NULL) {
    lnode_t *ln = list_find(inspector->opponentl, u, straightCompare);
    if (ln!= NULL)
      list_delete(inspector->opponentl, ln);
  }
  player *owner = u->owner;
  if (owner!=NULL) {
    lnode_t *ln= list_find(owner->unitList, u, straightCompare);
    list_delete(owner->unitList, ln);
  }

  free(u);
}// destroyUnit()


/**
 * create a unit with the given parameters and located at the given position on the map
 */
unit *createUnitAt (int unitType, player* owner, int x, int y) {
  /*if(x==133 && y==90)
    printf("createUnitAt %i => %i,%i    for %p\n",  unitType, x, y, owner);*/
  if (x<0 || x>=MapWidth || y<0 || y>=MapHeight)
    return NULL;
  unit *u = createUnit(unitType, owner);
  /*if(x==133 && y==90) {
    printf("   u= %i %i\n",  u->type, isNaval(u));
    printf("   elevation= %i\n", map[x+MapWidth*(y)].elevation);
    printf("   construction= %i\n", map[x+MapWidth*(y)].construction);
    printf("   irrigation= %i\n", map[x+MapWidth*(y)].irrigation);
  }*/
  if (owner!=NULL && isNaval(u)==1 && (map[x+MapWidth*(y)].elevation>=SEALEVEL && map[x+MapWidth*(y)].construction==NULL && map[x+MapWidth*(y)].irrigation<BIG_RIVER)) {
    fprintf(stderr, "***ERROR***: It is impossible to create a boat(%s %s) on land where there isnt'a a city or a river %d, %d!\n", nationTexts[owner->nation-FIRST_NATION], unitTexts[unitType-FIRST_UNIT], x, y);
    //fflush(stdout);
    lnode_t *ln= list_find(owner->unitList, u, straightCompare);
    list_delete(owner->unitList, ln);
    free(u);
    return NULL;
  } else if (owner!=NULL && isNaval(u)==2 && (map[x+MapWidth*(y)].elevation>=SEALEVEL && map[x+MapWidth*(y)].construction==NULL)) {
    fprintf(stderr, "***ERROR***: It is impossible to create a big boat(%s %s) on land where there isnt'a a city %d, %d!\n", nationTexts[owner->nation-FIRST_NATION], unitTexts[unitType-FIRST_UNIT], x, y);
    lnode_t *ln= list_find(owner->unitList, u, straightCompare);
    list_delete(owner->unitList, ln);
    free(u);
    return NULL;
  } else if (owner!=NULL && !isNaval(u) && (map[x+MapWidth*(y)].elevation<SEALEVEL)) {
    fprintf(stderr, "***ERROR***: It is impossible to create a non naval unit on sea %d, %d!\n", x, y);
    lnode_t *ln= list_find(owner->unitList, u, straightCompare);
    list_delete(owner->unitList, ln);
    free(u);
    return NULL;
  }
  u->location       = &map[x+MapWidth*(y)];

  if (u->location->construction!=NULL)
    u->lastCity    = u->location->construction;
  if (map[x+MapWidth*(y)].unitList==NULL)
    map[x+MapWidth*(y)].unitList = list_create(LISTCOUNT_T_MAX);

  list_append(map[x+MapWidth*(y)].unitList, lnode_create(u));

  if (u->location==(void*)0xFF){
    fprintf(stderr, "***ERROR***: bad location ! %d, %d!\n", x, y);
    fflush(stdout);
  }

  return u;
}// createUnitAt() --------------------------------------------------------------------


/**
 * create a unit with the given parameters
 */
unit *createUnit (int unitType, player* owner) {
  // create initial value
  unit *newUnit            = (unit *)malloc(sizeof(unit));
  if (newUnit==NULL)
    exit(444);
  newUnit->type            = unitType;
  newUnit->location        = NULL;
  newUnit->status          = WAITING;
  newUnit->tools           = 0;
  newUnit->muskets         = 0;
  newUnit->horses          = 0;
  newUnit->sight           = 2;
  newUnit->maxMovement     = 30;
  newUnit->itinerary       = NULL;
  newUnit->location        = NULL;
  newUnit->owner           = owner;
  newUnit->maxLoad         = 0;
  newUnit->goods           = NULL;
  newUnit->maxHealth       = 100;
  newUnit->health          = 100;
  newUnit->experience      = 0;
  newUnit->lastCity        = NULL;
  newUnit->destination     = NULL;
  newUnit->itinerary       = NULL;
  newUnit->lastWorkingTile = 0;
  newUnit->lastBuilding    = NULL;
  newUnit->group           = NULL;

  if (owner!=NULL)
    list_append(owner->unitList, lnode_create(newUnit));

  switch (unitType) {
  case PIONEER :
    newUnit->tools = 100;
    break;

  case SOLDIER :
  case ROYAL :
  case COLONIAL :
    newUnit->muskets = 100;
    break;

  case BLACKSMITH :
    break;

  case CARPENTER :
    break;

  case FARMER :
    break;

  case MILKMAID :
    break;

  case OREMINER :
    break;

  case SILVERMINER :
    break;

  case WEAVER :
    break;

  case COTTONPLANTER :
    break;

  case DISTILLER :
    break;

  case SUGARPLANTER :
    break;

  case TOBACCONIST :
    break;

  case TOBACCOPLANTER :
    break;

  case FISHERMAN :
    break;

  case FURTRAPPER :
    break;

  case LUMBERJACK :
    break;

  case FURTRADDER :
    break;

  case PREACHER :
    break;

  case STATEMAN :
    newUnit->maxMovement = newUnit->maxMovement*5/6;
    break;

  case GUNSMITH :
    break;

  case SERVANT :
    newUnit->maxMovement = newUnit->maxMovement*5/6;
    break;

  case CRIMINAL :
    newUnit->maxMovement = newUnit->maxMovement*5/6;
    break;

  case INDIAN :
    newUnit->maxMovement = newUnit->maxMovement*5/6;
    break;

  case CONVERT:
    newUnit->maxMovement = newUnit->maxMovement*5/6;
    break;

  case MISSIONNARY :
  case MORMON :
    //newUnit->isBlessed = TRUE;
    break;

  case WAGON :
    newUnit->maxLoad  = 2;
    break;

  case CARAVEL :
    newUnit->maxMovement = 120;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 3;
    break;

  case MERCHANTMAN :
    newUnit->maxMovement = 160;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 4;
    break;

  case GALLEON :
    newUnit->maxMovement = 180;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 6;
    break;

  case PRIVATEER :
    newUnit->maxMovement = 240;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 3;
    break;

  case FRIGATE :
    newUnit->maxMovement = 200;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 4;
    break;

  case MAN_O_WAR :
    newUnit->maxMovement = 180;
    newUnit->sight       = 4;
    newUnit->maxLoad     = 3;
    break;

  case SCOUT :
    newUnit->maxMovement = (int)(newUnit->maxMovement*1.5);
    newUnit->sight       = 3;
    newUnit->horses      = 50;
    break;

  case COLONIST :
  default :
    break;
  }

  if (newUnit->maxLoad>0) {
    newUnit->goods    = (good*)malloc(newUnit->maxLoad*sizeof(good));
    int k;
    for (k=0; k<newUnit->maxLoad; k++) {
      newUnit->goods[k].quantity  = 0;
      newUnit->goods[k].type      = CORN;
      newUnit->goods[k].passenger = NULL;
    }
  }
  if (newUnit->horses == 50)
    newUnit->maxMovement = newUnit->maxMovement*2;

  newUnit->movement = newUnit->maxMovement;
  return newUnit;
}// createUnit() --------------------------------------------------------------------


/**
 * add horses to a given unit if possible ! return FALE otherwise
 */
int addHorses(unit *u) {
  if (u->horses>0 || u->type>=FIRST_SPECIAL)
    return FALSE;
  u->horses = 50;
  u->maxMovement = u->maxMovement*2;
  u->movement    = u->movement*2;
  return TRUE;
}// addHorses()


/**
 * remove horses to a given unit if possible ! return FALE otherwise
 */
int removeHorses(unit *u) {
  if (u->horses<50 || u->type>=FIRST_SPECIAL)
    return FALSE;
  u->horses = 0;
  u->maxMovement = u->maxMovement/2;
  u->movement    = u->movement/2;
  return TRUE;
}// removeHorses()


/**
 * return if an unit is naval meanning it travel on seas
 */
int isNaval(unit *u) {
  if (u->type==CARAVEL || u->type==PRIVATEER)
    return 1;
  else if(u->type>=CARAVEL && u->type<=MERCHANTMAN)
    return 2;
  else
    return 0;
}// isNaval() --------------------------------------------------------------------


/**
 * return if an unit is an army
 */
int isArmy(unit *u) {
  if (u->muskets>=50 || u->type==ARTILLERY)
    return 1;
  else if(u->type>=PRIVATEER || u->type<=FRIGATE || u->type<=GALLEON)
    return 2;
  else
    return 0;
}// isArmy() --------------------------------------------------------------------


/**
 * recursively destroy the up river to a given node
 */
void destroyUpRiver_r(btnode_t *node) {
  if (node->left !=NULL)
    destroyUpRiver_r(node->left);
  if (node->right !=NULL)
    destroyUpRiver_r(node->right);
  tile *t = (tile*)node->elem;
  t->river_elem = NULL;
  updatesCachedTileAt(t->posX, t->posY);
  free(node);
}// destroyUpRiver_r() --------------------------------------------------------------------


/**
 * recursively refresh the up river to a given node
 */
void updateUpRiver_r(btnode_t *node) {
  if (node->left !=NULL)
    updateUpRiver_r(node->left);
  if (node->right !=NULL)
    updateUpRiver_r(node->right);
  tile *t = (tile*) node->elem;
  updatesCachedTileAt(t->posX, t->posY);
}// updateUpRiver_r() --------------------------------------------------------------------


/**
 * recursively find if a water tile is a lake or a sea (connected to one of the border of the map or big enough)
 */
int isLake_r(list_t *l, int x, int y) {
  if (x==0 || x==MapWidth-1 || y==0 || y==MapHeight-1 || list_count(l)>MAX_TILE_FOR_LAKE) {
    if (!list_find(l, &map[x+MapWidth*(y)], straightCompare))
      list_append(l, lnode_create(&map[x+MapWidth*(y)]));
    return FALSE;
  }

  list_t *l2 = list_create(8);
  if (!list_find(l, &map[x-1+MapWidth*(y-1)], straightCompare) && map[x-1+MapWidth*(y-1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x-1+MapWidth*(y-1)]));
  if (!list_find(l, &map[x+MapWidth*(y-1)], straightCompare) && map[x+MapWidth*(y-1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x+MapWidth*(y-1)]));
  if (!list_find(l, &map[x+1+MapWidth*(y-1)], straightCompare) && map[x+1+MapWidth*(y-1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x+1+MapWidth*(y-1)]));
  if (!list_find(l, &map[x+1+MapWidth*(y)], straightCompare) && map[x+1+MapWidth*(y)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x+1+MapWidth*(y)]));
  if (!list_find(l, &map[x+1+MapWidth*(y+1)], straightCompare) && map[x+1+MapWidth*(y+1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x+1+MapWidth*(y+1)]));
  if (!list_find(l, &map[x+MapWidth*(y+1)], straightCompare) && map[x+MapWidth*(y+1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x+MapWidth*(y+1)]));
  if (!list_find(l, &map[x-1+MapWidth*(y+1)], straightCompare) && map[x-1+MapWidth*(y+1)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x-1+MapWidth*(y+1)]));
  if (!list_find(l, &map[x-1+MapWidth*(y)], straightCompare) && map[x-1+MapWidth*(y)].elevation<SEALEVEL)
    list_append(l2, lnode_create(&map[x-1+MapWidth*(y)]));

  if (list_count(l2)==0) {
    if (!list_find(l, &map[x+MapWidth*(y)], straightCompare))
      list_append(l, lnode_create(&map[x+MapWidth*(y)]));
    list_destroy(l2);
    l2 = NULL;
    return !FALSE;
  }

  if (list_count(l2)+list_count(l)>MAX_TILE_FOR_LAKE) {
    list_sort(l,  tileCompare);
    list_sort(l2, tileCompare);
    list_merge(l, l2, tileCompare);
    list_destroy(l2);
    l2 = NULL;
    return FALSE;
  }

  list_sort(l2, tileCompare);
  if (!list_find(l, &map[x+MapWidth*(y)], straightCompare))
    list_append(l, lnode_create(&map[x+MapWidth*(y)]));

  lnode_t *ln = list_first(l2);
  while (ln!=&l2->list_nilnode) {
    tile *t = (tile*)ln->list_data;
    int res;
    res = isLake_r(l, t->posX, t->posY);
    if (!res) {
      list_destroy_nodes(l2);
      list_destroy(l2);
      l2 = NULL;
      return FALSE;
    }
    ln = ln->list_next;
  }
  list_destroy_nodes(l2);
  list_destroy(l2);
  l2 = NULL;
  return !FALSE;
}// isLake_r()


/**
 * return if a water tile is a lake or a sea (connected to one of the border of the map)
 *
int isLake(int x, int y) {
  if (map[x+MapWidth*(y)].elevation>=SEALEVEL)
    return FALSE;
  else {
    list_t *l = list_create(LISTCOUNT_T_MAX);
    int res = isLake_r(l, x, y);
    list_destroy_nodes(l);
    list_destroy(l);
    return res;
  }
}// isLake()*/


/**
 * return if a tile is connected to drinkable water (lake or river)
 */
int isConnectedToWater(int x, int y) {
  if (map[x+MapWidth*(y)].river_elem!=NULL)
    return !FALSE;

  int dx, dy;
  for (dx=-1; dx<2; dx++)
    for (dy=-1; dy<2; dy++)
      if (x+dx>=0 && y+dy>=0 && x+dx<MapWidth && y+dy<MapHeight)
        if (map[x+dx+MapWidth*(y+dy)].river_elem!=NULL && map[x+dx+MapWidth*(y+dy)].elevation>=map[x+MapWidth*(y)].elevation)
          return !FALSE;
        else if (map[x+dx+MapWidth*(y+dy)].elevation<SEALEVEL)
          return map[x+dx+MapWidth*(y+dy)].irrigation==LAKE;
  return FALSE;
}// isConnectedToWater() --------------------------------------------------------------------


/**
 * return if a given tile has a free boat with space available for the given unit
 */
unit *isFreeBoarding(tile *t, unit *passenger) {
  if (t==NULL || t->unitList==NULL || !getConnectedToCoast(t->posX, t->posY))
    return NULL;
  lnode_t *ln = list_first(t->unitList);
  while(ln!=NULL && ln!=&t->unitList->list_nilnode) {
    unit *u = (unit*)ln->list_data;
    if (isNaval(u) && getFreeCargo(u) && passenger->owner==u->owner)
      return u;
    ln = ln->list_next;
  }
  return NULL;
}// isFreeBoarding() --------------------------------------------------------------------


/**
 * return if a given tile has a free boat with space available for the given unit
 */
int isPortAt(tile *t) {
  if (t==NULL || t->construction==NULL || !getConnectedToOcean(t->posX, t->posY))
    return FALSE;
  return TRUE;
}// isPortAt() --------------------------------------------------------------------


/**
 * test what kind of nation it is
 */
int isIndianNation(int nationID){
  return (nationID>=FIRST_INDIAN_NATION && nationID<=LAST_INDIAN_NATION);
}// isIndianNation()


/**
* test what kind of nation it is
 */
int isIndian(player *p){
  return isIndianNation(p->nation);
}// isIndian()


/**
* test what kind of nation it is
 */
int isNewNation(int nationID){
  return (nationID>=FIRST_NEW_NATION && nationID<=LAST_NEW_NATION);
}// isIndianNation()


/**
 * return if a tile is defended
 */
int isThereArmy(int x, int y){
  if (map[x+MapWidth*(y)].unitList==NULL)
    return FALSE;

  lnode_t *ln = list_first(map[x+MapWidth*(y)].unitList);
  while(ln!=NULL&&ln!=&map[x+MapWidth*(y)].unitList->list_nilnode) {
    unit *u = (unit*)ln->list_data;
    if (u->muskets>0 || u->type==ARTILLERY || u->type==DAM_ARTILLERY)
      return TRUE;
    ln = ln->list_next;
  }
  return FALSE;
}// isThereArmy()


/**
 * return if a ocean tile is connected to a solid coast
 */
int getConnectedToCoast(int x, int y) {
  int nbCoast = 0;
  if (map[x+MapWidth*(y)].elevation>=SEALEVEL)
    return FALSE;

  int dx, dy;
  for (dx=-1; dx<2; dx++)
    for (dy=-1; dy<2; dy++)
      if (x+dx>=0 && y+dy>=0 && x+dx<MapWidth && y+dy<MapHeight)
        if (map[x+dx+MapWidth*(y+dy)].elevation>=SEALEVEL)
          nbCoast++;
  return nbCoast;
}// getConnectedToCoast() --------------------------------------------------------------------


/**
 * return how many connection to ocean a ground tile has
 */
int getConnectedToOcean(int x, int y) {
  int nbCoast = 0;
  int dx, dy;
  for (dx=-1; dx<2; dx++)
    for (dy=-1; dy<2; dy++)
      if (x+dx>=0 && y+dy>=0 && x+dx<MapWidth && y+dy<MapHeight)
        if (map[x+dx+MapWidth*(y+dy)].elevation<SEALEVEL)
          nbCoast++;
  return nbCoast;
}// getConnectedToOcean() --------------------------------------------------------------------


/**
 * attach recursively a river to the map by updating the river_elem attibute of the tile for the giver river
 */
void attachRiverToMap_r(btnode_t *node) {
  tile *t = (tile*) node->elem;
  t->river_elem = node;

  if (node->left!=NULL)
    attachRiverToMap_r(node->left);
  if (node->right!=NULL)
    attachRiverToMap_r(node->right);
}// attachRiverToMap_r() --------------------------------------------------------------------


/**
 * compute recursively how much water reach this tile;
 */
int computeRiverSize_r(btnode_t *node) {
  int size = 1;
  if (node->left!=NULL)
    size+=computeRiverSize_r(node->left);
  if (node->right!=NULL)
    size+=computeRiverSize_r(node->right);
  if (node->metadata!=NULL)
    free(node->metadata);
  int *riversize = (int*)malloc(sizeof(int));
  *riversize = size;
  node->metadata=riversize;
  return size;
}// computeRiverSize_r() --------------------------------------------------------------------


/**
 * compute recursively how much water reach this tile;
 */
void printRiver_r(btnode_t *node, int level) {
  int i;
  //int *size = (int*)node->metadata;
  //tile *t   = (tile*)node->elem;
  for (i=0; i<level; i++)
    printf(" ");
  //printf("%i, %i [%i]\n", t->posX, t->posY, *size);

  if (node->right!=NULL)
    printRiver_r(node->right, level+1);

  if (node->left!=NULL)
    printRiver_r(node->left, level+1);
}// printRiver_r() --------------------------------------------------------------------


/**
 * compute recursively how many tiles send their water to this tile;
 *
int computeRiverlength_r(btnode_t *node) {
  int size = 1;
  if (node->left!=NULL)
    size+=computeRiverSize_r(node->left);
  if (node->right!=NULL)
    size+=computeRiverSize_r(node->right);
  if (node->metadata!=NULL)
    free(node->metadata);
  int *riversize = (int*)malloc(sizeof(int));
  *riversize = size;
  node->metadata=riversize;
  return size;
}// computeRiverlength_r() --------------------------------------------------------------------
*/

/**
 * save connectivity info of this river node in an array of int
 */
int* saveConnectivity_r(btnode_t *node, int *array) {
  //printf("      saveConnectivity_r for %i,%i array = %p :\n", ((tile*)node->elem)->posX, ((tile*)node->elem)->posY, array);

  if (node==NULL)
    return NULL;

  *array++ = ((tile*)node->elem)->posX;
  *array++ = ((tile*)node->elem)->posY;

  if (node->father !=NULL) {
    *array++ = ((tile*)node->father->elem)->posX;
    *array++ = ((tile*)node->father->elem)->posY;
  } else {
    *array++ = -1;
    *array++ = -1;
  }
  if (node->left !=NULL) {
    *array++ = ((tile*)node->left->elem)->posX;
    *array++ = ((tile*)node->left->elem)->posY;
  } else {
    *array++ = -1;
    *array++ = -1;
  }
  if (node->right !=NULL) {
    *array++ = ((tile*)node->right->elem)->posX;
    *array++ = ((tile*)node->right->elem)->posY;
  } else {
    *array++ = -1;
    *array++ = -1;
  }
  if (node->left !=NULL)
    array=saveConnectivity_r(node->left, array);
  if (node->right !=NULL)
    array = saveConnectivity_r(node->right, array);

  return array;
}// saveConnectivity_r() --------------------------------------------------------------------


/**
 * Compute irrigation info of each tiles
 */
void computeIrrigation() {
  int x, y, dx, dy;

  for (x=0; x<MapWidth; x++)
    for (y=0; y<MapHeight; y++) {
      if (map[x+MapWidth*(y)].elevation<SEALEVEL && map[x+MapWidth*(y)].irrigation==UNKNOWN) {
        list_t *l = list_create(LISTCOUNT_T_MAX);
        int res = isLake_r(l, x, y);
        lnode_t *ln = list_first(l);
        while (ln!=NULL && ln !=&l->list_nilnode) {
          tile *t = (tile*)ln->list_data;
          if (res)
            t->irrigation=LAKE;
          else {
            t->irrigation=NOWATER;
          }
          ln = ln->list_next;
        }
        list_destroy_nodes(l);
        list_destroy(l);
        l = NULL;
      }
    }

  for (x=0; x<MapWidth; x++)
    for (y=0; y<MapHeight; y++)
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++) {
          if (x+dx<0 || y+dy<0 || x+dx>=MapWidth || y+dy>=MapHeight)
            continue;
          if (map[x+dx+MapWidth*(y+dy)].elevation<SEALEVEL && map[x+dx+MapWidth*(y+dy)].irrigation==LAKE && map[x+MapWidth*(y)].irrigation<LAKE)
            map[x+MapWidth*(y)].irrigation=LAKE;

          //printf("check %i,%i =  %p\n", x+dx, y+dy, map[x+dx+MapWidth*(y+dy)].river_elem);
          if (map[x+dx+MapWidth*(y+dy)].river_elem!=NULL && map[x+MapWidth*(y)].irrigation<BIG_RIVER) {
            int riversize = computeRiverSize_r(map[x+dx+MapWidth*(y+dy)].river_elem);
            //printf("  compute river size %i,%i =  %i\n", x+dx, y+dy, riversize);
            if (map[x+MapWidth*(y)].irrigation<BIG_RIVER && riversize>=BIG_RIVER_MIN_SIZE &&dx==0 && dy==0) {
              map[x+MapWidth*(y)].irrigation = BIG_RIVER;
            }
            if (map[x+MapWidth*(y)].irrigation<RIVER) {
              map[x+MapWidth*(y)].irrigation = RIVER;
            }
          }
          if (map[x+MapWidth*(y)].irrigation==UNKNOWN && map[x+MapWidth*(y)].ground!=DESERT && map[x+MapWidth*(y)].ground!=ROCKDESERT)
            map[x+MapWidth*(y)].irrigation = JUST_RAIN;

        }
}// computeIrrigation() --------------------------------------------------------------------


/**
 * play all the unit of the player trying to achieve the goals assignated to this AI player
 */
void playAI(player * player) {

}// playAI() --------------------------------------------------------------------


/**
 * save the map into file with the given filemname
 */
void saveMap(char *filename) {
  printf("Newcol is saving a map called %s \n", filename);
  int i, j;
  FILE *f1 = fopen(filename, "wb");

  // write date
  fwrite(&apptime, sizeof(int), 1, f1);

  // write current player nation
  player *cp = (player*)(currentPlayerElement->list_data);
  fwrite(&cp->nation, sizeof(int), 1, f1);

  // write the tiles of the map
  int tw = MapWidth;
  fwrite(&tw, sizeof(int), 1, f1);
  tw = MapHeight;
  fwrite(&tw, sizeof(int), 1, f1);
  for(i=0; i<MapWidth; i++) {
    for(j=0; j<MapHeight; j++) {
      map[i+MapWidth*(j)].ground       += 0;
      map[i+MapWidth*(j)].bonus        += 0;
      list_t * l1 = map[i+MapWidth*(j)].unitList;
      map[i+MapWidth*(j)].unitList     = NULL;
      btnode_t *re1 = map[i+MapWidth*(j)].river_elem;
      map[i+MapWidth*(j)].river_elem   = NULL;
      map[i+MapWidth*(j)].road         += 0;
      map[i+MapWidth*(j)].posX         += 0;
      map[i+MapWidth*(j)].posY         += 0;
      map[i+MapWidth*(j)].seed         += 0;
      //map[i+MapWidth*(j)].underground  += 0;
      //map[i+MapWidth*(j)].climate      += 0;
      map[i+MapWidth*(j)].lastExplored += 0;
      map[i+MapWidth*(j)].elevation    += 0;
      map[i+MapWidth*(j)].vegetation   += 0;
      city* c1 = map[i+MapWidth*(j)].construction;
      map[i+MapWidth*(j)].construction = NULL;
      map[i+MapWidth*(j)].seed         += 0;
      map[i+MapWidth*(j)].irrigation   += 0;
      fwrite(&map[i+MapWidth*(j)], sizeof(tile), 1, f1);
      map[i+MapWidth*(j)].unitList      = l1;
      map[i+MapWidth*(j)].construction  = c1;
      map[i+MapWidth*(j)].river_elem    = re1;
    }
  }

  //write the number of rivers
  tw = list_count(riverList);
  fwrite(&tw, sizeof(int), 1, f1);
  lnode_t *ln = list_first(riverList);
  while (ln!=NULL &&ln!=&riverList->list_nilnode) {
    river *r = (river*)ln->list_data;
    fwrite(r->name, MAXNAMELENGTH*sizeof(char), 1, f1);
    fwrite(&r->finishX, sizeof(float), 1, f1);
    fwrite(&r->finishY, sizeof(float), 1, f1);
    tw = computeRiverSize_r(r->itinerary->root);
    //printf("  write river = %s with %i nodes\n", r->name, tw);
    fwrite(&tw, sizeof(int), 1, f1);

    int *array = (int*)malloc(tw*8*sizeof(int));
    saveConnectivity_r(r->itinerary->root, array);
    int *ptr = array;
    for (j=0; j<tw; j++) {
      //int x  = *ptr++;
      //int y  = *ptr++;
      //int fx = *ptr++;
      //int fy = *ptr++;
      //int lx = *ptr++;
      //int ly = *ptr++;
      //int rx = *ptr++;
      //int ry = *ptr++;
      //printf("    connectivity for %i,%i father = %i, %i left=%i,%i  right=%i,%i :\n", x, y, fx, fy, lx, ly, rx, ry);
    }
    fwrite(array, sizeof(int), tw*8, f1);
    ln = ln->list_next;
  }

  //write number of players
  tw = list_count(playerList);
  fwrite(&tw, sizeof(int), 1, f1);

  // write players
  i=0;
  j=0;
  ln = list_first(playerList);
  while (ln!=NULL &&ln!=&playerList->list_nilnode) {
    player *p = (player*)ln->list_data;
    fwrite(p, sizeof(player), 1, f1);
    //write player name
    //printf("  write playernation = %i with %i units\n", p->nation, list_count(p->unitList));
    fwrite(p->name, MAXNAMELENGTH*sizeof(char), 1, f1);
    i+=list_count(p->unitList);
    j+=list_count(p->cityList);
    ln = ln->list_next;
  }

  // write the number of cities
  fwrite(&j, sizeof(int), 1, f1);
  int k=0, l=0;
  // write the cities
  ln = list_first(playerList);
  while (ln!=NULL &&ln!=&playerList->list_nilnode) {
    player *p = (player*)ln->list_data;
    lnode_t *ln2 = list_first(p->cityList);
    while(ln2!=NULL && ln2!=&p->cityList->list_nilnode) {
      city *c       = (city*) ln2->list_data;
      // affect an id to this city for later reference by units
      c->id = k;
      player *owner = c->owner;
      //TODO FIXIT
      c->owner      = (player*)c->owner->nation;
      tile *t       = c->location;
      c->location   = (tile*)(c->location->posY*MapWidth+c->location->posX);
      //printf("  wr city = %s   id=%i\n", c->name, c->id);
      fwrite(c, sizeof(city), 1, f1);
      fwrite(c->name, MAXNAMELENGTH*sizeof(char), 1, f1);
      fwrite(&list_count(c->buildings), sizeof(int), 1, f1);
      lnode_t *ln3 = list_first(c->buildings);
      while(ln3!=NULL && ln3!=&c->buildings->list_nilnode) {
        fwrite(ln3->list_data, sizeof(building), 1, f1);
        ln3 = ln3->list_next;
      }
      for (j=0; j<GOODS_NUMBER; j++) {
        fwrite(&c->stocks[j].quantity, sizeof(int), 1, f1);
      }
      c->owner      = owner;
      c->location   = t;
      ln2           = ln2->list_next;
      k++;
    }
    ln = ln->list_next;
  }

  // first sort the units to have transports AFTER unit it holds
  j=0;
  ln = list_first(playerList);
  while (ln!=NULL &&ln!=&playerList->list_nilnode) {
    player  *p   = (player*)ln->list_data;
    list_sort(p->unitList, cargoCompare);
    lnode_t *ln2 = list_last(p->unitList);
    while(ln2!=NULL && ln2!=&p->unitList->list_nilnode) {
      unit *u       = (unit*) ln2->list_data;
      //printf("  prepare unit#%i = %i by %s status=%i\n", j, u->type, p->name, u->status);
      if (u->status!=ONBOARD)
        u->id         = j;
      for (l=0; l<u->maxLoad; l++) {
        //if (u->goods[l].quantity>0)
        //  printf("   load=%i\n", u->goods[l].type);
        if (u->goods[l].passenger!=NULL) {
          //printf("    prepare passenger status=%i\n", u->status);
          u->goods[l].passenger->id = u->id*10000+l;
          u->goods[l].passenger->status=ONBOARD;
        }
      }
      ln2 = ln2->list_prev;
      j++;
    }

    ln = ln->list_next;
  }

  // write the number of units
  fwrite(&i, sizeof(int), 1, f1);
  //printf("  write %i units\n", i);
  // write the units
  j=0;
  ln = list_first(playerList);
  while (ln!=NULL &&ln!=&playerList->list_nilnode) {
    player  *p   = (player*)ln->list_data;
    lnode_t *ln2 = list_first(p->unitList);
    while(ln2!=NULL && ln2!=&p->unitList->list_nilnode) {
      unit *u       = (unit*) ln2->list_data;
      player *owner = u->owner;
      u->owner      = (player*)u->owner->nation;

      //printf("  write unit#%i = %i by %s/%s ID=%i cargo=%i status=%i\n", j, u->type, owner->name, p->name, u->id, u->maxLoad, u->status);
      tile *t       = u->location;
      if (u->status==ONBOARD) {
        u->location   = (tile*)u->id;
      } else if (u->status==PRODUCING || u->status==TEACHING)
        u->location   = (tile*)(u->lastCity->id*10000+u->lastBuilding->type);
      else if(u->status>=FIRST_OUTSIDE_STATUS && u->status<=LAST_STATUS) {
        u->location   = (tile*)(u->lastCity->id*10000+u->lastWorkingTile);
      } else if (u->location!=NULL)
        u->location   = (tile*)(u->location->posY*MapWidth+u->location->posX);

      fwrite(u, sizeof(unit), 1, f1);
      fwrite(u->goods, sizeof(good), u->maxLoad, f1);

      u->owner      = owner;
      u->location   = t;
      ln2           = ln2->list_next;
      j++;
    }
    ln = ln->list_next;
  }

  fclose(f1);
}// saveMap() --------------------------------------------------------------------


/**
 * load the map into file with the given filemname
 */
void loadMap(char *filename) {
  printf("Newcol is loading a map called %s \n ", filename);

  doReset(NULL, NULL);

  int i, j;
  FILE *f1 = fopen(filename, "rb");
  int tw, tw2;

  // read date
  fread(&apptime, sizeof(int), 1, f1);

  int cp;
  // read current player nation
  fread(&cp, sizeof(int), 1, f1);

  // read the tiles of the map
  fread(&tw, sizeof(int), 1, f1);
  //printf("  width=%i\n", tw);
  fread(&tw2, sizeof(int), 1, f1);
  //printf("  height=%i\n", tw2);
  initTiles(tw, tw2);

  for(i=0; i<MapWidth; i++) {
    for(j=0; j<MapHeight; j++) {
      fread(&map[i+MapWidth*(j)], sizeof(tile), 1, f1);
      map[i+MapWidth*(j)].ground       -= 0;
      map[i+MapWidth*(j)].bonus        -= 0;
      map[i+MapWidth*(j)].unitList     = NULL;
      map[i+MapWidth*(j)].posX         -= 0;
      map[i+MapWidth*(j)].posY         -= 0;
      map[i+MapWidth*(j)].seed         -= 0;
      map[i+MapWidth*(j)].lastExplored -= 0;
      map[i+MapWidth*(j)].elevation    -= 0;
      map[i+MapWidth*(j)].vegetation   -= 0;
      map[i+MapWidth*(j)].construction = NULL;
      map[i+MapWidth*(j)].river_elem   = NULL;
      map[i+MapWidth*(j)].seed         -= 0;
      map[i+MapWidth*(j)].irrigation   -= 0;
    }
  }

  // read the rivers in the map
  fread(&tw, sizeof(int), 1, f1);
  //printf("  ... reading %i rivers\n", tw);
  for (i=0; i<tw; i++) {
    river *r = (river*) malloc(sizeof(river));
    r->itinerary = binarytree_create(LISTCOUNT_T_MAX);
    r->name = (char*)malloc(1+MAXNAMELENGTH*sizeof(char));
    fread(r->name, MAXNAMELENGTH*sizeof(char), 1, f1);
    //printf("    river %s :\n", r->name);
    fread(&r->finishX, sizeof(float), 1, f1);
    fread(&r->finishY, sizeof(float), 1, f1);
    fread(&tw2, sizeof(int), 1, f1);
    int *array = (int*)malloc(tw2*8*sizeof(int));
    fread(array, sizeof(int), tw2*8, f1);
    int *ptr = array;
    for (j=0; j<tw2; j++) {
      int x  = *ptr++;
      int y  = *ptr++;
      int fx = *ptr++;
      int fy = *ptr++;
      int lx = *ptr++;
      int ly = *ptr++;
      int rx = *ptr++;
      int ry = *ptr++;

      //printf("    connectivity for %i,%i father = %i, %i left=%i,%i  right=%i,%i :\n", x, y, fx, fy, lx, ly, rx, ry);

      btnode_t *node = NULL;
      if (map[x+MapWidth*(y)].river_elem==NULL) {
        node = btnode_create(&map[x+MapWidth*(y)]);
        map[x+MapWidth*(y)].river_elem = node;
      } else
        node = map[x+MapWidth*(y)].river_elem;

      if(r->itinerary->root==NULL)
        r->itinerary->root = node;

      if (fx!=-1 && map[fx+MapWidth*(fy)].river_elem==NULL) {
        btnode_t *nodef = btnode_create(&map[fx+MapWidth*(fy)]);
        map[fx+MapWidth*(fy)].river_elem = nodef;
        binarytree_ins_left(r->itinerary, nodef, node);
      }

      if (lx!=-1 && map[lx+MapWidth*(ly)].river_elem==NULL) {
        btnode_t *nodel = btnode_create(&map[lx+MapWidth*(ly)]);
        map[lx+MapWidth*(ly)].river_elem = nodel;
        binarytree_ins_left(r->itinerary, node, nodel);
      }

      if (rx!=-1 && map[rx+MapWidth*(ry)].river_elem==NULL) {
        btnode_t *noder = btnode_create(&map[rx+MapWidth*(ry)]);
        map[rx+MapWidth*(ry)].river_elem = noder;
        binarytree_ins_right(r->itinerary, node, noder);
      }
    }
    free(array);

    list_append(riverList, lnode_create(r));
  }


  // read the players in the game
  fread(&tw, sizeof(int), 1, f1);
  //printf("  ... reading %i players\n", tw);
  for (i=0; i<tw; i++) {
    player *p = (player*) malloc(sizeof(player));
    fread(p, sizeof(player), 1, f1);
    p->name = (char*)malloc(1+MAXNAMELENGTH*sizeof(char));
    fread(p->name, MAXNAMELENGTH*sizeof(char), 1, f1);
    p->unitList = list_create(LISTCOUNT_T_MAX);
    p->cityList = list_create(LISTCOUNT_T_MAX);
    //printf("    player nation=%i name=%s\n", p->nation, p->name);
    nations[p->nation-FIRST_NATION] = p;
    lnode_t *ep = lnode_create(p);
    list_append(playerList, ep);
    if (p->nation==cp)
      currentPlayerElement = ep;
  }
  // read the cities in the game
  fread(&tw, sizeof(int), 1, f1);
  //printf("  ... reading %i cities\n", tw);
  for (i=0; i<tw; i++) {
    city *c0 = (city*) malloc(sizeof(city));
    fread(c0, sizeof(city), 1, f1);
    char *name = (char*)malloc(1+MAXNAMELENGTH*sizeof(char));
    fread(name, MAXNAMELENGTH*sizeof(char), 1, f1);
    //printf("  city size=%i  owner=%i id=%i\n", c0->size, (int)c0->owner-FIRST_NATION, c0->id);
    fread(&tw2, sizeof(int), 1, f1);
    player *p = nations[(int)c0->owner-FIRST_NATION];
    int x = ((int)c0->location)%MapWidth;
    int y = ((int)c0->location)/MapWidth;
    tile *t = &map[x+MapWidth*(y)];
    city *c = createCity(c0->size, name, t, p);
    c->id = c0->id;
    free(c0);
    //printf("    ... reading %i building\n", tw2);
    for (j=0; j<tw2; j++) {
      building *b = (building*) malloc(sizeof(building));
      fread(b, sizeof(building), 1, f1);
      building *b2 = isBuildingExist(c, b->type);
      if (b2) {
        free(b);
        b = b2;
      } else {
        b->homecity = c;
        list_append(c->buildings, lnode_create(b));
        //printf("    add building type=%i to %s\n", b->type, c->name);
        b->workers = list_create(LISTCOUNT_T_MAX);
      }
    }
    for (j=0; j<GOODS_NUMBER; j++) {
      int q;
      fread(&q, sizeof(int), 1, f1);
      c->stocks[i].quantity=q;
      c->prod[i].quantity =0;
    }
    //list_append(p->cityList, lnode_create(c));
    //printf("    owner called %s now have %i cities\n", p->name, list_count(p->cityList));
  }
  // read the units in the game
  fread(&tw, sizeof(int), 1, f1);
  //printf("  ... reading %i units\n", tw);
  for (i=0; i<tw; i++) {
    unit *u = (unit*) malloc(sizeof(unit));
    fread(u, sizeof(unit), 1, f1);
    u->goods = (good*)malloc(u->maxLoad*sizeof(good));
    fread(u->goods, sizeof(good), u->maxLoad, f1);

    //printf("\n  unit type=%i  owner=%i status=%i \n", u->type, (int)u->owner-FIRST_NATION, u->status);
    player *p = nations[(int)u->owner-FIRST_NATION];
    if (u->status==ONBOARD) {
      int unigood = (int)u->location;
      int unitid = unigood/10000;
      int goodindex = unigood%10000;
      //printf("    ... will try to drop unit in ship#%i[%i] \n        ", unitid, goodindex);
      lnode_t *ln = list_first(playerList);
      while (ln!=NULL &&ln!=&playerList->list_nilnode) {
        player  *p   = (player*)ln->list_data;
        lnode_t *ln2 = list_first(p->unitList);
        while(ln2!=NULL && ln2!=&p->unitList->list_nilnode) {
          unit *u2       = (unit*) ln2->list_data;
          printf("%i, ", u2->id);
          if (u2->id==unitid) {
            //printf("    drop unit in ship=%i at %i, %i    cargo=%i/\n", u2->type, u2->location->posX, u2->location->posY, goodindex);
            u2->goods[goodindex].type = u->type;
            u2->goods[goodindex].passenger = u;
            u->location = NULL;
          }
          ln2 = ln2->list_next;
        }
        ln = ln->list_next;
      }
      //printf("\n");

    } else if (u->status==PRODUCING || u->status==TEACHING) {
      int citbuil = (int)u->location;
      int citid = citbuil/10000;
      int buildingtype = citbuil%10000;
      lnode_t *ln = list_first(playerList);
      while (ln!=NULL &&ln!=&playerList->list_nilnode) {
        player *p = (player*)ln->list_data;
        lnode_t *ln2 = list_first(p->cityList);
        while(ln2!=NULL && ln2!=&p->cityList->list_nilnode) {
          city *c       = (city*) ln2->list_data;
          lnode_t *ln3 = list_first(c->buildings);
          while(ln3!=NULL && ln3!=&c->buildings->list_nilnode) {
            building *b       = (building*) ln3->list_data;
            if (c->id==citid && b->type==buildingtype) {
              //printf("    drop unit in building=%i in %s    citiids=%i/%i\n", b->type, c->name, c->id, citid);
              list_append(b->workers, lnode_create(u));
              u->lastCity     = c;
              u->lastBuilding = b;
              u->location = NULL;
            }
            ln3 = ln3->list_next;
          }
          ln2 = ln2->list_next;
        }
        ln = ln->list_next;
      }
    } else if(u->status==FIRST_OUTSIDE_STATUS && u->status<=LAST_STATUS) {
      int cittile = (int)u->location;
      int citid = cittile/10000;
      int tileid = cittile%10000;
      lnode_t *ln = list_first(playerList);
      while (ln!=NULL &&ln!=&playerList->list_nilnode) {
        player *p = (player*)ln->list_data;
        lnode_t *ln2 = list_first(p->cityList);
        while(ln2!=NULL && ln2!=&p->cityList->list_nilnode) {
          city *c       = (city*) ln2->list_data;
          if(c->id==citid) {
            //printf("    drop unit in fields=%i at %s \n", tileid, c->name);
            c->dependencies[tileid] = u;
            u->lastCity     = c;
            u->lastWorkingTile      = tileid;
            u->location = NULL;
          }
          ln2 = ln2->list_next;
        }
        ln = ln->list_next;
      }
    } else if (u->location!=NULL) {
      int x = ((int)u->location)%MapWidth;
      int y = ((int)u->location)/MapWidth;
      //printf("    drop unit on map at %i,%i\n", x, y);
      tile *t = &map[x+MapWidth*(y)];
      u->location = t;
      if (t->unitList==NULL)
        t->unitList = list_create(LISTCOUNT_T_MAX);
      list_append(t->unitList, lnode_create(u));
    }
    //printf("  owner called %s for unit located at %p\n", p->name, u->location);
    u->owner = p;
    list_append(p->unitList, lnode_create(u));
  }

  fclose(f1);
  updatesCache(-1, -1, -1, -1);
  updateMiniMap();

}// loadMap() --------------------------------------------------------------------


/**
 * try to add a given unit to a building of the given type in a given city
 */
int addUnitToBuilding(unit *u, city *c, int buildingType) {
  lnode_t *ln = list_first(c->buildings);
  while (ln!= NULL && ln!=&c->buildings->list_nilnode) {
    building *b = (building*)ln->list_data;
    if (b->type==buildingType) {
      if (list_count(b->workers) >= b->slots)
        return 2;
      list_append(b->workers, lnode_create(u));
      u->lastBuilding = b;
      u->lastCity = c;
      u->status = PRODUCING;
      return 0;
    }
    ln = ln->list_next;
  }

  return 1;
}// addUnitToBuilding() --------------------------------------------------------------------


/**
 * try to add a given unit to a dependency tile in a given city
 */
int addUnitToDependency(unit *u, city *c, int dx, int dy) {
  int range = getRangeForSize(c->size);
  int d = (int)sqrt((float)(dx*dx+dy*dy));
  if (d>range)
    return 2; // out of city
  int index = (dy+range)*(range*2+1)+dx+getRangeForSize(c->size);
  if (c->dependencies[index]==NULL) {
    c->dependencies[index] = u;
    u->lastWorkingTile = index;
    u->lastCity = c;
    return 0;
  } else
    return 3;// already someon here

  return 1; // not found
}// addUnitToDependency() --------------------------------------------------------------------


/**
 * create a player from the arguments
 */
player *createPlayer(int nation, char* playerName, int religion) {
  player *player0             = (player *)malloc (sizeof(player));
  player0->name               = (char*)malloc(1+MAXNAMELENGTH*sizeof(char));
  sprintf(player0->name, "%s", playerName);
  player0->nation             = nation;
  player0->unitList           = list_create(LISTCOUNT_T_MAX);
  player0->cityList           = list_create(LISTCOUNT_T_MAX);
  player0->religion           = religion;
  player0->totalCrosses       = 0;
  player0->money              = 0;
  if (nation>=FIRST_OLD_POWER && nation<=LAST_OLD_POWER)
    player0->money              = 10000;

  int i;
  for (i=0; i<NATION_NUMBER; i++)
    // people like their origins
    if (isColonyOf(nation, i))
      player0->diplomaticRelations[i] = BROTHERHOOD;
    // they don't like others culture they don't understand
    else if (isIndianNation(FIRST_NATION+i))
      player0->diplomaticRelations[i] = UPSET;
    //  they don't like even worst competitors
    else if (isNewNation(FIRST_NATION+i))
      player0->diplomaticRelations[i] = ANGRY;
    // but they are at peace with more powerfull than them
    else
      player0->diplomaticRelations[i] = PEACE;

  return player0;
}// createPlayer() --------------------------------------------------------------------


/**
 * init the player list
 */
void initPlayers(int number, int nationToPlay, char* playerName) {
  if(playerList!=NULL) {
    list_destroy_nodes(playerList);
    list_destroy(playerList);
    playerList = NULL;
  }

  playerList = list_create(LISTCOUNT_T_MAX);

  player *player0   = createPlayer(NEW_FRANCE, DEFAULT_NEW_FRENCH_PLAYER_NAME, SOFT_CATHOLICISM);
  if (nationToPlay==NEW_FRANCE) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(FRANCE, DEFAULT_FRENCH_PLAYER_NAME, TRADITIONAL_CATHOLICISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_SPAIN, DEFAULT_NEW_SPANISH_PLAYER_NAME, SOFT_CATHOLICISM);
  if (nationToPlay==NEW_SPAIN) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(SPAIN, DEFAULT_SPANISH_PLAYER_NAME, TRADITIONAL_CATHOLICISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_ENGLAND, DEFAULT_NEW_ENGLISH_PLAYER_NAME, PROTESTANTISM);
  if (nationToPlay==NEW_ENGLAND) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(ENGLAND, DEFAULT_ENGLISH_PLAYER_NAME, FUNDAMENTALIST_ANGLICAN);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_HOLLAND, DEFAULT_NEW_DUTCH_PLAYER_NAME, PROTESTANTISM);
  if (nationToPlay==NEW_HOLLAND) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(HOLLAND, DEFAULT_DUTCH_PLAYER_NAME, PROTESTANTISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_ITALY, DEFAULT_NEW_ITALIAN_PLAYER_NAME, SOFT_CATHOLICISM);
  if (nationToPlay==NEW_ITALY) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(ITALY, DEFAULT_ITALIAN_PLAYER_NAME, TRADITIONAL_CATHOLICISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_GERMANY, DEFAULT_NEW_GERMAN_PLAYER_NAME, GENERAL_CHRISTIANISM);
  if (nationToPlay==NEW_GERMANY) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(GERMANY, DEFAULT_GERMAN_PLAYER_NAME, PROTESTANTISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_RUSSIA, DEFAULT_NEW_RUSSIAN_PLAYER_NAME, GENERAL_CHRISTIANISM);
  if (nationToPlay==NEW_RUSSIA) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(RUSSIA, DEFAULT_RUSSIAN_PLAYER_NAME, ORTHODOX);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(NEW_PORTUGAL, DEFAULT_NEW_PORTUGUESE_PLAYER_NAME, SOFT_CATHOLICISM);
  if (nationToPlay==NEW_PORTUGAL) {
    sprintf(player0->name, "%s", playerName);
    currentPlayerElement = lnode_create(player0);
    list_append(playerList, currentPlayerElement);
  }  else
    list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(PORTUGAL, DEFAULT_PORTUGUESE_PLAYER_NAME, TRADITIONAL_CATHOLICISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;





  player0   = createPlayer(AZTEC, DEFAULT_AZTEC_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(OLMEC, DEFAULT_OLMEC_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(INCA, DEFAULT_INCA_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(APACHE, DEFAULT_APACHE_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(HURON, DEFAULT_HURON_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(CHEROKEE, DEFAULT_CHEROKEE_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(IROQUOIS, DEFAULT_IROQUOIS_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(SIOUX, DEFAULT_SIOUX_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(TUPI, DEFAULT_TUPI_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(ARAWAK, DEFAULT_ARAWAK_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(CHINOOK, DEFAULT_CHINOOK_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  player0   = createPlayer(INUIT, DEFAULT_INUIT_PLAYER_NAME, ANIMISM);
  list_append(playerList, lnode_create(player0));
  nations[player0->nation-FIRST_NATION] = player0;

  // TODO additional players
if (number==5) {}
}// initPlayers() --------------------------------------------------------------------


/**
 * return the player playing the european nation associated with this colony
 */
player* getParentNation(int nation) {
  if(nation>=FIRST_NEW_NATION && nation<=LAST_NEW_NATION)
    return nations[nation-FIRST_NATION-(FIRST_NEW_NATION-FIRST_OLD_POWER)];
  else
    return NULL;
}// getNationPlayer() --------------------------------------------------------------------


/**
 * init the map with values for every tile
 */
void initDebugMap() {
  // during this edit process we must be in EDIT mode to prevent internal functions to not work
  gamemode=EDIT;
  initGround();
  initForests();
  initBonuses(15);
  initWorldRivers();
  initEurope();
  initNatives();
  initDebugCitiesAndUnits();
  initLostCityRumors(2);
  gamemode=PLAY;
  printf("  finished to init debug game\n");

  // test a* here and press "e" to go to debug mode and visualize a* result
  unit *uspe = createUnitAt(WAGON, nations[NEW_FRANCE-FIRST_NATION], 688*MapWidth/2160, 272*MapHeight/1080);
  if (uspe!=NULL) {
    uspe->goods[0].type      = ROPE;
    uspe->goods[0].quantity  = 60;
    uspe->goods[1].type      = HEMP;
    uspe->goods[1].quantity  = 80;
  }
  if (uspe!=NULL) {
    astarSearch (uspe->location->posX, uspe->location->posY, 636*MapWidth/2160, 268*MapHeight/1080, uspe);
    destroyUnit(uspe);
  }
}// initDebugMap() --------------------------------------------------------------------


/**
 * init the map with values for every tile
 */
void initStartupMap() {
  // during this edit process we must be in EDIT mode to prevent internal functions to not work
  gamemode=EDIT;

  initGround();
  initForests();
  initBonuses(15);
  initWorldRivers();
  initEurope();
  initNatives();
  initLostCityRumors(2);

  player *currentPlayer = (player*)currentPlayerElement->list_data;
  player *myKing = nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION];
  city   *c = pickEmigrationPort(myKing);
  unit   *trans = createUnitAt(CARAVEL, currentPlayer, c->location->posX, c->location->posY);
  if (trans!=NULL) {
    trans->goods[0].type      = WHEAT;
    trans->goods[0].quantity  = 100;
    trans->goods[1].type      = COLONIST;
    trans->goods[1].quantity  = 1;
    trans->goods[1].passenger = createUnit(COLONIST, currentPlayer);
    trans->goods[1].passenger->tools = 100;
    trans->goods[1].passenger->status = ONBOARD;
    trans->goods[2].type      = COLONIST;
    trans->goods[2].quantity  = 1;
    trans->goods[2].passenger = createUnit(COLONIST, currentPlayer);
    trans->goods[2].passenger->muskets = 50;
    trans->goods[2].passenger->status = ONBOARD;
  }

  gamemode=PLAY;
}// initStartupMap() --------------------------------------------------------------------


/**
 * init the application ressources
 */
void initCaches(int w, int h) {
  //printf("initCache(%i, %i)\n", w, h);
  //fflush(stdout);
  int i, j;
  addMsg("Initializing tiles in cache");
  updateLoading();

  if (movecache!=NULL)
    free(movecache);
  movecache = (unsigned char *)malloc((w)*(h)*sizeof(char));

  if (tilecache!=NULL)
    free(tilecache);
  tilecache = (SDL_Surface **)malloc((w)*(h)*sizeof(SDL_Surface *));

  for (j=0; j<h; j++) {
    for (i=0; i<w; i++) {
      tilecache[j*(w)+i] = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, screen->format->BitsPerPixel,
                                  screen->format->Rmask,  screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
      //tilecache[j*(w)+i] = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, 32,
      //                                          0x000000FF,  0x0000FF00, 0x00FF0000, 0xFF000000);
      //printf("  %i inited\n", j*(w)+i);
      //printf("  tilecache[%i](%p) => %p \n", (j*w+i), tilecache+j*w+i, tilecache[j*w+i]);
      //fflush(stdout);
    }
  }
}// initCache() --------------------------------------------------------------------


/**
 * add a message in the list
 */
void addMsg(const char* msg0){
  char* msg = (char *)malloc(sizeof(char)*strlen(msg0)+2);
  strcpy(msg, msg0);
  list_append(messageList, lnode_create(msg));
}// addMsg()


/**
 * display a waiting message to the user to make him wait for loading to finish
 */
void updateLoading() {
  char *initmsg = (char*)list_last(messageList)->list_data;
  // afin de ne pas ralentir trop l'affichage on affiche que toutes les 2 mises a jour .. remplacer 2 par un plus gros chiffre si ca rame chez vous. Mettez 1 si ca va trop vite
  if (initcpt-lastUpdate>=2 || lastinitmsg!=initmsg || popupType&POPUP_ISVISIBLE) {
    // initmsg est une variable dans laquelle on a mis un pointeur vers le dernier message a afficher
    lastinitmsg= initmsg;
    
    // title0 est une chaine construite a la main pour afficher un chiffre en plus de la barre de progression
    char *title0 = (char *)malloc(32);
    sprintf(title0, "Loading %i / %i", initcpt, MAXINITCPT);
    int i;
    // la largeur de la bordure verte sur le bord de l'ecran
    int BORDER = 20;

    // un fond verdatre pour rappeler les grandes plaines americaines  
    boxRGBA(screen, BORDER, BORDER, screen->w-BORDER, screen->h-BORDER, 220, 255, 230, 255);
    
    // en SDL le texte qu'on veut afficher doit d'abord etre transformer en image ...
    // on choisi toutefois ici la taille du texte (15) et le style (bold=gras)
    TTF_SetFontStyle(fonts[15], TTF_STYLE_BOLD);
    SDL_Surface *img2 = TTF_RenderText_Blended(fonts[10], title0, LIGHTGREY);
    SDL_Surface *img3 = TTF_RenderText_Blended(fonts[10], title0, BLACK);
    SDL_Surface *img4 = TTF_RenderText_Blended(fonts[12], initmsg, WHITE);
    SDL_Surface *img5 = TTF_RenderText_Blended(fonts[12], initmsg, BLACK);

    // la position des images doit etre stockee dans une structure de rectanle 
    SDL_Rect *rect  = (SDL_Rect *)malloc(sizeof(SDL_Rect));
    SDL_Rect *rect1 = (SDL_Rect *)malloc(sizeof(SDL_Rect));
    rect1->x = (screen->w-img2->w)/2;
    rect1->y = (screen->h-img2->h)/3;
    rect1->y--;
    rect1->x--;
    // on affiche 5 fois le texte, 4 fois en gris a chaque fois decalle (haut, droite, bas, gauche) puis une fois en noir au centre pour faire un effet de halo
    SDL_BlitSurface(img2, NULL, screen, rect1);
    rect1->x+=2;
    SDL_BlitSurface(img2, NULL, screen, rect1);
    rect1->y+=2;
    SDL_BlitSurface(img2, NULL, screen, rect1);
    rect1->x-=2;
    SDL_BlitSurface(img2, NULL, screen, rect1);
    rect1->y-=2;
    rect1->x++;
    rect1->y++;
    SDL_BlitSurface(img3, NULL, screen, rect1);

    // meme chose pour l'autre texte
    rect1->x = (screen->w-img4->w)/2;
    rect1->y = (screen->h+40-img4->h)/3;
    rect1->y--;
    rect1->x--;
    SDL_BlitSurface(img4, NULL, screen, rect1);
    rect1->x+=2;
    SDL_BlitSurface(img4, NULL, screen, rect1);
    rect1->y+=2;
    SDL_BlitSurface(img4, NULL, screen, rect1);
    rect1->x-=2;
    SDL_BlitSurface(img4, NULL, screen, rect1);
    rect1->y-=2;
    rect1->x++;
    rect1->y++;
    SDL_BlitSurface(img5, NULL, screen, rect1);

    // L'icone du jeu representant un soldat anglais et un pionnier americain dos a dos 
    if (iconImage != NULL) {
      rect->x = (screen->w-iconImage->h)/2;
      rect->y = (screen->h)/3-iconImage->h-10;
      SDL_BlitSurface(iconImage, NULL, screen, rect);
    }

    // la barre de progression. Comme pour les images on doit utiliser une structure de rectangle comme parametre de la fonction de dessin (SDL_FillRect)
    rect->x = (screen->w-200)/2;
    rect->y = 30+(screen->h-img2->h)/3;
    rect->w = 202;
    rect->h = 10;
    SDL_FillRect(screen, rect, 0x000000);
    rect->x++;
    rect->y++;
    rect->w-=2;
    rect->h-=2;
    SDL_FillRect(screen, rect, 0xFFFFFF);
    rect->w=initcpt*200/MAXINITCPT;
    SDL_FillRect(screen, rect, 0x888888);
    
    // les images des textes etant juste temporaires, il faut liberer la memoire.
    SDL_FreeSurface(img2);
    SDL_FreeSurface(img3);
    SDL_FreeSurface(img4);
    SDL_FreeSurface(img5);

    // les batiments apparaissent au hasard mais comme on utilise une graine fixe (1234), le hasard est toujours le meme d'un affichage a l'autre
    srand(1234);
    for (i=0; i<BUILDING_NUMBER; i++) {
      // parceque cette fonction est appellee pendant le chargement, des fois les images sont encore inexistantes 
      if (buildingImages[i]!=NULL) {
        int largeurpossible = (screen->w-buildingImages[i]->w)-2*BORDER;
        int x = rand()%largeurpossible;
        int hauteurpossible = (screen->h/2-buildingImages[i]->h)-35-2*BORDER;
        int y = rand()%hauteurpossible;
        rect->x = BORDER+x;
        rect->y = BORDER+y+(screen->h)/2+35; // uniquement dans la partie basse de l'ecran 
        SDL_BlitSurface(buildingImages[i], NULL, screen, rect);
      }
      if (buildingIconImages[i]!=NULL) {
        rect->x = screen->w*i/BUILDING_NUMBER; // en fonction de i : tous bien alignes en bas
        rect->y = screen->h-BORDER-buildingIconImages[i]->h;
        // sin on en est a la deuxeimme partie de l'initialisation du jeu ...
        if (currentPlayerElement != NULL) {
          // on calcule ou on en est de la deuxiemme partie du chargement (en %) 
          int percentAnimation = (MAXINITCPT-initcpt)*100/(MAXINITCPT-FINISHLOADINGCPT);
          rect->y -= (100-percentAnimation);
        }
        SDL_BlitSurface(buildingIconImages[i], NULL, screen, rect);
      }
    }
    
    // Affichage de la derniere image telechargee
    if (lastLoadedImage!=NULL && lastLoadedImage->w <= screen->w){
      rect->x = screen->w/2-lastLoadedImage->w/2;
      rect->y = (3*screen->h)/4-lastLoadedImage->h/2;
      rect->w = lastLoadedImage->w-1;
      rect->h = lastLoadedImage->h-1;
      // tient, si on mettait un gradient de couleur a la place du fond blanc ?
      d1gradientboxRGBA(screen, rect->x, rect->y, rect->w, rect->h, 0x88, 0x00, 0xFF, 0xFF, 0x00, 0x80, 0xC0, 0xFF);
      SDL_BlitSurface(lastLoadedImage, NULL, screen, rect);
    }
    
    // la bordure verte est construite par un enboitement de rectangles de plus en plus vert
    for (i=0; i<BORDER; i++)
      rectangleRGBA(screen, i, i,screen->w-i,screen->h-i, 128-4*i, 200-4*i, 100-4*i, 255);

    // les structures de rectangles aussi sont temporaires et doivent etre liberees, de meme que le texte
    free(rect);
    free(rect1);
    free(title0);
    //printf(" display popup ? %d   %p\n", popupType, selectedOption);fflush(stdout);

    // si il y a un message popup il faut l'afficher explicitement car si on passe par ici ca veut dire qu'on a court-circuite l'affichage standard
    if (popupType&POPUP_ISVISIBLE)
      displayPopup();

    // affichage effectif en faisant basculer le double buffering a l'ecran
    SDL_Flip(screen);
    
    // on se rapelle quel etait le compteur lors du dernier affichage (celui qui vient d'avoir lieu) pour eviter de redessiner la meme chose (voir if du debut)
    lastUpdate = initcpt;
  }
}// updateLoading()


/**
 * init the application ressources
 */
void initApp(int s_width, int s_height) {
  printf(" initApp %d * %d\n", s_width, s_height);fflush(stdout);
  
  // here we'll put the list of messages 
  //initmsg     = (char*) malloc (512);
  messageList = list_create(LISTCOUNT_T_MAX);
  addMsg("Initializing application");
  
  nationTexts = (char**)malloc(NATION_NUMBER*sizeof(char*));
  nationTexts[FRANCE-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[FRANCE-FIRST_NATION], "France");
  nationTexts[SPAIN-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[SPAIN-FIRST_NATION], "Spain");
  nationTexts[ENGLAND-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[ENGLAND-FIRST_NATION], "England");
  nationTexts[HOLLAND-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[HOLLAND-FIRST_NATION], "Holland");
  nationTexts[ITALY-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[ITALY-FIRST_NATION], "Italy");
  nationTexts[GERMANY-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[GERMANY-FIRST_NATION], "Germany");
  nationTexts[RUSSIA-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[RUSSIA-FIRST_NATION], "Russia");
  nationTexts[PORTUGAL-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[PORTUGAL-FIRST_NATION], "Portugal");
  nationTexts[NEW_FRANCE-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_FRANCE-FIRST_NATION], "New France");
  nationTexts[NEW_SPAIN-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_SPAIN-FIRST_NATION], "New Spain");
  nationTexts[NEW_ENGLAND-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_ENGLAND-FIRST_NATION], "New England");
  nationTexts[NEW_HOLLAND-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_HOLLAND-FIRST_NATION], "New Holland");
  nationTexts[NEW_ITALY-FIRST_NATION]=(char *)malloc(32*sizeof(char)); 
  sprintf(nationTexts[NEW_ITALY-FIRST_NATION], "New Italy");
  nationTexts[NEW_GERMANY-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_GERMANY-FIRST_NATION], "New Germany");
  nationTexts[NEW_RUSSIA-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_RUSSIA-FIRST_NATION], "New Russia");
  nationTexts[NEW_PORTUGAL-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[NEW_PORTUGAL-FIRST_NATION], "New Portugal");

  nationTexts[AZTEC-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[AZTEC-FIRST_NATION], "Aztec");
  nationTexts[OLMEC-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[OLMEC-FIRST_NATION], "Olmec");
  nationTexts[INCA-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[INCA-FIRST_NATION], "Inca");
  nationTexts[APACHE-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[APACHE-FIRST_NATION], "Apache");
  nationTexts[HURON-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[HURON-FIRST_NATION], "Huron");
  nationTexts[CHEROKEE-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[CHEROKEE-FIRST_NATION], "Cheerokee");
  nationTexts[IROQUOIS-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[IROQUOIS-FIRST_NATION], "Iroquois");
  nationTexts[SIOUX-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[SIOUX-FIRST_NATION], "Sioux");
  nationTexts[TUPI-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[TUPI-FIRST_NATION], "Tupi");
  nationTexts[ARAWAK-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[ARAWAK-FIRST_NATION], "Arawak");
  nationTexts[CHINOOK-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[CHINOOK-FIRST_NATION], "Chinook");
  nationTexts[INUIT-FIRST_NATION]=(char *)malloc(32*sizeof(char));
  sprintf(nationTexts[INUIT-FIRST_NATION], "Inuit");

  /* INIT SDL : See documentation for details */
  Uint32 initflags = SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_TIMER | SDL_INIT_TIMER;;
  Uint8  video_bpp = 32;
  Uint32 videoflags =  SDL_HWSURFACE |  SDL_DOUBLEBUF /*| SDL_FULLSCREEN*/;

  /* Initialize the SDL library */
  if ( SDL_Init(initflags) < 0 ) {
    fprintf(stderr, "***ERROR*** Couldn't initialize SDL: %s\n", SDL_GetError());
    exit(1);
  }

  // check audio capabilities
  if (Mix_OpenAudio(22050, AUDIO_S16, 2, 4096) < 0) {
    fprintf(stderr, "***WARNING***  Audio could not be setup for 22050 Hz 16-bit stereo.\n  Reason: %s\n", SDL_GetError());
    //return;
    noSound = TRUE;
  } else
    printf(" sounds system started !\n");

  atexit(SDL_Quit); // Clean it up nicely :)
  /* Set video mode */

  if (s_width%64 !=0 || s_height%64 !=0){
    fprintf(stderr, "***ERROR*** Sorry, for the moment only width and height multiple of 64 are allowed \n");
    s_width  -= s_width%64;
    s_height -= s_height%64;
    //exit(1);
  }
  
  if (videoflags&SDL_FULLSCREEN) {
    //s_width = 1680;
    //s_height = 1050;
    int biggerW = 0;
    int biggerH = 0;
    int chosen = -1;
    SDL_Rect **modes;
    int i;

    /* Get available fullscreen/hardware modes */
    modes=SDL_ListModes(NULL, SDL_FULLSCREEN|SDL_HWSURFACE);

    /* Check if there are any modes available */
    if(modes == (SDL_Rect **)0){
      printf("No modes available!\n");
      exit(-1);
    }

    /* Check if our resolution is restricted */
    if(modes == (SDL_Rect **)-1){
      printf("All resolutions available.\n");
    }
    else{
      /* Print valid modes */
      printf("Available Modes\n");

      for(i=0;modes[i];++i) {
        if(modes[i]->w%64==0 && modes[i]->h%64==0 && modes[i]->w>=modes[i]->h &&(chosen==-1 || modes[i]->w>modes[chosen]->w || modes[i]->h>modes[chosen]->h)) {
          chosen = i;
        }
        printf(" %d:  %d x %d\n", i, modes[i]->w, modes[i]->h);
      }
      printf("choosen Mode : %d\n", chosen);
      if (chosen!=-1) {
        s_width = modes[chosen]->w;
        s_height = modes[chosen]->h;
      }
    }
    //exit(0);
  }

  screen = SDL_SetVideoMode(s_width, s_height, video_bpp, videoflags);
  if (screen == NULL) {
    fprintf(stderr, "***ERROR*** Couldn't set %d*%d*%d video mode: %s\n", s_width, s_height, video_bpp, SDL_GetError());
    Mix_CloseAudio();
    SDL_Quit();
    exit(2);
  }
  //boxRGBA(screen,  0,  0, screen->w   , screen->h   , 0, 0, 0, 255);
  //boxRGBA(screen, 10, 10, screen->w-10, screen->h-10, 255, 255, 255, 255);

  if (helperTile== NULL)
    helperTile = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, screen->format->BitsPerPixel,
                                      screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
  if (fieldTile== NULL)
    fieldTile  = SDL_DisplayFormatAlpha(helperTile);

  int i, j, k;
  if (maskTiles[0][0]==NULL){
    for (j=0; j<3; j++)
      for (i=0; i<3; i++)
        maskTiles[i][j] = SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, screen->format->BitsPerPixel,
                                               screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
  }

  SDL_WM_SetCaption("NewCol, The Game", "NewCol");
  SDL_EnableUNICODE(1);

  printf(" SDL is started !\n");
  SDL_SurfaceInfo("  screen image info: ", screen);

  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  miniposRect    = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  minimapRect    = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  minimapRect->x = -1;
  minimapRect->y = -1;
  cityViewRect   = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  unitViews      = list_create(LISTCOUNT_T_MAX);

  // to avoid creating building all the time
  for (i=0; i<BUILDING_NUMBER; i++) {
    building *b = createBuilding(FIRST_BUILDING+i, NULL);
    extensionTable[i] = b->extends;
    minSizeTable[i]   = b->minSize;
    hammerTable[i]    = b->buildingHammers;
    toolsTable[i]     = b->buildingTools;
    //printf("et[%i] = %i\n", i, extensionTable[i]);
    free(b);
  }

  if(TTF_Init()==-1) {
    fprintf(stderr, "***ERROR*** TTF_Init: %s\n", TTF_GetError());
    exit(2);
  }

  for(i=0; i<BUILDING_NUMBER; i++) {
    buildingImages[i]     = NULL;
    //miniBuildingImages[i] = NULL;
    buildingIconImages[i] = NULL;
  }

  // open a font from a file
  for (k=FIRST_FONT; k<=LAST_FONT; k++) {
    fonts[k]=TTF_OpenFont("fonts/FreeSans.ttf", k);
    if(!fonts[k]) {
      fprintf(stderr, "***ERROR*** Could not load font from file FreeSans.ttf: TTF_OpenFont: %s\n", TTF_GetError());
      exit(3);
    }
  }
  printf(" fonts are loaded !\n");

  title = (char *)malloc(256*sizeof(char));
  sprintf(title, "%s v%s", APPNAME, VERSION);
  SDL_WM_SetCaption(title, APPNAME);
  printf(" update? \n");fflush(stdout);
  updateLoading();

  if (!noSound) {
    printf(" Loading sounds !\n");fflush(stdout);
    addMsg("Loading sounds");
        
    updateLoading();
    natureSounds[OCEAN_SOUND-FIRST_SOUND] = Mix_LoadWAV("sounds/ocean.wav");
    initcpt++;
    updateLoading();
    natureSounds[GRASSLANDFOREST_SOUND-FIRST_SOUND] = Mix_LoadWAV("sounds/grasslandforest.wav");
    initcpt++;
    updateLoading();
    natureSounds[SAVANNAHFOREST_SOUND-FIRST_SOUND] = Mix_LoadWAV("sounds/savanahforest.wav");
    initcpt++;
    updateLoading();
  }

  // load units png into image from the freecol project
  printf(" Newcol is loading images ...\n");
  iconImage = IMG_LoadAndFormatAlpha("images/Icon64.png");
  if (iconImage==NULL) {
    FILE *f1 = fopen("images", "r");
    if (!f1) {
      fprintf(stderr, "***ERROR*** cannot open directory: images/ !\n");
      exit(0);
    }
    fclose(f1);
    fprintf(stderr, "***ERROR*** cannot load first image (pioneer.png)!\n");
    exit(0);
  }
  printf(" loading images ... mask=%x %x %x %x\n", iconImage->format->Rmask, iconImage->format->Gmask,
                                                   iconImage->format->Bmask, iconImage->format->Amask);
  addMsg("Loading images");
  initcpt++;
  updateLoading();
  coinImage  = IMG_LoadAndFormatAlpha("images/Coin.png");
  crossImage = IMG_LoadAndFormatAlpha("images/Cross.png");
  initcpt+=2;
  updateLoading();

  char* imgfilename = (char*)malloc(64*sizeof(char));

  // load the (horse, weapon, tool, etc) images for colonists first so we can use them as reference for other specialties
  unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]        = IMG_LoadAndFormatAlpha("images/Unit32.png");
  unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]          = IMG_LoadAndFormatAlpha("images/Unit29.png");
  unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]  = IMG_LoadAndFormatAlpha("images/Unit33.png");
  unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS]         = IMG_LoadAndFormatAlpha("images/Unit30.png");
  unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS] = IMG_LoadAndFormatAlpha("images/Unit32.png");

  initcpt+=5;
  updateLoading();

  for(i=FIRST_UNIT; i<=LAST_SPECIALTY; i++) {
    sprintf(imgfilename, "images/unitsmix/%02i/straight6.png", i-FIRST_UNIT);
    unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG] = IMG_LoadAndFormatAlpha(imgfilename);
    if (unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG] !=NULL) {
      sprintf(imgfilename, "images/unitsmix/%02i/gun6.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]          = IMG_LoadAndFormatAlpha(imgfilename);
      sprintf(imgfilename, "images/unitsmix/%02i/tool6.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS]         = IMG_LoadAndFormatAlpha(imgfilename);
      sprintf(imgfilename, "images/unitsmix/%02i/horse6.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]        = IMG_LoadAndFormatAlpha(imgfilename);
      sprintf(imgfilename, "images/unitsmix/%02i/horsegun6.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]  = IMG_LoadAndFormatAlpha(imgfilename);
      sprintf(imgfilename, "images/unitsmix/%02i/horsetool6.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS] = IMG_LoadAndFormatAlpha(imgfilename);
      initcpt+=6;
      updateLoading();
    }
    else {
      fprintf(stderr, "***WARNING***  %s was null so let's take old unit picts\n",  imgfilename);
      sprintf(imgfilename, "images/Unit%02i.png", i-FIRST_UNIT);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG] = IMG_LoadAndFormatAlpha(imgfilename);
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]          = unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS];
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS]         = unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS];
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS] = unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS];
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]        = unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES];
      unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]  = unitsImages[(COLONIST-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS];
      initcpt+=6;
      updateLoading();
    }
    if (unitsImages[(i-FIRST_UNIT)*POSSIBLE_UNITIMG]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  /*unitsImages[(COLONIAL-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]          = IMG_LoadAndFormatAlpha("images/Unit39.png");
  unitsImages[(COLONIAL-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]        = IMG_LoadAndFormatAlpha("images/Unit40.png");
  unitsImages[(COLONIAL-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]  = IMG_LoadAndFormatAlpha("images/Unit41.png");
  unitsImages[(REGULAR-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]           = IMG_LoadAndFormatAlpha("images/Unit42.png");
  unitsImages[(REGULAR-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]         = IMG_LoadAndFormatAlpha("images/Unit43.png");
  unitsImages[(REGULAR-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]   = IMG_LoadAndFormatAlpha("images/Unit44.png");
  unitsImages[(INDIAN-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]           = IMG_LoadAndFormatAlpha("images/Unit45.png");
  unitsImages[(INDIAN-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]         = IMG_LoadAndFormatAlpha("images/Unit46.png");
  unitsImages[(INDIAN-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]   = IMG_LoadAndFormatAlpha("images/Unit47.png");*/
  initcpt = initcpt+9;
  updateLoading();

  // some units are special !
  for(i=FIRST_SPECIAL; i<=LAST_SPECIAL; i++) {
    sprintf(imgfilename, "images/Unit%03i.png", 900+i-FIRST_SPECIAL);
    //printf("%i => %i (%s)\n", i, (SPECIALTY_NUMBER)*POSSIBLE_UNITIMG+(i-FIRST_SPECIAL), imgfilename);
    unitsImages[(SPECIALTY_NUMBER)*POSSIBLE_UNITIMG+(i-FIRST_SPECIAL)] = IMG_LoadAndFormatAlpha(imgfilename);
    initcpt++;
    updateLoading();
    if (unitsImages[(SPECIALTY_NUMBER)*POSSIBLE_UNITIMG+(i-FIRST_SPECIAL)]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  for(i=FIRST_BONUS; i<=LAST_BONUS; i++) {
    sprintf(imgfilename, "images/bonus/Bonus%02i.png", i-FIRST_BONUS);
    //printf("%i => %s\n", i-FIRST_BONUS, imgfilename);
    bonusImages[i-FIRST_BONUS] = IMG_LoadAndFormatAlpha(imgfilename);
    initcpt++;
    updateLoading();
    if (bonusImages[i-FIRST_BONUS]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  for(i=FIRST_MESSAGE; i<=LAST_MESSAGE; i++) {
    sprintf(imgfilename, "images/messages/message%02i.png", i-FIRST_MESSAGE);
    messageImages[i-FIRST_MESSAGE] = IMG_LoadAndFormatAlpha(imgfilename);
    initcpt++;
    updateLoading();
    if (messageImages[i-FIRST_MESSAGE]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  for(i=FIRST_GOOD; i<=LAST_GOOD; i++) {
    sprintf(imgfilename, "images/goods/Goods%02i.png", i-FIRST_GOOD);
    //printf("%i => %s\n", i, imgfilename);
    goodsImages[i-FIRST_GOOD] = IMG_LoadAndFormatAlpha(imgfilename);
    initcpt++;
    updateLoading();
    if (goodsImages[i-FIRST_GOOD]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  // unfortunately sometimes people are just goods for merchants
  for (k=FIRST_UNIT; k<=LAST_SPECIALTY; k++) {
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG]                   = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG], 2, 2);
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS]          = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHGUNS], 2, 2);
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS]         = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHTOOLS], 2, 2);
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS] = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDTOOLS], 2, 2);
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES]        = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSES], 2, 2);
    goodsImages[LAST_GOOD-FIRST_GOOD+1+(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS]  = shrinkSurface(unitsImages[(k-FIRST_UNIT)*POSSIBLE_UNITIMG+WITHHORSEANDGUNS], 2, 2);
  }

  nationFlags[FRANCE-FIRST_NATION]  = IMG_LoadAndFormatAlpha("images/flags/france.png");
  nationFlags[ENGLAND-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/england.png");
  nationFlags[SPAIN-FIRST_NATION]   = IMG_LoadAndFormatAlpha("images/flags/spain.png");
  nationFlags[HOLLAND-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/holland.png");
  nationFlags[ITALY-FIRST_NATION]   = IMG_LoadAndFormatAlpha("images/flags/italy.png");
  nationFlags[GERMANY-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/germany.png");
  nationFlags[PORTUGAL-FIRST_NATION]= IMG_LoadAndFormatAlpha("images/flags/portugal.png");
  nationFlags[RUSSIA-FIRST_NATION]  = IMG_LoadAndFormatAlpha("images/flags/russia.png");
  initcpt+=8;
  updateLoading();

  // When the user will declare independance he/she will be able to select an other one !
  nationFlags[NEW_FRANCE-FIRST_NATION]  = IMG_LoadAndFormatAlpha("images/flags/france.png");
  nationFlags[NEW_ENGLAND-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/england.png");
  nationFlags[NEW_SPAIN-FIRST_NATION]   = IMG_LoadAndFormatAlpha("images/flags/spain.png");
  nationFlags[NEW_HOLLAND-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/holland.png");
  nationFlags[NEW_ITALY-FIRST_NATION]   = IMG_LoadAndFormatAlpha("images/flags/italy.png");
  nationFlags[NEW_GERMANY-FIRST_NATION] = IMG_LoadAndFormatAlpha("images/flags/germany.png");
  nationFlags[NEW_PORTUGAL-FIRST_NATION]= IMG_LoadAndFormatAlpha("images/flags/portugal.png");
  nationFlags[NEW_RUSSIA-FIRST_NATION]  = IMG_LoadAndFormatAlpha("images/flags/russia.png");
  initcpt+=8;
  updateLoading();

  for (i=FIRST_OLD_POWER; i<=LAST_NEW_NATION; i++)
    nationMiniFlags[i-FIRST_OLD_POWER] = shrinkSurface(nationFlags[i-FIRST_OLD_POWER],
      nationFlags[i-FIRST_OLD_POWER]->h/(TITLE_BAR_HEIGHT), nationFlags[i-FIRST_OLD_POWER]->h/(TITLE_BAR_HEIGHT));

  // building images regenerated from the swecol2 project
  for(i=0; i<BUILDING_NUMBER; i++) {
    sprintf(imgfilename, "images/buildings/Building%02i.png", i);
    buildingImages[i] = IMG_LoadAndFormatAlpha(imgfilename);
    //miniBuildingImages[i] = shrinkSurface(buildingImages[i], 3, 3);

    initcpt++;
    updateLoading();
    if (buildingImages[i]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }
  for (i=FIRST_BUILDING; i<=LAST_BUILDING; i++)
    buildingIconImages[i-FIRST_BUILDING] = shrinkSurface(buildingImages[i-FIRST_BUILDING],
           buildingImages[i-FIRST_BUILDING]->h/(TITLE_BAR_HEIGHT), buildingImages[i-FIRST_BUILDING]->h/(TITLE_BAR_HEIGHT));

  forestImages[FOREST1]                                                = IMG_LoadAndFormatAlpha("images/rainForest.png");
  forestImages[FOREST2]                                                = IMG_LoadAndFormatAlpha("images/BroadleafForest.png");
  initcpt+=2;
  updateLoading();

  for (i=FIRST_TREE; i<FIRST_TREE+TREE_NUMBER; i++) {
    sprintf(imgfilename, "images/trees/tree%1i.png", i);
    initcpt++;
    updateLoading();
    treeImages[i-FIRST_TREE]                                           = IMG_LoadAndFormatAlpha(imgfilename);
    if (treeImages[i-FIRST_TREE]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  for (i=FIRST_FIELD; i<FIRST_FIELD+FIELD_NUMBER; i++) {
    sprintf(imgfilename, "images/tiles/field%1i.png", i);
    fieldImages[i-FIRST_FIELD]                                         = IMG_LoadAndFormatNoAlpha(imgfilename);
    initcpt++;
    updateLoading();
    if (fieldImages[i-FIRST_FIELD]==NULL)
      fprintf(stderr, "***ERROR*** %i => %s didn't work !\n", i, imgfilename);
  }

  // let's create few forests image in cache to use them for fast forest display
  int vegeTop, vegeRight, vegeBottom, vegeLeft;
  for (vegeTop=0; vegeTop<=1; vegeTop++)
    for (vegeRight=0; vegeRight<=1; vegeRight++)
      for (vegeBottom=0; vegeBottom<=1; vegeBottom++)
        for (vegeLeft=0; vegeLeft<=1; vegeLeft++){
          //printf("fred %i\n", vegeLeft);
          forest20Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft] =
            SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, screen->format->BitsPerPixel,
                                 screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0xFF000000);
          forest40Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft] =
            SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCALPHA, TILESIZE, TILESIZE, screen->format->BitsPerPixel,
                                 screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0xFF000000);
          //boxRGBA(forestImgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft], 0, 0, TILESIZE, TILESIZE, 0, 0, 0, 0);

          cacheVegetationOnTile(-20, vegeTop*-20, vegeRight*-20, vegeBottom*-20, vegeLeft*-20, forest20Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft]);
          cacheVegetationOnTile(-40, vegeTop*-20, vegeRight*-20, vegeBottom*-20, vegeLeft*-20, forest40Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft]);
        }

  cloudImage                                                           = IMG_LoadAndFormatAlpha("images/cloud.png");
  pathFootImage                                                        = IMG_LoadAndFormatAlpha("images/transportation/path-foot.png");
  pathHorseImage                                                       = IMG_LoadAndFormatAlpha("images/transportation/path-horse.png");
  pathNavalImage                                                       = IMG_LoadAndFormatAlpha("images/transportation/path-naval.png");
  pathWagonImage                                                       = IMG_LoadAndFormatAlpha("images/transportation/path-wagon.png");
  pathFootNTImage                                                      = IMG_LoadAndFormatAlpha("images/transportation/path-foot-nextturn.png");
  pathHorseNTImage                                                     = IMG_LoadAndFormatAlpha("images/transportation/path-horse-nextturn.png");
  pathNavalNTImage                                                     = IMG_LoadAndFormatAlpha("images/transportation/path-naval-nextturn.png");
  pathWagonNTImage                                                     = IMG_LoadAndFormatAlpha("images/transportation/path-wagon-nextturn.png");
  initcpt+=8;
  updateLoading();

  free(imgfilename);
  printf(" last image is loaded %p (%i*%i)\n", pathWagonNTImage, pathWagonNTImage->w, pathWagonNTImage->h);

  defaultSelectionList = list_create(LISTCOUNT_T_MAX);
  unitSelectionList    = defaultSelectionList;

  for(i=0; i<MapWidth; i++) {
    for(j=0; j<MapHeight; j++) {
      map[i+MapWidth*(j)].unitList     = NULL;
      map[i+MapWidth*(j)].ground       = PLAIN;
      map[i+MapWidth*(j)].bonus        = 0;
      map[i+MapWidth*(j)].unitList     = NULL;
      map[i+MapWidth*(j)].posX         = i;
      map[i+MapWidth*(j)].posY         = j;
      map[i+MapWidth*(j)].lastExplored = -1;
      map[i+MapWidth*(j)].elevation    = SEALEVEL;
      map[i+MapWidth*(j)].vegetation   = WILDGRASS;
      map[i+MapWidth*(j)].construction = NULL;
      map[i+MapWidth*(j)].seed         = ((rand()%8)<<28)+((rand()%8)<<24)+((rand()%8)<<20)+((rand()%8)<<16)+
                                          ((rand()%8)<<12)+((rand()%8)<<8)+((rand()%8)<<4)+((rand()%8)<<0);
      map[i+MapWidth*(j)].irrigation   = UNKNOWN;
      map[i+MapWidth*(j)].river_elem   = NULL;
      //map[i+MapWidth*(j)].influences = (int*)malloc(NATION_NUMBER*sizeof(int));
    }
  }

  free(rect);
}// initApp() --------------------------------------------------------------------


/**
 * reset the status of a given unit
 */
void resetStatus(unit *u) {
  u->status = WAITING;
  if (u->itinerary != NULL) {
    list_destroy_nodes(u->itinerary);
    list_destroy(u->itinerary);
    u->itinerary = NULL;
  }
}// resetStatus() --------------------------------------------------------------------


/**
 * reset the status of a given unit list
*/
void resetStatusAll(list_t *unitList) {
  lnode_t *unitelem = list_first(unitList);
  while (unitelem != &unitList->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    resetStatus(u);
    unitelem = unitelem->list_next;
  }
}// resetStatusAll() --------------------------------------------------------------------


/**
 * update surrounding visibility around a given unit
 */
int updatesVisibleSurroundings(unit *u) {
  int i, j;
  if (u->location==NULL)
    return 0;

  tile *t   = u->location;
  int sight = u->sight;
  if (t->elevation==HILL)
    sight+=1*MapWidth/1080;
  if (t->elevation==HIGHHILL)
    sight+=2*MapWidth/1080;
  if (t->elevation==MOUNTAIN)
    sight+=3*MapWidth/1080;

  // forests prevent seeing far away
  if (t->vegetation<=WOOD/2) {
    float darkness = (float)(t->vegetation-WOOD/2)/(FOREST-WOOD/2);
    sight-=(int)(sight*darkness);
    //printf("sight=%i %f   %i\n", (t->vegetation+WOOD/2), darkness, (FOREST-WOOD/2));
  }
  int updated = 0;
  for (i=-sight; i<=sight; i++) {
    for (j=-sight; j<=sight; j++) {
      int d =(int)sqrt((float)(i*i+j*j));
      if (d<=sight && t->posX+i>=0 && t->posY+j>=0 &&t->posX+i<MapWidth && t->posY+j<MapHeight) {
        int depx= t->posX;
        int depy= t->posY;
        while ((depx!=t->posX+i || depy!=t->posY+j) && map[depx+MapWidth*(depy)].elevation<=map[t->posX+MapWidth*(t->posY)].elevation) {
          int dx = t->posX+i-depx;
          int dy = t->posY+j-depy;

          if (dy==0) {
            depx += abs(dx)/dx;
          } else if (dx==0) {
            depy += abs(dy)/dy;
          } else if (abs(dx)<abs(dy)) {
            depx += abs(dx)/dx;
            if (abs(dy)-abs(dx)<=abs(dx))
              depy += abs(dy)/dy;
          } else {
            depy += abs(dy)/dy;
            if (abs(dx)-abs(dy)<=abs(dy))
              depx += abs(dx)/dx;
          }
          if (map[depx+MapWidth*(depy)].lastExplored!=0) {
            map[depx+MapWidth*(depy)].lastExplored = 0;
            updatesCachedTileAt(depx, depy);
            updated+=1;
          }
        }
        if (map[t->posX+MapWidth*(t->posY)].lastExplored!=0) {
          map[t->posX+MapWidth*(t->posY)].lastExplored = 0;
          updatesCachedTileAt(depx, depy);
          updated+=1;
        }
      }
    }
  }
  return updated;
}// updatesVisibleSurroundings()


/**
 * update visibility with all visible stuff from the given player
 */
void updatesVisibility(player *p) {

  int i, j;
  lnode_t *ln = list_first(p->cityList);
  while (ln!=NULL && ln !=  &p->cityList->list_nilnode) {
    city *cityNoi = (city *)ln->list_data;
    tile *t       = cityNoi->location;
    int sight     = (cityNoi->size+2);
    for (i=-sight; i<=sight; i++)
      for (j=-sight; j<=sight; j++) {
        int d =(int)hypot((float)i, (float)j);
        if (d<=sight && t->posX+i>=0 && t->posY+j>=0 &&t->posX+i<MapWidth && t->posY+j<MapHeight) {
          map[t->posX+i+MapWidth*(t->posY+j)].lastExplored = 0;
        }
      }
    ln = ln->list_next;
  }

  ln = list_first(p->unitList);
  while (ln!=NULL && ln != &p->unitList->list_nilnode) {
    unit *unitNoi = (unit *)ln->list_data;
    ln = ln->list_next;
    updatesVisibleSurroundings(unitNoi);
  }
}// updatesVisibility() --------------------------------------------------------------------


/**
 * update visibility
 */
void updatesLastExplored() {
  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  updatesVisibility(currentPlayer);
  player  *motherNationPlayer = nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION];
  updatesVisibility(motherNationPlayer);
}// updatesLastExplored() --------------------------------------------------------------------


/**
 * update the position of all units of a given player with a GOTO order
 */
int getMinMovePts(list_t  *unitList) {
  int minMovePts = -1;
  lnode_t *ln = list_first(unitList);
  while (ln !=  &unitList->list_nilnode) {
    unit *u = (unit *)ln->list_data;
    if (u->movement<minMovePts || minMovePts==-1)
      minMovePts = u->movement;
    ln = ln->list_next;
  }
  return minMovePts;
}// getMinMovePts() --------------------------------------------------------------------


/**
 * update the position of all units of a given player with a GOTO order
 */
int getMaxMoveCost(list_t  *unitList, tile *dest) {
  int maxMoveCost = -1;
  lnode_t *ln = list_first(unitList);
  while (ln !=  &unitList->list_nilnode) {
    unit *u = (unit *)ln->list_data;
    int diff = computeDifficulty(u->location, dest, u);
    if (diff>maxMoveCost || maxMoveCost==0)
      maxMoveCost = diff;
    ln = ln->list_next;
  }
  return maxMoveCost;
}// getMaxMoveCost() --------------------------------------------------------------------


/**
 * update the position of all units of a given player with a GOTO order
 */
void updatesGotoOrders(list_t  *unitList) {
  //printf("updatesGotoOrders() %i\n", list_count(unitList));
  tile *lastStop = NULL;
  int move       = 0;

  do {
    move = 0;
    unit *u         = (unit*)list_first(unitList)->list_data;
    list_t  *iti    = u->itinerary;
    tile *dest      = u->destination;

    if (dest==NULL || iti==NULL)
      break;

    if (list_count(iti)==0){
      list_destroy_nodes(u->itinerary);
      list_destroy(u->itinerary);
      u->itinerary = NULL;
      break;
    }

    tile *t         = (tile *)list_first(iti)->list_data;
    int minMovePts  = getMinMovePts(unitList);
    int maxMovecost = getMaxMoveCost(unitList, t);

    // we tryed to follow our way but something prevent us from doing that !
    if (maxMovecost>=1000 && lastStop!=u->location){
      lastStop          = u->location;
      tile *destination = u->destination;
      list_destroy_nodes(u->itinerary);
      list_destroy(u->itinerary);
      u->itinerary      = astarSearch(u->location->posX, u->location->posY, destination->posX, destination->posY, u);
      if (u->itinerary!=NULL)
        move = -1;
      else
        move = 0;
      // if the list can all move
    } else if (maxMovecost<=minMovePts){
      move = moveUnitList(unitList, t->posX, t->posY);
      if (t==dest)
        move = 0;
    }
  } while (move);

  // well, just in case there are new things to update
  unit *u               = (unit*)list_first(unitList)->list_data;
  if (u->location->posX<=firstVisibleTileX || u->location->posY<=firstVisibleTileY ||
      u->location->posX>=firstVisibleTileX+screen->w/TILESIZE || u->location->posY>=firstVisibleTileY+screen->h/TILESIZE) {
    panToCenter(u->location);
  }
  inspector->t          = u->location;
  inspector->needUpdate = TRUE;
}// updatesGotoOrders() --------------------------------------------------------------------


/**
 * updates the eventual bonuses on a given cached tile
 */
int getBonusForTile(tile *t) {
  int bn = NONE;
  if (t->elevation==HIGHMOUNTAIN)
    bn = PUREGOLD;
  else if (t->elevation==MOUNTAIN)
    bn = PURESILVER;
  else if (t->vegetation==WOOD && isConnectedToWater(t->posX, t->posY) && t->elevation>=SEALEVEL && t->elevation<=HILL)
    bn = PRIMEFUR;
  else if (t->vegetation==WOOD && t->elevation>=SEALEVEL && t->elevation<=HILL)
    bn = PRIMEGAME;
  else if (t->vegetation==FOREST && t->elevation>=SEALEVEL && t->elevation<=HIGHHILL)
    bn = PRIMELUMBER;
  else if (t->elevation==HIGHHILL)
    bn = PUREORE;
  else if (t->elevation==HILL)
    bn = PURECOAL;
  else if (t->ground==PLAIN && t->elevation==SEALEVEL)
    bn = PRIMECORN;
  else if (t->ground==GRASSLAND && t->elevation==SEALEVEL)
    bn = PRIMETOBACCO;
  else if (t->ground==PRAIRIE && t->elevation==SEALEVEL)
    bn = PRIMECOTTON;
  else if (t->ground==SAVANNAH && t->elevation==SEALEVEL)
    bn = PRIMESUGAR;
  else if (t->ground==DESERT && t->elevation<=SEALEVEL)
    bn = PRIMEOIL;
  else if (t->elevation<SEALEVEL)
    bn = PRIMEFISH;
  return bn;
}// getBonusForTile() --------------------------------------------------------------------


/**
 * update the plowing according to pioneer's work
 */
void updatesPioneerOrders() {
  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  list_t  *allUnitList   = currentPlayer->unitList;
  //printf("updatesPioneerOrders() %i\n", list_count(currentPlayer->unitList));

  lnode_t *ln = list_first(allUnitList);
  while (ln !=  &allUnitList->list_nilnode) {
    unit *u = (unit *)ln->list_data;
    tile *t = u->location;
    if (u->owner==currentPlayer && u->status==PLOWING && u->movement==u->maxMovement) {
      int tiletype = t->vegetation/20;
      if (u->type==PIONEER) {
        t->vegetation+=10;
        u->tools-=10;
        u->movement=0;
      } else {
        t->vegetation+=5;
        u->tools-=5;
        u->movement=0;
      }
      if (t->vegetation/20!=tiletype)
        u->status=WAITING;
    }
    if (u->owner==currentPlayer && u->status==ROADING && u->movement==u->maxMovement) {
      int vegetype = t->vegetation/20;
      int roadtype = t->road/20;
      int power = 10;

      if (u->type==PIONEER)
        power = power*2;
      if (vegetype<WOOD)
        power = power/4;
      if (vegetype<WILDGRASS)
        power = power/2;

      //printf("for tile %i, %i, road=%i will be modified with %i (vege is %i)\n", t->posX, t->posY, t->road, power, vegetype);
      t->road   = t->road+power;
      u->tools  = u->tools-power;
      u->movement=0;
      //printf("for tile %i, %i   road=%i was modified with %i  (old was %i)\n", t->posX, t->posY, t->road, power, roadtype);
      if ((t->road)/20!=roadtype) {
        u->status=WAITING;
      }
      int di, dj;
      if (t->posX>=firstVisibleTileX && t->posY>=firstVisibleTileY && t->posX<firstVisibleTileX+screen->w/TILESIZE && t->posY<firstVisibleTileY+screen->h/TILESIZE)
        for (di=-1; di<2; di++)
          for (dj=-1; dj<2; dj++)
            if (map[t->posX+di+MapWidth*(t->posY+dj)].road>0) {
              //int u= (t->posY+dj-firstVisibleTileY)*(screen->w/TILESIZE)+(t->posX+di-firstVisibleTileX);
              SDL_Surface * tc = getTileCache(t->posX+di, t->posY+dj);
              updatesRoadOnTile(t->posX+di, t->posY+dj, tc);
            }
    }

    ln = ln->list_next;
  }
}// updatesPioneerOrders() --------------------------------------------------------------------


/**
 * return the right cached image for the given position or NULL if there is no cache for there
 */
SDL_Surface *getTileCache(int x, int y){
  //printf("  getTileCache(%i, %i)=>(%i, %i)=>(%i, %i)=>%i\n", x, y, (x-firstVisibleTileX), (y-firstVisibleTileY),
  //                                                        (x-firstVisibleTileX), (y-firstVisibleTileY),
  //                            (y-firstVisibleTileY)*(screen->w/TILESIZE)+(x-firstVisibleTileX));
  //fflush(stdout);
  if (x<firstVisibleTileX || x>=firstVisibleTileX+screen->w/TILESIZE || y< firstVisibleTileY || y>=firstVisibleTileY+screen->h/TILESIZE)
    return NULL;
  int u= (y-firstVisibleTileY)*(screen->w/TILESIZE)+(x-firstVisibleTileX);
  return tilecache[u];
}// getTileCache()


/**
 * return the right image for the given unit
 */
SDL_Surface *getUnitImage(unit *u) {
  //printf("getUnitImage %i", u->type);
  int imageid = (u->type-FIRST_UNIT)*POSSIBLE_UNITIMG;

  if (u->tools>0 && u->horses>0)
    imageid+=WITHHORSEANDTOOLS;
  else if (u->muskets>0 && u->horses>0)
    imageid+=WITHHORSEANDGUNS;
  else if (u->muskets>0)
    imageid+=WITHGUNS;
  else if (u->tools>0)
    imageid+=WITHTOOLS;
  else if (u->horses>0)
    imageid+=WITHHORSES;

  if (u->type>LAST_SPECIALTY)
    imageid = (SPECIALTY_NUMBER)*POSSIBLE_UNITIMG+(u->type-FIRST_SPECIAL);
   //printf("=> %i\n", imageid);

  return unitsImages[imageid];
}// getUnitImage() --------------------------------------------------------------------


/**
 * return the right image for the given unit ... as good (in transport or in unit inspector, etc.)
 */
SDL_Surface *getUnitGoodImage(unit *u) {
  //printf("getUnitGoodImage (%i) %% %i\n", u->type, FURTRAPPER);
  int imageid = (u->type-FIRST_UNIT)*POSSIBLE_UNITIMG;

  if (u->tools>0 && u->horses>0)
    imageid+=WITHHORSEANDTOOLS;
  else if (u->muskets>0 && u->horses>0)
    imageid+=WITHHORSEANDGUNS;
  else if (u->muskets>0)
    imageid+=WITHGUNS;
  else if (u->tools>0)
    imageid+=WITHTOOLS;
  else if (u->horses>0)
    imageid+=WITHHORSES;

  if (u->type>LAST_SPECIALTY)
    imageid = (SPECIALTY_NUMBER)*POSSIBLE_UNITIMG+(u->type-FIRST_SPECIAL);
  //printf("=> %i\n", imageid);

  return goodsImages[LAST_GOOD-FIRST_GOOD+1+imageid];
}// getUnitGoodImage() --------------------------------------------------------------------


/**
 * return if the nation n1 is the colony of mothercountry n2
 */
int isColonyOf(int n1, int n2) {
  return (n1>n2 && n1>=FIRST_NATION+OLD_POWER_NUMBER && n1<FIRST_NATION+OLD_POWER_NUMBER+NEW_POWER_NUMBER && n1-n2==OLD_POWER_NUMBER);
}// isColonyOf() --------------------------------------------------------------------


/**
 * return if the nation n1 is a colony
*/
int isColony(int n1) {
  return (n1>=FIRST_NATION+OLD_POWER_NUMBER && n1<FIRST_NATION+OLD_POWER_NUMBER+NEW_POWER_NUMBER);
}// isColony() --------------------------------------------------------------------


/**
 * return the text for the given nation
 */
char *getNationText(int nation) {
  //printf("getNationText() %i\n", nation);
  if (nation<FIRST_NATION || nation>LAST_NATION )
    return NULL;
  return nationTexts[nation-FIRST_NATION];
}// getNationText() --------------------------------------------------------------------


/**
 * return the status text to describe a given unit activity
 **/
char *getStatusText(int status) {
  if (status>=FIRST_STATUS && status<=LAST_STATUS)
    return statusTexts[status-FIRST_STATUS];
  else
    return NULL;
}// getStatusText() --------------------------------------------------------------------


/**
 * return the text in english for the given tile
 */
char *getGroundText(tile *t) {
  if (t->elevation==SEALEVEL || t->elevation==HILL)
    return groundTexts[t->ground-FIRST_GROUND];
  else
    return elevationTexts[t->elevation-FIRST_ELEVATION];
}// getGroundText() --------------------------------------------------------------------


/**
 * create the text describing the bonus in english for the given tile
 */
char *getGoodText(good *g) {
  return goodTexts[g->type-FIRST_GOOD];
}// getGoodText() --------------------------------------------------------------------


/**
 * create the text describing the bonus in english for the given tile
 */
char *getBonusText(tile *t) {
  int bn = getBonusForTile(t);
  return bonusTexts[bn-FIRST_BONUS];
}// getBonusText() --------------------------------------------------------------------


/**
 * return the text in english for the given unit
 */
char *getUnitText(unit *u) {
  if (u->type==SOLDIER && u->horses>0) return "Dragoon";
  return unitTexts[u->type-FIRST_UNIT];
}// getUnitText() --------------------------------------------------------------------


/**
 * return the image associated with a given good
 */
SDL_Surface *getGoodImage(good* g) {
  if(g==NULL)
    return goodsImages[0];
  //printf("getGoodImage(%i)", g->type);
  if (g->type>=FIRST_GOOD && g->type<=LAST_GOOD) {
    //printf("\n");
    return goodsImages[g->type-FIRST_GOOD];
  } else if (g->passenger!=NULL){
    //printf("    will return goodsImages[%i]\n", LAST_GOODS-FIRST_GOOD+1+g->type-FIRST_UNIT);
    return getUnitGoodImage(g->passenger);//goodsImages[LAST_GOOD-FIRST_GOOD+1+type-FIRST_UNIT];
  }
}// getGoodImage() --------------------------------------------------------------------


/**
 * return the image associated with a given building
 */
SDL_Surface *getBuildingImage(building* b) {
  return buildingImages[b->type-FIRST_BUILDING];
}// getBuildingImage() --------------------------------------------------------------------


/**
 * display an unit list
 */
void displayUnitList(list_t *unitList, int isSelected) {
  //printf("displayUnitList(listOf%i, %i)\n", list_count(unitList) , isDrag);
  char        *text = (char*)malloc(32*sizeof(char));

  if (unitList==NULL || list_isempty(unitList))
    return ;
  if (currentPlayerElement==NULL)
    return;
  player  *currentPlayer = (player *)currentPlayerElement->list_data;

  lnode_t *unitelem = list_first(unitList);
  unit * firstUnit  = (unit *)unitelem->list_data;
  if (firstUnit->location==NULL || firstUnit->location->posX<firstVisibleTileX || firstUnit->location->posY<firstVisibleTileY ||
                                   firstUnit->location->posX>=firstVisibleTileX+screen->w/TILESIZE || firstUnit->location->posY>=firstVisibleTileY+screen->h/TILESIZE)
    return;
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  rect->x = (firstUnit->location->posX-firstVisibleTileX)*TILESIZE;
  rect->y = (firstUnit->location->posY-firstVisibleTileY)*TILESIZE;
  rect->w = TILESIZE;
  rect->h = TILESIZE;

  SDL_Color *col = nationColors[firstUnit->owner->nation-FIRST_NATION];
  //SDL_FillRect(screen, rect, SDL_MapRGB( screen->format, col->r, col->g, col->b ));

  int alpha = 0;
  if (animID%16<8) alpha = (animID%16)*32+16;
  else          alpha = 255-(animID-8)*32;

  if (isDrag==UNIT && isSelected) { // shadow if dragged
    //rect->x+=5;rect->y+=5;
    //roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 62, 292, 0, 64);
    //rect->x-=5;rect->y-=5;
    roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, col->r, col->g, col->b, alpha);
    roundedRectangleRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 0, 0, 0, 255);
  }
  else if (isDrag!=UNIT && unitList==unitSelectionList) {
    roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, col->r, col->g, col->b, alpha);
    roundedRectangleRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 0, 0, 0, 255);
  }

  int minMovement      = 64;
  int minMaxMovement   = 64;
  int minHealth        = 100;
  int minMaxHealth     = 100;
  int minExperience    = MAX_EXPERIENCE;

  int i                = 0;
  int i2               = 0;
  int commonStatus     = -1;
  int nbgoods          = 0;
  rect->x+=2;
  rect->y+=2;
  while (unitelem != &unitList->list_nilnode) {
    unit *unitNoi = (unit *)unitelem->list_data;
    unitelem = unitelem->list_next;

    // don't display this one as non-selected because it will be re-displayed as the selection
    if (!isSelected && unitSelectionList!=NULL && unitSelectionList!=unitList &&list_count(unitSelectionList)>0 && ((unit*)list_first(unitSelectionList)->list_data)->location == unitNoi->location &&list_find(unitSelectionList, unitNoi, straightCompare))
      continue;

    nbgoods += unitNoi->maxLoad;
    SDL_Surface *img1 = getUnitImage(unitNoi);

    rect->y-=(img1->h-TILESIZE);
    SDL_BlitSurface(img1, 0, screen, rect);
    rect->y+=(img1->h);
    if (isDrag!=UNIT && unitList==unitSelectionList) {
      char *unitname    = getUnitText(unitNoi);
      TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
      SDL_Surface *img2 = TTF_RenderText_Blended(fonts[10], unitname, WHITE);
      SDL_Surface *img3 = TTF_RenderText_Blended(fonts[10], unitname, BLACK);
      TTF_SetFontStyle(fonts[10], TTF_STYLE_NORMAL);
      //int w = rect->w;
      rect->x += (TILESIZE-img2->w)/2;
      rect->y += 13*i;
      rect->y--;
      rect->x--;
      SDL_BlitSurface(img2, 0, screen, rect);
      rect->x+=2;
      SDL_BlitSurface(img2, 0, screen, rect);
      rect->y+=2;
      SDL_BlitSurface(img2, 0, screen, rect);
      rect->x-=2;
      SDL_BlitSurface(img2, 0, screen, rect);
      rect->y-=2;
      rect->x++;
      rect->y++;
      SDL_BlitSurface(img3, 0, screen, rect);

      rect->x -= (TILESIZE-img2->w)/2;
      rect->y -= 13*i;
      SDL_FreeSurface(img2);
      SDL_FreeSurface(img3);
    }
    rect->y -= TILESIZE;

    if (unitNoi->owner==currentPlayer || gamemode!=PLAY) {
      if (unitNoi->experience<minExperience)
        minExperience = unitNoi->experience;

      if (unitNoi->health<minHealth)
        minHealth = unitNoi->health;
      if (unitNoi->maxHealth<minMaxHealth)
        minMaxHealth = unitNoi->maxHealth;

      if (unitNoi->movement<minMovement)
        minMovement = unitNoi->movement;
      if (unitNoi->maxMovement<minMaxMovement)
        minMaxMovement = unitNoi->maxMovement;

      // we can only show the status if the unit is owned by the player or we are in the edit mode
      if (commonStatus==-1 &&(gamemode==EDIT || unitNoi->owner==currentPlayer))
        commonStatus=unitNoi->status;
      else if (commonStatus!=unitNoi->status)
        commonStatus=MIXEDSTATUS;
      i2++;
    } else {
      minExperience = 0;
    }
    rect->x+=2;
    i++;
  }

  //int goodid = 0;
  // goods associated with this units
  /*if (isDrag!=UNIT && isSelected) {
    rect->x = (int)((firstUnit->location->posX-firstVisibleTileX)*TILESIZE+(0.5-nbgoods/4)*(TILESIZE/2));
    rect->y = (int)((firstUnit->location->posY-firstVisibleTileY)*TILESIZE+TILESIZE);
    rect->w = nbgoods/2*TILESIZE/2;
    rect->h = TILESIZE;
    SDL_FillRect(screen, rect, SDL_MapRGB( screen->format, 32, 20, 25));

    lnode_t *unitelem = list_first(unitList);
    while (unitelem != &unitList->list_nilnode) {
      unit *unitNoi = (unit *)unitelem->list_data;
      int k;
      for (k=0; k<unitNoi->maxLoad/2; k++) {
        goodid++;
        rect->x = (int)((firstUnit->location->posX-firstVisibleTileX)*TILESIZE+(0.5-nbgoods/4+k)*(TILESIZE/2));
        rect->y = (int)((firstUnit->location->posY-firstVisibleTileY)*TILESIZE+TILESIZE);
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;

        d1gradientboxRGBA(screen, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);
        hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y-1,         192, 192, 192, 255);
        vlineRGBA(screen, rect->x-1,           rect->y,           rect->y+rect->h-1, 64, 64, 64, 255);
        hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y+rect->h,   192, 192, 192, 255);
        vlineRGBA(screen, rect->x-1+rect->w+1, rect->y,           rect->y+rect->h-1, 64, 64, 64, 255);
        if (unitNoi->goods[2*k].quantity>0) {
          SDL_Surface *img = getGoodImage(&unitNoi->goods[2*k]);
          rect->x += TILESIZE/4-img->w/2;
          rect->y += TILESIZE/2-img->h;
          rect->w = TILESIZE/2;
          rect->h = TILESIZE/2;
          SDL_BlitSurface(img, 0, screen, rect);
          if (unitNoi->goods[k].type>=FIRST_GOOD && unitNoi->goods[2*k].type<=LAST_GOOD) {
            rect->x = (int)((firstUnit->location->posX-firstVisibleTileX)*TILESIZE+(0.5-nbgoods/4+k)*(TILESIZE/2));
            rect->y = (int)((firstUnit->location->posY-firstVisibleTileY)*TILESIZE+TILESIZE);
            TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
            char *text = (char*)malloc(4*sizeof(char));
            sprintf(text, "%i", unitNoi->goods[2*k].quantity);
            SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
            rect->x+=3;
            SDL_BlitSurface(imgText, 0, screen, rect);
            SDL_FreeSurface(imgText);
            imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
            rect->x--;
            rect->y--;
            SDL_BlitSurface(imgText, 0, screen, rect);
            rect->x-=2;
            rect->y++;
            ;
            SDL_FreeSurface(imgText);
            free(text);
            TTF_SetFontStyle(fonts[10], TTF_STYLE_NORMAL);
          }
        }
        rect->y += TILESIZE/2;
        rect->w = TILESIZE/2;
        rect->h = TILESIZE/2;
        d1gradientboxRGBA(screen, rect->x, rect->y, rect->w, rect->h, 32, 20, 25, 255, 82, 70, 75, 255);
        hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y-1,         192, 192, 192, 255);
        vlineRGBA(screen, rect->x-1,           rect->y,           rect->y+rect->h-1, 64, 64, 64, 255);
        hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y+rect->h,   192, 192, 192, 255);
        vlineRGBA(screen, rect->x-1+rect->w+1, rect->y,           rect->y+rect->h-1, 64, 64, 64, 255);
        if (unitNoi->goods[2*k+1].quantity>0) {
          SDL_Surface *img = getGoodImage(&unitNoi->goods[2*k+1]);
          //rect->x += TILESIZE/4-img->w/2;
          rect->y += TILESIZE/2-img->h;
          SDL_BlitSurface(img, 0, screen, rect);
          if (unitNoi->goods[k].type>=FIRST_GOOD && unitNoi->goods[2*k+1].type<=LAST_GOOD) {
            rect->x = (int)((firstUnit->location->posX-firstVisibleTileX)*TILESIZE+(0.5-nbgoods/4+k)*(TILESIZE/2));
            rect->y = (int)((firstUnit->location->posY-firstVisibleTileY)*TILESIZE+TILESIZE+TILESIZE/2);
            TTF_SetFontStyle(fonts[10], TTF_STYLE_BOLD);
            char *text = (char*)malloc(4*sizeof(char));
            sprintf(text, "%i", unitNoi->goods[2*k+1].quantity);
            SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
            rect->x+=3;
            SDL_BlitSurface(imgText, 0, screen, rect);
            SDL_FreeSurface(imgText);
            imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
            rect->x--;
            rect->y--;
            SDL_BlitSurface(imgText, 0, screen, rect);
            rect->x-=2;
            rect->y++;
            ;
            SDL_FreeSurface(imgText);
            free(text);
            TTF_SetFontStyle(fonts[10], TTF_STYLE_NORMAL);
          }
        }
      }
      unitelem = unitelem->list_next;
    }
  }*/

  rect->x = (firstUnit->location->posX-firstVisibleTileX)*TILESIZE;
  rect->y = (firstUnit->location->posY-firstVisibleTileY)*TILESIZE;
  rect->x = rect->x+TILESIZE-15;
  rect->y = rect->y+3;
  rect->w = 13;
  rect->h = 13;

  SDL_FillRect(screen, rect, SDL_MapRGB( screen->format, col->r, col->g, col->b ));
  hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y-1,         0, 0, 0, 255);
  vlineRGBA(screen, rect->x-1,           rect->y,           rect->y+rect->h-1, 0, 0, 0, 255);
  hlineRGBA(screen, rect->x,             rect->x+rect->w-1, rect->y+rect->h,   0, 0, 0, 255);
  vlineRGBA(screen, rect->x-1+rect->w+1, rect->y,           rect->y+rect->h-1, 0, 0, 0, 255);
  rect->x+=2;
  rect->y-=2;

  SDL_Surface *imgText = NULL;
  switch(commonStatus) {
  case WAITING     :
    imgText  = TTF_RenderText_Blended(fonts[10], "W", BLACK);
    break;
  case PLOWING     :
    imgText  = TTF_RenderText_Blended(fonts[10], "P", BLACK);
    break;
  case ROADING     :
    imgText  = TTF_RenderText_Blended(fonts[10], "R", BLACK);
    break;
  case DIGGING     :
    imgText  = TTF_RenderText_Blended(fonts[10], "D", BLACK);
    break;
  case GOINGTO     :
    imgText  = TTF_RenderText_Blended(fonts[10], "G", BLACK);
    break;
  case FORTIFYING  :
    imgText  = TTF_RenderText_Blended(fonts[10], "F", BLACK);
    break;
  case SENTRY      :
    imgText  = TTF_RenderText_Blended(fonts[10], "S", BLACK);
    break;
  case MIXEDSTATUS :
  default          :
    imgText  = TTF_RenderText_Blended(fonts[10], "?", BLACK);
    break;
  }
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);

  // to avoid poluting the map space, we only display status bars on demands
  if ((firstUnit->owner==currentPlayer || gamemode!=PLAY) && displayedItinerary==NULL && isDrag==UNIT && ((i2>0)||(unitList==unitSelectionList))){
    rect->x = (firstUnit->location->posX-firstVisibleTileX)*TILESIZE;
    rect->y = (firstUnit->location->posY-firstVisibleTileY)*TILESIZE;

    if (firstUnit->location->posX>firstVisibleTileX) {
      hgradientboxRGBA(screen, rect->x-10, rect->y+TILESIZE-minMaxHealth/2,   5, minMaxHealth/2, 0, 0, 0, 255, 64, 64, 64, 255);
      hgradientboxRGBA(screen, rect->x-5,  rect->y+TILESIZE-minMaxHealth/2,   5, minMaxHealth/2, 64, 64, 64, 255, 0, 0, 0, 255);
      hgradientboxRGBA(screen, rect->x-10, rect->y+TILESIZE-minHealth/2,   5, minHealth/2, 255, 128, 128, 255, 255, 0, 0, 255);
      hgradientboxRGBA(screen, rect->x-5,  rect->y+TILESIZE-minHealth/2,   5, minHealth/2, 255, 0, 0, 255, 128, 0, 0, 255);
    }
    if (firstUnit->location->posX<=firstVisibleTileX+screen->w/TILESIZE-1) {
      hgradientboxRGBA(screen, rect->x+TILESIZE,   rect->y+TILESIZE-minMaxMovement/2, 5, minMaxMovement/2, 0, 0, 0, 255, 64, 64, 64, 255);
      hgradientboxRGBA(screen, rect->x+TILESIZE+5, rect->y+TILESIZE-minMaxMovement/2, 5, minMaxMovement/2, 64, 64, 64, 255, 0, 0, 0, 255);
      hgradientboxRGBA(screen, rect->x+TILESIZE,   rect->y+TILESIZE-minMovement/2, 5,    minMovement/2, 128, 255, 128, 255, 0, 255, 0, 255);
      hgradientboxRGBA(screen, rect->x+TILESIZE+5, rect->y+TILESIZE-minMovement/2, 5,    minMovement/2, 0, 255, 0, 255, 0, 128, 0, 255);
    }
    int k;
    for (k=0; k<minExperience; k++) {
      boxRGBA(screen, rect->x+TILESIZE-8, rect->y+TILESIZE-3-k*9,    rect->x+TILESIZE-2, rect->y+TILESIZE-3-k*9-6, 0, 0, 200, 255);
      filledCircleRGBA(screen , rect->x+TILESIZE-5, rect->y+TILESIZE-6-k*9, 2, 255, 255, 0, 255);
    }
  }
  free(text);
  free(rect);
}// displayUnitList() --------------------------------------------------------------------


/**
 * display the itinerary assignated to an unit
*/
void displayPath(unit *u, list_t *itinerary) {
  //printf("displayPath %p => %i*%i\n", pathHorseImage, pathHorseImage->w, pathHorseImage->h);

  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  list_t *itinerary0 = itinerary;
  if (itinerary0==NULL)
    itinerary0 = u->itinerary;
  tile *t= u->location;
  // display path of the last unit
  if (itinerary0 != NULL) {
    list_t *tileList = itinerary0;

    displaySnake(u->location, tileList, u);
    SDL_Surface *img = pathFootImage;
    SDL_Surface *altImg = pathFootNTImage;
    if (isNaval(u)) {
      img = pathNavalImage;
      altImg = pathNavalNTImage;
    } else if (u->type ==WAGON) {
      img = pathWagonImage;
      altImg = pathWagonNTImage;
    } else if (u->horses>0) {
      img = pathHorseImage;
      altImg = pathHorseNTImage;
    }
    lnode_t *tileelem = list_first(tileList);
    int sumDiff = 0;
    while (tileelem != &tileList->list_nilnode) {
      tile *t2 = (tile *)tileelem->list_data;
      rect->w = TILESIZE;
      rect->h = TILESIZE;
      rect->x = (int)(((1.0+t->posX+t2->posX)/2-firstVisibleTileX)*TILESIZE-img->w/2);
      rect->y = (int)(((1.0+t->posY+t2->posY)/2-firstVisibleTileY)*TILESIZE-img->h/2);

      int diff = computeDifficulty(t, t2, u);
      if (diff==1000 && itinerary==NULL && u->itinerary!=NULL) {
        list_destroy_nodes(u->itinerary);
        list_destroy(u->itinerary);
        u->itinerary = NULL;
        return;
      }
      sumDiff += diff;

      if (sumDiff>u->movement)
        SDL_BlitSurface(altImg, 0, screen, rect);
      else
        SDL_BlitSurface(img, 0, screen, rect);

      char *text = (char *)malloc(8);
      sprintf(text, "%i", diff);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, WHITE);
      rect->x = (int)(((1.0+t->posX+t2->posX)/2-firstVisibleTileX)*TILESIZE-imgText->w/2);
      rect->y = (int)(((1.0+t->posY+t2->posY)/2-firstVisibleTileY)*TILESIZE-imgText->h/2);
      SDL_BlitSurface(imgText, 0, screen, rect);
      rect->x-=2;
      rect->y-=2;
      SDL_BlitSurface(imgText, 0, screen, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x++;
      rect->y++;
      SDL_BlitSurface(imgText, 0, screen, rect);

      free(text);
      SDL_FreeSurface(imgText);

      t = t2;
      tileelem = tileelem->list_next;
    }
  }

  free(rect);
}// displayPath() --------------------------------------------------------------------


/**
 * display the itinerary assignated to an unit
*/
void displaySnake(tile *t, list_t *tileList, unit* u) {
  //printf("\ndisplaySnake(%p, %p)\n", t, tileList);
  Sint16* vx = (Sint16*)malloc(3*sizeof(Sint16));
  Sint16* vy = (Sint16*)malloc(3*sizeof(Sint16));
  tile *t1 = t;
  if (list_count(tileList)==0)
    return;
  lnode_t *tileelem = list_first(tileList);
  tile *t2 = (tile *)tileelem->list_data;
  float addRoute, addRoute1, addRoute2;
  int nbSteps;

  // 1rst segment is special (shorter)
  vx[0] = (int)((t1->posX+0.5-firstVisibleTileX)*TILESIZE);
  vy[0] = (int)((t1->posY+0.5-firstVisibleTileY)*TILESIZE);
  vx[2] = (int)(((1.0+t1->posX+t2->posX)/2-firstVisibleTileX)*TILESIZE);
  vy[2] = (int)(((1.0+t1->posY+t2->posY)/2-firstVisibleTileY)*TILESIZE);
  vx[1] = (vx[0]+vx[2])/2;
  vy[1] = (vy[0]+vy[2])/2;
  int diff = computeDifficulty(t1, t2, u);
  if (diff==1000)
    return;
  if (t1->posX-t2->posX==0 || t1->posY-t2->posY==0) {
    addRoute = diff/10.0f;
    nbSteps = 5;
  } else {
    addRoute = diff/14.0f;
    nbSteps = 7;
  }
  bezier2RGBA(screen, vx, vy, addRoute, addRoute, 3, nbSteps, 128, 0, 0, 255, 0, 128, 0, 255, 1.0, 2);

  int prevdiff = diff;
  tileelem = tileelem->list_next;
  while (tileelem != &tileList->list_nilnode) {
    t1 = t2;
    prevdiff = diff;
    t2 = (tile *)tileelem->list_data;

    vx[0] = vx[2];
    vy[0] = vy[2];
    vx[1] = (int)((t1->posX+0.5-firstVisibleTileX)*TILESIZE);
    vy[1] = (int)((t1->posY+0.5-firstVisibleTileY)*TILESIZE);
    vx[2] = (int)(((1.0+t1->posX+t2->posX)/2-firstVisibleTileX)*TILESIZE);
    vy[2] = (int)(((1.0+t1->posY+t2->posY)/2-firstVisibleTileY)*TILESIZE);

    diff = computeDifficulty(t1, t2, u);
    if (diff==1000)
      return;

    if (t1->posX-t2->posX==0 || t1->posY-t2->posY==0) {
      addRoute1 = prevdiff/10.0f;
      addRoute2 = diff/10.0f;
      nbSteps = 10;
    } else {
      addRoute1 = prevdiff/14.0f;
      addRoute2 = diff/14.0f;
      nbSteps = 14;
    }

    bezier2RGBA(screen, vx, vy, addRoute1, addRoute2, 3, nbSteps, 128, 0, 0, 255, 0, 128, 0, 255, 1.0, 2);
    tileelem = tileelem->list_next;
  }
  // last segment is special (shorter)
  if (t1->posX-t2->posX==0 || t1->posY-t2->posY==0) {
    addRoute = diff/10.0f;
    nbSteps = 5;
  } else {
    addRoute = diff/14.0f;
    nbSteps = 7;
  }
  vx[0] = vx[2];
  vy[0] = vy[2];
  vx[2] = (int)((t2->posX+0.5-firstVisibleTileX)*TILESIZE);
  vy[2] = (int)((t2->posY+0.5-firstVisibleTileY)*TILESIZE);
  vx[1] = (vx[0]+vx[2])/2;
  vy[1] = (vy[0]+vy[2])/2;
  bezier2RGBA(screen, vx, vy, addRoute, addRoute, 3, nbSteps, 128, 0, 0, 255, 0, 128, 0, 255, 1.0, 2);

  free(vx);
  free(vy);
}// displaySnake() --------------------------------------------------------------------


/**
 * display a* algo for debug purpose !
 */
void displayAStar() {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  // for debug purpose, display the result of a* algorithm
  if (openList!=NULL && list_count(openList)>0) {
    lnode_t *etileelem = list_first(openList);
    while (etileelem!=NULL && etileelem != &openList->list_nilnode) {
      etile *et = (etile *)etileelem->list_data;
      tile  *t  = et->location;
      etileelem = etileelem->list_next;
      if (t->posX<firstVisibleTileX || t->posX>firstVisibleTileX+screen->w/TILESIZE ||
          t->posY<firstVisibleTileY || t->posY>firstVisibleTileY+screen->h/TILESIZE)
        continue;
      rect->w = TILESIZE;
      rect->h = TILESIZE;
      rect->x = (t->posX-firstVisibleTileX)*TILESIZE;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE;
      roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 0, 192, 0, 64);

      char *text = (char *)malloc(64*sizeof(char));
      sprintf(text, "%i", et->f);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (t->posX-firstVisibleTileX)*TILESIZE+5;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE+5;
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);

      text = (char *)malloc(64*sizeof(char));
      sprintf(text, "%i", et->g);
      imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (t->posX-firstVisibleTileX+1)*TILESIZE-25;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE+5;
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);

      text = (char *)malloc(64*sizeof(char));
      sprintf(text, "%i", et->h);
      imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (int)((t->posX-firstVisibleTileX+0.5)*TILESIZE-12);
      rect->y = (int)((t->posY-firstVisibleTileY+0.7)*TILESIZE+5);
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);
    }
  }
  if (closedList !=NULL && list_count(closedList)>0) {
    lnode_t *etileelem = list_first(closedList);
    while (etileelem!= NULL && etileelem != &closedList->list_nilnode) {
      etile *et = (etile *)etileelem->list_data;
      tile  *t  = et->location;
      etileelem = etileelem->list_next;
      if (t->posX<firstVisibleTileX || t->posX>firstVisibleTileX+screen->w/TILESIZE ||
          t->posY<firstVisibleTileY || t->posY>firstVisibleTileY+screen->h/TILESIZE)
        continue;
      rect->w = TILESIZE;
      rect->h = TILESIZE;
      rect->x = (t->posX-firstVisibleTileX)*TILESIZE;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE;
      roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 192, 0, 192, 64);

      char *text = (char *)malloc(94*sizeof(char));
      sprintf(text, "%i", et->f);
      SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (t->posX-firstVisibleTileX)*TILESIZE+5;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE+5;
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);

      text = (char *)malloc(64*sizeof(char));
      sprintf(text, "%i", et->g);
      imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (t->posX-firstVisibleTileX+1)*TILESIZE-25;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE+5;
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);

      text = (char *)malloc(64*sizeof(char));
      sprintf(text, "%i", et->h);
      imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
      rect->x = (int)((t->posX-firstVisibleTileX+0.5)*TILESIZE-12);
      rect->y = (int)((t->posY-firstVisibleTileY+0.6)*TILESIZE+5);
      SDL_BlitSurface(imgText, 0, screen, rect);
      free(text);
      SDL_FreeSurface(imgText);
    }
  }

  if (foundPath !=NULL && list_count(foundPath)>0) {
    lnode_t *etileelem = list_first(foundPath);
    while (etileelem!= NULL && etileelem != &foundPath->list_nilnode) {
      tile  *t  = (tile *)etileelem->list_data;
      etileelem = etileelem->list_next;      
      if (t->posX<firstVisibleTileX || t->posX>firstVisibleTileX+screen->w/TILESIZE ||
          t->posY<firstVisibleTileY || t->posY>firstVisibleTileY+screen->h/TILESIZE)
        continue;
      rect->w = TILESIZE;
      rect->h = TILESIZE;
      rect->x = (t->posX-firstVisibleTileX)*TILESIZE;
      rect->y = (t->posY-firstVisibleTileY)*TILESIZE;
      roundedBoxRGBA(screen, rect->x, rect->y, TILESIZE, TILESIZE, 192, 192, 192, 64);
    }
  }

  free(rect);
}// displayAStar() --------------------------------------------------------------------


/**
 * display the map (the big one !)
 */
void displayMap() {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  int k, l;
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      rect->w = TILESIZE;
      rect->h = TILESIZE;
      rect->x = (i-firstVisibleTileX)*TILESIZE;
      rect->y = (j-firstVisibleTileY)*TILESIZE;

      if ((map[i+MapWidth*(j)].lastExplored>=0 || gamemode != PLAY) && (popupType&POPUP_ISVISIBLE && !(popupType&POPUP_ISMENU)))
        SDL_BlitSurfacePastel(tilecache[(j-firstVisibleTileY)*screen->w/TILESIZE+(i-firstVisibleTileX)], 0, screen, rect, 128);
      else if (map[i+MapWidth*(j)].lastExplored>=0 || gamemode != PLAY)
        SDL_BlitSurface(tilecache[(j-firstVisibleTileY)*screen->w/TILESIZE+(i-firstVisibleTileX)], 0, screen, rect);
      else
        SDL_FillRect(screen, rect, SDL_MapRGB(screen->format, 0, 0, 0));

      if (gamemode==DEBUG && (editmode==E_RIVER || editmode==E_GROUND)) {
        char* text = (char *)malloc(64*sizeof(char));
        sprintf(text, "%i", map[i+MapWidth*(j)].irrigation);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += TILESIZE/2;
        rect->y += TILESIZE/2;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);
        int seeds[3][3] = {map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed ,
                           map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed};
        int seeds_i[3][3];

        if (i>0           && j>0) {
          seeds[0][0]  = map[i-1+MapWidth*(j-1)].seed;
        }
        if (i>0) {
          seeds[0][1]  = map[i-1+MapWidth*(j)].seed;
        }
        if (i>0           && j<MapHeight-1) {
          seeds[0][2]  = map[i-1+MapWidth*(j+1)].seed;
        }
        if (                 j<MapHeight-1) {
          seeds[1][2]  = map[i+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1 && j<MapHeight-1) {
          seeds[2][2]  = map[i+1+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1) {
          seeds[2][1]  = map[i+1+MapWidth*(j)].seed;
        }
        if (i<MapWidth-1 && j>0) {
          seeds[2][0]  = map[i+1+MapWidth*(j-1)].seed;
        }
        if (                 j>0) {
          seeds[1][0]  = map[i+MapWidth*(j-1)].seed;
        }

        if (i==0 && j>0 && j<MapHeight-1)           {
          seeds[0][0]  = map[0+MapWidth*(j-1)].seed;
          seeds[0][2]  = map[0+MapWidth*(j+1)].seed;
        }
        if (j==0 && i>0 &&i<MapWidth-1)             {
          seeds[0][0]  = map[i-1+MapWidth*(0)].seed;
          seeds[2][0]  = map[i+1+MapWidth*(0)].seed;
        }
        if (i==MapWidth-1 && j>0 && j<MapHeight-1) {
          seeds[2][0]  = map[MapWidth-1+MapWidth*(j-1)].seed;
          seeds[2][2]  = map[MapWidth-1+MapWidth*(j+1)].seed;
        }
        if (j==MapHeight-1 && i>0 &&i<MapWidth-1)  {
          seeds[0][2]  = map[i-1+MapWidth*(MapHeight-1)].seed;
          seeds[2][2]  = map[i+1+MapWidth*(MapHeight-1)].seed;
        }
        int myseed = map[i+MapWidth*(j)].seed;
        seeds_i[0][0] = ((myseed&0xF0000000)>>28);
        seeds_i[1][0] = ((myseed&0x0F000000)>>24);
        seeds_i[2][0] = ((myseed&0x00F00000)>>20);
        seeds_i[2][1] = ((myseed&0x000F0000)>>16);
        seeds_i[0][1] = ((myseed&0x0000F000)>>12);
        seeds_i[0][2] = ((myseed&0x00000F00)>>8);
        seeds_i[1][2] = ((myseed&0x000000F0)>>4);
        seeds_i[2][2] = ((myseed&0x0000000F)>>0);
        int i2, j2;
        for (i2=0; i2<3; i2++)
          for (j2=0; j2<3; j2++){
            sprintf(text, "%i", (seeds_i[i2][j2]));
            SDL_Color DG = {40, 40, 40};
            imgText = TTF_RenderText_Blended(fonts[8], text, DG);
            rect->x = (int)(5+(i-firstVisibleTileX)*TILESIZE+i2*TILESIZE/2.5);
            rect->y = (int)(2+(j-firstVisibleTileY)*TILESIZE+j2*TILESIZE/2.8);
            if (i2!=1 || j2!=1)
              SDL_BlitSurface(imgText, 0, screen, rect);

            SDL_FreeSurface(imgText);
          }
        free(text);
      } else if (gamemode==DEBUG && editmode==E_FOREST) {
        char* text = (char *)malloc(64*sizeof(char));
        sprintf(text, "%i", map[i+MapWidth*(j)].vegetation);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += TILESIZE/2;
        rect->y += TILESIZE/2;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);

        int neighs[3][3] = {map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation ,
                            map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation};
        int seeds[3][3] = {map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed ,
                           map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed};
        int seeds_i[3][3];
        int seeds_o[5][5];
        for (k=0; k<5; k++)
          for (l=0; l<5; l++)
            seeds_o[k][l] = 0;

        if (i>0           && j>0) {
          neighs[0][0] = map[i-1+MapWidth*(j-1)].elevation;
          seeds[0][0]  = map[i-1+MapWidth*(j-1)].seed;
        }
        if (i>0) {
          neighs[0][1] = map[i-1+MapWidth*(j)].elevation;
          seeds[0][1]  = map[i-1+MapWidth*(j)].seed;
        }
        if (i>0           && j<MapHeight-1) {
          neighs[0][2] = map[i-1+MapWidth*(j+1)].elevation;
          seeds[0][2]  = map[i-1+MapWidth*(j+1)].seed;
        }
        if (                 j<MapHeight-1) {
          neighs[1][2] = map[i+MapWidth*(j+1)].elevation;
          seeds[1][2]  = map[i+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1 && j<MapHeight-1) {
          neighs[2][2] = map[i+1+MapWidth*(j+1)].elevation;
          seeds[2][2]  = map[i+1+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1) {
          neighs[2][1] = map[i+1+MapWidth*(j)].elevation;
          seeds[2][1]  = map[i+1+MapWidth*(j)].seed;
        }
        if (i<MapWidth-1 && j>0) {
          neighs[2][0] = map[i+1+MapWidth*(j-1)].elevation;
          seeds[2][0]  = map[i+1+MapWidth*(j-1)].seed;
        }
        if (                 j>0) {
          neighs[1][0] = map[i+MapWidth*(j-1)].elevation;
          seeds[1][0]  = map[i+MapWidth*(j-1)].seed;
        }

        if (i==0 && j>0 && j<MapHeight-1)           {
          neighs[0][0] = map[0+MapWidth*(j-1)].elevation;
          neighs[0][2] = map[0+MapWidth*(j+1)].elevation;
          seeds[0][0]  = map[0+MapWidth*(j-1)].seed;
          seeds[0][2]  = map[0+MapWidth*(j+1)].seed;
        }
        if (j==0 && i>0 &&i<MapWidth-1)             {
          neighs[0][0] = map[i-1+MapWidth*(0)].elevation;
          neighs[2][0] = map[i+1+MapWidth*(0)].elevation;
          seeds[0][0]  = map[i-1+MapWidth*(0)].seed;
          seeds[2][0]  = map[i+1+MapWidth*(0)].seed;
        }
        if (i==MapWidth-1 && j>0 && j<MapHeight-1) {
          neighs[2][0] = map[MapWidth-1+MapWidth*(j-1)].elevation;
          neighs[2][2] = map[MapWidth-1+MapWidth*(j+1)].elevation;
          seeds[2][0]  = map[MapWidth-1+MapWidth*(j-1)].seed;
          seeds[2][2]  = map[MapWidth-1+MapWidth*(j+1)].seed;
        }
        if (j==MapHeight-1 && i>0 &&i<MapWidth-1)  {
          neighs[0][2] = map[i-1+MapWidth*(MapHeight-1)].elevation;
          neighs[2][2] = map[i+1+MapWidth*(MapHeight-1)].elevation;
          seeds[0][2]  = map[i-1+MapWidth*(MapHeight-1)].seed;
          seeds[2][2]  = map[i+1+MapWidth*(MapHeight-1)].seed;
        }

        int myseed = map[i+MapWidth*(j)].seed;
        seeds_i[0][0] = 2+((myseed&0xF0000000)>>28);
        seeds_i[1][0] = 2+((myseed&0x0F000000)>>24);
        seeds_i[2][0] = 2+((myseed&0x00F00000)>>20);
        seeds_i[2][1] = 2+((myseed&0x000F0000)>>16);
        seeds_i[0][1] = 2+((myseed&0x0000F000)>>12);
        seeds_i[0][2] = 2+((myseed&0x00000F00)>>8);
        seeds_i[1][2] = 2+((myseed&0x000000F0)>>4);
        seeds_i[2][2] = 2+((myseed&0x0000000F)>>0);
        //seeds_i[1][1] = 2+(myseed&0x000000FF)%4;

        seeds_o[0][0] = 2+((seeds[0][0]&0x0000000F)>>0);
        seeds_o[2][0] = 2+((seeds[1][0]&0x000000F0)>>4);
        seeds_o[4][0] = 2+((seeds[2][0]&0x00000F00)>>8);
        seeds_o[4][2] = 2+((seeds[2][1]&0x0000F000)>>12);
        seeds_o[0][2] = 2+((seeds[0][1]&0x000F0000)>>16);
        seeds_o[0][4] = 2+((seeds[0][2]&0x00F00000)>>20);
        seeds_o[2][4] = 2+((seeds[1][2]&0x0F000000)>>24);
        seeds_o[4][4] = 2+((seeds[2][2]&0xF0000000)>>28);
        seeds_o[1][0] = 2+((seeds[1][0]&0x00000F00)>>8);
        seeds_o[3][0] = 2+((seeds[1][0]&0x0000000F)>>0);
        seeds_o[4][1] = 2+((seeds[2][1]&0xF0000000)>>28);
        seeds_o[4][3] = 2+((seeds[2][1]&0x00000F00)>>8);
        seeds_o[1][4] = 2+((seeds[1][2]&0xF0000000)>>28);
        seeds_o[3][4] = 2+((seeds[1][2]&0x00F00000)>>20);
        seeds_o[0][1] = 2+((seeds[0][1]&0x00F00000)>>20);
        seeds_o[0][3] = 2+((seeds[0][1]&0x0000000F)>>0);


        // now compute values at border with the next tile
        int borders[3][3];

        borders[0][0] = 460+(neighs[0][0]*seeds_o[0][0]+neighs[0][1]*seeds_o[0][1]+neighs[1][0]*seeds_o[1][0]+neighs[1][1]*seeds_i[0][0])*768/(seeds_o[0][0]+seeds_o[0][1]+seeds_o[1][0]+seeds_i[0][0]);
        borders[2][2] = 460+(neighs[2][2]*seeds_o[4][4]+neighs[1][2]*seeds_o[3][4]+neighs[2][1]*seeds_o[4][3]+neighs[1][1]*seeds_i[2][2])*768/(seeds_o[4][4]+seeds_o[3][4]+seeds_o[4][3]+seeds_i[2][2]);

        borders[0][2] = 460+(neighs[0][2]*seeds_o[0][4]+neighs[0][1]*seeds_o[0][3]+neighs[1][2]*seeds_o[1][4]+neighs[1][1]*seeds_i[0][2])*768/(seeds_o[0][2]+seeds_o[0][1]+seeds_o[1][2]+seeds_i[0][2]);
        borders[2][0] = 460+(neighs[2][0]*seeds_o[4][0]+neighs[2][1]*seeds_o[4][1]+neighs[1][0]*seeds_o[3][0]+neighs[1][1]*seeds_i[2][0])*768/(seeds_o[2][0]+seeds_o[2][1]+seeds_o[1][0]+seeds_i[2][0]);

        // in this double diagonal conflict, we decided to make an exception: the sea always win. This is the rule of erosion
        if (neighs[0][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[0][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
          borders[0][0] = 460+(neighs[1][1]+neighs[0][0])*768/2;
        if (neighs[2][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][2]>=SEALEVEL)
          borders[2][2] = 460+(neighs[1][1]+neighs[2][2])*768/2;
        if (neighs[2][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
          borders[2][0] = 460+(neighs[1][1]+neighs[2][0])*768/2;
        if (neighs[0][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[1][2]>=SEALEVEL && neighs[0][1]>=SEALEVEL)
          borders[0][2] = 460+(neighs[1][1]+neighs[0][2])*768/2;

        if (neighs[0][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[0][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
          borders[0][0] = 460+(neighs[1][0]+neighs[0][1])*768/2;
        if (neighs[2][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][2]<SEALEVEL)
          borders[2][2] = 460+(neighs[2][1]+neighs[1][2])*768/2;
        if (neighs[2][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
          borders[2][0] = 460+(neighs[1][0]+neighs[2][1])*768/2;
        if (neighs[0][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[1][2]<SEALEVEL && neighs[0][1]<SEALEVEL)
          borders[0][2] = 460+(neighs[1][2]+neighs[0][1])*768/2;

        borders[0][1] = 460+(neighs[0][1]*seeds_o[0][2]+neighs[1][1]*seeds_i[0][1])*768/(seeds_o[0][1]+seeds_i[0][1]);
        borders[1][2] = 460+(neighs[1][2]*seeds_o[2][4]+neighs[1][1]*seeds_i[1][2])*768/(seeds_o[1][2]+seeds_i[1][2]);
        borders[2][1] = 460+(neighs[2][1]*seeds_o[4][2]+neighs[1][1]*seeds_i[2][1])*768/(seeds_o[2][1]+seeds_i[2][1]);
        borders[1][0] = 460+(neighs[1][0]*seeds_o[2][0]+neighs[1][1]*seeds_i[1][0])*768/(seeds_o[1][0]+seeds_i[1][0]);
        int i2, j2;
        for (i2=0; i2<5; i2++)
          for (j2=0; j2<5; j2++) {
            sprintf(text, "%i", seeds_o[i2][j2]);
            imgText = TTF_RenderText_Blended(fonts[8], text, BLACK);
            rect->x = 1+(i-firstVisibleTileX)*TILESIZE+i2*TILESIZE/5;
            rect->y = 2+(j-firstVisibleTileY)*TILESIZE+j2*TILESIZE/5;
            if (i2==0 || i2==4 || j2==0 || j2==4)
              SDL_BlitSurface(imgText, 0, screen, rect);
            SDL_FreeSurface(imgText);
          }

      free(text);
      } else if (gamemode==DEBUG && editmode==E_TRANSPORT) {
        char* text = (char *)malloc(64*sizeof(char));
        sprintf(text, "%i, %i=%i", i, j, map[i+MapWidth*(j)].elevation);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += TILESIZE/2-20;
        rect->y += (TILESIZE-imgText->w)/2;
        SDL_BlitSurface(imgText, 0, screen, rect);

        sprintf(text, "%i", map[i+MapWidth*(j)].road);
        imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += 5;
        rect->y += 20;
        SDL_BlitSurface(imgText, 0, screen, rect);
        free(text);
        SDL_FreeSurface(imgText);
      } else if (gamemode==DEBUG && editmode==E_ALTITUDE) {
        char* text = (char *)malloc(64*sizeof(char));
        sprintf(text, "%i", 460+map[i+MapWidth*(j)].elevation*768);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += TILESIZE/2-imgText->w/2;
        rect->y += TILESIZE/2-imgText->h/2;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);

        int neighs[3][3] = {map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation ,
                            map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation};
        int seeds[3][3] = {map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed ,
                           map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed};
        int seeds_i[3][3];
        int seeds_o[5][5];
        for (k=0; k<5; k++)
          for (l=0; l<5; l++)
            seeds_o[k][l] = 0;

        if (i>0           && j>0) {
          neighs[0][0] = map[i-1+MapWidth*(j-1)].elevation;
          seeds[0][0]  = map[i-1+MapWidth*(j-1)].seed;
        }
        if (i>0) {
          neighs[0][1] = map[i-1+MapWidth*(j)].elevation;
          seeds[0][1]  = map[i-1+MapWidth*(j)].seed;
        }
        if (i>0           && j<MapHeight-1) {
          neighs[0][2] = map[i-1+MapWidth*(j+1)].elevation;
          seeds[0][2]  = map[i-1+MapWidth*(j+1)].seed;
        }
        if (                 j<MapHeight-1) {
          neighs[1][2] = map[i+MapWidth*(j+1)].elevation;
          seeds[1][2]  = map[i+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1 && j<MapHeight-1) {
          neighs[2][2] = map[i+1+MapWidth*(j+1)].elevation;
          seeds[2][2]  = map[i+1+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1) {
          neighs[2][1] = map[i+1+MapWidth*(j)].elevation;
          seeds[2][1]  = map[i+1+MapWidth*(j)].seed;
        }
        if (i<MapWidth-1 && j>0) {
          neighs[2][0] = map[i+1+MapWidth*(j-1)].elevation;
          seeds[2][0]  = map[i+1+MapWidth*(j-1)].seed;
        }
        if (                 j>0) {
          neighs[1][0] = map[i+MapWidth*(j-1)].elevation;
          seeds[1][0]  = map[i+MapWidth*(j-1)].seed;
        }

        if (i==0 && j>0 && j<MapHeight-1)           {
          neighs[0][0] = map[0+MapWidth*(j-1)].elevation;
          neighs[0][2] = map[0+MapWidth*(j+1)].elevation;
          seeds[0][0]  = map[0+MapWidth*(j-1)].seed;
          seeds[0][2]  = map[0+MapWidth*(j+1)].seed;
        }
        if (j==0 && i>0 &&i<MapWidth-1)             {
          neighs[0][0] = map[i-1+MapWidth*(0)].elevation;
          neighs[2][0] = map[i+1+MapWidth*(0)].elevation;
          seeds[0][0]  = map[i-1+MapWidth*(0)].seed;
          seeds[2][0]  = map[i+1+MapWidth*(0)].seed;
        }
        if (i==MapWidth-1 && j>0 && j<MapHeight-1) {
          neighs[2][0] = map[MapWidth-1+MapWidth*(j-1)].elevation;
          neighs[2][2] = map[MapWidth-1+MapWidth*(j+1)].elevation;
          seeds[2][0]  = map[MapWidth-1+MapWidth*(j-1)].seed;
          seeds[2][2]  = map[MapWidth-1+MapWidth*(j+1)].seed;
        }
        if (j==MapHeight-1 && i>0 &&i<MapWidth-1)  {
          neighs[0][2] = map[i-1+MapWidth*(MapHeight-1)].elevation;
          neighs[2][2] = map[i+1+MapWidth*(MapHeight-1)].elevation;
          seeds[0][2]  = map[i-1+MapWidth*(MapHeight-1)].seed;
          seeds[2][2]  = map[i+1+MapWidth*(MapHeight-1)].seed;
        }

        int myseed = map[i+MapWidth*(j)].seed;
        seeds_i[0][0] = 2+((myseed&0xF0000000)>>28);
        seeds_i[1][0] = 2+((myseed&0x0F000000)>>24);
        seeds_i[2][0] = 2+((myseed&0x00F00000)>>20);
        seeds_i[2][1] = 2+((myseed&0x000F0000)>>16);
        seeds_i[0][1] = 2+((myseed&0x0000F000)>>12);
        seeds_i[0][2] = 2+((myseed&0x00000F00)>>8);
        seeds_i[1][2] = 2+((myseed&0x000000F0)>>4);
        seeds_i[2][2] = 2+((myseed&0x0000000F)>>0);
        //seeds_i[1][1] = 2+(myseed&0x000000FF)%4;

        seeds_o[0][0] = 2+((seeds[0][0]&0x0000000F)>>0);
        seeds_o[2][0] = 2+((seeds[1][0]&0x000000F0)>>4);
        seeds_o[4][0] = 2+((seeds[2][0]&0x00000F00)>>8);
        seeds_o[4][2] = 2+((seeds[2][1]&0x0000F000)>>12);
        seeds_o[0][2] = 2+((seeds[0][1]&0x000F0000)>>16);
        seeds_o[0][4] = 2+((seeds[0][2]&0x00F00000)>>20);
        seeds_o[2][4] = 2+((seeds[1][2]&0x0F000000)>>24);
        seeds_o[4][4] = 2+((seeds[2][2]&0xF0000000)>>28);
        seeds_o[1][0] = 2+((seeds[1][0]&0x00000F00)>>8);
        seeds_o[3][0] = 2+((seeds[1][0]&0x0000000F)>>0);
        seeds_o[4][1] = 2+((seeds[2][1]&0xF0000000)>>28);
        seeds_o[4][3] = 2+((seeds[2][1]&0x00000F00)>>8);
        seeds_o[1][4] = 2+((seeds[1][2]&0xF0000000)>>28);
        seeds_o[3][4] = 2+((seeds[1][2]&0x00F00000)>>20);
        seeds_o[0][1] = 2+((seeds[0][1]&0x00F00000)>>20);
        seeds_o[0][3] = 2+((seeds[0][1]&0x0000000F)>>0);

        // now compute values at border with the next tile
        int borders[3][3];

        borders[0][0] = 460+(neighs[0][0]*seeds_o[0][0]+neighs[0][1]*seeds_o[0][1]+neighs[1][0]*seeds_o[1][0]+neighs[1][1]*seeds_i[0][0])*768/(seeds_o[0][0]+seeds_o[0][1]+seeds_o[1][0]+seeds_i[0][0]);
        borders[2][2] = 460+(neighs[2][2]*seeds_o[4][4]+neighs[1][2]*seeds_o[3][4]+neighs[2][1]*seeds_o[4][3]+neighs[1][1]*seeds_i[2][2])*768/(seeds_o[4][4]+seeds_o[3][4]+seeds_o[4][3]+seeds_i[2][2]);
        borders[0][2] = 460+(neighs[0][2]*seeds_o[0][4]+neighs[0][1]*seeds_o[0][3]+neighs[1][2]*seeds_o[1][4]+neighs[1][1]*seeds_i[0][2])*768/(seeds_o[0][2]+seeds_o[0][1]+seeds_o[1][2]+seeds_i[0][2]);
        borders[2][0] = 460+(neighs[2][0]*seeds_o[4][0]+neighs[2][1]*seeds_o[4][1]+neighs[1][0]*seeds_o[3][0]+neighs[1][1]*seeds_i[2][0])*768/(seeds_o[2][0]+seeds_o[2][1]+seeds_o[1][0]+seeds_i[2][0]);

        // in this double diagonal conflict, we decided to make an exception: the sea always win. This is the rule of erosion
        if (neighs[0][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[0][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
          borders[0][0] = 460+(neighs[1][1]+neighs[0][0])*768/2;
        if (neighs[2][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][2]>=SEALEVEL)
          borders[2][2] = 460+(neighs[1][1]+neighs[2][2])*768/2;
        if (neighs[2][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
          borders[2][0] = 460+(neighs[1][1]+neighs[2][0])*768/2;
        if (neighs[0][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[1][2]>=SEALEVEL && neighs[0][1]>=SEALEVEL)
          borders[0][2] = 460+(neighs[1][1]+neighs[0][2])*768/2;

        if (neighs[0][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[0][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
          borders[0][0] = 460+(neighs[1][0]+neighs[0][1])*768/2;
        if (neighs[2][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][2]<SEALEVEL)
          borders[2][2] = 460+(neighs[2][1]+neighs[1][2])*768/2;
        if (neighs[2][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
          borders[2][0] = 460+(neighs[1][0]+neighs[2][1])*768/2;
        if (neighs[0][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[1][2]<SEALEVEL && neighs[0][1]<SEALEVEL)
          borders[0][2] = 460+(neighs[1][2]+neighs[0][1])*768/2;

        borders[0][1] = 460+(neighs[0][1]*seeds_o[0][2]+neighs[1][1]*seeds_i[0][1])*768/(seeds_o[0][1]+seeds_i[0][1]);
        borders[1][2] = 460+(neighs[1][2]*seeds_o[2][4]+neighs[1][1]*seeds_i[1][2])*768/(seeds_o[1][2]+seeds_i[1][2]);
        borders[2][1] = 460+(neighs[2][1]*seeds_o[4][2]+neighs[1][1]*seeds_i[2][1])*768/(seeds_o[2][1]+seeds_i[2][1]);
        borders[1][0] = 460+(neighs[1][0]*seeds_o[2][0]+neighs[1][1]*seeds_i[1][0])*768/(seeds_o[1][0]+seeds_i[1][0]);
        int i2, j2;
        for (i2=0; i2<3; i2++)
          for (j2=0; j2<3; j2++) {
            if (i2!=1 || j2!=1) {
              sprintf(text, "%i", borders[i2][j2]);
              imgText = TTF_RenderText_Blended(fonts[8], text, BLACK);
              rect->x = (int)(1+(i-firstVisibleTileX)*TILESIZE+i2*TILESIZE/2.8);
              rect->y = (int)(2+(j-firstVisibleTileY)*TILESIZE+j2*TILESIZE/3);
              SDL_BlitSurface(imgText, 0, screen, rect);
              SDL_FreeSurface(imgText);
            }
          }

        free(text);
      } else if (gamemode==DEBUG && editmode==E_INFLUENCE) {
        char* text = (char *)malloc(64*sizeof(char));
        //printf("DEBUG MODE OK\n");
        for (int nation=0;nation<NATION_NUMBER;nation++) {
          //printf("nation %i has %i influence in there !\n",nation,map[i+MapWidth*(j)].influences[nation]);
          sprintf(text, "%i ", map[i+MapWidth*(j)].influences[nation]);
        }
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += TILESIZE/2;
        rect->y += TILESIZE/2;
        SDL_BlitSurface(imgText, 0, screen, rect);\
        SDL_FreeSurface(imgText);
        int seeds[3][3] = {map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed ,
                           map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed};

        if (i>0           && j>0) {
          seeds[0][0]  = map[i-1+MapWidth*(j-1)].seed;
        }
        if (i>0) {
          seeds[0][1]  = map[i-1+MapWidth*(j)].seed;
        }
        if (i>0           && j<MapHeight-1) {
          seeds[0][2]  = map[i-1+MapWidth*(j+1)].seed;
        }
        if (                 j<MapHeight-1) {
          seeds[1][2]  = map[i+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1 && j<MapHeight-1) {
          seeds[2][2]  = map[i+1+MapWidth*(j+1)].seed;
        }
        if (i<MapWidth-1) {
          seeds[2][1]  = map[i+1+MapWidth*(j)].seed;
        }
        if (i<MapWidth-1 && j>0) {
          seeds[2][0]  = map[i+1+MapWidth*(j-1)].seed;
        }
        if (                 j>0) {
          seeds[1][0]  = map[i+MapWidth*(j-1)].seed;
        }

        if (i==0 && j>0 && j<MapHeight-1)           {
          seeds[0][0]  = map[0+MapWidth*(j-1)].seed;
          seeds[0][2]  = map[0+MapWidth*(j+1)].seed;
        }
        if (j==0 && i>0 &&i<MapWidth-1)             {
          seeds[0][0]  = map[i-1+MapWidth*(0)].seed;
          seeds[2][0]  = map[i+1+MapWidth*(0)].seed;
        }
        if (i==MapWidth-1 && j>0 && j<MapHeight-1) {
          seeds[2][0]  = map[MapWidth-1+MapWidth*(j-1)].seed;
          seeds[2][2]  = map[MapWidth-1+MapWidth*(j+1)].seed;
        }
        if (j==MapHeight-1 && i>0 &&i<MapWidth-1)  {
          seeds[0][2]  = map[i-1+MapWidth*(MapHeight-1)].seed;
          seeds[2][2]  = map[i+1+MapWidth*(MapHeight-1)].seed;
        }
        //int myseed = map[i+MapWidth*(j)].seed;
        int i2, j2;
        for (i2=0; i2<3; i2++)
          for (j2=0; j2<3; j2++){
            sprintf(text, "%4x", (seeds[i2][j2]&0xFFFF0000)>>16);
            imgText = TTF_RenderText_Blended(fonts[8], text, GREY);
            rect->x = (int)(1+(i-firstVisibleTileX)*TILESIZE+i2*TILESIZE/2.8);
            rect->y = (int)(2+(j-firstVisibleTileY)*TILESIZE+j2*TILESIZE/3);
            if (i2!=1 || j2!=1)
              SDL_BlitSurface(imgText, 0, screen, rect);
            SDL_FreeSurface(imgText);
            sprintf(text, "%4x", seeds[i2][j2]&0x0000FFFF);
            imgText = TTF_RenderText_Blended(fonts[8], text, GREY);
            rect->x = (int)(1+(i-firstVisibleTileX)*TILESIZE+i2*TILESIZE/2.8);
            rect->y = (int)(11+(j-firstVisibleTileY)*TILESIZE+j2*TILESIZE/3);
            if (i2!=1 || j2!=1)
              SDL_BlitSurface(imgText, 0, screen, rect);
            SDL_FreeSurface(imgText);
          }


        free(text);
      } else if (gamemode==DEBUG && editmode==E_BONUS) {
        char* text = (char *)malloc(64*sizeof(char));

        sprintf(text, "%u       %u", (map[i+MapWidth*(j)].seed&0xff000000)>>24, (map[i+MapWidth*(j)].seed&0x00ff0000)>>16);
        SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += 5;
        rect->y += TILESIZE/2-24;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);

        sprintf(text, "%u       %u", (map[i+MapWidth*(j)].seed&0x0000ff00)>>8 , (map[i+MapWidth*(j)].seed&0x000000ff));
        imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->y +=30;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);

        sprintf(text, "%u", map[i+MapWidth*(j)].seed&0x0000ff00);
        imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
        rect->x += 1+(i-firstVisibleTileX)*TILESIZE-imgText->w/2;
        rect->y += 1+(j-firstVisibleTileY)*TILESIZE-imgText->h/2;
        SDL_BlitSurface(imgText, 0, screen, rect);

        free(text);
        SDL_FreeSurface(imgText);
      }
      i++;
    }
    j++;
  }
  free(rect);
}// displayMap() --------------------------------------------------------------------


/**
 * display the elevations
 */
void displayGrid() {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  // grid drawing
  int i = 0;
  while(i*TILESIZE<screen->w) {
    int j = 0;
    while(j*TILESIZE<screen->h) {
      rect->w = TILESIZE;
      rect->h = 1;
      rect->x = j*TILESIZE;
      rect->y = i*TILESIZE;
      hlineRGBA(screen, i*TILESIZE, (i+1)*TILESIZE-1, j*TILESIZE, 192, 192, 192, 128);
      hlineRGBA(screen, i*TILESIZE, (i+1)*TILESIZE-1, (j+1)*TILESIZE-1, 64, 64, 64, 128);
      vlineRGBA(screen, i*TILESIZE, j*TILESIZE, (j+1)*TILESIZE-1, 192, 192, 192, 128);
      vlineRGBA(screen, (i+1)*TILESIZE-1, j*TILESIZE, (j+1)*TILESIZE-1, 64, 64, 64, 128);
      j++;
    }
    i++;
  }
  free(rect);
}// displayGrid() --------------------------------------------------------------------


/**
 * display the units on the board
 */
void displayUnits() {
  if (currentPlayerElement==NULL)
    return;
  player  *currentPlayer = (player *)currentPlayerElement->list_data;

  int i = firstVisibleTileX;
  while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
    int j = firstVisibleTileY;
    while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
      if (map[i+MapWidth*(j)].unitList!=NULL && !list_isempty(map[i+MapWidth*(j)].unitList)) {
        tile *t = &map[i+MapWidth*(j)];
        list_t *ul = t->unitList;
        unit *firstUnit = (unit*)list_first(ul)->list_data;
        if (t->lastExplored==0 || firstUnit->owner==currentPlayer || gamemode != PLAY) {
          displayUnitList(map[i+MapWidth*(j)].unitList, FALSE) ;
        }
      }
      j++;
    }
    i++;
  }
}// displayUnits() --------------------------------------------------------------------


/**
 * display how to use shortcuts to edit the map by priting some options at top right of the screen
 */
void displayEditOptions() {
  char *text =(char*) malloc(64*sizeof(char));
  SDL_Rect *rect = (SDL_Rect*)malloc(sizeof(SDL_Rect));
  rect->y = 30;
  sprintf(text , "A = Edit Altitude");
  if (editmode==E_ALTITUDE)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  SDL_Surface *imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);

  sprintf(text , "I = Edit Influence");
  if (editmode==E_INFLUENCE)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);

  sprintf(text , "F = Forests");
  if (editmode==E_FOREST)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "T = Transportation");
  if (editmode==E_TRANSPORT)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "U = Units");
  if (editmode==E_UNIT)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "C = Cities");
  if (editmode==E_CITY)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "R = Rivers");
  if (editmode==E_RIVER)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "G = Ground");
  if (editmode==E_GROUND)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "B = Bonus Tiles");
  if (editmode==E_BONUS)
    TTF_SetFontStyle(fonts[12], TTF_STYLE_BOLD);
  else
    TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "--------------");
  TTF_SetFontStyle(fonts[12], TTF_STYLE_NORMAL);
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "Ctrl+drag = Duplicate attibute");
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  sprintf(text , "Alt+wheel = soft elevation");
  imgText = TTF_RenderText_Blended(fonts[12], text, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y += 16;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[12], text, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y--;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  free(text);
  free(rect);
}// displayEditOptions() --------------------------------------------------------------------


/**
 * update a given cached tile
 */
void updatesBackgroundOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  rect->w = TILESIZE;
  rect->h = TILESIZE;
  rect->x = 0;
  rect->y = 0;

  if (map[i+MapWidth*(j)].vegetation>0) {
    boxRGBA(fieldTile, 0, 0, TILESIZE, TILESIZE, 0, 0, 0, 0);
    SDL_FillRect(fieldTile, rect, 0x00000000);
    updatesFieldOnTile(i, j, fieldTile);

    /*printf("------%i------\n", fieldTile->flags);
    printf("\n\n");
    int i, j;
    for (j=0; j<32; j++){
      for (i=0; i<32; i++){
        Uint32 *pixelField = (Uint32 *) fieldTile->pixels + (j) * fieldTile->pitch / 4 + (i);
        printf("%08X ", *pixelField);
      }
      printf("\n");
    }*/
  }

  // let's make a local elevation map to work with
  int neighs[3][3] = {map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation ,
                      map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation, map[i+MapWidth*(j)].elevation};
  int seeds[3][3] = {map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed ,
                     map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed, map[i+MapWidth*(j)].seed};
  int seeds_i[3][3];
  int seeds_o[5][5];

  // tile at the border of the world
  if (i>0           && j>0) {
    neighs[0][0] = map[i-1+MapWidth*(j-1)].elevation;
    seeds[0][0]  = map[i-1+MapWidth*(j-1)].seed;
  }
  if (i>0) {
    neighs[0][1] = map[i-1+MapWidth*(j)].elevation;
    seeds[0][1]  = map[i-1+MapWidth*(j)].seed;
  }
  if (i>0           && j<MapHeight-1) {
    neighs[0][2] = map[i-1+MapWidth*(j+1)].elevation;
    seeds[0][2]  = map[i-1+MapWidth*(j+1)].seed;
  }
  if (                 j<MapHeight-1) {
    neighs[1][2] = map[i+MapWidth*(j+1)].elevation;
    seeds[1][2]  = map[i+MapWidth*(j+1)].seed;
  }
  if (i<MapWidth-1 && j<MapHeight-1) {
    neighs[2][2] = map[i+1+MapWidth*(j+1)].elevation;
    seeds[2][2]  = map[i+1+MapWidth*(j+1)].seed;
  }
  if (i<MapWidth-1) {
    neighs[2][1] = map[i+1+MapWidth*(j)].elevation;
    seeds[2][1]  = map[i+1+MapWidth*(j)].seed;
  }
  if (i<MapWidth-1 && j>0) {
    neighs[2][0] = map[i+1+MapWidth*(j-1)].elevation;
    seeds[2][0]  = map[i+1+MapWidth*(j-1)].seed;
  }
  if (                 j>0) {
    neighs[1][0] = map[i+MapWidth*(j-1)].elevation;
    seeds[1][0]  = map[i+MapWidth*(j-1)].seed;
  }

  if (i==0 && j>0 && j<MapHeight-1)           {
    neighs[0][0] = map[0+MapWidth*(j-1)].elevation;
    neighs[0][2] = map[0+MapWidth*(j+1)].elevation;
    seeds[0][0]  = map[0+MapWidth*(j-1)].seed;
    seeds[0][2]  = map[0+MapWidth*(j+1)].seed;
  }
  if (j==0 && i>0 &&i<MapWidth-1)             {
    neighs[0][0] = map[i-1+MapWidth*(0)].elevation;
    neighs[2][0] = map[i+1+MapWidth*(0)].elevation;
    seeds[0][0]  = map[i-1+MapWidth*(0)].seed;
    seeds[2][0]  = map[i+1+MapWidth*(0)].seed;
  }
  if (i==MapWidth-1 && j>0 && j<MapHeight-1) {
    neighs[2][0] = map[MapWidth-1+MapWidth*(j-1)].elevation;
    neighs[2][2] = map[MapWidth-1+MapWidth*(j+1)].elevation;
    seeds[2][0]  = map[MapWidth-1+MapWidth*(j-1)].seed;
    seeds[2][2]  = map[MapWidth-1+MapWidth*(j+1)].seed;
  }
  if (j==MapHeight-1 && i>0 &&i<MapWidth-1)  {
    neighs[0][2] = map[i-1+MapWidth*(MapHeight-1)].elevation;
    neighs[2][2] = map[i+1+MapWidth*(MapHeight-1)].elevation;
    seeds[0][2]  = map[i-1+MapWidth*(MapHeight-1)].seed;
    seeds[2][2]  = map[i+1+MapWidth*(MapHeight-1)].seed;
  }

  // let's compute the weight of my altitude in every direction
  // to be weighted with ...
  int myseed = map[i+MapWidth*(j)].seed;
  seeds_i[0][0] = 2+((myseed&0xF0000000)>>28);
  seeds_i[1][0] = 2+((myseed&0x0F000000)>>24);
  seeds_i[2][0] = 2+((myseed&0x00F00000)>>20);
  seeds_i[2][1] = 2+((myseed&0x000F0000)>>16);
  seeds_i[0][1] = 2+((myseed&0x0000F000)>>12);
  seeds_i[0][2] = 2+((myseed&0x00000F00)>>8);
  seeds_i[1][2] = 2+((myseed&0x000000F0)>>4);
  seeds_i[2][2] = 2+((myseed&0x0000000F)>>0);
  //seeds_i[1][1] = 2+(myseed&0x000000FF)%4;

  // to be weighted with the weight of my neightbours toward my direction ...
  // but sometime the weight of one of my neighbour in the direction of a common other neighbour also matters
  seeds_o[0][0] = 2+((seeds[0][0]&0x0000000F)>>0);
  seeds_o[2][0] = 2+((seeds[1][0]&0x000000F0)>>4);
  seeds_o[4][0] = 2+((seeds[2][0]&0x00000F00)>>8);
  seeds_o[4][2] = 2+((seeds[2][1]&0x0000F000)>>12);
  seeds_o[0][2] = 2+((seeds[0][1]&0x000F0000)>>16);
  seeds_o[0][4] = 2+((seeds[0][2]&0x00F00000)>>20);
  seeds_o[2][4] = 2+((seeds[1][2]&0x0F000000)>>24);
  seeds_o[4][4] = 2+((seeds[2][2]&0xF0000000)>>28);
  seeds_o[1][0] = 2+((seeds[1][0]&0x00000F00)>>8);
  seeds_o[3][0] = 2+((seeds[1][0]&0x0000000F)>>0);
  seeds_o[4][1] = 2+((seeds[2][1]&0xF0000000)>>28);
  seeds_o[4][3] = 2+((seeds[2][1]&0x00000F00)>>8);
  seeds_o[1][4] = 2+((seeds[1][2]&0xF0000000)>>28);
  seeds_o[3][4] = 2+((seeds[1][2]&0x00F00000)>>20);
  seeds_o[0][1] = 2+((seeds[0][1]&0x00F00000)>>20);
  seeds_o[0][3] = 2+((seeds[0][1]&0x0000000F)>>0);

  // now compute values at border with the next tile
  int borders[3][3];

  borders[0][0] = 460+(neighs[0][0]*seeds_o[0][0]+neighs[0][1]*seeds_o[0][1]+neighs[1][0]*seeds_o[1][0]+neighs[1][1]*seeds_i[0][0])*768/(seeds_o[0][0]+seeds_o[0][1]+seeds_o[1][0]+seeds_i[0][0]);
  borders[2][2] = 460+(neighs[2][2]*seeds_o[4][4]+neighs[1][2]*seeds_o[3][4]+neighs[2][1]*seeds_o[4][3]+neighs[1][1]*seeds_i[2][2])*768/(seeds_o[4][4]+seeds_o[3][4]+seeds_o[4][3]+seeds_i[2][2]);

  borders[0][2] = 460+(neighs[0][2]*seeds_o[0][4]+neighs[0][1]*seeds_o[0][3]+neighs[1][2]*seeds_o[1][4]+neighs[1][1]*seeds_i[0][2])*768/(seeds_o[0][4]+seeds_o[0][3]+seeds_o[1][4]+seeds_i[0][2]);
  borders[2][0] = 460+(neighs[2][0]*seeds_o[4][0]+neighs[2][1]*seeds_o[4][1]+neighs[1][0]*seeds_o[3][0]+neighs[1][1]*seeds_i[2][0])*768/(seeds_o[4][0]+seeds_o[4][1]+seeds_o[3][0]+seeds_i[2][0]);

  // in this double diagonal conflict, we decided to make an exception: the sea always win. This is the rule of erosion
  if (neighs[0][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[0][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
    borders[0][0] = 460+(neighs[1][1]+neighs[0][0])*768/2;
  if (neighs[2][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][2]>=SEALEVEL)
    borders[2][2] = 460+(neighs[1][1]+neighs[2][2])*768/2;
  if (neighs[2][0]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[2][1]>=SEALEVEL && neighs[1][0]>=SEALEVEL)
    borders[2][0] = 460+(neighs[1][1]+neighs[2][0])*768/2;
  if (neighs[0][2]<SEALEVEL && neighs[1][1]<SEALEVEL && neighs[1][2]>=SEALEVEL && neighs[0][1]>=SEALEVEL)
    borders[0][2] = 460+(neighs[1][1]+neighs[0][2])*768/2;

  if (neighs[0][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[0][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
    borders[0][0] = 460+(neighs[1][0]+neighs[0][1])*768/2;
  if (neighs[2][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][2]<SEALEVEL)
    borders[2][2] = 460+(neighs[2][1]+neighs[1][2])*768/2;
  if (neighs[2][0]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[2][1]<SEALEVEL && neighs[1][0]<SEALEVEL)
    borders[2][0] = 460+(neighs[1][0]+neighs[2][1])*768/2;
  if (neighs[0][2]>=SEALEVEL && neighs[1][1]>=SEALEVEL && neighs[1][2]<SEALEVEL && neighs[0][1]<SEALEVEL)
    borders[0][2] = 460+(neighs[1][2]+neighs[0][1])*768/2;


  borders[0][1] = 460+(neighs[0][1]*seeds_o[0][2]+neighs[1][1]*seeds_i[0][1])*768/(seeds_o[0][2]+seeds_i[0][1]);
  borders[1][2] = 460+(neighs[1][2]*seeds_o[2][4]+neighs[1][1]*seeds_i[1][2])*768/(seeds_o[2][4]+seeds_i[1][2]);
  borders[2][1] = 460+(neighs[2][1]*seeds_o[4][2]+neighs[1][1]*seeds_i[2][1])*768/(seeds_o[4][2]+seeds_i[2][1]);
  borders[1][0] = 460+(neighs[1][0]*seeds_o[2][0]+neighs[1][1]*seeds_i[1][0])*768/(seeds_o[2][0]+seeds_i[1][0]);

  //borders[0][0] = 460+(neighs[0][0]*(1+seeds[0][0])+neighs[0][1]*(1+seeds[0][1])+neighs[1][0]*(1+seeds[1][0])+neighs[1][1]*(1+seeds[1][1]))*768/(4+seeds[0][0]%2+seeds[0][1]+seeds[1][0]%2+seeds[1][1]%2);
  //borders[2][2] = 460+(neighs[2][2]*(1+seeds[2][2])+neighs[2][1]*(1+seeds[2][1])+neighs[1][2]*(1+seeds[1][2])+neighs[1][1]*(1+seeds[1][1]))*768/(4+seeds[2][2]%2+seeds[2][1]+seeds[1][2]%2+seeds[1][1]%2);
  //borders[2][2] = 460+(neighs[1][1]*(abs(neighs[1][1])+CtW)+neighs[1][2]*(abs(neighs[1][2])+CtW)+neighs[2][1]*(abs(neighs[2][1])+CtW)+neighs[2][2]*(abs(neighs[2][2])+CtW))*768/(abs(neighs[1][1])+abs(neighs[1][2])+abs(neighs[2][1])+abs(neighs[2][2])+4*CtW);
  //borders[0][2] = 460+(neighs[0][1]*(abs(neighs[0][1])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW)+neighs[0][2]*(abs(neighs[0][2])+CtW)+neighs[1][2]*(abs(neighs[1][2])+CtW))*768/(abs(neighs[0][1])+abs(neighs[1][1])+abs(neighs[0][2])+abs(neighs[1][2])+4*CtW);
  //borders[2][0] = 460+(neighs[1][0]*(abs(neighs[1][0])+CtW)+neighs[2][0]*(abs(neighs[2][0])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW)+neighs[2][1]*(abs(neighs[2][1])+CtW))*768/(abs(neighs[1][0])+abs(neighs[2][0])+abs(neighs[1][1])+abs(neighs[2][1])+4*CtW);
  //borders[0][1] = 460+(neighs[0][1]*(abs(neighs[0][1])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW))*768/(abs(neighs[0][1])+abs(neighs[1][1])+2*CtW);
  //borders[1][2] = 460+(neighs[1][2]*(abs(neighs[1][2])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW))*768/(abs(neighs[1][2])+abs(neighs[1][1])+2*CtW);
  //borders[2][1] = 460+(neighs[2][1]*(abs(neighs[2][1])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW))*768/(abs(neighs[2][1])+abs(neighs[1][1])+2*CtW);
  //borders[1][0] = 460+(neighs[1][0]*(abs(neighs[1][0])+CtW)+neighs[1][1]*(abs(neighs[1][1])+CtW))*768/(abs(neighs[1][0])+abs(neighs[1][1])+2*CtW);
  borders[1][1] = 460+map[i+MapWidth*(j)].elevation*768;


  // let's make a local color map to work with
  int tiletypes[3][3] = {map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground ,
                         map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground, map[i+MapWidth*(j)].ground};

  if (i>0           && j>0)
    tiletypes[0][0] = map[i-1+MapWidth*(j-1)].ground;
  if (i>0)
    tiletypes[0][1] = map[i-1+MapWidth*(j)].ground;
  if (i>0           && j<MapHeight-1)
    tiletypes[0][2] = map[i-1+MapWidth*(j+1)].ground;
  if (                 j<MapHeight-1)
    tiletypes[1][2] = map[i+MapWidth*(j+1)].ground;
  if (i<MapWidth-1 && j<MapHeight-1)
    tiletypes[2][2] = map[i+1+MapWidth*(j+1)].ground;
  if (i<MapWidth-1)
    tiletypes[2][1] = map[i+1+MapWidth*(j)].ground;
  if (i<MapWidth-1 && j>0)
    tiletypes[2][0] = map[i+1+MapWidth*(j-1)].ground;
  if (                 j>0)
    tiletypes[1][0] = map[i+MapWidth*(j-1)].ground;

  //printf("call updatesBackgroundOnTile(%d)\n", apptime%12);
  if (map[i+MapWidth*(j)].vegetation>0)
    landscapeTile(tc, rect, borders, tiletypes, map[i+MapWidth*(j)].seed, fieldTile, apptime%12, (j*180.0f/MapHeight)-90.0f);
  else
    landscapeTile(tc, rect, borders, tiletypes, map[i+MapWidth*(j)].seed, NULL, apptime%12, (j*180.0f/MapHeight)-90.0f);
  free(rect);
}// updatesBackgroundOnTile() --------------------------------------------------------------------


/**
* compute for all visible tiles how many turns it will take to reach
 */
void resetMovecache(){
  int i, j;
  for (j=0; j<screen->h/TILESIZE; j++)
    for (i=0; i<screen->w/TILESIZE; i++)
      movecache[j*screen->w/TILESIZE+i] = 0;
}// resetMovecache()


/**
 * compute for all visible tiles how many turns it will take to reach
 */
void updateMovecache(list_t *unitlist){
  if (unitlist==NULL || list_count(unitlist)==0)
    return;
  int w = screen->w/TILESIZE;
  //int h = screen->h/TILESIZE;
  unit *u = (unit *)(list_first(unitlist)->list_data);
  //printf("updateMovecache (%i) %i, %i\n", u->type, firstVisibleTileX, firstVisibleTileY);

  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) { 
      if (map[i+MapWidth*(j)].lastExplored<0 || (isNaval(u) && (map[i+MapWidth*(j)].elevation>=SEALEVEL && !isPortAt(&map[i+MapWidth*(j)]))) 
                                             || (!isNaval(u) && (map[i+MapWidth*(j)].elevation<SEALEVEL && !isFreeBoarding(&map[i+MapWidth*(j)], u)))){
          /*printf("\nmap[i+MapWidth*(j)].lastExplored=%d\n ", map[i+MapWidth*(j)].lastExplored);
          printf("isNaval(u)=%d\n ", isNaval(u));
          printf("map[i+MapWidth*(j)].elevation=%d\n ", map[i+MapWidth*(j)].elevation);
          printf("isPortAt(&map[i+MapWidth*(j)])=%d\n ", isPortAt(&map[i+MapWidth*(j)]));
          printf("isFreeBoarding(&map[i+MapWidth*(j)], u))=%d\n ", isFreeBoarding(&map[i+MapWidth*(j)], u));*/
        movecache[(j-firstVisibleTileY)*(w)+(i-firstVisibleTileX)] = -1;
        i++;
        continue;
      }
      int diff = 0;// = computeDifficulty(u->location, &map[i+MapWidth*(j)], u);
      //if (i==167 && j==61)
      //  printf("[[%i, %i]->[%i, %i]] = ", u->location->posX, u->location->posY, i, j);
      list_t *itinerary = astarSearch(u->location->posX, u->location->posY, i, j, u);

      if (itinerary==NULL) {
        //printf("%3i \n", 999);
        diff = 255;
      } else {
        //if (i==167 && j==61)
        //  printf("{%3i} ", list_count(itinerary));
        lnode_t *ln1 = NULL;
        tile *t1 = &map[u->location->posX+MapWidth*(u->location->posY)];
        lnode_t *ln2 = list_first(itinerary);
        tile *t2 = (tile*)ln2->list_data;
        //printf(" ");
        while (ln2 != &itinerary->list_nilnode) {
          diff+=computeDifficulty(t1, t2, u);
          //if (i==167 && j==61)
          //  printf("(%i,%i->%i,%i)%2i+", t1->posX, t1->posY, t2->posX, t2->posY, computeDifficulty(t1, t2, u));
          ln1 = ln2;
          ln2 = ln1->list_next;
          t1 = (tile*)ln1->list_data;
          t2 = (tile*)ln2->list_data;
        }
        unsigned char diff2;
        if (diff<=u->movement)
          diff2 = 0;
        else if (diff<255)
          diff2 = 1+(diff-u->movement)/u->maxMovement;
        else
          diff2=255;
        //if (i==167 && j==61)
        //  printf("0=%i=%i  (%i / %i)\n", diff, diff2, u->movement, u->maxMovement);

        diff = diff2;
        list_destroy_nodes(itinerary);
        list_destroy(itinerary);
      }
      //printf("%3i ", diff);

      movecache[(j-firstVisibleTileY)*(w)+(i-firstVisibleTileX)] = diff;
      i++;
    }
    //printf("\n");
    j++;
  }
  movecache[(u->location->posY-firstVisibleTileY)*(w)+(u->location->posX-firstVisibleTileX)] = 0;
}//updateMovecache()


/**
 * as it is too slow to display the tile content in real time we pre-compute the visible one in a cache for later displays
 * this function avoid recompute tile between x1,y1 and x2, y2
 */
void updatesBackgroundInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      // excluded from update (already done)
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      } else {
        SDL_Surface *tc = getTileCache(i,j);
        updatesBackgroundOnTile(i, j, tc);
        i++;
      }
    }
    j++;
  }
}// updatesBackgroundInCache() --------------------------------------------------------------------


/**
 * update a cached tile by adding the necessary fog of war effect
 **/
void updatesFogOfWarOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  rect->w = TILESIZE;
  rect->h = TILESIZE;
  rect->x = 0;
  rect->y = 0;
  //printf("updatesFogOfWarOnTile(%i, %i)=>%i\n", i, j, map[i+MapWidth*(j)].lastExplored);
  /*char *text = (char *)malloc(64*sizeof(char));
  sprintf(text, "%i", map[i+MapWidth*(j)].lastExplored);
  SDL_Surface *imgText = TTF_RenderText_Blended(fonts[10], text, BLACK);
  SDL_BlitSurface(imgText, 0, tc, rect);
  free(text);
  SDL_FreeSurface(imgText);*/

  rect->w = TILESIZE;
  rect->h = TILESIZE;

  //SDL_FillRect(tc, 0, 0x88000000);
  if (map[i+MapWidth*(j)].lastExplored>=16)
    map[i+MapWidth*(j)].lastExplored = 15;
  boxRGBA(tc, 0, 0, TILESIZE, TILESIZE, 128, 128, 128, 128+4*map[i+MapWidth*(j)].lastExplored);

  // a minimum big shadow to show user doesn't see unit movements anymore on this tile
  //if (map[i+MapWidth*(j)].lastExplored>0)
  //SDL_SetAlpha(tc, SDL_SRCALPHA, 0);
  //    SDL_BlitSurface(FogOfWarImage3, 0, tc, 0);

  // shadow proportionnal to age of last visit
  /*if (map[i+MapWidth*(j)].lastExplored%2==1|| map[i+MapWidth*(j)].lastExplored>=16)
    SDL_BlitSurface(FogOfWarImage1, 0, tc, 0);

  if ((map[i+MapWidth*(j)].lastExplored/2)%2==1|| map[i+MapWidth*(j)].lastExplored>=16)
    SDL_BlitSurface(FogOfWarImage2, 0, tc, 0);

  if ((map[i+MapWidth*(j)].lastExplored/4)%2==1|| map[i+MapWidth*(j)].lastExplored>=16)
    SDL_BlitSurface(FogOfWarImage3, 0, tc, 0);

  if ((map[i+MapWidth*(j)].lastExplored/8)%2==1 || map[i+MapWidth*(j)].lastExplored>=16)
    SDL_BlitSurface(FogOfWarImage4, 0, tc, 0);*/

  free(rect);
}// updateFogOfWarOnTile() --------------------------------------------------------------------


/**
 * update the fog of war on cached tiles
 */
void updatesFogOfWarInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 &&j>=y1 &&j<=y2) {
        i++;
        continue;
      } else if (map[i+MapWidth*(j)].lastExplored>0) {
        SDL_Surface *tc = getTileCache(i,j);
        updatesFogOfWarOnTile(i, j, tc);
      }
      i++;
    }
    j++;
  }
}// updatesFogOfWarInCache() --------------------------------------------------------------------


/**
 * display a river portion on at a given position in a given img or in or in the norlam cache if tc==nULL
 */
void updatesRiverOnTile(int i, int j, SDL_Surface *tc) {
  btnode_t *ln = map[i+MapWidth*(j)].river_elem;
  //printf("updatesRiverOnTile(%i, %i)=>%p-%p-%p\n", i, j, ln->left, ln, ln->right);

  if (ln->left!=NULL)
    updatesRiverNodesOnTile(ln->tree, ln->father, ln,  ln->left, -1, -1, tc);
  if (ln->right!=NULL)
    updatesRiverNodesOnTile(ln->tree, ln->father, ln, ln->right, -1, -1, tc);
}// updatesRiverOnTile() --------------------------------------------------------------------


/**
 * display all the rivers over the cached tiles recurcively tile by tile
 */
void updatesRiverNodesOnTile(binarytree_t *tree, btnode_t * nodebefore, btnode_t * node,
                            btnode_t * nodeafter, int fx, int fy, SDL_Surface *img) {

  Sint16* vx    = (Sint16*)malloc(3*sizeof(Sint16));
  Sint16* vy    = (Sint16*)malloc(3*sizeof(Sint16));
  //float   sizel = 0;
  //float   sizer = 0;
  int     sum   = 0;
  tile  * t1    = (tile *)node->elem;
  int isSolidBed = TRUE;
  if (t1->elevation<=OCEAN0)
    isSolidBed = FALSE;

  // computing or retrieving size of the river here
  if (nodeafter != NULL) {
    /*if (img==NULL) {
      if (nodeafter->right != NULL) {
        tile *t0 = (tile *)node->elem;
        tile *t1 = (tile *)nodeafter->elem;
        tile *t2 = (tile *)nodeafter->left->elem;
        int dx0 = t0->posX-t1->posX;
        int dy0 = t0->posY-t1->posY;
        int dx2 = t2->posX-t1->posX;
        int dy2 = t2->posY-t1->posY;
        int x1  = TILESIZE/2+TILESIZE*(dx0+dx2)/8;
        int y1  = TILESIZE/2+TILESIZE*(dy0+dy2)/8;
        sizer   = updatesRiverInCache_r(tree, NULL, nodeafter, nodeafter->right, x1, y1, NULL);
      }
      sizel = updatesRiverInCache_r(tree, node, nodeafter, nodeafter->left, -1, -1, NULL);
      sum = (int)(sizel+sizer);

      if (sizel>sizer && sizel>0)
        sum = (int)((2*sizel+sizer)/2);
      else if (sizer>sizel && sizer>0)
        sum = (int)((2*sizer+sizel)/2);

      if (node->metadata!=NULL)
        free(node->metadata);
      node->metadata = malloc(sizeof(int));
      int* riversize = (int*)(node->metadata);
      *riversize = sum;
      //printf("storing(%i, %i)=>%i\n", t1->posX,t1->posY, sum);
    } else {
      sum = *((int*)node->metadata);
    }*/
  }
  int *riversize = (int*)(node->metadata);
  sum = *riversize;

  map[t1->posX+MapWidth*(t1->posY)].river_elem = node;
  SDL_Surface *tc;
  if (img !=NULL)
    tc = img;
  else
    tc = getTileCache(t1->posX,t1->posY);

  if (t1->posY<firstVisibleTileY || t1->posY-firstVisibleTileY>=screen->h/TILESIZE ||
      t1->posX<firstVisibleTileX || t1->posX-firstVisibleTileX>=screen->w/TILESIZE)
    return;

  int rs = 1+(int)sqrt((float)sum);
  if (nodeafter!=NULL && nodebefore==NULL) {
    tile *t2 = (tile *)nodeafter->elem;
    float addRoute;
    int nbSteps;
    // 1rst segment is special (shorter)
    vx[0] = TILESIZE/2;
    vy[0] = TILESIZE/2;
    vx[2] = (int)(((1.0+t2->posX-t1->posX)/2)*TILESIZE); //+r->finishX
    vy[2] = (int)(((1.0+t2->posY-t1->posY)/2)*TILESIZE);
    vx[1] = (vx[0]+vx[2])/2;
    vy[1] = (vy[0]+vy[2])/2;
    if (fx!=-1) {
      vx[0] = fx;
      vy[0] = fy;
    }

    int diff = computeDifficulty(t1, t2, NULL);

    if (t1->posX-t2->posX==0 || t1->posY-t2->posY==0) {
      addRoute = (40-diff)/20.0f;
      nbSteps = 10;
    } else {
      addRoute = (60-diff)/28.0f;
      nbSteps = 14;
    }

    bezier3Texture(tc, vx, vy, addRoute, addRoute, 3, nbSteps/2, rs, isSolidBed);

    //  a river crossing 2 tites through a diagonal point need to refresh the 2 other tiles around in order
    // to show a visual continuity
    if (t2->posX-t1->posX!=0 && t2->posY-t1->posY!=0) {
      int dx = t2->posX-t1->posX;
      int dy = t2->posY-t1->posY;
      if (t1->posY+dy-firstVisibleTileY>=0 && (t1->posY+dy-firstVisibleTileY)*TILESIZE<screen->h &&
          t1->posX-firstVisibleTileX>=0    && (t1->posX-firstVisibleTileX)*TILESIZE<screen->w) {
        SDL_Surface *tc3 = getTileCache(t1->posX,(t1->posY+dy));
        vy[0] -= dy*TILESIZE;
        vy[1] -= dy*TILESIZE;
        vy[2] -= dy*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute, addRoute, 3, nbSteps/2, rs, isSolidBed);
        vy[0] += dy*TILESIZE;
        vy[1] += dy*TILESIZE;
        vy[2] += dy*TILESIZE;
      }
      if (t1->posY-firstVisibleTileY>=0    && (t1->posY+dy-firstVisibleTileY)*TILESIZE<screen->h &&
          t1->posX+dx-firstVisibleTileX>=0 && (t1->posX+dx-firstVisibleTileX)*TILESIZE<screen->w) {
        SDL_Surface *tc3 = getTileCache(t1->posX+dx,(t1->posY));
        vx[0] -= dx*TILESIZE;
        vx[1] -= dx*TILESIZE;
        vx[2] -= dx*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute, addRoute, 3, nbSteps/2, rs, isSolidBed);
        vx[0] += dx*TILESIZE;
        vx[1] += dx*TILESIZE;
        vx[2] += dx*TILESIZE;
      }
    }
    // last tile of this arm in the river
  } else if (nodebefore!=NULL && nodeafter==NULL) {
    tile *t0 = (tile *)nodebefore->elem;
    float addRoute;
    int nbSteps;
    // 1rst segment is special (shorter)
    vx[0] = TILESIZE/2;
    vy[0] = TILESIZE/2;
    vx[2] = (int)(((1.0+t0->posX-t1->posX)/2)*TILESIZE);
    vy[2] = (int)(((1.0+t0->posY-t1->posY)/2)*TILESIZE);
    vx[1] = (vx[0]+vx[2])/2;
    vy[1] = (vy[0]+vy[2])/2;
    int diff = computeDifficulty(t0, t1, NULL);
    if (t0->posX-t1->posX==0 || t0->posY-t1->posY==0) {
      addRoute = (40-diff)/20.0f;
      nbSteps = 10;
    } else {
      addRoute = (60-diff)/28.0f;
      nbSteps = 14;
    }
    bezier3Texture(tc, vx, vy, addRoute, addRoute, 3, nbSteps/2, rs, isSolidBed);
  } else if (nodeafter!=NULL && nodebefore!=NULL) {
    float addRoute1, addRoute2;
    int nbSteps;
    tile *t2 = (tile *)nodeafter->elem;
    tile *t0 = (tile *)nodebefore->elem;
    int prevdiff = computeDifficulty(t0, t1, NULL);
    int diff = computeDifficulty(t1, t2, NULL);

    vx[0] = (int)(((1.0+t0->posX-t1->posX)/2)*TILESIZE);
    vy[0] = (int)(((1.0+t0->posY-t1->posY)/2)*TILESIZE);
    vx[1] = TILESIZE/2;
    vy[1] = TILESIZE/2;
    vx[2] = (int)(((1.0+t2->posX-t1->posX)/2)*TILESIZE);
    vy[2] = (int)(((1.0+t2->posY-t1->posY)/2)*TILESIZE);

    if (t1->posX-t2->posX==0 || t1->posY-t2->posY==0) {
      addRoute1 = (40-prevdiff)/10.0f;
      addRoute2 = (40-diff)/10.0f;
      nbSteps = 20;
    } else {
      addRoute1 = (60-prevdiff)/14.0f;
      addRoute2 = (60-diff)/14.0f;
      nbSteps = 28;
    }

    bezier3Texture(tc, vx, vy, addRoute1, addRoute2, 3, nbSteps, rs, isSolidBed);

    // river can have a side effect on neightbours tiles when connected in diagonal
    if (t2->posX-t1->posX!=0 && t2->posY-t1->posY!=0) {
      int dx = t2->posX-t1->posX;
      int dy = t2->posY-t1->posY;
      if (t1->posY+dy>=firstVisibleTileY && t1->posY+dy-firstVisibleTileY<screen->h/TILESIZE &&
              t1->posX>=firstVisibleTileX    && t1->posX-firstVisibleTileX<screen->w/TILESIZE) {
        SDL_Surface *tc3 = getTileCache(t1->posX,(t1->posY+dy));
        vy[0] -= dy*TILESIZE;
        vy[1] -= dy*TILESIZE;
        vy[2] -= dy*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute1, addRoute2, 3, nbSteps, rs, isSolidBed);
        vy[0] += dy*TILESIZE;
        vy[1] += dy*TILESIZE;
        vy[2] += dy*TILESIZE;
      }
      if (t1->posY>=firstVisibleTileY &&    t1->posY-firstVisibleTileY<screen->h/TILESIZE &&
              t1->posX+dx>=firstVisibleTileX && t1->posX+dx-firstVisibleTileX<screen->w/TILESIZE) {
        SDL_Surface *tc3 = getTileCache(t1->posX+dx,(t1->posY));
        vx[0] -= dx*TILESIZE;
        vx[1] -= dx*TILESIZE;
        vx[2] -= dx*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute1, addRoute2, 3, nbSteps, rs, isSolidBed);
        vx[0] += dx*TILESIZE;
        vx[1] += dx*TILESIZE;
        vx[2] += dx*TILESIZE;
      }
    }
    if (t0->posX-t1->posX!=0 && t0->posY-t1->posY!=0) {
      int dx = t0->posX-t1->posX;
      int dy = t0->posY-t1->posY;
      if (t1->posY+dy>=firstVisibleTileY && t1->posY+dy-firstVisibleTileY<screen->h/TILESIZE &&
              t1->posX>=firstVisibleTileX    && t1->posX-firstVisibleTileX<screen->w/TILESIZE) {
        SDL_Surface * tc3 = getTileCache(t1->posX,(t1->posY+dy));
        vy[0] -= dy*TILESIZE;
        vy[1] -= dy*TILESIZE;
        vy[2] -= dy*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute1, addRoute2, 3, nbSteps, rs, isSolidBed);
        vy[0] += dy*TILESIZE;
        vy[1] += dy*TILESIZE;
        vy[2] += dy*TILESIZE;
      }
      if (t1->posY>=firstVisibleTileY &&    t1->posY-firstVisibleTileY<screen->h/TILESIZE &&
              t1->posX+dx>=firstVisibleTileX && t1->posX+dx-firstVisibleTileX<screen->w/TILESIZE) {
        SDL_Surface *tc3 = getTileCache(t1->posX+dx,(t1->posY));
        vx[0] -= dx*TILESIZE;
        vx[1] -= dx*TILESIZE;
        vx[2] -= dx*TILESIZE;
        bezier3Texture(tc3, vx, vy, addRoute1, addRoute2, 3, nbSteps, rs, isSolidBed);
        vx[0] += dx*TILESIZE;
        vx[1] += dx*TILESIZE;
        vx[2] += dx*TILESIZE;
      }
    }
  }

  free(vx);
  free(vy);
  //if (t1->elevation>OCEAN0)
  //  return sizel+sizer+0.5f;
  //else
  //  return sizel+sizer;
}// updatesRiverNodesOnTile() --------------------------------------------------------------------


/**
 * display a given river on the cached tiles
 *
void updatesRiverInCache(river *r) {
  binarytree_t *tileTree = r->itinerary;
  btnode_t *tileelem = binarytree_root(tileTree);

  if (tileelem->left!=NULL)
    updatesRiverInCache_r(tileTree, NULL, tileelem, tileelem->left, -1, -1, NULL);

  if (tileelem->right!=NULL)
    updatesRiverInCache_r(tileTree, NULL, tileelem, tileelem->right, -1, -1, NULL);
}// updatesRiverInCache() --------------------------------------------------------------------
*/

/**
 * display all the main rivers over the cached tiles
 */
void updatesRiversInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      } else {
        if (map[i+MapWidth*(j)].river_elem!=NULL){
          SDL_Surface * tc = getTileCache(i,j);
          updatesRiverOnTile(i, j, tc);
        }
        i++;
      }
    }
    j++;
  }
}// updateRiversInCache() --------------------------------------------------------------------


/**
 * updates the eventual bonuses on a given cached tile
 */
void updatesBonusOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  int bn = getBonusForTile(&map[i+MapWidth*(j)]);

  if (bn!=NONE) {
    int k = 0;
    for (k=0; k<map[i+MapWidth*(j)].bonus; k++) {
      rect->x = k*10+(TILESIZE-bonusImages[bn-FIRST_BONUS]->w-(map[i+MapWidth*(j)].bonus-1)*10)/2;
      rect->y = (TILESIZE-bonusImages[bn-FIRST_BONUS]->h)/2;
      SDL_BlitSurface(bonusImages[bn-FIRST_BONUS], 0, tc, rect);
    }
  }

  free(rect);
}// updatesBonusOnTile() --------------------------------------------------------------------


/**
 * display the bonuses on the tiles
 */
void updatesBonusesInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 &&j>=y1 &&j<=y2){
        i++;
        continue;
      }else if (map[i+MapWidth*(j)].construction==NULL && map[i+MapWidth*(j)].bonus>0) {
        SDL_Surface * tc = getTileCache(i,j);
        updatesBonusOnTile(i, j, tc);
      }
      i++;
    }
    j++;
  }
}// updateBonusesInCache() --------------------------------------------------------------------


/**
 * updates the eventual cultures on a given cached tile
 */
void updatesCulturesOnTile(int i, int j, SDL_Surface *tc) {
}// updatesCulturesOnTile() --------------------------------------------------------------------


/**
 * display the cultures on the tiles
 */
void updatesCulturesInCache() {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (map[i+MapWidth*(j)].construction==NULL && map[i+MapWidth*(j)].bonus>0) {
        SDL_Surface *tc = getTileCache(i,j);
        updatesCulturesOnTile(i, j, tc);
      }
      i++;
    }
    j++;
  }
}// updateCulturesInCache() --------------------------------------------------------------------

/*
* adds a point on the given tile for the given nation
*/
void addInfluence(int xStart, int yStart, int range, int nation) {
  for (int j=0;j<range;j++) {
    for (int i=0;i<range;i++) {
      map[xStart+i+MapWidth*(yStart+j)].influences[nation]++;
    }
  }
}// addInfluence()

/**
 * updates all cultures values going throw all units and buildings of all nations.
 */
void updatesInfluencesForAll() {
  lnode_t *pl;
  lnode_t *ul;
  lnode_t *cl;
  pl = list_first(playerList);
  while (pl!=NULL &&pl!=&playerList->list_nilnode) {
    player *p = (player*)pl->list_data;

    // adding influence on tiles regarding player's units
    ul = list_first(p->unitList);
    while (ul!=NULL &&ul!=&(p->unitList)->list_nilnode) {
      unit *u = (unit*)ul->list_data;
      if (u->horses>0)
        addInfluence(u->location->posX-1,u->location->posY-1,3,u->owner->nation);
      else
        addInfluence(u->location->posX-2,u->location->posY-2,5,u->owner->nation);
      ul=ul->list_next;
    }

    // adding influence on tiles regarding player's cities
    cl = list_first(p->cityList);
    while (cl!=NULL &&cl!=&(p->cityList)->list_nilnode) {
      city *c = (city*)cl->list_data;
      int range = getRangeForSize(c->size);
      addInfluence(c->location->posX-range,c->location->posY-range,2*range+1,c->owner->nation);
      cl=cl->list_next;
    }
    pl=pl->list_next;
  }
}// updatesInfluencesForAll() -------------------------------------------------------------------


/**
 * return what is the maximum money a city can offer
 */
int getMaximumMoneyForIndianCity(city *c){
  switch (c->owner->nation) {
    case AZTEC : return 1500;
    case OLMEC : return 1500;
    case INCA  : return 2500;
    case APACHE: return 800;
    case HURON: return 800;
    case CHEROKEE: return 800;
    case IROQUOIS: return 800;
    case SIOUX: return 500;
    case TUPI: return 500;
    case ARAWAK: return 500;
    case CHINOOK: return 500;
    case INUIT: return 200;
  }
  return 1;
}// getMaximumMoneyForIndianCity()


/**
*  gets the dominating nation of a tile
*/
int getInfluentNation (int i, int j) {
  int best = -1;
  for (int x=0;x<NATION_NUMBER;x++) {
    if (map[i+MapWidth*(j)].influences[x]!=0 && map[i+MapWidth*(j)].influences[x]>best)
      best=x;
  }
  return best;
}// getInfluentNation

/**
 * updates the eventual influence on a given cached tile
 */
void updatesInfluencesOnTile(int i, int j, SDL_Surface *tc) {
  int influentNation = getInfluentNation(i,j);
  //if (influentNation!=-1)
  //  printf("influences : influentNation is %i\n", influentNation);
  // only applying function if there is an influence on the current tile
  if (influentNation>0) {

    // init of some booleans used to set configuration, will be set to false if we must draw border
    bool topLeft,top,topRight,left,right,botLeft,bot,botRight=true;
    if (getInfluentNation(i-1,j-1)==influentNation)
      topLeft=false;
    if (getInfluentNation(i,j-1)==influentNation)
      top=false;
    if (getInfluentNation(i+1,j-1)==influentNation)
      topRight=false;
    if (getInfluentNation(i-1,j)==influentNation)
      left=false;
    if (getInfluentNation(i+1,j)==influentNation)
      right=false;
    if (getInfluentNation(i-1,j+1)==influentNation)
      botLeft=false;
    if (getInfluentNation(i,j+1)==influentNation)
      bot=false;
    if (getInfluentNation(i+1,j+1)==influentNation)
      botRight=false;

  if (topLeft&&top&&topRight&&left&&right&&botLeft&&bot&&botRight) {}
    else {
      drawInfluence(tc,influentNation,topLeft,top,topRight,left,right,botLeft,bot,botRight);
    }
  }
}// updatesInfluencesOnTile() --------------------------------------------------------------------


/**
 * display the influences on the tiles
 */
void updatesInfluencesInCache() {
  //printf("influences : updatesInfluencesInCache lance\n");
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      SDL_Surface *tc = getTileCache(i,j);
      updatesInfluencesOnTile(i, j, tc);
      i++;
    }
    j++;
  }
}// updateInfluencesInCache() --------------------------------------------------------------------


/**
 * display the roads on a given tile
 */
void updatesRoadOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  Sint16* vx = (Sint16*)malloc(3*sizeof(Sint16));
  Sint16* vy = (Sint16*)malloc(3*sizeof(Sint16));
  float addRoute, addRoute1, addRoute2;
  int nbSteps;

  tile *t1 = NULL;
  tile *t2 = NULL;
  float sx = 0;
  float sy = 0;

  float percentRoad = ((float)map[i+MapWidth*(j)].road)/20.0f;
  int di, dj;
  int nbConnect = 0;
  for (di=-1; di<2; di++)
    for (dj=-1; dj<2; dj++)
      if ((di!=0||dj!=0) && i+di>=0 && i+di<=MapWidth && j+dj>=0 && j+dj<=MapHeight && map[i+di+MapWidth*(j+dj)].road>0) {
        nbConnect++;
        if (t1==NULL)
          t1=&map[i+di+MapWidth*(j+dj)];
        else
          t2=&map[i+di+MapWidth*(j+dj)];
        sx += di;
        sy+= dj;
      }
  sx = sx / (nbConnect+1);
  sy = sy / (nbConnect+1);

  if (nbConnect==2) {
    vx[0] = TILESIZE/2-(i-t1->posX)*TILESIZE/2;
    vy[0] = TILESIZE/2-(j-t1->posY)*TILESIZE/2;
    vx[2] = TILESIZE/2-(i-t2->posX)*TILESIZE/2;
    vy[2] = TILESIZE/2-(j-t2->posY)*TILESIZE/2;
    vx[1] = TILESIZE/2;
    vy[1] = TILESIZE/2;
    int diff1 = computeDifficulty(t1, &map[i+MapWidth*(j)], NULL);
    int diff2 = computeDifficulty(t1, &map[i+MapWidth*(j)], NULL);
    if ((i-t1->posX)==0 || (j-t1->posY)==0) {
      addRoute1 = diff1/10.0f;
      if (addRoute1<1)
        addRoute1=1;
      nbSteps = 5;
    } else {
      addRoute1 = diff1/14.0f;
      if (addRoute1<1)
        addRoute1=1;
      nbSteps = 7;
    }
    if ((i-t2->posX)==0 || (j-t2->posY)==0) {
      addRoute2 = diff2/10.0f;
      if (addRoute2<1)
        addRoute2=1;
      nbSteps = 5;
    } else {
      addRoute2 = diff2/14.0f;
      if (addRoute2<1)
        addRoute2=1;
      nbSteps = 7;
    }
    if (map[i+MapWidth*(j)].road<=ROAD)
      bezier2RGBA(tc, vx, vy, 0.5f+addRoute1, 0.5f+addRoute2, 3, nbSteps, 52, 16, 0, 255, 64, 32, 0, 255, percentRoad, 2);
    else if (map[i+MapWidth*(j)].road<=HIGHWAY)
      bezier2RGBA(tc, vx, vy, 1, 1, 3, nbSteps, 0, 0, 0, 255, 12, 12, 12, 255, percentRoad, 3);
    else if (map[i+MapWidth*(j)].road<=RAILWAY)
      bezier2RGBA(tc, vx, vy, 1, 1, 3, nbSteps/2, 64, 64, 64, 192, 0, 0, 0, 255, percentRoad, 4);

  } else
    for (di=-1; di<2; di++)
      for (dj=-1; dj<2; dj++)
        if ((di!=0||dj!=0) && i+di>=0 && i+di<=MapWidth && j+dj>=0 && j+dj<=MapHeight && map[i+di+MapWidth*(j+dj)].road>0) {
          t1 = &map[i+MapWidth*(j)];
          t2 = &map[i+di+MapWidth*(j+dj)];
          if (map[i+MapWidth*(j)].construction!=NULL || nbConnect==1) {
            nbSteps = 0;
            sx=0;
            sy=0;
          }

          vx[0] = TILESIZE/2+(int)(sx*(TILESIZE/2));
          vy[0] = TILESIZE/2+(int)(sy*(TILESIZE/2));
          vx[2] = (di+1)*TILESIZE/2;
          vy[2] = (dj+1)*TILESIZE/2;
          vx[1] = (vx[0]+vx[2])/2;
          vy[1] = (vy[0]+vy[2])/2;
          int diff = computeDifficulty(t1, t2, NULL);
          if (di==0 || dj==0) {
            addRoute = diff/10.0f;
            if (addRoute<1)
              addRoute=1;
            nbSteps = 5;
          } else {
            addRoute = diff/14.0f;
            if (addRoute<1)
              addRoute=1;
            nbSteps = 7;
          }
          if (map[i+MapWidth*(j)].road<=ROAD)
            bezier2RGBA(tc, vx, vy, 0.5f+addRoute, 0.5f+addRoute, 3, nbSteps, 52, 16, 0, 255, 64, 32, 0, 255, percentRoad, 2);
          else if (map[i+MapWidth*(j)].road<=HIGHWAY)
            bezier2RGBA(tc, vx, vy, 1, 1, 3, nbSteps, 0, 0, 0, 255, 12, 12, 12, 255, percentRoad, 3);
          else if (map[i+MapWidth*(j)].road<=RAILWAY)
            bezier2RGBA(tc, vx, vy, 1, 1, 3, nbSteps/2, 64, 64, 64, 192, 0, 0, 0, 255, percentRoad, 4);
        }
  free(vx);
  free(vy);
  free(rect);
}// updatesRoadOnTile() --------------------------------------------------------------------


/**
 * display the roads on the tiles
 */
void updatesRoadsInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      } else {
        SDL_Surface *tc = getTileCache(i,j);
        if (map[i+MapWidth*(j)].road>0)
          updatesRoadOnTile(i, j, tc);
        i++;
      }
    }
    j++;
  }
}// updatesRoadsInCache() --------------------------------------------------------------------


/**
 * draw a tree according to the drawing method
 *
void drawTree(SDL_Surface *tc, int x, int y, int r, int green) {

  /*this parameter will be used in case 4 to specify what kind of tree will be used
  0 -> colored circles
  1 -> using a forest
  _ -> using tree pngs
  int param = 2;

  switch (forestgraphics) {
  case 0:
    filledCircleRGBA(tc, x+r/2, y+r/2, r, 0, green, 0, 255);
    break;
  case 1:
    texturedCircle(tc, x+2, y+2, r);
    break;
  case 2:
    treeCircle(tc, x+2, y+2, r);
    break;
  case 3:
    progressiveTexturedCircle(tc, x+r/2, y+r/2, r);
    break;
  case 4:
    tree3d(tc, x+r/2, y+r/2, r, &zbuf[0][0], param);
    break;
  }
}// drawTree() --------------------------------------------------------------------
*/

/**
 * display the vegetation on a cache tile
 */
void cacheVegetationOnTile(int vegeLevel, int vegeTop, int vegeRight, int vegeBottom, int vegeLeft, SDL_Surface *tc) {
  memset(&zbuf, 0, TILESIZE*TILESIZE);
  srand(12345);
  int nb_trees = -(vegeLevel)*4;
  //printf("cacheVegetationOnTile %i\n", nb_trees);
  // tant qu'il reste des arbres a afficher
  while (nb_trees!=0) {
    // on choisit un type d'arbre au hasard
    //int imgindex = rand()%4;

    // debut du traitement vertical
    // on choisit un nombre vside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int vside = rand()%2*2-1;
    float y;
    if ((vside==-1 && vegeTop<0)||(vside==1 && vegeBottom<0)) {
      y=ranf()*(TILESIZE/2)*vside+(TILESIZE/2);
    } else {
      y=((TILESIZE/2)+vside*positiveGaussian()*(TILESIZE/2));
    }
    //if ((y>0)&&(y<64-treeImages[imgindex]->w)) {
    //rect->y = treeImages[imgindex]->w/2+y;}

    // debut du traitement horizontal
    // on choisit un nombre hside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int hside = rand()%2*2-1;
    float x;
    if ((hside==-1 && vegeLeft<0)||(hside==1 && vegeRight<0)) {
      x=ranf()*(TILESIZE/2)*hside+(TILESIZE/2);
    } else {
      x=((TILESIZE/2)+hside*positiveGaussian()*(TILESIZE/2));
    }

    int r = 4+rand()%4;
    //int green = 32+rand()%64;
    debug=TRUE;
    //treeShadow(tc, (int)x, (int)y, r, &zbuf[0][0]);
    debug=FALSE;
    //tree3d(tc, (int)x, (int)y, r, &zbuf[0][0], 2);
    nb_trees--;
  }

  memset(&zbuf,0,TILESIZE*TILESIZE);
  srand(12345);
  nb_trees = -(vegeLevel)*4;
  //printf("cacheVegetationOnTile %i\n", nb_trees);
  // tant qu'il reste des arbres a afficher
  while (nb_trees!=0) {
    // on choisit un type d'arbre au hasard
    //int imgindex = rand()%4;

    // debut du traitement vertical
    // on choisit un nombre vside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int vside = rand()%2*2-1;
    float y;
    if ((vside==-1 && vegeTop<0)||(vside==1 && vegeBottom<0)) {
      y=ranf()*32*vside+32;
    } else {
      y=(32+vside*positiveGaussian()*32);
    }
    //if ((y>0)&&(y<64-treeImages[imgindex]->w)) {
    //rect->y = treeImages[imgindex]->w/2+y;}

    // debut du traitement horizontal
    // on choisit un nombre hside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int hside = rand()%2*2-1;
    float x;
    if ((hside==-1 && vegeLeft<0)||(hside==1 && vegeRight<0)) {
      x=ranf()*32*hside+32;
    } else {
      x=(32+hside*positiveGaussian()*32);
    }

    int r = 4+rand()%4;
    //int green = 32+rand()%64;
    tree3d(tc, (int)x, (int)y, r, &zbuf[0][0], 2, apptime%12);
    /*if (x-r<0 && vegeBottom){
      tree3d(tc, (int)x+TILESIZE, (int)y, r, &zbuf[0][0], 2);
    }
    if (y-r<0 && vegeRight){
      tree3d(tc, (int)x, (int)y+TILESIZE, r, &zbuf[0][0], 2);
    }*/
    nb_trees--;
  }
}// cacheVegetationOnTile();


/**
 * display the vegetation on a given tile
 */
void updatesVegetationOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  memset(&zbuf,0,TILESIZE*TILESIZE);

  rect->w = TILESIZE;
  rect->h = TILESIZE;
  rect->x = 0;
  rect->y = 0;
  srand(map[i+MapWidth*(j)].seed);

  SDL_Surface *tcLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0) {
    tcLeft = getTileCache(i-1,j);
  }

  SDL_Surface *tcTop = NULL;
  if (j>0 && j-1-firstVisibleTileY>=0) {
    tcTop = getTileCache(i,j-1);
  }

  SDL_Surface *tcBot = NULL;
  if (j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBot = getTileCache(i,j+1);
  }

  SDL_Surface *tcRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE) {
    tcRight = getTileCache(i+1,j);
  }

  SDL_Surface *tcTopLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0 && j>0 && j-1-firstVisibleTileY>=0) {
    tcTopLeft = getTileCache(i-1,j-1);
  }

  SDL_Surface *tcTopRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE && j>0 && j-1-firstVisibleTileY>=0) {
    tcTopRight = getTileCache(i+1,j-1);
  }

  SDL_Surface *tcBotLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0 && j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBotLeft = getTileCache(i-1,j+1);
  }

  SDL_Surface *tcBotRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE && j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBotRight = getTileCache(i+1,j+1);
  }

  int nb_trees = -(map[i+MapWidth*(j)].vegetation); // *3
  PolySite *res = getCVTRandomPoints(nb_trees, 2);
  while (nb_trees!=0) {
    float x= res[nb_trees-1].coord.x*TILESIZE;
    float y= res[nb_trees-1].coord.y*TILESIZE;
    //float x = ranf()*TILESIZE;
    //float y = ranf()*TILESIZE;
    int r = 6+rand()%4;
    if (x>TILESIZE/2 && map[i+1+MapWidth*(j)].vegetation>=0){
      int max = TILESIZE/2+rand()%(TILESIZE/2-r);
      if (x>=max) {nb_trees--;continue;}
    }
    if (x<TILESIZE/2 && map[i-1+MapWidth*(j)].vegetation>=0){
      int min = r+rand()%(TILESIZE/2-r);
      if (x<=min) {nb_trees--;continue;}
    }
    if (y>TILESIZE/2 && map[i+MapWidth*(j+1)].vegetation>=0){
      int max = TILESIZE/2+rand()%(TILESIZE/2-r);
      if (y>=max) {nb_trees--;continue;}
    }
    if (y<TILESIZE/2 && map[i+MapWidth*(j-1)].vegetation>=0){
      int min = r+rand()%(TILESIZE/2-r);
      if (y<=min) {nb_trees--;continue;}
    }
    int nextseed = rand();
    tree3d(tc, (int)x, (int)y, r, &zbuf[0][0], 0, apptime%12);

    if (tcLeft!=NULL && x<r && x>=-r)
      tree3d(tcLeft, (int)x+TILESIZE, (int)y, r, &zbuf[0][0], 0, apptime%12);
    if (tcTop!=NULL && y<r && y>=-r)
      tree3d(tcTop, (int)x, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r)
      tree3d(tcRight, (int)x-TILESIZE, (int)y, r, &zbuf[0][0], 0, apptime%12);
    if (tcBot!=NULL && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBot, (int)x, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcTopLeft!=NULL && x<r && x>=-r && y<r && y>=-r)
      tree3d(tcTopLeft, (int)x+TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcTopRight!=NULL && y<r && y>=-r && x<TILESIZE+r && x>=TILESIZE-r)
      tree3d(tcTopRight, (int)x-TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcBotLeft!=NULL && x<r && x>=-r && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBotLeft, (int)x+TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcBotRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBotRight, (int)x-TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    srand(nextseed);
    nb_trees--;
  }
  //free(res);
  return;
  
  /* tant qu'il reste des arbres a afficher
  while (nb_trees!=0) {

    // on choisit un type d'arbre au hasard
    //int imgindex = rand()%4;

    // debut du traitement vertical
    // on choisit un nombre vside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int vside = rand()%2*2-1;
    float y;
    if (map[i+MapWidth*(j+vside)].vegetation<0) {
      y=ranf()*(TILESIZE/2)*vside+(TILESIZE/2);
    } else {
      y=((TILESIZE/2)+vside*positiveGaussian()*(TILESIZE/2));
    }
    //if ((y>0)&&(y<64-treeImages[imgindex]->w)) {
    //rect->y = treeImages[imgindex]->w/2+y;}

    // debut du traitement horizontal
    // on choisit un nombre hside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int hside = rand()%2*2-1;
    float x;
    if (map[i+hside+MapWidth*(j)].vegetation<0) {
      x=ranf()*(TILESIZE/2)*hside+(TILESIZE/2);
    } else {
      x=((TILESIZE/2)+hside*positiveGaussian()*(TILESIZE/2));
    }

    int r = 6+rand()%4;
    int nextseed = rand();
    //int green = 32+rand()%64;
    tree3d(tc, (int)x, (int)y, r, &zbuf[0][0], 0, apptime%12);

    if (tcLeft!=NULL && x<r && x>=-r)
      tree3d(tcLeft, (int)x+TILESIZE, (int)y, r, &zbuf[0][0], 0, apptime%12);
    if (tcTop!=NULL && y<r && y>=-r)
      tree3d(tcTop, (int)x, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r)
      tree3d(tcRight, (int)x-TILESIZE, (int)y, r, &zbuf[0][0], 0, apptime%12);
    if (tcBot!=NULL && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBot, (int)x, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcTopLeft!=NULL && x<r && x>=-r && y<r && y>=-r)
      tree3d(tcTopLeft, (int)x+TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcTopRight!=NULL && y<r && y>=-r && x<TILESIZE+r && x>=TILESIZE-r)
      tree3d(tcTopRight, (int)x-TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcBotLeft!=NULL && x<r && x>=-r && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBotLeft, (int)x+TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    if (tcBotRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r && y<TILESIZE+r && y>=TILESIZE-r)
      tree3d(tcBotRight, (int)x-TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0], 0, apptime%12);
    srand(nextseed);
    nb_trees--;
  }
  */
  free(rect);
}// updatesVegetationOnTile() --------------------------------------------------------------------


/**
* display the vegetation's shadow on a given tile
 */
void updatesVegetationShadowOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  memset(&zbuf, 0, TILESIZE*TILESIZE);

  rect->w = TILESIZE;
  rect->h = TILESIZE;
  rect->x = 0;
  rect->y = 0;
  srand(map[i+MapWidth*(j)].seed);

  SDL_Surface *tcLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0) {
    tcLeft = getTileCache(i-1,j);
  }

  SDL_Surface *tcTop = NULL;
  if (j>0 && j-1-firstVisibleTileY>=0) {
    tcTop = getTileCache(i,j-1);
  }

  SDL_Surface *tcBot = NULL;
  if (j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBot = getTileCache(i,j+1);
  }

  SDL_Surface *tcRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE) {
    tcRight = getTileCache(i+1,j);
  }

  SDL_Surface *tcTopLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0 && j>0 && j-1-firstVisibleTileY>=0) {
    tcTopLeft = getTileCache(i-1,j-1);
  }

  SDL_Surface *tcTopRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE && j>0 && j-1-firstVisibleTileY>=0) {
    tcTopRight = getTileCache(i+1,j-1);
  }

  SDL_Surface *tcBotLeft = NULL;
  if (i>0 && i-1-firstVisibleTileX>=0 && j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBotLeft = getTileCache(i-1,j+1);
  }

  SDL_Surface *tcBotRight = NULL;
  if (i<MapWidth && i+1-firstVisibleTileX<screen->w/TILESIZE && j<MapHeight && j+1-firstVisibleTileY<screen->h/TILESIZE) {
    tcBotRight = getTileCache(i+1,j+1);
  }

  int nb_trees = -(map[i+MapWidth*(j)].vegetation)*3;
  // tant qu'il reste des arbres a afficher
  while (nb_trees!=0) {

    // on choisit un type d'arbre au hasard
    //int imgindex = rand()%4;

    // debut du traitement vertical
    // on choisit un nombre vside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int vside = rand()%2*2-1;
    float y;
    if (map[i+MapWidth*(j+vside)].vegetation<0) {
      y=ranf()*(TILESIZE/2)*vside+(TILESIZE/2);
    } else {
      y=((TILESIZE/2)+vside*positiveGaussian()*(TILESIZE/2));
    }
    //if ((y>0)&&(y<64-treeImages[imgindex]->w)) {
    //rect->y = treeImages[imgindex]->w/2+y;}

    // debut du traitement horizontal
    // on choisit un nombre hside aleatoire entre 0 et 1 pour decider de quel cote on affiche l'arbre
    int hside = rand()%2*2-1;
    float x;
    if (map[i+hside+MapWidth*(j)].vegetation<0) {
      x=ranf()*(TILESIZE/2)*hside+(TILESIZE/2);
    } else {
      x=((TILESIZE/2)+hside*positiveGaussian()*(TILESIZE/2));
    }

    int r = 4+rand()%4;
    //int green = 32+rand()%64;
    //treeShadow(tc, (int)x, (int)y, r, &zbuf[0][0]);

    /*if (tcLeft!=NULL && x<r && x>=-r)
      treeShadow(tcLeft, (int)x+TILESIZE, (int)y, r, &zbuf[0][0]);
    if (tcTop!=NULL && y<r && y>=-r)
      treeShadow(tcTop, (int)x, (int)y+TILESIZE, r, &zbuf[0][0]);
    if (tcRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r)
      treeShadow(tcRight, (int)x-TILESIZE, (int)y, r, &zbuf[0][0]);
    if (tcBot!=NULL && y<TILESIZE+r && y>=TILESIZE-r)
      treeShadow(tcBot, (int)x, (int)y-TILESIZE, r, &zbuf[0][0]);
    if (tcTopLeft!=NULL && x<r && x>=-r && y<r && y>=-r)
      treeShadow(tcTopLeft, (int)x+TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0]);
    if (tcTopRight!=NULL && y<r && y>=-r && x<TILESIZE+r && x>=TILESIZE-r)
      treeShadow(tcTopRight, (int)x-TILESIZE, (int)y+TILESIZE, r, &zbuf[0][0]);
    if (tcBotLeft!=NULL && x<r && x>=-r && y<TILESIZE+r && y>=TILESIZE-r)
      treeShadow(tcBotLeft, (int)x+TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0]);
    if (tcBotRight!=NULL && x<TILESIZE+r && x>=TILESIZE-r && y<TILESIZE+r && y>=TILESIZE-r)
      treeShadow(tcBotRight, (int)x-TILESIZE, (int)y-TILESIZE, r, &zbuf[0][0]);
   */
    nb_trees--;
  }

  free(rect);
}// updatesVegetationShadowOnTile() --------------------------------------------------------------------


/**
 * update vegetation using a pre-computed image
 */
void updatesFastVegetationInCache(int x1, int y1, int x2, int y2){
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      } else {
        SDL_Surface * tc = getTileCache(i,j);
        int vegeTop    = 0; if (map[i+MapWidth*(j-1)].vegetation<0) vegeTop    = 1;
        int vegeRight  = 0; if (map[i+1+MapWidth*(j)].vegetation<0) vegeRight  = 1;
        int vegeBottom = 0; if (map[i+MapWidth*(j+1)].vegetation<0) vegeBottom = 1;
        int vegeLeft   = 0; if (map[i-1+MapWidth*(j)].vegetation<0) vegeLeft   = 1;
        if (map[i+MapWidth*(j)].vegetation<-10 && map[i+MapWidth*(j)].vegetation>-30)
          SDL_BlitSurface(forest20Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft], NULL, tc, NULL);
        else if (map[i+MapWidth*(j)].vegetation<=-30)
          SDL_BlitSurface(forest40Imgs[vegeTop+2*vegeRight+4*vegeBottom+8*vegeLeft], NULL, tc, NULL);
        i++;
      }
    }
    j++;
  }
}//updatesFastVegetationInCache()


/**
 * display the vegetation on the tiles
 */
void updatesVegetationInCache(int x1, int y1, int x2, int y2) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      }
      SDL_Surface *tc = getTileCache(i,j);
      assert(tc!=NULL);

      if (map[i+MapWidth*(j)].vegetation<0)
        updatesVegetationOnTile(i, j, tc);
      i++;
    }
    j++;
  }
  free(rect);
}// updatesVegetationInCache() --------------------------------------------------------------------


/**
 * display the vegetation's shadow on the tiles
 */
void updatesVegetationShadowInCache(int x1, int y1, int x2, int y2) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      }
      SDL_Surface *tc = getTileCache(i,j);

      //if (map[i+MapWidth*(j)].vegetation<0)
      //  updatesVegetationShadowOnTile(i, j, tc);
      i++;
    }
    j++;
  }
  free(rect);
}// updatesVegetationShadowInCache() --------------------------------------------------------------------


/**
 * updates the fields on a given tile
 */
void updatesFieldOnTile(int i, int j, SDL_Surface *tc) {
  srand(map[i+MapWidth*(j)].seed);

  int k;
  for (k=0; k<map[i+MapWidth*(j)].vegetation; k++){
    int w = 12+rand()%12;
    int h = 12+rand()%12;
    int x = rand()%(TILESIZE);
    int y = rand()%(TILESIZE);
    if (x<TILESIZE/2 && map[i-1+MapWidth*(j)].vegetation<=0)
      x = TILESIZE/2-positiveGaussian()*TILESIZE/2;
    if (x>TILESIZE/2 && map[i+1+MapWidth*(j)].vegetation<=0)
      x = TILESIZE/2+positiveGaussian()*TILESIZE/2;
    if (y<TILESIZE/2 && map[i+MapWidth*(j-1)].vegetation<=0)
      y = TILESIZE/2-positiveGaussian()*TILESIZE/2;
    if (y>TILESIZE/2 && map[i+MapWidth*(j+1)].vegetation<=0)
      y = TILESIZE/2+positiveGaussian()*TILESIZE/2;

    x-=w/2;
    y-=h/2;

    //int x0 = x+w/2;
    //int y0 = y+h/2;

    blitField(tc, x, y, w, h, rand()%5);
  }
}// updatesFieldOnTile()


/**
 * display a city on a given tile
 */
void updatesCityOnTile(int i, int j, SDL_Surface *tc) {
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  // lost city rumor
  if (map[i+MapWidth*(j)].construction!=NULL && map[i+MapWidth*(j)].construction->size==-1){
    SDL_BlitSurface(cloudImage, NULL, tc, NULL);

    //normal city
  } else if (map[i+MapWidth*(j)].construction!=NULL) {
    city *ci      = map[i+MapWidth*(j)].construction;
    float citywidth = 8.0f+((float)ci->size/4.0f*TILESIZE/2.0f);
    float mainroad  = 1.0f+(float)ci->size/4.0f;
    rect->x = TILESIZE/2;
    rect->w = (int)(citywidth/2);
    rect->y = TILESIZE/2-(int)(citywidth/2);
    rect->h  = (int)citywidth;
    cityTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad, 1,  0, ci->seed);
    cityTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad, -1, 0, ci->seed);
    cityTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad, 0,  1, ci->seed);
    cityTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad, 0, -1, ci->seed);

    streetTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad,  1, 0);
    streetTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad, -1, 0);
    streetTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad,  0, 1);
    streetTiteQuarter(tc, TILESIZE/2, TILESIZE/2, citywidth/2.0f, mainroad,  0, -1);

    if (ci->flagImage != NULL){
      SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
      rect->x = TILESIZE/2-ci->flagImage->w/2;
      rect->y = TILESIZE/2-ci->flagImage->h/2;
      SDL_BlitSurface(ci->flagImage, 0, tc, rect);
    }
  }
  free(rect);
}// updatesCityOnTile() --------------------------------------------------------------------


/**
 * display the cities on the tiles
 */
void updatesCitiesInCache(int x1, int y1, int x2, int y2) {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      if (i>=x1 && i<=x2 && j>=y1 && j<=y2) {
        i++;
        continue;
      } else {
        SDL_Surface * tc = getTileCache(i,j);
        if (map[i+MapWidth*(j)].construction!=NULL)
          updatesCityOnTile(i, j, tc);
        i++;
      }
    }
    j++;
  }
}// updatesCitiesInCache() --------------------------------------------------------------------


/**
 * display a city name on a given cached tile
 */
void updatesCityNamesOnTile(int i, int j, SDL_Surface *tc) {
  if (tc==NULL)
    return;
  //printf("updatesCityNamesOnTile(%p)\n", tc);
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  city *ci      = map[i+MapWidth*(j)].construction;

  int fontSize = 10+(ci->size/2)%5;
  if (ci->size%2==1)
    TTF_SetFontStyle(fonts[fontSize], TTF_STYLE_BOLD);
  //SDL_Surface *imgText = TTF_RenderText_Blended(fonts[fontSize], ci->name, BLACK);
  char* spacepos = strstr(ci->name, " ");
  SDL_Surface *imgText = NULL;
  if (spacepos==NULL) {
    SDL_Surface *imgText = renderTextShadowed_Blended(fonts[fontSize], ci->name, WHITE, BLACK);
    rect->x = TILESIZE/2-imgText->w/2;
    rect->y = TILESIZE/2-imgText->h/2;
    SDL_BlitSurface(imgText, 0, tc, rect);
    SDL_FreeSurface(imgText);
  } else {
    imgText = renderTextShadowed_Blended(fonts[fontSize], spacepos+1, WHITE, BLACK);
    rect->x = TILESIZE/2-imgText->w/2;
    rect->y = TILESIZE/2;
    SDL_BlitSurface(imgText, 0, tc, rect);
    SDL_FreeSurface(imgText);

    *spacepos = 0;
    imgText = renderTextShadowed_Blended(fonts[fontSize], ci->name, WHITE, BLACK);
    rect->x = TILESIZE/2-imgText->w/2;
    rect->y = TILESIZE/2-imgText->h/2;
    SDL_BlitSurface(imgText, 0, tc, rect);
    SDL_FreeSurface(imgText);
    *spacepos = ' ';
    rect->y += fontSize/2;
  }

  char *txt = (char *)malloc(8*sizeof(char));
  sprintf(txt, "%i", ci->size);
  imgText = TTF_RenderText_Blended(fonts[fontSize], txt, WHITE);
  rect->y += rect->h+3;
  rect->x += rect->w/2-imgText->w/2-5;
  rect->w = imgText->w+10;
  rect->h = 13;
  player *p = ci->owner;
  SDL_Color *col = nationColors[p->nation-FIRST_NATION];
  SDL_FillRect(tc, rect, SDL_MapRGB( tc->format, col->r, col->g, col->b ));
  hlineRGBA(tc, rect->x,             rect->x+rect->w-1, rect->y-1,         0, 0, 0, 255);
  vlineRGBA(tc, rect->x-1,           rect->y,           rect->y+rect->h-1, 0, 0, 0, 255);
  hlineRGBA(tc, rect->x,             rect->x+rect->w-1, rect->y+rect->h,   0, 0, 0, 255);
  vlineRGBA(tc, rect->x-1+rect->w+1, rect->y,           rect->y+rect->h-1, 0, 0, 0, 255);

  rect->y -= 3;
  rect->x += 5;
  SDL_BlitSurface(imgText, 0, tc, rect);
  //printf("  ... finishing %p\n", tc);fflush(stdout);
  free(txt);
  SDL_FreeSurface(imgText);
  free(rect);
}// updatesCityNamesOnTile() --------------------------------------------------------------------


/**
 * display the cities names on the cached tiles
 */
void updatesCityNamesInCache() {
  int j = firstVisibleTileY;
  while((j-firstVisibleTileY)*TILESIZE<screen->h && j<MapHeight) {
    int i = firstVisibleTileX;
    while((i-firstVisibleTileX)*TILESIZE<screen->w && i<MapWidth) {
      SDL_Surface * tc = getTileCache(i,j);

      if (map[i+MapWidth*(j)].construction!=NULL && map[i+MapWidth*(j)].construction->size>0)
        updatesCityNamesOnTile(i, j, tc);
      i++;
    }
    j++;
  }
}// updatesCityNamesInCache() --------------------------------------------------------------------


/**
 * update the given image with the graphism corresponding to i,j on the map
 **/
void updatesImageTile(int i, int j, SDL_Surface *t, int dispBonus) {
  //printf("updatesImageTile(..., %i)\n", dispBonus);
  updatesBackgroundOnTile(i, j, t);
  SDL_Surface *swaper;
  if (i>=firstVisibleTileX && j>=firstVisibleTileY && i<firstVisibleTileX+screen->w/TILESIZE && j<firstVisibleTileY+screen->h/TILESIZE) {
    if (i>firstVisibleTileX && j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1-1];
      maskTiles[1-1][1-1] = swaper;
    }
    if (i>firstVisibleTileX) {
      int u= (j-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1];
      maskTiles[1-1][1] = swaper;
    }
    if (i>firstVisibleTileX && j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1+1];
      maskTiles[1-1][1+1] = swaper;
    }
    if (j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1][1+1];
      maskTiles[1][1+1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1 && j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1+1];
      maskTiles[1+1][1+1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1){
      int u= (j-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1];
      maskTiles[1+1][1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1 && j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1-1];
      maskTiles[1+1][1-1] = swaper;
    }
    if (j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1][1-1];
      maskTiles[1][1-1] = swaper;
    }
  }


  if (map[i+MapWidth*(j)].vegetation>0 && map[i+MapWidth*(j)].elevation>=SEALEVEL && map[i+MapWidth*(j)].elevation<=HIGHHILL)
    updatesFieldOnTile(i, j, t);

  if (map[i+MapWidth*(j)].vegetation<0 && map[i+MapWidth*(j)].elevation>=SEALEVEL && map[i+MapWidth*(j)].elevation<=HIGHHILL)
    updatesVegetationShadowOnTile(i, j, t);

  if (map[i+MapWidth*(j)].vegetation<0 && map[i+MapWidth*(j)].elevation>=SEALEVEL && map[i+MapWidth*(j)].elevation<=HIGHHILL)
    updatesVegetationOnTile(i, j, t);

  if (map[i+MapWidth*(j)].construction!=NULL)
    updatesCityOnTile(i, j, t);

  if (map[i+MapWidth*(j)].river_elem!=NULL)
    updatesRiverOnTile(i, j, t);

  if (map[i+MapWidth*(j)].road>0)
    updatesRoadOnTile(i, j, t);

  if (dispBonus && map[i+MapWidth*(j)].bonus>0)
    updatesBonusOnTile(i, j, t);

  if (map[i+MapWidth*(j)].construction!=NULL && map[i+MapWidth*(j)].construction->size>0)
    updatesCityNamesOnTile(i, j, t);

  if (map[i+MapWidth*(j)].lastExplored>0 && gamemode == PLAY)
    updatesFogOfWarOnTile(i, j, t);

  if (i>=firstVisibleTileX && j>=firstVisibleTileY && i<firstVisibleTileX+screen->w/TILESIZE && j<firstVisibleTileY+screen->h/TILESIZE) {
    if (i>firstVisibleTileX && j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1-1];
      maskTiles[1-1][1-1] = swaper;
    }
    if (i>firstVisibleTileX) {
      int u= (j-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1];
      maskTiles[1-1][1] = swaper;
    }
    if (i>firstVisibleTileX && j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1-1][1+1];
      maskTiles[1-1][1+1] = swaper;
    }
    if (j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1][1+1];
      maskTiles[1][1+1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1 && j<firstVisibleTileY+screen->h/TILESIZE-1){
      int u= (j+1-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1+1];
      maskTiles[1+1][1+1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1){
      int u= (j-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1];
      maskTiles[1+1][1] = swaper;
    }
    if (i<firstVisibleTileX+screen->w/TILESIZE-1 && j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i+1-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1+1][1-1];
      maskTiles[1+1][1-1] = swaper;
    }
    if (j>firstVisibleTileY){
      int u= (j-1-firstVisibleTileY)*(screen->w/TILESIZE)+(i-firstVisibleTileX);
      swaper = tilecache[u];
      tilecache[u] = maskTiles[1][1-1];
      maskTiles[1][1-1] = swaper;
    }
  }
}// updatesImageTile() --------------------------------------------------------------------


/**
 * update the tile at the given position ... if the given position is actually visible !
 **/
void updatesCachedTileAt(int i, int j) {
  if (i>=firstVisibleTileX && j>=firstVisibleTileY && i<firstVisibleTileX+screen->w/TILESIZE && j<firstVisibleTileY+screen->h/TILESIZE) {
    int u= (j-firstVisibleTileY)*(screen->w/TILESIZE)+i-firstVisibleTileX;
    SDL_Surface * tc = tilecache[u];
    updatesImageTile(i, j, tc, TRUE);
  }
}// updatesCachedTileAt() --------------------------------------------------------------------


/**
 * return a random float between 0 and 1 with three digit precision
 */
float ranf() {
  float tmp=(float)(rand()%1000)/1000.0f;
  return tmp;
}// ranf() -----------------------------------------------------------------------------


/**
 * return a random float number beetween 0 and 1 but with a gaussian distribution.
 ERREUR C PAS GAUSSIEN*/
float gaussian() {
  float x1, x2, w, y1, y2;
  do {
    x1 = 2.0f * ranf() - 1.0f;
    x2 = 2.0f * ranf() - 1.0f;
    w = x1 * x1 + x2 * x2;
  } while ( w >= 1.0 );
  w = sqrt( (-2.0f * log( w) ) / w );
  y1 = x1 * w;
  y2 = x2 * w;
  return y1/4;
}// gaussian()


float positiveGaussian() {
  float x = fabs(gaussian());
  return x;
}// positiveGaussian() --------------------------------------------------------------------


/**
 * return how strong a nuit will be in battle (
 */
int getBattleStrength(const unit *uni, const tile *loc, const int attack){
  int strength = 1;
  // those guys know how to fight !
  if (uni->type==SCOUT || uni->type==FURTRAPPER || uni->type==SOLDIER)
    strength = 2;

  if (!attack && loc!=NULL && loc->construction!=NULL){
    strength += 1;
    int bt = WATCH_TOWER;
    if (list_find(loc->construction->buildings, &bt, compareBuildingType) )
      strength += 1;
    bt = COMMAND_POST;
    if (list_find(loc->construction->buildings, &bt, compareBuildingType) )
      strength += 1;
    bt = STOCKADE;
    if (list_find(loc->construction->buildings, &bt, compareBuildingType) )
      strength += 1;
    bt = FORT;
    if (list_find(loc->construction->buildings, &bt, compareBuildingType) )
      strength += 2;
    bt = FORTRESS;
    if (list_find(loc->construction->buildings, &bt, compareBuildingType) )
      strength += 3;
  }

  if (uni->muskets>0){
    strength = strength*2;
    // in the west, everybody know how to use a horse
    if (uni->horses>0)
      strength += 2;
    // those guys know how to use muskets !
    if (uni->type==SOLDIER) {
      strength = strength*2;
      strength += uni->experience;
    }

  }
  if (uni->type==ARTILLERY){
    strength = 15;
    strength += 2*uni->experience;
  }
  if (uni->type==DAM_ARTILLERY){
    strength = 10;
    strength += 2*uni->experience;
  }
  return strength;
}//getBattleStrength()


/**
 * prepare a battle between the 2 lists of units in the inspector
 */
battle *prepareBattle() {
  int nb                   = 0;
  battle *battle0          = (battle*)malloc(sizeof(battle));
  battle0->attackStrength  = 0;
  battle0->defenseStrength = 0;
  battle0->locationAttack  = NULL;
  battle0->text            = (char*)malloc(4096*sizeof(char));
  strcpy(battle0->text, "\n");
  strcat(battle0->text, "  Friends:\n");
  
  // we duplicate the lista of units because some of them will die and it's a pain to destroy them in the lists while we are pqrsing one of them.
  battle0->attackerlist = list_create(LISTCOUNT_T_MAX);
  lnode_t *ln = list_first(inspector->ul);
  while (ln!=NULL && ln != &inspector->ul->list_nilnode) {
    unit *uni = (unit *)ln->list_data;
    list_append(battle0->attackerlist, lnode_create(uni));
    ln = ln->list_next;
  }    
  
  battle0->defenderlist = list_create(LISTCOUNT_T_MAX);
  ln = list_first(inspector->opponentl);
  while (ln!=NULL && ln != &inspector->opponentl->list_nilnode) {
    unit *uni = (unit *)ln->list_data;
    list_append(battle0->defenderlist, lnode_create(uni));
    ln = ln->list_next;
  }    
  
  // float retreatAtt        = 1.0f;

  if (inspector->ul!=NULL && list_count(inspector->ul)>0) {
    ln = list_first(inspector->ul);
    battle0->locationAttack = ((unit *)ln->list_data)->location;
    while (ln != &inspector->ul->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      battle0->attacker  = uni->owner;
      ln = ln->list_next;
      nb++;
      int strength = getBattleStrength(uni, battle0->locationAttack, TRUE);

      //char* text = (char *)malloc(32*sizeof(char));
      //getUnitText(uni, text);
      strcat(battle0->text, "   ");
      strcat(battle0->text, getUnitText(uni));
      char descr[50];
      sprintf (descr, " %i*%i", strength, uni->health);
      strcat(battle0->text, descr);
      strcat(battle0->text, "(");
      int i;
      for (i=0; i<uni->experience; i++)
        strcat(battle0->text, "*");
      //free(text);
      strcat(battle0->text, ")\n");
      battle0->attackStrength += strength*uni->health;
    }
  }
  strcat(battle0->text, "   ------------\n");
  char descr[50];
  sprintf (descr, "   Total(%i) : %i\n", nb, battle0->attackStrength);
  strcat(battle0->text, descr);

  nb                  = 0;
  strcat(battle0->text, "  Opponents:\n");
  if (inspector->opponentl!=NULL &&list_count(inspector->opponentl)>0) {
    lnode_t *ln = list_first(inspector->opponentl);
    battle0->locationDefense = ((unit *)ln->list_data)->location;
    while (ln != &inspector->opponentl->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      battle0->defender  = uni->owner;
      ln = ln->list_next;
      nb++;
      int strength = getBattleStrength(uni, battle0->locationAttack, FALSE);
      //char* text = (char *)malloc(32*sizeof(char));

      strcat(battle0->text, "   ");
      strcat(battle0->text, getUnitText(uni));
      char descr[50];
      sprintf (descr, " %i*%i", strength, uni->health);
      strcat(battle0->text, descr);
      strcat(battle0->text, "(");
      int i;
      for (i=0; i<uni->experience; i++)
        strcat(battle0->text, "*");
      strcat(battle0->text, ")\n");
      battle0->defenseStrength += strength*uni->health;
    }
  }

  battle0->attackBonusMalus = 1;
  if (battle0->locationAttack->elevation>battle0->locationDefense->elevation)
    battle0->attackBonusMalus = battle0->attackBonusMalus*(1.0f+(battle0->locationAttack->elevation-battle0->locationDefense->elevation)/2.0f);
  else if (battle0->locationAttack->elevation<battle0->locationDefense->elevation)
    battle0->attackBonusMalus = battle0->attackBonusMalus*(1.0f-(battle0->locationDefense->elevation-battle0->locationAttack->elevation)/5.0f);

  battle0->defenseBonusMalus = 1;
  if (battle0->locationDefense->ground==SWAMP)
    battle0->defenseBonusMalus = battle0->defenseBonusMalus*0.75f;
  if (battle0->locationDefense->vegetation<0)
    battle0->defenseBonusMalus = battle0->defenseBonusMalus*(1+(battle0->locationDefense->vegetation/100));

  strcat(battle0->text, "   ------------\n");
  sprintf (descr, "   Total(%i) : %i\n", nb, battle0->defenseStrength);
  strcat(battle0->text, descr);
  sprintf (descr, "  Terrain elevation %i - %i\n", battle0->locationAttack->elevation, battle0->locationDefense->elevation);
  strcat(battle0->text, descr);
  //printf ("prepareBattle %f - %f\n", battle0->attackBonusMalus, battle0->defenseBonusMalus);
  return battle0;
}// prepareBattle() --------------------------------------------------------------------


/**
 * return how much the given city would buy this stuff to player0
 * return -1 if refuse to buy
 */
int getGlobalPrice(int goodType){
  if (goodType==WHEAT || goodType==LUMBER)
    return 4;
  else if (goodType==GOLD || goodType==SILVER)
    return 25;
  else if (goodType==PEARL || goodType==GEM)
    return 20;
  if (goodType==MUSKET)
    return 16;
  if (goodType==TOOL)
    return 10;
  if (goodType>=FIRST_GOOD && goodType<=LAST_RAW_GOOD)
    return 6;
  else
    return 15;
}// getGlobalPrice()


/**
 * return how much the given city would buy this stuff to player0
 * return -1 if refuse to buy
 */
int getBuyPriceFor(int goodType, city *c, player *p0){
  //printf("getBuyPriceFor(%s, %s, %s) \n", goodTexts[goodType-FIRST_GOOD], c->name, p0->name);
  //printf("  stocks[%s] = %d / %d \n", goodTexts[goodType-FIRST_GOOD], c->stocks[goodType-FIRST_GOOD].quantity, getMaxQuantity(c, goodType));

  player *buyer = c->owner;

  // really don't need that
  if (c->stocks[goodType-FIRST_GOOD].quantity >= getMaxQuantity(c, goodType)-20)
    return -1;

  int price = getGlobalPrice(goodType)-1;

  if (buyer->money<200)
    price = -1;

  // too poor to increase prices
  if (buyer->money<500)
    return price;

  // TODO check food for starving cities
  //if ((goodType==CORN || goodType==RICE || goodType==WHEAT || goodType==FISH) && getFoodStocks(c)<10)
  //  price = 5*price;

  // TODO check relations
  // TODO check muskets for cities under attack

  // very interesting for me !
  if (c->prod[goodType-FIRST_GOOD].quantity<0 && c->stocks[goodType-FIRST_GOOD].quantity <= -1 * c->prod[goodType-FIRST_GOOD].quantity)
    price = price*2;
  else if (c->prod[goodType-FIRST_GOOD].quantity<0)
    price = price*1.4;
  return price;
}// getBuyPriceFor()


/**
 * return how much the given city would sell this stuff to player0
 * return -1 if refuse to sell
 */
int getSellPriceFor(int goodType, city *c, player *p0){
  if (c->stocks[goodType-FIRST_GOOD].quantity==0)
    return -1;
  if (c->prod[goodType-FIRST_GOOD].quantity<0 && c->stocks[goodType-FIRST_GOOD].quantity < -4*c->prod[goodType-FIRST_GOOD].quantity)
    return -1;

  int price = getGlobalPrice(goodType)+1;

  // very interesting for me !
  if (c->prod[goodType-FIRST_GOOD].quantity>0 && c->stocks[goodType-FIRST_GOOD].quantity +4 * c->prod[goodType-FIRST_GOOD].quantity >getMaxQuantity(c, goodType))
    price = price*0.8;
  else if (c->prod[goodType-FIRST_GOOD].quantity<0)
    price = price*1.4;
  return price;
}// getSellPriceFor()


/**
 * find a random port good for immigration
 */
city *pickEmigrationPort(player *king){
  int i;
  int score = -1;
  list_t * cl = king->cityList;
  city *c0 = NULL;
  int nwo = NEW_WORLD_OFFICE;
  int nbtry = 0;
  while (nbtry<100) {
    city *c = NULL;
    nbtry ++;
    int x = rand()%list_count(cl);
    lnode_t *ln = list_first(cl);
    for (i=0; i<x; i++)
      ln = ln->list_next;
    c = (city*)ln->list_data;

    // not a port
    //printf("%s is connected to ocean ? %i\n", c->name, getConnectedToOcean(c->location->posX, c->location->posY));
    if (!getConnectedToOcean(c->location->posX, c->location->posY)) {
      c = NULL;
      continue;
    }

    // no office for emmigration here
    /* ln = list_first(c->buildings);
    while (ln != &c->buildings->list_nilnode){
      //building *b = (building *)ln->list_data;
      printf("  %s has an %i !\n", c->name, b->type);
      ln = ln->list_next;
    }*/
    ln = list_find(c->buildings, &nwo, compareBuildingType);
    //printf("%s has an new world office(%i) ? %p\n", c->name, nwo, ln);
    if (ln==NULL) {
      c = NULL;
      continue;
    }

    // office full
    building *b = (building *)ln->list_data;
    //printf("%s has an new world office with %i/%i slots\n", c->name, list_count(b->workers), b->slots);
    if (list_count(b->workers)>=b->slots){
      c = NULL;
      continue;
    }
    
    int cscore = MapWidth - c->location->posX;
    if (cscore>score){
      score = cscore;
      c0 = c;
    }
    //printf("we chose %s\n", c->name);fflush(stdout);
  }
  return c0;
}//pickImmigrationPort ()


/**
 * finish turn and prepare the next one.
 */
void finishTurn (){
  int i, j;
  srand((unsigned int)time(0));

  if (currentPlayerElement==NULL || gamemode != PLAY)
    return;
  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  list_t  *allUnitList   = currentPlayer->unitList;

  //updatesInfluencesForAll();

  // update fog of war
  for (i=0; i<MapWidth; i++)
    for (j=0; j<MapHeight; j++) {
      if (map[i+MapWidth*(j)].lastExplored>=0)
        map[i+MapWidth*(j)].lastExplored++;
    }

  updatesPioneerOrders();

  // update all city production
  lnode_t *ln = list_first(currentPlayer->cityList);
  while (ln!=NULL && ln !=  &currentPlayer->cityList->list_nilnode) {
    city *c = (city *)ln->list_data;
    //printf("for the city %s  there are %i crosses \n", c->name, c->stocks[CROSS-FIRST_GOOD].quantity);
    if (currentPlayer->religion>=FREE_RELIGION && currentPlayer->religion<=SOFT_CATHOLICISM)
      currentPlayer->totalCrosses += c->stocks[CROSS-FIRST_GOOD].quantity;
    else
      currentPlayer->totalCrosses -= c->stocks[CROSS-FIRST_GOOD].quantity;
    c->stocks[CROSS-FIRST_GOOD].quantity = 0;
    updateCityProduction(c);
    ln = ln->list_next;
  }

  // compute religious emigration
  if (isColony(currentPlayer->nation)) {
    int nb = nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION]->totalCrosses;
    //printf("for the colony of %s we have %i when the mothercountry only have %i crosses\n", currentPlayer->name, currentPlayer->totalCrosses, nb);
    if (currentPlayer->totalCrosses-nb>=CROSSES_FOR_NEW_COLONIST) {
      player *myKing = nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION];
      city *c = pickEmigrationPort(myKing);
      if (c!=NULL) {
        srand(apptime+currentPlayer->nation+list_count(currentPlayer->unitList)+list_count(currentPlayer->cityList));
        int nu = rand();
        nu = FIRST_UNIT+nu%(LAST_EUROPEAN_UNIT-FIRST_UNIT);
        nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION]->totalCrosses+=100;
        unit* u = createUnit(FIRST_UNIT+rand()%(LAST_EUROPEAN_UNIT-FIRST_UNIT), myKing);
        addUnitToBuilding(u, c, NEW_WORLD_OFFICE);
      }
    }
  }

  // play the other players as AI, local or network
  lnode_t *playerelem = currentPlayerElement->list_next;
  while (playerelem != &playerList->list_nilnode) {
    player *playerNoi = (player *)playerelem->list_data;
    //printf("Playing ... %s\n", playerNoi->name);
    playAI(playerNoi);
    ln = list_first(playerNoi->cityList);
    while (ln!=NULL && ln !=  &playerNoi->cityList->list_nilnode) {
      city *c = (city *)ln->list_data;
      if (playerNoi->religion>=FREE_RELIGION && playerNoi->religion<=SOFT_CATHOLICISM)
        playerNoi->totalCrosses += c->stocks[CROSS-FIRST_GOOD].quantity;
      else
        playerNoi->totalCrosses -= c->stocks[CROSS-FIRST_GOOD].quantity;
      c->stocks[CROSS-FIRST_GOOD].quantity = 0;
      updateCityProduction(c);
      ln = ln->list_next;
    }
    playerelem = playerelem->list_next;
  }

  apptime++;

  playerelem = list_first(playerList);
  while (playerelem != currentPlayerElement) {
    player *playerNoi = (player *)playerelem->list_data;
    //printf("Playing ... %s\n", playerNoi->name);
    playAI(playerNoi);
    ln = list_first(playerNoi->cityList);
    while (ln!=NULL && ln !=  &playerNoi->cityList->list_nilnode) {
      city *c = (city *)ln->list_data;
      if (playerNoi->religion>=FREE_RELIGION && playerNoi->religion<=SOFT_CATHOLICISM)
        playerNoi->totalCrosses += c->stocks[CROSS-FIRST_GOOD].quantity;
      else
        playerNoi->totalCrosses -= c->stocks[CROSS-FIRST_GOOD].quantity;
      c->stocks[CROSS-FIRST_GOOD].quantity = 0;
      updateCityProduction(c);
      ln = ln->list_next;
    }
    playerelem = playerelem->list_next;
  }

  //updatesLastExplored();

  allUnitList   = currentPlayer->unitList;

  ln = list_first(allUnitList);
  while (ln!=NULL && ln !=  &allUnitList->list_nilnode) {
    unit *unitNoi = (unit *)ln->list_data;
    if (unitNoi->owner==currentPlayer)
      unitNoi->movement = unitNoi->maxMovement;
    ln = ln->list_next;
  }

  ln = list_first(currentPlayer->unitList);
  while (ln!=NULL && ln != &currentPlayer->unitList->list_nilnode){
    unit *unitNoi = (unit*)ln->list_data;
    if (unitNoi->status==GOINGTO && unitNoi->group!=NULL){
      updatesGotoOrders(unitNoi->group);
    } else if (unitNoi->status==GOINGTO) {
      list_t *ul = list_create(LISTCOUNT_T_MAX);
      list_append(ul, lnode_create(unitNoi));
      updatesGotoOrders(ul);
      list_destroy_nodes(ul);
      list_destroy(ul);
    }
    ln = ln->list_next;
  }
  updateMiniMap();
  //updatesGotoOrders(currentPlayer->unitList);
  updatesLastExplored();
  updatesCache(-1, -1, -1, -1);
}// finishTurn()


/**
 * a timer callback posting an event in the queue
 */
Uint32 press_callbackfunc(Uint32 interval, void *param) {
  if (isDrag==UNIT && unitSelectionList!=NULL) {
    list_t *l = copylist(unitSelectionList);
    updateMovecache(unitSelectionList);
    list_destroy_nodes(l);
    list_destroy(l);
  }
  //printf("timer stopped by finishing \n");
  press_timer_id = NULL;
  return 0;
}// press_callbackfunc()


/**
 * a timer callback posting an event in the queue
 */
Uint32 event_callbackfunc(Uint32 interval, void *param) {
  //printf("----NEW event_callbackfunc EVENT--- %d \n", interval);
  SDL_Event *events = (SDL_Event *)malloc(sizeof(SDL_Event));
  int nbevts = SDL_PeepEvents(events, 1, SDL_PEEKEVENT, SDL_EVENTMASK(SDL_USEREVENT));
  if (nbevts==0) {
    SDL_Event event;
    SDL_UserEvent userevent;

    userevent.type = SDL_USEREVENT;
    userevent.code = 0;
    userevent.data1 = NULL;
    userevent.data2 = NULL;

    event.type = SDL_USEREVENT;
    event.user = userevent;

    SDL_PushEvent(&event);
  }
  return(interval);
}// event_callbackfunc()


/**
 * global mouseMoved function, will forward to specialied or treat the event if global
 */
void mouseMoved(SDL_Event *event, Uint32 time){
  mouseMovedX = event->motion.x;
  mouseMovedY = event->motion.y;

  if (popupType&POPUP_ISVISIBLE && popupOptionList!=NULL) {
    computePopupSize();
    int x = mousePressedX-popupRect->w/2;
    int y = mousePressedY-popupRect->h/2;
    if (x<0) x=0;
    if (x+popupRect->w>=screen->w) y=screen->w-popupRect->w-1;
    if (y<0) y=0;
    if (y+popupRect->h>=screen->h) y=screen->h-popupRect->h-1;

    if (popupType&POPUP_ISMENU)
      mouseMovedPopup(event->motion.x-x, event->motion.y-y);
    else
      mouseMovedPopup(event->motion.x-screen->w/2+popupRect->w/2, event->motion.y-screen->h/2+popupRect->h/2);

  } else if (selectedCity!=NULL && isInCityView(mouseX, mouseY)){
    mouseMovedCV(selectedCity, event->motion.x-cityViewRect->x, event->motion.y-cityViewRect->y);
  }
}// mouseMoved()


/**
 * global mousePressed function, will forward to specialied or treat the event if global
 */
void mousePressed(SDL_Event *event, Uint32 time){
  //printf("mousePressed() %i   %i   %i\n", lastMouseDownTime, lastMouseUpTime, time);
  //printf("   at %i , %i   %i times\n", mouseX, mouseY, nbClick);
  //printf("   %i / %i or %i \n", modifier, KMOD_RCTRL, KMOD_LCTRL);
  //printf("   %i / %i \n", gamemode, EDIT  );
  //printf("   %i / %i \n", (lastMouseUpTime-lastMouseDownTime), (time-lastMouseUpTime));
  isMousePressed = 1;
  mousePressedX = event->motion.x;
  mousePressedY = event->motion.y;

  // computes number of consecutive clicks in the same tile and fast enough to be multiple clicks
  //printf("mousePressed(%i)  MDT=%i(@ %i,%i)   MUT%i(@ %i,%i)  NOW=%i(@ %i,%i)\n", nbClick, lastMouseDownTime, lastMouseDownLocX, lastMouseDownLocY, lastMouseUpTime, lastMouseUpLocX, lastMouseUpLocY, time, event->motion.x, event->motion.y);
  int i          = (event->motion.x/TILESIZE)+firstVisibleTileX;
  int j          = (event->motion.y/TILESIZE)+firstVisibleTileY;
  if (lastMouseUpTime-lastMouseDownTime < 200 && time-lastMouseUpTime<500 &&
      lastMouseDownLocX==lastMouseUpLocX && lastMouseDownLocY==lastMouseUpLocY &&
      lastMouseDownLocX == event->motion.x && lastMouseDownLocY == event->motion.y)
    nbClick++;
  else
    nbClick = 1;
  //printf("   nbClick=%i\n", nbClick);

  //update global variables
  lastMouseDownTime = time;
  lastMouseDownLocX = event->motion.x;
  lastMouseDownLocY = event->motion.y;
  mouseX         = event->motion.x;
  mouseY         = event->motion.y;
  int oldnbsel   = list_count(unitSelectionList);
  unit *ou       = NULL;
  if (oldnbsel>0)
    ou = (unit *)list_first(unitSelectionList)->list_data;

  // click on an options in a popup
  if(popupType&POPUP_ISVISIBLE && popupOptionList!=NULL && selectedOption!=NULL) {
    //printf("reset popup because popupType=%i\n", popupType);
    //int i = (mouseX/TILESIZE)+firstVisibleTileX;
    //int j = (mouseY/TILESIZE)+firstVisibleTileY;
    activatePopup();

    return;
  // click away from options in a popup menu we should close
  } else if (popupType&POPUP_ISVISIBLE && popupType&POPUP_ISMENU && popupOptionList!=NULL) {
    //printf("reset popup because popupType=%i\n", popupType);
    discardPopup();
    return;
  } else if (popupType&POPUP_ISVISIBLE) {
    return;
  }

  /* if (map[i+MapWidth*(j)].unitList!=NULL && !list_isempty(map[i+MapWidth*(j)].unitList) && (
    ((unit*)list_first(map[i+MapWidth*(j)].unitList)->list_data)->owner==currentPlayer || gamemode==EDIT)) {
    if (modifier&KMOD_LCTRL||modifier&KMOD_RCTRL) */
  //printf("mousedown %i, %i => ul=%p[%i]   modifier=%i\n", mouseX, mouseY, map[i+MapWidth*(j)].unitList, list_count(map[i+MapWidth*(j)].unitList), modifier);

  // right click on the selection
  if (ou!=NULL && ou->location!=NULL && event->button.button == SDL_BUTTON_RIGHT && oldnbsel>0 && ou->location->posX==i && ou->location->posY==j) {
    discardPopup();

    popupType     = POPUP_MENU;
    popupUnitList = list_create(LISTCOUNT_T_MAX);
    lnode_t *ln = list_first(unitSelectionList);
    int founder = FALSE;
    int pioneer = FALSE;
    int soldier = FALSE;
    int group   = FALSE;
    while(ln!=NULL&&ln!=&unitSelectionList->list_nilnode) {
      unit *u = (unit *)ln->list_data;
      if (u->type>=FIRST_UNIT && u->type<=LAST_SPECIALTY)
        founder = TRUE;
      if (u->tools>=20)
        pioneer = TRUE;
      if (u->muskets>=50)
        soldier = TRUE;
      if (u->group != NULL)
        group = TRUE;
      list_append(popupUnitList, lnode_create(u));
      ln = ln->list_next;
    }
    if (pioneer) {
      addPopupOption("Plow", doPlow);
      addPopupOption("Road", doRoad);
      addPopupOption("Mine", doMine);
    }
    if (founder)
      addPopupOption("Found City...", doAskCityNameAndBuild);

    if (soldier)
      addPopupOption("Fortify", doFortify);

    if (group)
      addPopupOption("Ungroup", doUngroup);
    else
      addPopupOption("Group", doGroup);

    addPopupOption("Clear Orders", doWait);
    addPopupOption("Go To...", doAskCityNameAndGoto);
    preSelectMiddleOptionPopup();
  // click in the minimap
  } else if (isInMinimapView(mouseX, mouseY))  {
    mousePressedMM(mouseX-minimapRect->x, mouseY-minimapRect->y, event->button.button, nbClick);
  } else if(isInAnyUnitView(mouseX, mouseY) && event->button.button==SDL_BUTTON_LEFT) {
    druv = getUnitView(mouseX, mouseY);
    mousePressedUV(druv, mouseX-druv->rect->x, mouseY-druv->rect->y);
  } else if (selectedCity!=NULL && isInCityView(mouseX, mouseY)) {
    mousePressedCV(selectedCity, mouseX-cityViewRect->x, mouseY-cityViewRect->y, event->button.button, nbClick);
  } else if (map[i+MapWidth*(j)].construction!=NULL && map[i+MapWidth*(j)].construction->size>0 &&nbClick==2 && event->button.button==SDL_BUTTON_LEFT) {
    openCityView(map[i+MapWidth*(j)].construction);
  } else if (gamemode==EDIT && editmode!=E_UNIT && event->button.button == SDL_BUTTON_LEFT && (modifier == KMOD_RCTRL || modifier == KMOD_LCTRL)) {
    copytile = &map[i+MapWidth*(j)];
  } else  if (gamemode==EDIT && editmode == E_UNIT && event->button.button == SDL_BUTTON_WHEELDOWN && inspector->ul!=NULL && list_count(inspector->ul)>0 && (modifier == KMOD_RMETA || modifier == KMOD_LMETA)) {
    unit *u = (unit *)list_first(inspector->ul)->list_data;
    if (u->horses==0 && u->muskets==0 && u->tools==0) {}
    else if (u->horses==50 && u->muskets==0 && u->tools==0)
      removeHorses(u);
    else if (u->horses==0 && u->muskets==50 && u->tools==0) {
      addHorses(u);
      u->muskets=0;
    }  else if (u->horses==50 && u->muskets==50 && u->tools==0)
      removeHorses(u);
    else if (u->tools>0) {
      addHorses(u);
      u->muskets=50;
      u->tools=0;
    }
  } else  if (gamemode==EDIT && editmode == E_UNIT && event->button.button == SDL_BUTTON_WHEELUP && inspector->ul!=NULL && list_count(inspector->ul)>0 && (modifier == KMOD_RMETA || modifier == KMOD_LMETA)) {
    unit *u = (unit *)list_first(inspector->ul)->list_data;
    if (u->horses==0 && u->muskets==0 && u->tools==0) {
      addHorses(u);
    } else if (u->horses==50 && u->muskets==0 && u->tools==0) {
      removeHorses(u);
      u->muskets=50;
    } else if (u->horses==0 && u->muskets==50 && u->tools==0) {
      addHorses(u);
    }  else if (u->horses==50 && u->muskets==50 && u->tools==0) {
      removeHorses(u);
      u->muskets=0;
      u->tools=100;
    }

  } else  if (gamemode==EDIT && editmode == E_UNIT && event->button.button == SDL_BUTTON_WHEELDOWN && inspector->ul!=NULL && list_count(inspector->ul)>0) {
    unit *u = (unit *)list_first(inspector->ul)->list_data;
    if (u->type>FIRST_UNIT)
      u->type--;
  } else  if (gamemode==EDIT && editmode == E_UNIT && event->button.button == SDL_BUTTON_WHEELUP && inspector->ul!=NULL && list_count(inspector->ul)>0) {
    unit *u = (unit *)list_first(inspector->ul)->list_data;
    if (u->type<LAST_UNIT)
      u->type++;
  } else  if (gamemode==EDIT && editmode == E_FOREST && event->button.button == SDL_BUTTON_WHEELDOWN) {
    if (map[i+MapWidth*(j)].vegetation<IRRIGATION) {
      map[i+MapWidth*(j)].vegetation+=20;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }
  } else if (gamemode==EDIT && editmode == E_FOREST && event->button.button == SDL_BUTTON_WHEELUP) {
    if (map[i+MapWidth*(j)].vegetation>FOREST) {
      map[i+MapWidth*(j)].vegetation-=20;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }
  } else  if (gamemode==EDIT && editmode == E_ALTITUDE && event->button.button == SDL_BUTTON_WHEELDOWN && (modifier == KMOD_LMETA || modifier == KMOD_RMETA)) {
    if (map[i+MapWidth*(j)].elevation>OCEAN1) {
      int dx, dy;
      map[i+MapWidth*(j)].elevation--;
      for (dx=-3; dx<4; dx++)
        for (dy=-3; dy<4; dy++) {
          float d = sqrt((float)dx*dx+dy*dy);
          if (i+dx>=0 && i+dx<MapWidth && j+dy>=0 && j+dy<MapHeight && map[i+dx+MapWidth*(j+dy)].elevation>map[i+MapWidth*(j)].elevation+ceil(d))
            map[i+dx+MapWidth*(j+dy)].elevation = map[i+MapWidth*(j)].elevation+(int)ceil(d);
        }
          for (dx=-4; dx<5; dx++)
            for (dy=-4; dy<5; dy++)
              if (i+dx>=0 && i+dx<MapWidth && j+dy>=0 && j+dy<MapHeight)
                updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }
  } else if (gamemode==EDIT && editmode == E_ALTITUDE && event->button.button == SDL_BUTTON_WHEELUP && (modifier == KMOD_LMETA || modifier == KMOD_RMETA)) {
    if (map[i+MapWidth*(j)].elevation<HIGHMOUNTAIN) {
      int dx, dy;
      map[i+MapWidth*(j)].elevation++;
      for (dx=-3; dx<4; dx++)
        for (dy=-3; dy<4; dy++) {
          float d = sqrt((float)dx*dx+dy*dy);
          if (i+dx>=0 && i+dx<MapWidth && j+dy>=0 && j+dy<MapHeight && map[i+dx+MapWidth*(j+dy)].elevation<map[i+MapWidth*(j)].elevation-ceil(d))
            map[i+dx+MapWidth*(j+dy)].elevation = map[i+MapWidth*(j)].elevation-(int)ceil(d);
        }
          for (dx=-4; dx<5; dx++)
            for (dy=-4; dy<5; dy++)
              if (i+dx>=0 && i+dx<MapWidth && j+dy>=0 && j+dy<MapHeight)
                updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }
  } else  if (gamemode==EDIT && editmode == E_BONUS && event->button.button == SDL_BUTTON_WHEELDOWN) {
    if (map[i+MapWidth*(j)].bonus>0) {
      map[i+MapWidth*(j)].bonus--;
      updatesCachedTileAt(i, j);
    }
  } else  if (gamemode==EDIT && editmode == E_BONUS && event->button.button == SDL_BUTTON_WHEELUP) {
    if (map[i+MapWidth*(j)].bonus<4) {
      map[i+MapWidth*(j)].bonus++;
      updatesCachedTileAt(i, j);
    }
  } else  if (gamemode==EDIT && editmode == E_GROUND && event->button.button == SDL_BUTTON_WHEELDOWN) {
    if (map[i+MapWidth*(j)].ground>FIRST_GROUND) {
      map[i+MapWidth*(j)].ground--;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
    }
  } else  if (gamemode==EDIT && editmode == E_GROUND && event->button.button == SDL_BUTTON_WHEELUP) {
    if (map[i+MapWidth*(j)].ground<LAST_EDIT_GROUND) {
      map[i+MapWidth*(j)].ground++;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
    }
  } else  if (gamemode==EDIT && editmode == E_ALTITUDE && event->button.button == SDL_BUTTON_WHEELDOWN) {
    if (map[i+MapWidth*(j)].elevation>OCEAN1) {
      map[i+MapWidth*(j)].elevation--;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }
  } else if (gamemode==EDIT && editmode == E_ALTITUDE && event->button.button == SDL_BUTTON_WHEELUP) {
    if (map[i+MapWidth*(j)].elevation<HIGHMOUNTAIN) {
      map[i+MapWidth*(j)].elevation++;
      int dx, dy;
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(i+dx, j+dy);
      updateMiniMap();
    }

  // click on some units !
  }  else if (map[i+MapWidth*(j)].lastExplored>=0 && map[i+MapWidth*(j)].unitList!=NULL && !list_isempty(map[i+MapWidth*(j)].unitList) && event->button.button==SDL_BUTTON_LEFT) {
    // double click on the selection. Select ALL the units there
    if ( unitSelectionList!=NULL && list_count(unitSelectionList)>0 && !(modifier&KMOD_LCTRL) && !(modifier&KMOD_RCTRL) &&
         &map[i+MapWidth*(j)] == ou->location && nbClick==2 && (gamemode==EDIT || map[i+MapWidth*(j)].lastExplored==0)) {
      selectedCity = NULL;
      list_destroy_nodes(unitSelectionList);
      copylistTo(map[i+MapWidth*(j)].unitList, unitSelectionList);

      list_t *ul = list_create(LISTCOUNT_T_MAX);

      lnode_t *ln = list_first(unitSelectionList);
      while (ln != &unitSelectionList->list_nilnode) {
        unit *u = (unit*)ln->list_data;
        if (u->group!=NULL)
          resetGroup(u->group);
        list_append(ul, lnode_create(u));
        u->group = ul;
        ln = ln->list_next;
      }
      //updateMovecache(unitSelectionList);
      resetMovecache();
      updatesInspector(unitSelectionList, NULL);
      isDrag = UNIT;
      return;
    // reclick on the selection. Do nothing but return to the drag mode
    } else if ( unitSelectionList!=NULL && list_count(unitSelectionList)>0 && !(modifier&KMOD_LCTRL) && !(modifier&KMOD_RCTRL) &&
         &map[i+MapWidth*(j)] == ou->location && (gamemode==EDIT || map[i+MapWidth*(j)].lastExplored==0)) {
      selectedCity = NULL;
      //updateMovecache(unitSelectionList);
      resetMovecache();
      isDrag = UNIT;
      return;
      // click on units
    } else if (!(modifier&KMOD_LCTRL) && !(modifier&KMOD_RCTRL)) {
      unitSelectionList    = defaultSelectionList;
      list_destroy_nodes(unitSelectionList);
      //ctrl click on an other tile with others units
    } else if (unitSelectionList!=NULL && list_count(unitSelectionList)>0 &&
               &map[i+MapWidth*(j)] != ou->location &&
               ((modifier&KMOD_LCTRL) || (modifier&KMOD_RCTRL))) {
      unitSelectionList    = defaultSelectionList;
      list_destroy_nodes(unitSelectionList);
    }
    // append to the selection list
    if (modifier&KMOD_LCTRL || modifier&KMOD_RCTRL) {
      lnode_t *elem = list_first(map[i+MapWidth*(j)].unitList);
      while(elem != &map[i+MapWidth*(j)].unitList->list_nilnode)  {
        unit *u = (unit*)elem->list_data;
        if (!list_find(unitSelectionList, u, straightCompare)) {
          //printf("before we append %i + u%i\n", list_count(unitSelectionList), u->type);
          if (list_count(unitSelectionList)==1){
            list_t *ul = list_create(LISTCOUNT_T_MAX);
            list_append(ul, lnode_create(u));
            unit *prevu = (unit *)list_first(unitSelectionList)->list_data;
            list_append(ul, lnode_create(prevu));
            if (u->group!=NULL)
              resetGroup(u->group);
            if (prevu->group!=NULL)
              resetGroup(prevu->group);
            prevu->group = ul;
            u->group = ul;
          }
          list_prepend(unitSelectionList, lnode_create(u));
          break;
        }
        elem = elem->list_next;
      }

      if (!list_isempty(unitSelectionList)) {
        unit *nu = (unit *)list_first(unitSelectionList)->list_data;
        if (oldnbsel==list_count(unitSelectionList)&&ou->location->posX==nu->location->posX&& ou->location->posY== nu->location->posY) {
          // nothing new, we reselected the same list. Let's permute to have an other unit on top
          elem = list_last(unitSelectionList);
          list_delete(unitSelectionList, elem);
          list_prepend(unitSelectionList, elem);
          elem = list_last(map[i+MapWidth*(j)].unitList);
          list_delete(map[i+MapWidth*(j)].unitList, elem);
          list_prepend(map[i+MapWidth*(j)].unitList, elem);
          unit *lastUnit = (unit *)list_last(map[i+MapWidth*(j)].unitList)->list_data;
        }
      }
      // refresh the inspector !!!!!!!!
      updatesInspector(unitSelectionList, NULL);
    
    // we have to select the last unit 
    } else if (gamemode==EDIT || map[i+MapWidth*(j)].lastExplored==0) {
      lnode_t *elem = list_last(map[i+MapWidth*(j)].unitList);
      unit *u = (unit*)elem->list_data;
      if (u->group!=NULL) {
        copylistTo(u->group, unitSelectionList);
      } else
        list_append(unitSelectionList, lnode_create(u));
      /*
      while(elem != &map[i+MapWidth*(j)].unitList->list_nilnode)  {
        u = (unit*)elem->list_data;
        //if ((u->owner==currentPlayer || gamemode==EDIT) ) {
        list_append(unitSelectionList, lnode_create(u));
        //break;
        //}
        elem = elem->list_prev;
      }*/

      if (unitSelectionList!=NULL && list_count(unitSelectionList)>0)
        updatesInspector(unitSelectionList, NULL);
    }
    selectedCity = NULL;
    isDrag = UNIT;
    //updateMovecache(unitSelectionList);
    resetMovecache();

  // click on the ground where there is no unit !
  } else if (map[i+MapWidth*(j)].lastExplored>=0 && event->button.button==SDL_BUTTON_LEFT){
    FVTx = firstVisibleTileX+(mouseX/TILESIZE);
    FVTy = firstVisibleTileY+(mouseY/TILESIZE);

    unitSelectionList    = defaultSelectionList;
    list_destroy_nodes(unitSelectionList);
    updatesInspector(NULL, NULL);
    inspector->t = &map[FVTx+MapWidth*(FVTy)];

    if (!noSound) {
      int oldsoundID = soundID;
      //printf("NOW PLAY SOUND ambianceChannelID=%i\n", ambianceChannelID);
      //printf("  oldsoundID=%d\n", soundID);

      soundID = NONE;
      if (map[FVTx+MapWidth*(FVTy)].elevation < SEALEVEL ) {
        soundID = OCEAN_SOUND;
      } else if (map[FVTx+MapWidth*(FVTy)].vegetation<0 && map[FVTx+MapWidth*(FVTy)].ground==SAVANNAH){
        soundID = SAVANNAHFOREST_SOUND;
      } else if (map[FVTx+MapWidth*(FVTy)].vegetation<0 && map[FVTx+MapWidth*(FVTy)].ground==GRASSLAND){
        soundID = GRASSLANDFOREST_SOUND;
      }
     // printf("  new soundID=%d\n", soundID);

      if (oldsoundID != soundID && ambianceChannelID!=-1){
        //printf("  STOPPING ambianceChannelID=%i\n", ambianceChannelID);
        Mix_FadeOutChannel(ambianceChannelID, 1000);
        if (ambianceChannelID==ambianceChannel1) ambianceChannelID=ambianceChannel0;
        else if (ambianceChannelID==ambianceChannel0) ambianceChannelID=ambianceChannel1;
      } else
        ambianceChannelID = ambianceChannel0;

      //printf("  new ambianceChannelID=%d \n", ambianceChannelID);

      if (oldsoundID != soundID && soundID!=NONE) {
        //printf("  STARTING ambianceChannelID=%d soundID=%d\n", ambianceChannelID, soundID);
        Mix_Volume(ambianceChannelID, 128);
        Mix_FadeInChannel(ambianceChannelID, natureSounds[soundID-FIRST_SOUND], -1, 1000);
        if (ambianceChannelID<0)
          printf(" error due to %s\n", SDL_GetError());
      } else if (soundID==NONE) {
        //Mix_FadeOutChannel(ambianceChannelID, 1000);
        ambianceChannelID = -1;
      }
    }

    selectedCity = NULL;
    isDrag = MAP;
    // click on an unknown background
  } else if (event->button.button==SDL_BUTTON_LEFT){
    FVTx = firstVisibleTileX+(mouseX/TILESIZE);
    FVTy = firstVisibleTileY+(mouseY/TILESIZE);
    selectedCity = NULL;
    isDrag = MAP;
    // right click somewhere is a shortcup for "going to"
  } else if (unitSelectionList!=NULL && list_count(unitSelectionList)>0 && event->button.button==SDL_BUTTON_RIGHT && (i!=ou->location->posX || j!=ou->location->posY)){
    lnode_t *unitelem = list_first(unitSelectionList);
    while (unitelem != &unitSelectionList->list_nilnode) {
      unit *unitNoi = (unit *)unitelem->list_data;
      if (unitNoi->location->posX != i ||  unitNoi->location->posY != j) {
        resetStatus(unitNoi);
        if (unitNoi->itinerary!=NULL){
          list_destroy_nodes(unitNoi->itinerary);
          list_destroy(unitNoi->itinerary);
        }

        unitNoi->itinerary = (list_t *)astarSearch(unitNoi->location->posX, unitNoi->location->posY, i, j, unitNoi);
        if (unitNoi->itinerary!=NULL){
          unitNoi->status = GOINGTO;
          unitNoi->destination = &map[i+MapWidth*(j)];
        }
      }
      unitelem = unitelem->list_next;
    }
    updatesGotoOrders(unitSelectionList);
    updateMiniMap();
    unitelem = list_first(unitSelectionList);
    unit *u = (unit *)unitelem->list_data;
    if (!(popupType&POPUP_ISVISIBLE) && u->destination != NULL)
      selectNextWaitingUnit();
  }
}// mousePressed();


/**
 * global mouseDragged function, will forward to specialied or treat the event if global
 */
void mouseDragged(SDL_Event *event, Uint32 time){
  //printf("mouseDragged() %i   %i   %i\n", lastMouseDownTime, lastMouseUpTime, time);

  if (popupType&POPUP_ISVISIBLE && popupOptionList!=NULL) {
    if (popupType&POPUP_ISMENU)
      mouseMovedPopup(event->motion.x-mousePressedX+popupRect->w/2, event->motion.y-mousePressedY+popupRect->h/2);
    else
      mouseMovedPopup(event->motion.x-screen->w/2+popupRect->w/2, event->motion.y-screen->h/2+popupRect->h/2);

    return;
  } else if (isDrag==DRAGMAP || isDrag==MINIPOS)  {
    mouseDraggedMM(mouseX-minimapRect->x, mouseY-minimapRect->y, event->button.button, nbClick);
  } else if (isDrag==INNERCITYVIEW) {
    mouseDraggedCV(selectedCity, mouseX-cityViewRect->x, mouseY-cityViewRect->y);
    // we are dragging something from a unit view to a city view
  } else if (isDrag==INNERUNITVIEW && selectedCity!=NULL && isInCityView(mouseX, mouseY)) {
    mouseDragCV(selectedCity, druv, mouseX-cityViewRect->x, mouseY-cityViewRect->y);
  } else if (isDrag==INNERCITYVIEW && selectedCity!=NULL && isInAnyUnitView(mouseX, mouseY)) {
    unitview *uv = getUnitView(mouseX, mouseY);
    if (uv!=NULL)
      mouseDragUV(uv, selectedCity, mouseX-uv->rect->x, mouseY-uv->rect->y);
  } else if(isDrag==INNERUNITVIEW) {
    mouseDraggedUV(druv, mouseX-druv->rect->x, mouseY-druv->rect->y);
  } else if (isDrag==UNIT) {
    if (unitSelectionList!=NULL && !list_isempty(unitSelectionList)) {
      int destX = (event->motion.x/TILESIZE)+firstVisibleTileX;
      int destY = (event->motion.y/TILESIZE)+firstVisibleTileY;
      lnode_t *unitelem = list_last(unitSelectionList);
      unit *unitNoi = (unit *)unitelem->list_data;
      if (unitNoi->location->posX != destX ||  unitNoi->location->posY != destY) {
        if (displayedItinerary != NULL) {
          list_destroy_nodes(displayedItinerary);
          list_destroy(displayedItinerary);
        }
        displayedItinerary = (list_t *)astarSearch(unitNoi->location->posX, unitNoi->location->posY, destX, destY, unitNoi);
        //printf("res should be %p\n", displayedItinerary);
      }
    }
  } else if (isDrag==MAP) {
    panMap(FVTx-(event->motion.x/TILESIZE), FVTy-(event->motion.y/TILESIZE));
  } else if (isDrag == MINIMAP) {
    //printf("mouseMotion(%i, %i)   %i\n", mouseX, mouseY, isDrag);
    minimapRect->x = innitialDragPosX+event->motion.x-mousePressedX;
    minimapRect->y = innitialDragPosY+event->motion.y-mousePressedY;
    if (minimapRect->x<0)
      minimapRect->x = 0;
    if (minimapRect->y<0)
      minimapRect->y = 0;
    if (minimapRect->x+minimapRect->w>=screen->w)
      minimapRect->x = screen->w-minimapRect->w;
    if (minimapRect->y+minimapRect->h>=screen->h)
      minimapRect->y = screen->h-minimapRect->h;
  }  else if (isDrag == UNITVIEW) {
    //druv->rect->x += event->motion.x-mouseX;
    //druv->rect->y += event->motion.y-mouseY;
    druv->rect->x = innitialDragPosX+event->motion.x-mousePressedX;
    druv->rect->y = innitialDragPosY+event->motion.y-mousePressedY;

    if (druv->rect->x<0)
      druv->rect->x = 0;
    if (druv->rect->y<0)
      druv->rect->y = 0;
    if (druv->rect->x+druv->rect->w>=screen->w)
      druv->rect->x = screen->w-druv->rect->w;
    if (druv->rect->y+druv->rect->h>=screen->h)
      druv->rect->y = screen->h-druv->rect->h;
  } else if (isDrag == CITYVIEW) {
    //cityViewRect->x += event->motion.x-mouseX;
    //cityViewRect->y += event->motion.y-mouseY;
    cityViewRect->x = innitialDragPosX+event->motion.x-mousePressedX;
    cityViewRect->y = innitialDragPosY+event->motion.y-mousePressedY;
    if (cityViewRect->x<0)
      cityViewRect->x = 0;
    if (cityViewRect->y<0)
      cityViewRect->y = 0;
    if (cityViewRect->x+cityViewRect->w>=screen->w)
      cityViewRect->x = screen->w-cityViewRect->w;
    if (cityViewRect->y+cityViewRect->h>=screen->h)
      cityViewRect->y = screen->h-cityViewRect->h;
  } else if(gamemode==EDIT && copytile!=NULL && isMousePressed && (modifier == KMOD_RCTRL  || modifier == KMOD_LCTRL)) {
    int dcx = (event->motion.x%TILESIZE)-TILESIZE/2;
    int dcy = (event->motion.y%TILESIZE)-TILESIZE/2;
    int d = (int)sqrt((float)dcx*dcx+dcy*dcy);
    if (d<=TILESIZE/2) {
      int destX = (event->motion.x/TILESIZE)+firstVisibleTileX;
      int destY = (event->motion.y/TILESIZE)+firstVisibleTileY;
      int dx = destX-copytile->posX;
      int dy = destY-copytile->posY;
      float distToCopyTile = sqrt((float)dx*dx+dy*dy);
      switch(editmode) {
        case E_FOREST   :
          map[destX+MapWidth*(destY)].vegetation = copytile->vegetation;
          break;
        case E_ALTITUDE :
          map[destX+MapWidth*(destY)].elevation  = copytile->elevation;
          break;
        case E_GROUND   :
          map[destX+MapWidth*(destY)].ground     = copytile->ground;
          break;
        case E_TRANSPORT     :
          map[destX+MapWidth*(destY)].road       = copytile->road;
          break;
        case E_BONUS    :
          map[destX+MapWidth*(destY)].bonus      = copytile->bonus;
          break;
        case E_RIVER    :
          //printf("copytile water %p -> %p distToCopyTile=%f?\n", copytile->river_elem, map[destX+MapWidth*(destY)].river_elem, distToCopyTile);
          //printf("  !=null %p and %p ?\n", copytile, copytile->river_elem);
          //printf("  l=%p  r=%p ?\n", copytile->river_elem->left, copytile->river_elem->right);
          //printf("  %p != %p ?\n", copytile, &map[destX+MapWidth*(destY)]);
          //printf("  ==null %p ?\n", map[destX+MapWidth*(destY)].river_elem);

          if (copytile!=NULL && copytile->river_elem!=NULL && (copytile->river_elem->left==NULL || copytile->river_elem->right==NULL) &&
              copytile != &map[destX+MapWidth*(destY)] && map[destX+MapWidth*(destY)].river_elem==NULL && distToCopyTile<1.5) {
            btnode_t     *bte  = copytile->river_elem;
            binarytree_t *tree = bte->tree;
            //printf ("  retrieving river el%p at %i, %i connected to tree %p\n ", bte, copytile->posX, copytile->posY, tree);
            btnode_t     *node = btnode_create(&map[destX+MapWidth*(destY)]);
            if (bte->left==NULL) {
              binarytree_ins_left(tree, bte, node);
            } else if (bte->right==NULL) {
              binarytree_ins_right(tree, bte, node);
            } else {
              printf (" ERROR: Couldn't propagate river from copy tile because node is full of children ! (2)\n ", node, destX, destY, tree, node->tree);
              free(node);
              break;
            }
            map[destX+MapWidth*(destY)].river_elem = node;
            //printf ("0inserted river el%p at %i, %i connected to tree %p|%p\n ", node, destX, destY, tree, node->tree);
            computeRiverSize_r(tree->root);
            //printf ("1inserted river el%p at %i, %i connected to tree %p|%p\n ", node, destX, destY, tree, node->tree);
            copytile = &map[destX+MapWidth*(destY)];
            updateUpRiver_r(tree->root);
          }
          break;
      }
      for (dx=-1; dx<2; dx++)
        for (dy=-1; dy<2; dy++)
          updatesCachedTileAt(destX+dx, destY+dy);
      updateMiniMap();
    }
  }
  mouseX = event->motion.x;
  mouseY = event->motion.y;
}//mouseDragged()


/**
 * global mouseReleased function, will forward to specialied or treat the event if global
 */
void mouseReleased(SDL_Event *event, Uint32 time){
  //printf("mouseReleased() %i   %i   %i\n", lastMouseDownTime, lastMouseUpTime, time);
  isMousePressed  = 0;
  int i           = (event->motion.x/TILESIZE)+firstVisibleTileX;
  int j           = (event->motion.y/TILESIZE)+firstVisibleTileY;
  lastMouseUpTime = time;
  lastMouseUpLocX = event->motion.x;
  lastMouseUpLocY = event->motion.y;
  float d         = sqrt((float)(mousePressedX-event->motion.x)*(mousePressedX-event->motion.x)+
                                (mousePressedY-event->motion.y)*(mousePressedY-event->motion.y));
  mouseX = event->motion.x;
  mouseY = event->motion.y;

  //printf("  mouseUp %i\n", isDrag);
  if (lastMouseUpTime-lastMouseDownTime>1000 && d==0 && map[i+MapWidth*(j)].construction!=NULL && map[i+MapWidth*(j)].construction->size>0 && event->button.button==SDL_BUTTON_LEFT){
    openCityView(map[i+MapWidth*(j)].construction);
  } else if (popupType&POPUP_ISVISIBLE && popupType&POPUP_ISMENU && popupOptionList!=NULL && selectedOption!=NULL && d>5) {
    //printf("reset popup because popupType=%i\n", popupType);
    activatePopup();
  } else if (popupType&POPUP_ISVISIBLE && popupType&POPUP_ISMENU && popupOptionList!=NULL && d<5) {
    //printf("reset popup because popupType=%i\n", popupType);
    //discardPopup();
    // drop something from a unit view in the city view ... maybe a present ? ;-)
  } else if (isDrag==INNERUNITVIEW && selectedCity!=NULL && isInCityView(mouseX, mouseY)) {
    mouseDropCV(selectedCity, druv, mouseX-cityViewRect->x, mouseY-cityViewRect->y);
  } else  if (isDrag==INNERCITYVIEW && isInAnyUnitView(mouseX, mouseY)) {
    unitview *uv = getUnitView(mouseX, mouseY);
    if (uv!=NULL)
      mouseDropUV(uv, selectedCity, mouseX-uv->rect->x, mouseY-uv->rect->y);
  } else if (isDrag==MINIMAP || isDrag==MINIPOS)  {
    mouseReleasedMM(mouseX-minimapRect->x, mouseY-minimapRect->y, event->button.button, nbClick);
  } else  if (isDrag==INNERCITYVIEW || isDrag==CITYVIEW) {
    mouseReleasedCV(selectedCity, mouseX-cityViewRect->x, mouseY-cityViewRect->y, event->button.button, nbClick);
  } else  if ((isDrag==INNERUNITVIEW || isDrag==UNITVIEW) && isInAnyUnitView(mouseX, mouseY)) {
    unitview *uv = getUnitView(mouseX, mouseY);
    if (uv!=NULL)
      mouseReleasedUV(uv, mouseX-druv->rect->x, mouseY-druv->rect->y);
  } else if (isDrag==UNIT && (mouseX!=mousePressedX ||mouseY!=mousePressedY)) {
    if (displayedItinerary != NULL) {
      list_destroy_nodes(displayedItinerary);
      list_destroy(displayedItinerary);
      displayedItinerary = NULL;
    }
    if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

    } else if (unitSelectionList!=NULL && list_count(unitSelectionList)>0) {
      lnode_t *unitelem = list_first(unitSelectionList);
      while (unitelem != &unitSelectionList->list_nilnode) {
        unit *unitNoi = (unit *)unitelem->list_data;
        if (unitNoi->location->posX != i ||  unitNoi->location->posY != j) {
          resetStatus(unitNoi);

          unitNoi->itinerary = (list_t *)astarSearch(unitNoi->location->posX, unitNoi->location->posY, i, j, unitNoi);
          if (unitNoi->itinerary!=NULL){
            unitNoi->status = GOINGTO;
            unitNoi->destination = &map[i+MapWidth*(j)];
          } else {
            // we could'nt all get there so nobody move
            resetStatusAll(unitSelectionList);
            return;
          }
        }
        unitelem = unitelem->list_next;
      }

      updatesGotoOrders(unitSelectionList);
      updateMiniMap();
      unitelem = list_first(unitSelectionList);
      unit *u = (unit *)unitelem->list_data;
      if (!(popupType&POPUP_ISVISIBLE) && u->destination != NULL)
        selectNextWaitingUnit();
    }
  } else if (isDrag==INNERUNITVIEW && uvDrag==GOODS && inspector->ul!=NULL && list_count(inspector->ul)>0) {
    unit *u = (unit *)list_first(inspector->ul)->list_data;
    int srcX = u->location->posX;
    int srcY = u->location->posY;
    int destX = (mouseX/TILESIZE)+firstVisibleTileX;
    int destY = (mouseY/TILESIZE)+firstVisibleTileY;
    int dx = destX-srcX;
    int dy = destY-srcY;
    float d = (float)hypot(dx, dy);
    //printf("  mousedown uvDrag %i,%i -> %i,%i ->%i, %i ->  d=%i \n", srcX, srcY, destX, destY, dx, dy, d);
    if (d<1.01) {
      int i;
      for (i=0; i<u->maxLoad; i++) {
        if (&u->goods[i]==dragGood && u->goods[i].passenger!=NULL) {
          u->goods[i].passenger->location = &map[destX+MapWidth*(destY)];
          u->goods[i].passenger->status = WAITING;
          u->goods[i].passenger->movement = 0;
          if (map[destX+MapWidth*(destY)].unitList==NULL)
            map[destX+MapWidth*(destY)].unitList = list_create(LISTCOUNT_T_MAX);
          list_append(map[destX+MapWidth*(destY)].unitList, lnode_create(u->goods[i].passenger));
          dragGood->quantity    = 0;
          dragGood->passenger   = NULL;
          inspector->needUpdate = TRUE;
          dragGood              = NULL;
        }
      }
    }
    dragGood = NULL;
    uvDrag   = NONE;
  } else if (isDrag==MAP || isDrag==MINIPOS) {

  } else if (isDrag==MAP && FVTx == firstVisibleTileX+(mouseX/TILESIZE) && FVTy == firstVisibleTileY+(mouseY/TILESIZE)){
    if (event->button.button == SDL_BUTTON_LEFT && !(modifier&KMOD_LCTRL) && !(modifier&KMOD_RCTRL)) {
      unitSelectionList    = defaultSelectionList;
      list_destroy_nodes(unitSelectionList);
      selectedCity = NULL;
      updatesInspector(NULL, NULL);
      inspector->t = &map[FVTx+MapWidth*(FVTy)];
    }
    /*if(map[FVTx+MapWidth*(FVTy)].elevation < SEALEVEL && !nosound) {
    Mix_FadeInChannel(ambianceChannel, natureSounds[OCEAN_SOUND-FIRST_SOUND], 10, 1000);
    //printf("NOW PLAY SOUND %d \n", ambianceChannel);
    if (ambianceChannel<0)
    printf(" error due to %s\n", SDL_GetError());
    } else {
      Mix_FadeOutChannel(ambianceChannel, 1000);
    }*/
    //inspector->needUpdate = TRUE;
  }

  if ((isDrag==MAP || isDrag==MINIPOS) && cacheNeedUpdate) {
    updatesCache(-1, -1, -1, -1);
  }
  isDrag = NONE;

  // just in case user would drop stuff anywhere
  dragGood = NULL;
  if(inspector!=NULL)
    inspector->needUpdate = TRUE;
}// mouseReleased()


/**
 * global keyPressed function, will forward to specialied or treat the event if global
 */
void keyPressed(SDL_Event *event, Uint32 time) {
  lnode_t *unitelem;
  unit *u;
  tile *tile0;
  player  *currentPlayer;

  //printf("keyPressed %i    %i/%i\n", event->key.keysym.sym, SDL_GetModState(), KMOD_SHIFT);

  if (popupType&POPUP_TEXT && ((event->key.keysym.sym>=SDLK_a && event->key.keysym.sym<=SDLK_z) ||
                               event->key.keysym.sym==SDLK_SPACE )) {
    Uint16 c = event->key.keysym.sym;
    if(event->key.keysym.mod & KMOD_SHIFT)
      c+='A'-'a';
    size_t l = strlen(popuptext);
    if (l<60) {
      char* newpopuptext = (char*)malloc(64*sizeof(char));
      sprintf(newpopuptext, "");
      strncat(newpopuptext, popuptext, popuptextcursor);
      newpopuptext[popuptextcursor] = (char)c;
      newpopuptext[popuptextcursor+1] = 0;
      char* ptr = popuptext;
      ptr+=popuptextcursor;
      strncat(newpopuptext, ptr, l-popuptextcursor);

      free(popuptext);
      popuptextcursor++;
      popuptext = newpopuptext;

    }
    popupneedUpdate = TRUE;
    return;
  } else if (popupType&POPUP_TEXT && event->key.keysym.sym==SDLK_BACKSPACE) {
    if (popuptextcursor>0) {
      size_t l = strlen(popuptext);
      char* newpopuptext = (char*)malloc(64*sizeof(char));
      sprintf(newpopuptext, "");
      strncat(newpopuptext, popuptext, popuptextcursor-1);
      char* ptr = popuptext;
      ptr+=popuptextcursor;
      strncat(newpopuptext, ptr, l-popuptextcursor);

      free(popuptext);
      popuptextcursor--;
      popuptext = newpopuptext;
    }
    popupneedUpdate = TRUE;
    return;
  } else if (popupType&POPUP_TEXT && event->key.keysym.sym==SDLK_LEFT) {
    popupneedUpdate = TRUE;
    if (popuptextcursor>0)
      popuptextcursor--;
  } else if (popupType&POPUP_TEXT && event->key.keysym.sym==SDLK_RIGHT) {
    popupneedUpdate = TRUE;
    if (popuptextcursor<strlen(popuptext))
      popuptextcursor++;
  } else if (popupType&POPUP_ISVISIBLE && popupOptionList!=NULL && event->key.keysym.sym==SDLK_ESCAPE) {
    lnode_t *ln = list_first(popupOptionList);
    while (ln!=NULL && ln!=&popupOptionList->list_nilnode) {
      option *o = (option*)ln->list_data;
      // there is a doNothing we can activate by pressing esc !
      if (o->act == &doNothing) {
        discardPopup();
        break;
      }
      ln=ln->list_next;
    }
  } else if (popupType&POPUP_ISVISIBLE){
    return;
  } else
  switch (event->key.keysym.sym) {
    case SDLK_LCTRL  :
      modifier =  KMOD_LCTRL;
      break;
    case SDLK_RCTRL  :
      modifier =  KMOD_RCTRL;
      break;
    case SDLK_LMETA  :
      modifier =  KMOD_LMETA;
      break;
    case SDLK_RMETA  :
      modifier =  KMOD_RMETA;
      break;
    case SDLK_ESCAPE :
      if (selectedCity!=NULL)
        selectedCity = NULL;
      else {
        if (popupOptionList!=NULL) {
          discardPopup();
        }

        popupType = POPUP_MESSAGE|POPUP_YESNO;
        addPopupOption("Do you really want to leave NewCol ?", NULL);
        addPopupOption("yes ?", doQuit);
        addPopupOption("NO !", doNothing);
        selectedOption = NULL;
      }
        break;
    case SDLK_KP8 :
    case SDLK_UP:
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX, tile0->posY-1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX+MapWidth*(tile0->posY-1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP2 :
    case SDLK_DOWN:
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX, tile0->posY+1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX+MapWidth*(tile0->posY+1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP4 :
    case SDLK_LEFT:
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX-1, tile0->posY, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX-1+MapWidth*(tile0->posY)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP6 :
    case SDLK_RIGHT:
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX+1, tile0->posY, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX+1+MapWidth*(tile0->posY)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP3 :
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX+1, tile0->posY+1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX+1+MapWidth*(tile0->posY+1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP7 :
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX-1, tile0->posY-1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX-1+MapWidth*(tile0->posY-1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP9 :
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX+1, tile0->posY-1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX+1+MapWidth*(tile0->posY-1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_KP1 :
      if (unitSelectionList==NULL || list_count(unitSelectionList)==0)
        return;

      // not allowed to move other's units
      if (gamemode!=EDIT && unitSelectionList!= NULL && !list_isempty(unitSelectionList) && ((unit *)list_last(unitSelectionList)->list_data)->owner != currentPlayerElement->list_data){

      } else {
        resetStatusAll(unitSelectionList);
        lnode_t *ln =  list_first(unitSelectionList);
        while (ln != &unitSelectionList->list_nilnode) {
          unit *uNoi = (unit *)ln->list_data;
          tile0 = uNoi->location;
          uNoi->itinerary = astarSearch(uNoi->location->posX, uNoi->location->posY,  tile0->posX-1, tile0->posY+1, uNoi);
          if (uNoi->itinerary!=NULL){
            uNoi->status = GOINGTO;
            uNoi->destination = &map[tile0->posX-1+MapWidth*(tile0->posY+1)];
          }
          ln = ln->list_next;
        }
        updatesGotoOrders(unitSelectionList);
      }
      break;
    case SDLK_SPACE:
      unitelem = list_first(unitSelectionList);
      if (unitelem==NULL)
        return;
        resetStatusAll(unitSelectionList);
      while (unitelem != &unitSelectionList->list_nilnode) {
        unit *unitNoi = (unit *)unitelem->list_data;
        unitNoi->movement = 0;
        unitelem = unitelem->list_next;
      }
        selectNextWaitingUnit();
      break;
    case SDLK_RETURN:
      if (popupType&POPUP_ISVISIBLE && popupOptionList!=NULL) {
        lnode_t *ln = list_first(popupOptionList);

        while (ln!=NULL && ln!=&popupOptionList->list_nilnode) {
          option *o = (option*)ln->list_data;
          // here is the first option that do something !
          if (o->act!=NULL && o->act != &doNothing) {
            //printf("now it's time to act %s\n", o->text);
            activatePopup();
            //printf("   popupType2=  %i\n", popupType);
            return;
          }
          ln=ln->list_next;
        }
      } else
        finishTurn();

      break;
    default :
      break;
  }
  //printf("look for key %i \n", event->key.keysym.unicode);
  // depend on keyboard layout !
  switch (event->key.keysym.unicode) {
    case SDLK_HASH:
      isDisplayGrid=!isDisplayGrid;
      break;
    case SDLK_a:
      if (gamemode==EDIT || gamemode==DEBUG)
        editmode = E_ALTITUDE;
      break;

    case SDLK_b:
      if (gamemode==EDIT || gamemode==DEBUG && editmode != E_BONUS)
        editmode = E_BONUS;
      else
        doAskCityNameAndBuild(unitSelectionList, NULL);
      break;

    case SDLK_c:
      if (gamemode==EDIT || gamemode==DEBUG)
        editmode = E_CITY;
      break;

    case SDLK_e:
      if (gamemode!=LAST_MODE)
        gamemode++;
      else
        gamemode = FIRST_MODE;
      updatesLastExplored();
      updatesCache(-1, -1, -1, -1);
      updateMiniMap();
      break;

    case SDLK_f:
      if (gamemode==EDIT || gamemode==DEBUG)
        if (editmode!=E_FOREST)
          editmode = E_FOREST;
        else {
          int i = (mouseX/TILESIZE)+firstVisibleTileX;
          int j = (mouseY/TILESIZE)+firstVisibleTileY;
          if(map[i+MapWidth*(j)].vegetation < IRRIGATION)
            map[i+MapWidth*(j)].vegetation += 20;
          else
            map[i+MapWidth*(j)].vegetation = FOREST;
          int dx, dy;
          for (dx=-1; dx<2; dx++)
            for (dy=-1; dy<2; dy++)
              updatesCachedTileAt(i+dx, j+dy);
          break;
        } else {
          doFortify(unitSelectionList, NULL);
          selectNextWaitingUnit();
        }
        break;

    case SDLK_g:
      if (gamemode==EDIT || gamemode==DEBUG) {
        if (editmode!=E_GROUND)
          editmode = E_GROUND;
        else {
          int i = (mouseX/TILESIZE)+firstVisibleTileX;
          int j = (mouseY/TILESIZE)+firstVisibleTileY;
          if(map[i+MapWidth*(j)].ground < LAST_EDIT_GROUND)
            map[i+MapWidth*(j)].ground ++;
          else
            map[i+MapWidth*(j)].ground = FIRST_GROUND;
          int dx, dy;
          for (dx=-1; dx<2; dx++)
            for (dy=-1; dy<2; dy++)
              updatesCachedTileAt(i+dx, j+dy);
          break;
        }
      // a popup list of cities if at least one unit is selected
      } else if (gamemode==PLAY){
        doAskCityNameAndGoto(unitSelectionList, NULL);
      }
      break;

    case SDLK_i:
      if (gamemode==EDIT || gamemode==DEBUG)
        editmode = E_INFLUENCE;
      break;

    case SDLK_l:
      loadMap("Fred-January1492.map");
      break;

    case SDLK_m:
      selectNextWaitingUnit();
      break;

    case SDLK_p:
      doPlow(unitSelectionList, NULL);
      selectNextWaitingUnit();
      break;

    case SDLK_r:
      if (gamemode==EDIT || gamemode==DEBUG) {
        if (editmode==E_RIVER) {
          int i = (mouseX/TILESIZE)+firstVisibleTileX;
          int j = (mouseY/TILESIZE)+firstVisibleTileY;
          if (getConnectedToCoast(i, j) && map[i+MapWidth*(j)].river_elem==NULL) {
            river* river0 = (river *)malloc(sizeof(river));
            river0->name = (char*)malloc(64*sizeof(char));
            sprintf(river0->name, "River-%i", list_count(riverList));
            river0->itinerary = binarytree_create(LISTCOUNT_T_MAX);
            btnode_t *node = btnode_create(&map[i+MapWidth*(j)]);
            binarytree_ins_left(river0->itinerary, NULL, node);
            map[i+MapWidth*(j)].river_elem = node;
            river0->finishX = 0.5 ;
            river0->finishY = 0.5;
            list_append(riverList, lnode_create(river0));
          } else if (map[i+MapWidth*(j)].river_elem!=NULL) {
            btnode_t *father = map[i+MapWidth*(j)].river_elem->father;
            btnode_t *btn = map[i+MapWidth*(j)].river_elem;
            if (father!=NULL) {
              destroyUpRiver_r(map[i+MapWidth*(j)].river_elem);
              if (father->left==btn)
                father->left = NULL;
              else if (father->right==btn)
                father->right = NULL;
            } else {
              //printf("want to totally destroy a river %p\n", map[i+MapWidth*(j)].river_elem);
              lnode_t *rln = list_find(riverList, map[i+MapWidth*(j)].river_elem, compareItinerary);
              if (rln==NULL) {
                fprintf(stderr, "coulnd't find river !\n");
              } else {
                //printf("we found the river among %i\n", list_count(riverList));
                destroyUpRiver_r(map[i+MapWidth*(j)].river_elem);
                list_delete(riverList, rln);
              }
            }
          }
        } else
          editmode = E_RIVER;
      } else {
        doRoad(unitSelectionList, NULL);
        selectNextWaitingUnit();
      }
      break;

    case SDLK_s:
      char *text;
      text = getMonthForTime(apptime);
      char *text2;
      text2 = (char *)malloc(64*sizeof(char));
      if (currentPlayerElement==NULL || gamemode != PLAY)
        return;
        currentPlayer = (player *)currentPlayerElement->list_data;
      sprintf(text2, "%s-%s%i.map", currentPlayer->name, text, 1492+apptime/12);
      saveMap(text2);
      free(text);
      free(text2);
      break;

    case SDLK_t:
      if (gamemode==EDIT || gamemode==DEBUG) {
        if (editmode!=E_TRANSPORT)
          editmode = E_TRANSPORT;
        else {
          int i = (mouseX/TILESIZE)+firstVisibleTileX;
          int j = (mouseY/TILESIZE)+firstVisibleTileY;
          if(map[i+MapWidth*(j)].road < RAILWAY)
            map[i+MapWidth*(j)].road += 20;
          else
            map[i+MapWidth*(j)].road = 0;
          int dx, dy;
          for (dx=-1; dx<2; dx++)
            for (dy=-1; dy<2; dy++)
              updatesCachedTileAt(i+dx, j+dy);
          break;
        }
      }
      break;

    case SDLK_u:
      if (gamemode==EDIT || gamemode==DEBUG) {
        if (editmode == E_UNIT) {
          if (currentPlayerElement==NULL)
            return;
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          if (inspector->t->unitList==NULL)
            inspector->t->unitList = list_create(LISTCOUNT_T_MAX);
          createUnitAt(COLONIST, currentPlayer, inspector->t->posX, inspector->t->posY);
        } else
          editmode = E_UNIT;
      }
      break;

    case SDLK_w:
      doWait(unitSelectionList, NULL);
      selectNextWaitingUnit();
      break;

    case SDLK_z :
      if (gamemode!=EDIT)
        break;
      discardPopup();
      popupType = POPUP_MESSAGE|POPUP_YESNO;
      popupOptionList = list_create(LISTCOUNT_T_MAX);

      option *o;
      o = (option*)malloc(sizeof(option));
      o->text   = (char*)malloc(64*sizeof(char));
      o->act    = NULL;
      sprintf(o->text, "Do you really want reset the map ?");
      list_append(popupOptionList, lnode_create(o));

      o = (option *)malloc(sizeof(option));
      o->text = (char*)malloc(16*sizeof(char));
      o->act    = doReset;
      sprintf(o->text, "YES");
      list_append(popupOptionList, lnode_create(o));

      o = (option *)malloc(sizeof(option));
      o->text = (char*)malloc(16*sizeof(char));
      o->act    = doNothing;
      sprintf(o->text, "NO");
      list_append(popupOptionList, lnode_create(o));
      break;

    default :
      break;
  }
}//keyPressed()


/**
 * main display function. draw the game UI (using cache)
 */
void display() {
  //if (!isDrag && isMousePressed)
  displayMap();

  if (isDisplayGrid)
    displayGrid();

  //if (isDisplayAStar)
  if(gamemode==DEBUG) {
    if(SDL_mutexP(astarmut)==-1){
      fprintf(stderr, "Couldn't lock astar mutex\n");
      exit(-1);
    }
    displayAStar();
    if(SDL_mutexV(astarmut)==-1){
      fprintf(stderr, "Couldn't unlock astar mutex\n");
      exit(-1);
    }    
  }

  if (!isDisplayOnlyTerrain)
    displayUnits();

  // selected unitS
  if (unitSelectionList!=NULL) {
    /*printf("...display unitSelectionList %d : ", list_count(unitSelectionList));
    lnode_t *ln = list_first(unitSelectionList);
    while (ln!=NULL && ln !=&unitSelectionList->list_nilnode) {
      unit *u = (unit *)ln->list_data;
      printf(" %p ", u);
      ln = ln->list_next;
    }
    printf("\n");fflush(stdout);*/

    displayUnitList(unitSelectionList, isDrag);

    if (!list_isempty(unitSelectionList)) {
      lnode_t *lastunit = list_last(unitSelectionList);
      displayPath((unit *)lastunit->list_data, displayedItinerary);
    }
  }

  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));

  // movement gradient color on tiles
  if (isDrag==UNIT && displayedItinerary!=NULL) {
    int i, j;
    int w = screen->w/TILESIZE;
    int h = screen->h/TILESIZE;
    //printf("%i*%i\n", w, h);
    for (j=0; j<h; j++) {
      for (i=0; i<w; i++) {
       // printf("%4i ", movecache[(j)*(w)+(i)]);
        unsigned char a = movecache[(j)*(w)+(i)];
        if (a==255)
          boxRGBA(screen, (i)*TILESIZE, (j)*TILESIZE, (i+1)*TILESIZE, (j+1)*TILESIZE, 32, 32, 32, 192);
        else if (a>=4)
          boxRGBA(screen, (i)*TILESIZE, (j)*TILESIZE, (i+1)*TILESIZE, (j+1)*TILESIZE, 192, 32, 32, 128);
        else if (a>0)
          boxRGBA(screen, (i)*TILESIZE, (j)*TILESIZE, (i+1)*TILESIZE, (j+1)*TILESIZE, a*64, 128+(a%2)*64, 128, 128);
      }
    //printf("\n");
    }
  }

  // city view
  if (selectedCity!=NULL)
    displayCityView(selectedCity);

  // unit views
  if (unitViews!=NULL && list_count(unitViews)>0) {
    lnode_t *ln = list_first(unitViews);
    while (ln !=&unitViews->list_nilnode) {
      unitview *uv = (unitview *)ln->list_data;
      displayUnitView(uv);
      ln = ln->list_next;
    }
  }

  //dragging goods
  // goods and units being dragged inside or between views
  //printf("uvDrag=%i cvDrag=%i\n", uvDrag, cvDrag);
  if (uvDrag==GOODS || cvDrag==GOODS) {
    //printf("  Drag GOODS %i\n", dragGood->type);
    SDL_Surface *img1 = getGoodImage(dragGood);
    rect->x           = mouseX-mousedX;
    rect->y           = mouseY-mousedY;
    SDL_BlitSurface(img1, 0, screen, rect);
  } else if (cvDrag == NEWCOMER || cvDrag == OUTWORKER || cvDrag == INWORKER) {
    //printf("  Drag UNIT %i\n", dragUnit->type);
    SDL_Surface *img1 = getUnitImage(dragUnit);
    rect->x           = mouseX-mousedX;
    rect->y           = mouseY-mousedY;
    SDL_BlitSurface(img1, 0, screen, rect);
  }

  //minimap
  if (isDisplayMiniMap)
    displayMiniMap();

  // application name version number
  char *text2 = (char *)malloc(256*sizeof(char));
  SDL_Surface *imgText = NULL;
  if (currentPlayerElement!=NULL) {
    sprintf(text2 , "%s %s (%3.2f Hz) ", APPNAME, VERSION, refreshrate);
    TTF_SetFontStyle(fonts[15], TTF_STYLE_BOLD);
    imgText = TTF_RenderText_Blended(fonts[15], text2, BLACK);
    rect->x = 10;
    rect->y = 10;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[15], text2, YELLOW);
    rect->x = 9;
    rect->y = 9;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    TTF_SetFontStyle(fonts[15], TTF_STYLE_NORMAL);
  }

  // display (mode) and date
  char *text = getMonthForTime(apptime);
  if (gamemode==EDIT)
    sprintf(text2 , "%s %i (%s)", text, 1492+apptime/12, "EDIT");
  else if (gamemode==DEBUG)
    sprintf(text2 , "%s %i (%s)", text, 1492+apptime/12, "DEBUG");
  else
    sprintf(text2 , "%s %i", text, 1492+apptime/12);
  imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
  rect->x = screen->w-imgText->w-10;
  rect->y = 10;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);
  imgText = TTF_RenderText_Blended(fonts[14], text2, WHITE);
  rect->x = screen->w-imgText->w-11;
  rect->y = 9;
  SDL_BlitSurface(imgText, 0, screen, rect);
  SDL_FreeSurface(imgText);

  // display money !
  if (gamemode==PLAY && currentPlayerElement!=NULL) {
    SDL_Surface *imgIcon = coinImage;
    player  *currentPlayer = (player *)currentPlayerElement->list_data;
    sprintf(text2 , "%d", currentPlayer->money);
    imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
    rect->x = screen->w-imgText->w-imgIcon->w-10;
    rect->y = 26;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[14], text2, YELLOW);
    rect->x = screen->w-imgText->w-imgIcon->w-11;
    rect->y = 25;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    rect->x = screen->w-imgIcon->w-11;
    rect->y = 27;
    SDL_BlitSurface(imgIcon, 0, screen, rect);

    imgIcon = crossImage;
    sprintf(text2 , "%d", currentPlayer->totalCrosses);
    imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
    rect->x = screen->w-imgText->w-imgIcon->w-10;
    rect->y = 45;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[14], text2, YELLOW);
    rect->x = screen->w-imgText->w-imgIcon->w-11;
    rect->y = 44;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    rect->x = screen->w-imgIcon->w-11;
    rect->y = 46;
    SDL_BlitSurface(imgIcon, 0, screen, rect);
  }

  rect->y = 16;
  // Display general debug info
  if (gamemode==DEBUG && unitSelectionList!=NULL && list_count(unitSelectionList)>0) {
    lnode_t *unitelem = list_first(unitSelectionList);
    unit *unitNoi = (unit *)unitelem->list_data;

    sprintf(text2 , "Selection : %i units at %i, %i", list_count(unitSelectionList), unitNoi->location->posX, unitNoi->location->posY);
    imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
    rect->x = 15;
    rect->y += 26;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[14], text2, WHITE);
    rect->x = 14;
    rect->y -= 1;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);

    unitelem = list_first(unitSelectionList);
    while (unitelem != &unitSelectionList->list_nilnode) {
      unitNoi = (unit *)unitelem->list_data;
      unitelem = unitelem->list_next;
      sprintf(text2 , " %s : %s    H:%i G:%i T:%i", getUnitText(unitNoi), getStatusText(unitNoi->status), unitNoi->horses, unitNoi->muskets, unitNoi->tools);
      imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
      rect->x = 20;
      rect->y += 16;
      SDL_BlitSurface(imgText, 0, screen, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[14], text2, WHITE);
      rect->x = 19;
      rect->y -= 1;
      SDL_BlitSurface(imgText, 0, screen, rect);
      SDL_FreeSurface(imgText);
    }
    int i          = (mouseMovedX/TILESIZE)+firstVisibleTileX;
    int j          = (mouseMovedY/TILESIZE)+firstVisibleTileY;
    tile *loc = &map[i+MapWidth*(j)];
    list_t *ul = loc->unitList;
    if (ul!=NULL && list_count(ul)>0){
      sprintf(text2 , "Under Mouse : %i units at %i, %i", list_count(ul), loc->posX, loc->posY);
      imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
      rect->x = 15;
      rect->y += 26;
      SDL_BlitSurface(imgText, 0, screen, rect);
      SDL_FreeSurface(imgText);
      imgText = TTF_RenderText_Blended(fonts[14], text2, WHITE);
      rect->x = 14;
      rect->y -= 1;
      SDL_BlitSurface(imgText, 0, screen, rect);
      SDL_FreeSurface(imgText);

      unitelem = list_first(ul);
      while (unitelem != &ul->list_nilnode) {
        unit *unitNoi = (unit *)unitelem->list_data;
        unitelem = unitelem->list_next;
        sprintf(text2 , " %s : %s    H:%i G:%i T:%i", getUnitText(unitNoi), getStatusText(unitNoi->status), unitNoi->horses, unitNoi->muskets, unitNoi->tools);
        imgText = TTF_RenderText_Blended(fonts[14], text2, BLACK);
        rect->x = 20;
        rect->y += 16;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);
        imgText = TTF_RenderText_Blended(fonts[14], text2, WHITE);
        rect->x = 19;
        rect->y -= 1;
        SDL_BlitSurface(imgText, 0, screen, rect);
        SDL_FreeSurface(imgText);
      }
    }
  }
  int i, nbmsg = 5;
  if (list_count(messageList)<5)
    nbmsg = list_count(messageList);
  lnode_t *node = list_last(messageList);
  for (i=0; i<nbmsg; i++) {
    char    *msg  = (char*)node->list_data;
    SDL_Color shadcolor = BLACK;
    if (strncmp(msg, "TRADE: ", 7)==0) {
      msg+=7;
      shadcolor = YELLOW;
    }
    if (strncmp(msg, "BATTLELOST: ", 12)==0) {
      msg+=12;
      shadcolor = RED;
    }
    if (strncmp(msg, "BATTLEWIN: ", 11)==0) {
      msg+=11;
      shadcolor = GREEN;
    }        
    // a shadow must remain dark !
    shadcolor.r = shadcolor.r/2;
    shadcolor.g = shadcolor.g/2;
    shadcolor.b = shadcolor.b/2;
    imgText = TTF_RenderText_Blended(fonts[12], msg, shadcolor);
    rect->x = 15;
    rect->y += 18;
    SDL_BlitSurface(imgText, 0, screen, rect);
    rect->x -= 2;
    SDL_BlitSurface(imgText, 0, screen, rect);
    rect->y += 2;
    SDL_BlitSurface(imgText, 0, screen, rect);
    rect->x += 2;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    imgText = TTF_RenderText_Blended(fonts[12], msg, WHITE);
    rect->x -= 1;
    rect->y -= 1;
    SDL_BlitSurface(imgText, 0, screen, rect);
    SDL_FreeSurface(imgText);
    node = node->list_prev;
  }

  free(text);
  free(text2);
  free(rect);

  // edition options
  if (gamemode==EDIT || gamemode==DEBUG)
    displayEditOptions();

  //popup
  //printf("display ()   %i\n", popupType);
  
  if (popupType&POPUP_ISVISIBLE)
    displayPopup();

  SDL_Flip(screen);
  uiPaintNb++;

  if (uiPaintNb==50) {
    elapsedTime     = SDL_GetTicks()-lastRefreshInfo;
    refreshrate = 50000.0/elapsedTime;
    //printf("Refresh rate is now %4.2f fps\n", refreshrate);
    lastRefreshInfo = SDL_GetTicks();
    uiPaintNb = 0;
  }
}// paint()


/**
 * starts the game
 */
int main(int argc, char *argv[]) {
  int       i, j  = 0;
  SDL_Event event;
  riverList  = list_create(LISTCOUNT_T_MAX);

  gameSeed = time(0);
  printf(" Newcol is starting with %i arguments and seed = %d \n ", argc, gameSeed);fflush(stdout);
  srand(gameSeed);

  int distri1[10];
  int distri2[10];
  int distri3[10];
  for (i=0; i<10; i++) {
    distri1[i] = 0;
    distri2[i] = 0;
    distri3[i] = 0;
  }

  for (i=0; i<1000; i++) {
    float val1 = ranf();
    float val2 = positiveGaussian();
    int val3 = rand()%10;
    distri1[(int)(val1*10)]++;
    distri2[(int)(val2*10)]++;
    distri3[val3]++;
  }

  printf("   ranf distribution   : | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i |\n ",
         distri1[0], distri1[1], distri1[2], distri1[3], distri1[4], distri1[5], distri1[6], distri1[7], distri1[8], distri1[9]);
  printf("   gaussian distribution : | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i |\n ",
         distri2[0], distri2[1], distri2[2], distri2[3], distri2[4], distri2[5], distri2[6], distri2[7], distri2[8], distri2[9]);
  printf("   rand distribution   : | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i | %3i |\n ",
         distri3[0], distri3[1], distri3[2], distri3[3], distri3[4], distri3[5], distri3[6], distri3[7], distri3[8], distri3[9]);

  printf("   perlin values       :   |");
  double x = 0, t=0;
  p_init(1);
  for (i=1; i<=10; i++) {
    for (; t<0.09999999*i; t+=0.01) {
      x = noise1(t);
      printf(" %3i |", (int)(x*50));
    }
    if (i!=10)
      printf("\n                            |");
  }

  printf("\n\n   perlin loop values :     |");
  x = 0; t=0;
  p_init(1);
  for (t=-M_PI; t<M_PI+0.001; t+=M_PI/50) {
    x = noise2(cos(t), sin(t));
    printf(" %3i |", (int)(x*50));
    if (((int)(51+t*50/M_PI))%10==0)
      printf("\n                            |");
  }
  printf("\n                            |\n");

  printf("   perlin 2d values     :   |");
  p_init(1);
  for (i=1; i<=10; i++) {
    for (j=1; j<=10; j++) {
      x = noise2(((float)i)/10, ((float)j)/10);
      printf(" %3i |", (int)(x*50));
    }
    if (i!=10)
      printf("\n                            |");
  }
  printf("\n");

  printf("   20 blue noise values     :   |");
  PolySite *res = getCVTRandomPoints(20, 5);
  for (i=1; i<20; i++) {
    printf("pt%i = %f, %f\n", i, res[i].coord.x, res[i].coord.y);
  }
  
  initApp(1024, 896);
  //initApp(1280, 1024);
  //initApp(1280, 940);
  //initApp(1920, 1200);
  //initApp(2560, 1408);
  initTextures();

  doAskDifficulty(NULL, "");

  //if (argc>=2) {
  //  loadMap(argv[1]);
  //} else {
    //loadMap("Fred-January1492.map");
  //  updateMiniMap();
  //  initGroundsFromBitmap("images/globecol.png", 4, 4);
    //initTiles(2160/4, 1080/4);
  //}

  //computeIrrigation();
  initCaches(screen->w/TILESIZE+1, screen->h/TILESIZE+1);

  printf(" Initialisation finished !\n");
  fflush(stdout);

  addMsg("Starting game");
  updateLoading();

  //selectNextWaitingUnit();

  SDL_TimerID  event_timer_id       = SDL_AddTimer((1000 / 160) * 10, event_callbackfunc, NULL);
  SDL_Event   *forwardEventsToCheck = (SDL_Event *)malloc (16*sizeof(SDL_Event));

  // main loop of the game
  done = 0;
  while((!done) && (SDL_WaitEvent(&event))) {
    if (event.type==SDL_MOUSEMOTION) {
      int n = SDL_PeepEvents(forwardEventsToCheck, 10, SDL_GETEVENT, SDL_EVENTMASK (SDL_MOUSEMOTION));
      if (n>0) {
        //printf("we drop %i events %d at %d,%d \n", n, event.type, event.motion.x, event.motion.y);
        event = forwardEventsToCheck[n-1];
        //for (i=1; i<n; i++)
        //  printf("   and also %d at %d,%d \n", forwardEventsToCheck[i].type, forwardEventsToCheck[i].motion.x, forwardEventsToCheck[i].motion.y);
        //printf("AND WE PREFER THE EVENT %d at %d,%d \n\n", event.type, event.motion.x, event.motion.y);
      }
    }
    Uint32 now = SDL_GetTicks();

    //printf("\n\n----NEW EVENT--- %i\n", event.type);
    switch (event.type) {
    case SDL_USEREVENT:
      animID++;
      break;

    case SDL_MOUSEMOTION:
      if (!isMousePressed)
        mouseMoved(&event, now);
      else
        mouseDragged(&event, now);
      break;

    case SDL_MOUSEBUTTONUP:
      if (press_timer_id!=NULL) {
        SDL_RemoveTimer(press_timer_id);
        //printf("timer stopped bu MR \n");
        press_timer_id = NULL;
      }
      mouseReleased(&event, now);
      break;

    case SDL_MOUSEBUTTONDOWN:
      mousePressed(&event, now);
      if (!(popupType&POPUP_ISVISIBLE)&&press_timer_id==NULL) {
        //printf("timer started \n");
        press_timer_id = SDL_AddTimer(500, press_callbackfunc, NULL);
      }
      break;

    case SDL_KEYDOWN:
      keyPressed(&event, now);
      break;

    case SDL_KEYUP:
      switch (event.key.keysym.sym) {
        case SDLK_LCTRL  :
          modifier = KMOD_NONE;
          break;
        case SDLK_RCTRL  :
          modifier = KMOD_NONE;
          break;
        case SDLK_LMETA  :
          modifier = KMOD_NONE;
          break;
        case SDLK_RMETA  :
          modifier = KMOD_NONE;
          break;
        default :
          break;
      }
      break;
    case SDL_QUIT:
      done = 1;
      break;
    default:
      break;
    }
    //printf("display %p ? \n", currentPlayerElement);
    if (currentPlayerElement==NULL) {
      updateLoading();
    }else
      display();
  }

  /* Clean up the SDL library */
  Mix_CloseAudio();
  SDL_Quit();
  return 0;
}// main() --------------------------------------------------------------------


/**
 * ask the given unit list to plow the tile they are on
*/
void doPlow(list_t *ul, char *order) {
  tile *t = NULL;
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    t = u->location;
    if (u->tools>=20 && (t->elevation==SEALEVEL || t->elevation==HILL) &&
            (t->vegetation!=IRRIGATION) && (t->vegetation!=PLOWED||isWaterAround(t))) {
      u->status = PLOWING;
    }
    unitelem = unitelem->list_next;
  }
}// doPlow() --------------------------------------------------------------------


/**
 * ask the given unit list to make a road on the tile they are on
*/
void doRoad(list_t *ul, char *order) {
  tile *t = NULL;
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    t = u->location;
    if (u->tools>=20 && (t->elevation==SEALEVEL || t->elevation==HILL || t->elevation==HIGHHILL || t->elevation==MOUNTAIN)) {
      u->status = ROADING;
    }
    unitelem = unitelem->list_next;
  }
}// doRoad() --------------------------------------------------------------------


/**
 * ask the given unit list to wait orders and forget old ones
*/
void doMine(list_t *ul, char *order) {
  tile *t = NULL;
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    t = u->location;
    if (u->tools>=20 && (t->elevation==HILL|| t->elevation==HIGHHILL) &&
            (t->underground!=MINE) && (t->vegetation!=PLOWED||isWaterAround(t))) {
      u->status = DIGGING;
    }
    unitelem = unitelem->list_next;
  }
}// doMine() --------------------------------------------------------------------


/**
 * ask the given unit list to wait orders and forget old ones
*/
void doWait(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    u->status = WAITING;
    unitelem = unitelem->list_next;
  }
}// doWait() --------------------------------------------------------------------


/**
 * ask the given unit list to fortify
*/
void doFortify(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    u->status = FORTIFYING;
    unitelem = unitelem->list_next;
  }
}// doFortify() --------------------------------------------------------------------


/**
 * ask the given unit list to group
 */
void doGroup(list_t *ul, char *order) {
  //printf("doGroup %d\n", list_count(ul));
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  unit *u = (unit *)unitelem->list_data;
  tile *t = u->location;
  list_t *ul2 = t->unitList;

  resetStatusAll(ul2);
  unitelem = list_first(ul2);
  list_t *newgroup = list_create(LISTCOUNT_T_MAX);
  while (unitelem != &ul2->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    if (u->group!=NULL)
      resetGroup(u->group);
    u->group = newgroup;
    list_append(newgroup, lnode_create(u));
    unitelem = unitelem->list_next;
  }
  if (unitSelectionList!=NULL &&list_count(unitSelectionList)>0)
    list_destroy_nodes(unitSelectionList);
  copylistTo(newgroup, unitSelectionList);
  updatesInspector(unitSelectionList, NULL);
}// doGroup() --------------------------------------------------------------------


/**
 * ask the given unit list to disband groups
 */
void doUngroup(list_t *ul, char *order) {
  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    if (u->group!=NULL)
      resetGroup(u->group);
    unitelem = unitelem->list_next;
  }
  if (unitSelectionList!=NULL &&list_count(unitSelectionList)>0)
    list_destroy_nodes(unitSelectionList);
  unitelem = list_first(ul);
  unit *u = (unit *)unitelem->list_data;
  list_append(unitSelectionList, lnode_create(u));
  updatesInspector(unitSelectionList, NULL);
}// doUngroup() --------------------------------------------------------------------




/**
 * ask the given unit list to fortify
 */
void doGoto(list_t *ul, char *order) {
  //printf("doGoto(%i) %s\n", list_count(ul), order);

  player *myking = getParentNation(((player *)currentPlayerElement->list_data)->nation);
  lnode_t *ln = list_first(ul);
  unit *u = (unit *)ln->list_data;

  list_t *cl = ((player *)currentPlayerElement->list_data)->cityList;
  lnode_t *cityelem = list_first(cl);
  city *c = NULL;
  while (cityelem != &cl->list_nilnode && c==NULL) {
    if (strcmp(order, ((city*)cityelem->list_data)->name)==0)
      c = (city*)cityelem->list_data;
    cityelem = cityelem->list_next;
  }
  if (c==NULL && isNaval(u) && myking!=NULL) {
    cl = myking->cityList;
    lnode_t *cityelem = list_first(cl);

    while (cityelem != &cl->list_nilnode && c==NULL) {
      if (strcmp(order, ((city*)cityelem->list_data)->name)==0)
        c = (city*)cityelem->list_data;
      cityelem = cityelem->list_next;
    }
  }
  if (c==NULL)
    return;

  int i= c->location->posX;
  int j= c->location->posY;

  lnode_t *unitelem = list_first(ul);
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);
  while (unitelem != &ul->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    u->itinerary = (list_t *)astarSearch(u->location->posX, u->location->posY, i, j, u);
    if (u->itinerary!=NULL){
      u->status = GOINGTO;
      u->destination = &map[i+MapWidth*(j)];
    }
    unitelem = unitelem->list_next;
  }
  updatesGotoOrders(ul);
  updateMiniMap();
  if (u->destination != NULL)
    selectNextWaitingUnit();
}// doGoto() --------------------------------------------------------------------


/**
 * ask a city name in a list and ask the given unit(s) to get there
 */
void doAskCityNameAndGoto(list_t *ul, char *order) {
  //printf("doAskCityNameAndGoto(%i)\n", list_count(ul));
  if (ul==NULL || list_count(ul)==0)
    return;

  discardPopup();
  popupType     = POPUP_MENU;

  popupUnitList = list_create(LISTCOUNT_T_MAX);
  lnode_t *ln = list_first(ul);
  mousePressedX = (((unit*)ln->list_data)->location->posX-firstVisibleTileX)*TILESIZE+TILESIZE/2;
  mousePressedY = (((unit*)ln->list_data)->location->posY-firstVisibleTileY)*TILESIZE+TILESIZE/2;
  while(ln!=NULL&&ln!=&ul->list_nilnode) {
    list_append(popupUnitList, lnode_create(ln->list_data));
    ln = ln->list_next;
  }
  popupOptionList = list_create(LISTCOUNT_T_MAX);
  list_t *cl = ((player *)currentPlayerElement->list_data)->cityList;
  lnode_t *cityelem = list_first(cl);
  city *c = NULL;
  while (cityelem!= NULL && cityelem != &cl->list_nilnode && c==NULL) {
    addPopupOption(((city*)cityelem->list_data)->name, doGoto);
    cityelem = cityelem->list_next;
  }
  player *myking = getParentNation(((player *)currentPlayerElement->list_data)->nation);
  ln = list_first(ul);
  unit *u = (unit *)ln->list_data;
  if (isNaval(u) && myking!=NULL){
    cl = myking->cityList;
    lnode_t *cityelem = list_first(cl);
    city *c = NULL;
    while (cityelem != &cl->list_nilnode && c==NULL) {
      addPopupOption(((city*)cityelem->list_data)->name, doGoto);
      cityelem = cityelem->list_next;
    }
  }
}// doAskCityNameAndGoto()


/**
 * start a war against the nation writen in the order !
 */
void doDeclareWar(list_t *ul, char *order) {
  player *player0 = (player*)currentPlayerElement->list_data;
  //printf("order before :[%s]\n", order);
  if (strstr(order, "[[")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+2, strstr(order, "]]") - ptr-2);
    txt[strstr(order, "]]") - ptr-2] = '\0';
    int nationToAttack = atoi(txt);
    //printf("Declare war to %d\n", nationToAttack);
    player0->diplomaticRelations[nationToAttack-FIRST_NATION] = WAR;
    lnode_t *ln = list_first(playerList);
    while (ln!=NULL &&ln!=&playerList->list_nilnode) {
      player *p = (player*)ln->list_data;

      // by solidarity ... war is a transitive property
      if (p->nation!=nationToAttack || p->diplomaticRelations[nationToAttack-FIRST_NATION]==BROTHERHOOD) {
        p->diplomaticRelations[player0->nation-FIRST_NATION] = WAR;
        player0->diplomaticRelations[player0->nation-FIRST_NATION] = WAR;
      }

      // war is a reflexive property
      if (p->nation==nationToAttack || p->diplomaticRelations[nationToAttack-FIRST_NATION]==BROTHERHOOD)
        p->diplomaticRelations[player0->nation-FIRST_NATION] = WAR;
      ln = ln->list_next;
    }
    free(txt);

    if (ul!=NULL && list_count(ul)>0){
      unit *u = ((unit*)list_first(ul)->list_data);
      //printf("  Attacker = %d\n", u->owner->nation);
      if (u->destination!=NULL && u->destination->unitList!=NULL &&list_count(u->destination->unitList)>0){
        unit *opponent = ((unit*)list_first(u->destination->unitList)->list_data);
        //printf("  Defender = %d\n", opponent->owner->nation);
        if (u->owner->nation != opponent->owner->nation && isArmy(u) && u->owner->diplomaticRelations[opponent->owner->nation-FIRST_NATION] >= WAR) {
          inspector->opponentl = copylist(u->destination->unitList);
          showPopupBattle();
        }
      }
    }
  }
  //printf("order after :[%s]\n", order);
}// doDelareWar()


/**
 * move the units without verification to the given destination
 */
void doMove(list_t *ul, char *order) {
  player *player0 = (player*)currentPlayerElement->list_data;
  //printf("doMove ... order before :[%s]\n", order);fflush(stdout);
  if (strstr(order, "[[l")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[l") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[l");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+3, strstr(order, "]]") - ptr-3);
    txt[strstr(order, "]]") - ptr-3] = '\n';
    char *txt2 = strstr(order, ",")+1;
    txt[strstr(order, ",") - ptr-3] = '\n';
    int x = atoi(txt);
    int y= atoi(txt2);

    //printf("  Move %d to %d,%d\n", list_count(ul), x, y);fflush(stdout);
    free(txt);
    if (map[x+MapWidth*(y)].unitList==NULL)
      map[x+MapWidth*(y)].unitList=list_create(LISTCOUNT_T_MAX);
    if (ul!=NULL && list_count(ul)>0){
      lnode_t *ln = list_first(ul);
      while(ln!=&ul->list_nilnode) {
        unit *u = (unit*)ln->list_data;
        tile *t = u->location;
        lnode_t *ln2 = list_find(t->unitList, u, straightCompare);
        list_delete(t->unitList, ln2);
        list_append(map[x+MapWidth*(y)].unitList, ln2);
        u->location = &map[x+MapWidth*(y)];
        if (u->itinerary!=NULL && ((tile*)list_first(u->itinerary)->list_data)==&map[x+MapWidth*(y)])
          list_del_first(u->itinerary);
        ln = ln->list_next;
        if (list_count(t->unitList)==0){
          list_destroy(t->unitList);
          t->unitList = NULL;
        }
      }
      updatesGotoOrders(ul);
      //printf("  Attacker = %d\n", u->owner->nation);

    }
  }
  //printf("order after :[%s]\n", order);
}// doMove()


/**
 * move the units without verification to the given destination
 */
void doExplore(list_t *ul, char *order) {
  player *player0 = (player*)currentPlayerElement->list_data;
  //printf("doExplore ... order before :[%s]\n", order);fflush(stdout);
  if (strstr(order, "[[l")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[l") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[l");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+3, strstr(order, "]]") - ptr-3);
    txt[strstr(order, "]]") - ptr-3] = '\n';
    char *txt2 = strstr(order, ",")+1;
    txt[strstr(order, ",") - ptr-3] = '\n';
    int x = atoi(txt);
    int y= atoi(txt2);

    //printf("  Explore %d to %d,%d\n", list_count(ul), x, y);fflush(stdout);
    free(txt);
    if (map[x+MapWidth*(y)].unitList==NULL)
      map[x+MapWidth*(y)].unitList=list_create(LISTCOUNT_T_MAX);
    if (ul!=NULL && list_count(ul)>0){
      if (map[x+MapWidth*(y)].construction!=NULL && map[x+MapWidth*(y)].construction->size==-1){
        // printf(" exploring %d at %d, %d\n ", map[x+MapWidth*(y)].construction->seed, x, y);

        // fountain of youth
        if (map[x+MapWidth*(y)].construction->seed%100<=5){
          int i;
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "You found a fountain of youth, rumor spread accross europe !!!");
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);
          srand(apptime+currentPlayer->nation+list_count(currentPlayer->unitList)+list_count(currentPlayer->cityList));
          for (i=0; i<8; i++){
            player *myKing = nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION];
            city *c = pickEmigrationPort(myKing);
            if (c!=NULL) {
              int nu = rand();
              nu = FIRST_UNIT+nu%(LAST_EUROPEAN_UNIT-FIRST_UNIT);
              nations[currentPlayer->nation-OLD_POWER_NUMBER-FIRST_NATION]->totalCrosses+=100;
              unit* u = createUnit(FIRST_UNIT+rand()%(LAST_EUROPEAN_UNIT-FIRST_UNIT), myKing);
              addUnitToBuilding(u, c, NEW_WORLD_OFFICE);
            }
          }
          // city of cibola
        } else if (map[x+MapWidth*(y)].construction->seed%100<=20){
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          srand(map[x+MapWidth*(y)].construction->seed);
          int amount = rand()%7000;

          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "You found one of the seven city of cibola with a treasure of %dp.", amount);
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);
          unit *u = createUnitAt(WAGON, nations[currentPlayer->nation-FIRST_NATION], x, y);
          u->goods[0].quantity  = 0;
          u->goods[0].type     = MONEY;
          u->goods[0].quantity = amount;
          // lost colony swear allegeance
        } else if (map[x+MapWidth*(y)].construction->seed%100<=55){
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "You found a lost colonist who swear alleageance to %s.", nationTexts[currentPlayer->nation-FIRST_NATION]);
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);
          unit *u = createUnitAt(COLONIST, nations[currentPlayer->nation-FIRST_NATION], x, y);
          // small amount of money
        } else if (map[x+MapWidth*(y)].construction->seed%100<=75){
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          srand(map[x+MapWidth*(y)].construction->seed);
          int amount = rand()%600;
          currentPlayer->money += amount;
          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "You found valuable stuff for %ip.", amount);
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);
          // holy indian treasure
        } else if (map[x+MapWidth*(y)].construction->seed%100<=90){
          player  *currentPlayer = (player *)currentPlayerElement->list_data;
          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "You enter a holy grave of %s. They declare war right away against you !", nationTexts[map[x+MapWidth*(y)].construction->owner->nation-FIRST_NATION]);
          player  *indianNation = nations[map[x+MapWidth*(y)].construction->owner->nation-FIRST_NATION];
          currentPlayer->diplomaticRelations[indianNation->nation-FIRST_NATION] = DEATH_WAR;
          indianNation->diplomaticRelations[currentPlayer->nation-FIRST_NATION] = DEATH_WAR;
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);
          // explorer is lost !
        } else {
          printf("  Explorers disapear \n");
          discardPopup();
          char* text = (char *)malloc(256*sizeof(char));
          sprintf(text, "Your explorer dispears without leaving any sign of life !");
          addPopupOption(text, NULL);
          sprintf(text, "OK");
          addPopupOption(text, doNothing);
          popupType = POPUP_MESSAGE|POPUP_YESNO;
          free(text);

          lnode_t *ln = list_first(ul);
          while(ln!=&ul->list_nilnode) {
            unit    *u   = (unit*)ln->list_data;
            // FIX ME destroy unit will mess up the list
            destroyUnit(u);
            ln = ln->list_next;
          }
          list_destroy_nodes(ul);
        }
        free(map[x+MapWidth*(y)].construction);
        map[x+MapWidth*(y)].construction = NULL;
        updatesCachedTileAt(x, y);
      }
      if (ul!=NULL && list_count(ul)>0) {
        lnode_t *ln = list_first(ul);
        while(ln!=&ul->list_nilnode) {
          unit    *u   = (unit*)ln->list_data;
          tile    *t   = u->location;
          lnode_t *ln2 = list_find(t->unitList, u, straightCompare);
          list_delete(t->unitList, ln2);
          list_append(map[x+MapWidth*(y)].unitList, ln2);
          u->location = &map[x+MapWidth*(y)];
          map[x+MapWidth*(y)].lastExplored=0;
          if (u->itinerary!=NULL && ((tile*)list_first(u->itinerary)->list_data)==&map[x+MapWidth*(y)])
            list_del_first(u->itinerary);
          ln = ln->list_next;
          if (list_count(t->unitList)==0){
            list_destroy(t->unitList);
            t->unitList = NULL;
          }
        }
        updatesGotoOrders(ul);
      }
    }
  }
  //printf("order after :[%s]\n", order);
}// doExplore()


void doAskCountry(list_t *ul, char*order){
  if (strstr(order, "[[")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+2, strstr(order, "]]") - ptr-2);
    txt[strstr(order, "]]") - ptr-2] = '\n';
    Mapsize= atoi(txt);
    free(txt);
    //printf("size is %s => %d\n", order, Mapsize);
  }
  popupType = POPUP_MESSAGE|POPUP_YESNO;
  addPopupOption("What country send you ?", NULL);
  char *txt = (char*)malloc(64*sizeof(char));
  sprintf(txt, "Debug [[%i]]", FRANCE);
  addPopupOption(txt, doReset);
  sprintf(txt, "France [[%i]]", FRANCE);
  addPopupOption(txt, doReset);
  sprintf(txt, "Spain [[%i]]", SPAIN);
  addPopupOption(txt, doReset);
  sprintf(txt, "England [[%i]]", ENGLAND);
  addPopupOption(txt, doReset);
  sprintf(txt, "Holland [[%i]]", HOLLAND);
  addPopupOption(txt, doReset);
  sprintf(txt, "Italy [[%i]]", ITALY);
  addPopupOption(txt, doReset);
  sprintf(txt, "Germany [[%i]]", GERMANY);
  addPopupOption(txt, doReset);
  sprintf(txt, "Russia [[%i]]", RUSSIA);
  addPopupOption(txt, doReset);
  sprintf(txt, "Portugal [[%i]]", PORTUGAL);
  addPopupOption(txt, doReset);
  free(txt);
}// doAskCountry()


void doAskMapSize(list_t *ul, char*order){
  if (strstr(order, "[[")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+2, strstr(order, "]]") - ptr-2);
    txt[strstr(order, "]]") - ptr-2] = '\n';
    GameDifficulty= atoi(txt);
    free(txt);
    //printf("diff is %s => %d\n", order, GameDifficulty);
  }
  
  popupType = POPUP_MESSAGE|POPUP_YESNO;
  addPopupOption("What size of the world map do you want  ?", NULL);
  char *txt = (char*)malloc(64*sizeof(char));
  sprintf(txt, "675*338 [[%i]]", M675_338);
  addPopupOption(txt, doAskCountry);
  sprintf(txt, "1024*512 [[%i]]", M1024_512);
  addPopupOption(txt, doAskCountry);
  sprintf(txt, "1350*765 [[%i]]", M1350_765);
  addPopupOption(txt, doAskCountry);
  sprintf(txt, "2700*1350 [[%i]]", M2700_1350);
  addPopupOption(txt, doAskCountry);
  sprintf(txt, "5400*2700 [[%i]]", M5400_2700);
  addPopupOption(txt, doAskCountry);  
  sprintf(txt, "10800*5400 [[%i]]", M10800_5400);
  addPopupOption(txt, doAskCountry);
  free(txt);
}// doAskMapSize()


void doAskDifficulty(list_t *ul, char*order){
  popupType = POPUP_MESSAGE|POPUP_YESNO;
  addPopupOption("What role do you want to play  ?", NULL);
  char *txt = (char*)malloc(64*sizeof(char));
  sprintf(txt, "discoverer [[%i]]", DISCOVERER);
  addPopupOption(txt, doAskMapSize);
  sprintf(txt, "explorer [[%i]]", EXPLORER);
  addPopupOption(txt, doAskMapSize);
  sprintf(txt, "conquistador [[%i]]", CONQUISTADOR);
  addPopupOption(txt, doAskMapSize);
  sprintf(txt, "governor [[%i]]", GOVERNOR);
  addPopupOption(txt, doAskMapSize);
  sprintf(txt, "viceroy [[%i]]", VICEROY);
  addPopupOption(txt, doAskMapSize);
  free(txt);
}// doAskDifficulty()


/**
 * ask the given unit(s) to found a city
*/
void doAskCityNameAndBuild(list_t *ul, char *order) {
  //printf("doAskCityNameAndBuild(%i)\n", list_count(ul));

  list_t *ul2 = list_create(LISTCOUNT_T_MAX);
  lnode_t *ln = list_first(ul);
  while (ln!=NULL && ln!=&ul->list_nilnode){
    unit *u = (unit*)ln->list_data;
    list_append(ul2, lnode_create(u));
    ln = ln->list_next;
  }

  discardPopup();
  popupType = POPUP_MESSAGE|POPUP_YESNO|POPUP_TEXT;
  popupOptionList = list_create(LISTCOUNT_T_MAX);
  //printf("popupType=%i\n", popupType);

  // TODO suggest city name according to player
  resetPopupText("");

  addPopupOption("What name do you want to give to this city ?", NULL);
  //popupDecoration = getUnitImage((unit *)(list_first(ul)->list_data));
  setPopupDecoration(messageImages[NEW_COLONY-FIRST_MESSAGE]);
  SDL_Rect *rect = (SDL_Rect *)malloc(sizeof(SDL_Rect));
  ln = list_first(ul);
  while (ln!=NULL && ln!=&ul->list_nilnode){
    unit *u = (unit*)ln->list_data;
    SDL_Surface *imgunit = getUnitImage(u);
    rect->x += imgunit->w;
    rect->y = popupDecoration->h -imgunit->h;
    SDL_BlitSurfaceColW(imgunit, NULL, popupDecoration, rect, 255, FALSE, nationColors[u->owner->nation-FIRST_NATION]);
    SDL_BlitSurface(imgunit, NULL, popupDecoration, rect);
    ln = ln->list_next;
  }
  free(rect);
  addPopupOption("Found city", doFoundCity);
  addPopupOption("Cancel", doNothing);

  popupUnitList  = ul2;
}// doAskCityNameAndBuild() --------------------------------------------------------------------


/**
 * ask the given unit(s) to found a city
 */
void doFoundCity(list_t *ul, char *order) {
  //printf("doFoundCity(%i)\n", list_count(ul));
  if (ul==NULL || list_isempty(ul) || order==NULL)
    return;
  lnode_t *unitelem = list_first(ul);
  unit *u = (unit *)unitelem->list_data;
  if (unitelem==NULL)
    return;
  resetStatusAll(ul);

  list_t *l = list_create(LISTCOUNT_T_MAX);
  while (unitelem != &ul->list_nilnode) {
    list_append(l, lnode_create(unitelem->list_data));
    unitelem = unitelem->list_next;
  }

  if (strlen(order)==0)
    sprintf(order, "citywithoutname");
  unitelem = list_first(l);

  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  srand(apptime+currentPlayer->nation+list_count(currentPlayer->unitList)+list_count(currentPlayer->cityList));
  city *c = createCity(list_count(ul), order, u->location, (player*)currentPlayerElement->list_data);
  u->location->construction = c;
  if (u->location->road==NONE)
    u->location->road=ROAD;
  //int range = getRangeForSize(c->size);
  int i=0;
  while (unitelem != &l->list_nilnode) {
    unit *u = (unit *)unitelem->list_data;
    lnode_t *ln = list_find(c->location->unitList, u, *straightCompare);

    if (u->type>=COLONIST && u->type<=SCOUT && ln !=NULL) {
      list_delete(c->location->unitList, ln);
      c->dependencies[i] = u;
      u->status          = CORNING;
      u->location        = NULL;
      if (u->tools>0) {
        c->stocks[TOOL-FIRST_GOOD].quantity+=u->tools;
        u->tools = 0;
      }
      if (u->muskets>0) {
        c->stocks[MUSKET-FIRST_GOOD].quantity+=u->muskets;
        u->muskets = 0;
      }
      if (u->horses>0) {
        c->stocks[HORSE-FIRST_GOOD].quantity+=u->horses;
        removeHorses(u);
      }

      i++;
    }
    unitelem = unitelem->list_next;
  }
  list_destroy_nodes(l);
  list_destroy(l);
  l = NULL;
  c->size = i;
  selectNextWaitingUnit();
  updatesCachedTileAt(c->location->posX, c->location->posY);
}// doFoundCity() --------------------------------------------------------------------


/**
 * ask to quit the application for good
*/
void doQuit(list_t *ul, char *order) {
  done = 1;
}// doQuit() --------------------------------------------------------------------


/**
 * ask to reset the application
*/
void doReset(list_t *ul, char *order) {
  currentPlayerElement = NULL;
  if (playerList!=NULL){
    lnode_t *ln = list_first(playerList);
    while (ln!=NULL &&ln!=&playerList->list_nilnode) {
      player *p = (player*)ln->list_data;
      lnode_t *ln2 = list_first(p->cityList);
      while(ln2!=NULL && ln2!=&p->cityList->list_nilnode) {
        city *c       = (city*) ln2->list_data;
        lnode_t *ln3 = list_first(c->buildings);
        while(ln3!=NULL && ln3!=&c->buildings->list_nilnode) {
          building *b       = (building*) ln3->list_data;
          list_destroy_nodes(b->workers);
          list_destroy(b->workers);
          b->workers = NULL;
          free(b);
          b = NULL;
          ln3 = ln3->list_next;
        }

        list_destroy_nodes(c->buildings);
        list_destroy(c->buildings);
        c->buildings = NULL;
        free(c->dependencies);
        free(c->stocks);
        free(c->name);
        free(c);
        c = NULL;
        ln2 = ln2->list_next;
      }
      list_destroy_nodes(p->cityList);
      list_destroy(p->cityList);
      p->cityList = NULL;
      ln = ln->list_next;
      free(p->name);
      ln2 = list_first(p->unitList);
      while(ln2!=NULL && ln2!=&p->unitList->list_nilnode) {
        unit *u       = (unit*) ln2->list_data;
        if (u->itinerary!=NULL) {
          list_destroy_nodes(u->itinerary);
          list_destroy(u->itinerary);
          u->itinerary = NULL;
        }

        free(u);
        ln2 = ln2->list_next;
      }
    }
    list_destroy_nodes(playerList);
    if (unitSelectionList!=NULL)
      list_destroy_nodes(unitSelectionList);
    currentPlayerElement = NULL;
    ln = list_first(unitViews);
    while (ln!=NULL && ln !=&unitViews->list_nilnode) {
      unitview *uv = (unitview *)ln->list_data;
      if (uv->ul!=NULL){
        list_destroy_nodes(uv->ul);
        list_destroy(uv->ul);
      }
      uv->ul = NULL;
      ln = ln->list_next;
    }
  }

  // right now we only have one map ! .. and it's already transformed with robinson projection (no need to do it ourself)
  // but we handle different map sizes 
  char *txt = (char *)malloc(256*sizeof(char));
  switch (Mapsize){
    case M10800_5400 : sprintf(txt, "images/globecol.png");break;
    case M5400_2700 : sprintf(txt, "images/globecol2.png");break;
    case M2700_1350 : sprintf(txt, "images/globecol4.png");break;
    case M1350_765 : sprintf(txt, "images/globecol8.png");break;
    case M1024_512 : sprintf(txt, "images/globecol10.png");break;
    case M675_338 : sprintf(txt, "images/globecol16.png");break;
  }
  //printf("the string for img is %s\n", txt);fflush(stdout);
  FILE *f1 = fopen(txt, "r");
  if (!f1) {
    popupType = POPUP_MESSAGE|POPUP_YESNO;
    addPopupOption("Sorry the map corresponding to your choice is not available", NULL);
    char *txt = (char*)malloc(64*sizeof(char));
    sprintf(txt, "Quit [[%i]]", 0);
    addPopupOption(txt, doQuit);
    sprintf(txt, "Select another one [[%i]]", EXPLORER);
    addPopupOption(txt, doAskMapSize);
    free(txt);
    return;
  }
  fclose(f1);

  //printf("riverList %p %i\n", riverList, list_count(riverList));
  list_destroy_nodes(riverList);
  if (strstr(order, "Debug")) {
    initPlayers(8, NEW_FRANCE, "Fred Vernier");
    apptime = 367;
  }else if (strstr(order, "France")) {
    initPlayers(8, NEW_FRANCE, "Jacques Cartier");
    apptime = 67;
  } else  if (strstr(order, "Spain")) {
    initPlayers(8, NEW_SPAIN, "Christopher Columbus");
    apptime = 7;
  } else if (strstr(order, "England")) {
    apptime = 67;
    initPlayers(8, NEW_ENGLAND, "Walter Raleigh");
  } else if (strstr(order, "Holland")){
    apptime = 67;
    initPlayers(8, NEW_HOLLAND, "Michiel de Ruyter");
  } else if (strstr(order, "Italy")){
    apptime = 127;
    initPlayers(8, NEW_ITALY, "ZZZ");
  } else if (strstr(order, "Germany")){
    apptime = 127;
    initPlayers(8, NEW_GERMANY, "WWW");
  } else if (strstr(order, "Russia")){
    apptime = 127;
    initPlayers(8, NEW_RUSSIA, "YYY");
  } else if (strstr(order, "Portugal")){
    apptime = 127;
    initPlayers(8, NEW_PORTUGAL, "XXX");
  } else {
    initPlayers(8, NEW_FRANCE, "Fred Vernier");
    apptime = 127;
  }

  unitSample = createUnit(COLONIST, (player *)currentPlayerElement->list_data);
  
  char* msg = (char *)malloc(512);
  sprintf(msg, "Loading world map (%s)", txt);
  addMsg(msg);
  free(msg);
  updateLoading();
  isRobinsonTransfo = FALSE;
  initGroundsFromBitmap(txt, 1, 1, FALSE);
  isRobinsonTransfo = TRUE;
  free(txt);
  addMsg("Initializing map");
  updateLoading();
  if (strstr(order, "Debug")) {
    initDebugMap();
    gamemode = DEBUG;
  } else
    initStartupMap();


  //updateMiniMap();
  //computeIrrigation();

  // create a unit view with the first unit of the first player
  addMsg("Creating unit inspector");
  updateLoading();
  if (inspector==NULL) {
    inspector = createUnitView();
    list_append(unitViews, lnode_create(inspector));
  }

  //printf(" reset with %i unit(s) selected \n", list_count(unitSelectionList));
  isDisplayGrid        = TRUE;
  isDisplayMiniMap     = TRUE;

  addMsg("Updating fog of war");
  updateLoading();
  updatesLastExplored();
  updatesCache(-1, -1, -1, -1);
  addMsg("Updating minimap");
  updateLoading();
  updateMiniMap();
  addMsg("Selecting first unit");
  updateLoading();
  int nb = selectNextWaitingUnit();
}// doReset() --------------------------------------------------------------------


/**
 * visit natives 
 */
void doVisitIndianTribe(list_t *ul, char *order) {
  city *cityToVisit = NULL;
  if (strstr(order, "[[")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[");
    char * txt     = (char*)malloc(256*sizeof(char));
    strncpy(txt, ptr+2, strstr(order, "]]") - ptr-2);
    txt[strstr(order, "]]") - ptr-2] = '\0';
    cityToVisit = (city *)atol(txt);
    free(txt);
    cityToVisit->type = cityToVisit->type|KNOWN_CITY;
    if (cityToVisit->seed%100<=15) {
      popupType = POPUP_MESSAGE|POPUP_OKCANCEL;
      srand(cityToVisit->seed);
      int amount = rand()%getMaximumMoneyForIndianCity(cityToVisit);
      char * txt     = (char*)malloc(256*sizeof(char));
      sprintf (txt, "This tribe offers an ammount of valuable (%d p) items as gift to their guests !", amount);
      ((player*)currentPlayerElement->list_data)->money += amount;
      addPopupOption(txt, NULL);
      free(txt);
      addPopupOption("OK", doNothing);
    } else if (cityToVisit->seed%100<=35) {
      int i, j;
      popupType = POPUP_MESSAGE|POPUP_OKCANCEL;
      srand(cityToVisit->seed);
      tile *t       = cityToVisit->location;
      int sight     = 3*(cityToVisit->size+2);
      for (i=-sight; i<=sight; i++)
        for (j=-sight; j<=sight; j++) {
          int d =(int)hypot((float)i, (float)j);
          if (d<=sight && t->posX+i>=0 && t->posY+j>=0 &&t->posX+i<MapWidth && t->posY+j<MapHeight && rand()%100<80) {
            map[t->posX+i+MapWidth*(t->posY+j)].lastExplored = 0;
          }
        }

      addPopupOption("This tribe give you a map of surroundings !", NULL);

      addPopupOption("OK", doNothing);
    } else {
      popupType = POPUP_MESSAGE|POPUP_OKCANCEL;
      addPopupOption("this event is not supported yet !", NULL);
      addPopupOption("OK", doNothing);
    }
  }
}// doVisitIndianTribe()


/**
 * take a city !
 */
void doInvade(list_t *ul, char *order) {
  unit *u0 = (unit *)list_first(ul)->list_data;
  //printf("doInvade() ... %s\n", order);
  city *cityToInvade = NULL;
  if (strstr(order, "[[")!=NULL && strstr(order, "]]")!=NULL && strstr(order, "[[") < strstr(order, "]]")) {
    char *ptr = strstr(order, "[[");
    char * txt     = (char*)malloc(256*sizeof(char));
    //printf("  we are between %p and %p => %i\n", ptr, strstr(order, "]]"), (strstr(order, "]]") - ptr-2));
    strncpy(txt, ptr+2, strstr(order, "]]") - ptr-2);
    txt[strstr(order, "]]") - ptr-2] = '\0';
    cityToInvade = (city *)atol(txt);
    free(txt);
    //printf("doInvade(%s) %d / %d \n", cityToInvade->name, sizeof (city*), sizeof(atol(txt)));
    int money =  cityToInvade->owner->money;
    int totalSize = 0;
    lnode_t *ln = list_first(cityToInvade->owner->cityList);
    while(ln!=NULL && ln != &cityToInvade->owner->cityList->list_nilnode){
      city *c = (city *)ln->list_data;
      totalSize+=c->size;
      ln = ln->list_next;
    }
    money = money*cityToInvade->size;
    money = money/totalSize;
    u0->owner->money += money;
    cityToInvade->owner->money -= money;
    changeCityOwner(cityToInvade, u0->owner);
    char *msg = (char *)malloc(512);
    sprintf(msg, "BATTLEWIN: %02d/%4d: We take te city of %s to the %s and plunder %dp!", 1+apptime%12, 1492+apptime/12, cityToInvade->name, nationTexts[cityToInvade->owner->nation-FIRST_NATION], money);
    addMsg(msg);
    free(msg);

    if (cityToInvade->location->unitList==NULL)
      cityToInvade->location->unitList = list_create(LISTCOUNT_T_MAX);
    ln = list_first(ul);
    while (ln!=NULL && ln!=&ul->list_nilnode){
      unit *u = (unit*)ln->list_data;
      tile *t = u->location;
      if (t!=NULL) {
        lnode_t * ln = list_find(t->unitList, u, *straightCompare);
        if (ln!=NULL) {
          list_delete(t->unitList, ln);
          list_append(cityToInvade->location->unitList, lnode_create(u));
          u->location = cityToInvade->location;
          if (u->itinerary!=NULL) {
            list_destroy_nodes(u->itinerary);
            list_destroy(u->itinerary);
            u->itinerary = NULL;
          }
          u->status = WAITING;
        }
      }

      ln = ln->list_next;
    }
    updatesCachedTileAt(cityToInvade->location->posX, cityToInvade->location->posY);
  }
}// doInvade()


/**
 * make the 2 lists of units in the inspector fighting
 */
void doFight(list_t *ul, char *order) {
  //printf("doFight()  inspector get %d against %d\n", list_count(inspector->ul), list_count(inspector->opponentl));fflush(stdout);
  if (press_timer_id!=NULL)
    SDL_RemoveTimer(press_timer_id);
  while (press_timer_id!=NULL){
    //printf("...waiting timer to be stopped \n");
    SDL_Delay(20);
  }
  lnode_t *ln = NULL;
  battle *bat = prepareBattle();
  //printf("  countries are %s against %s\n", bat->attacker->name, bat->defender->name);fflush(stdout);

  player  *currentPlayer = (player *)currentPlayerElement->list_data;
  srand(apptime+currentPlayer->nation+list_count(currentPlayer->unitList)+list_count(currentPlayer->cityList));
  int dice = rand()%((int)(bat->attackBonusMalus*bat->attackStrength)+(int)(bat->defenseBonusMalus*bat->defenseStrength));
  //printf("doFight1(%d %d)\n", time(0), dice);
  dice = rand()%((int)(bat->attackBonusMalus*bat->attackStrength)+(int)(bat->defenseBonusMalus*bat->defenseStrength));
  //printf("doFight2(%d %d)\n", time(0), dice);
  dice = rand()%((int)(bat->attackBonusMalus*bat->attackStrength)+(int)(bat->defenseBonusMalus*bat->defenseStrength));
  //printf("doFight3(%d %d)\n", time(0), dice);
  
  dice = rand()%((int)(bat->attackBonusMalus*bat->attackStrength)+(int)(bat->defenseBonusMalus*bat->defenseStrength));
  tile *dest = NULL;
  //printf("dice =%i / 0-%i-%i\n", dice, (int)(bat->attackBonusMalus*bat->attackStrength), ((int)(bat->attackBonusMalus*bat->attackStrength)+(int)(bat->defenseBonusMalus*bat->defenseStrength)));
  if (dice<(int)(bat->attackBonusMalus*bat->attackStrength)){
    int nbcausalities = 0;
    //loosers
    ln = list_first(bat->defenderlist);
    while (ln!=NULL && ln != &bat->defenderlist->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      dest = uni->location;
      destroyUnit(uni);
      nbcausalities++;
      ln = ln->list_next;
    }
     
    int nblost = 0;
    //winners
    ln = list_first(bat->attackerlist);
    while (ln != &bat->attackerlist->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      float ratio = ((float)(1+(int)(bat->attackBonusMalus*bat->attackStrength)-dice))/(int)(bat->attackBonusMalus*bat->attackStrength);
      uni->health = (int)(ratio*uni->health);
      if(uni->health<=0) {
        //printf("destroying friend %i\n", uni->type);
        destroyUnit(uni);
        nblost++;
      } else {
        tile *t = uni->location;
        if (t!=NULL) {
          lnode_t * ln = list_find(t->unitList, uni, *straightCompare);
          if (ln!=NULL) {
            list_delete(t->unitList, ln);
            list_append(dest->unitList, lnode_create(uni));
            uni->location = dest;
            if (uni->itinerary!=NULL) {
              list_destroy_nodes(uni->itinerary);
              list_destroy(uni->itinerary);
              uni->itinerary = NULL;
            }
            uni->status = WAITING;
          }
        }
      }
      ln = ln->list_next;
    }
    char *msg = (char *)malloc(512);
    sprintf(msg, "BATTLEWIN: %02d/%4d: battle won against %s(%s). %d units destroyed!", 1+apptime%12, 1492+apptime/12, bat->defender->name, nationTexts[bat->defender->nation-FIRST_NATION], nbcausalities);
    addMsg(msg);
    free(msg);
    if (nblost>0){
      char *msg = (char *)malloc(512);
      sprintf(msg, "BATTLELOST:   ... but during the fight %d units were destroyed :-(", 1+apptime%12, 1492+apptime/12, bat->defender->name, nationTexts[bat->defender->nation-FIRST_NATION], nbcausalities);
      addMsg(msg);
      free(msg);
    }
  } else {
    int nbcausalities = 0;
    //loosers
    ln = list_first(bat->attackerlist);
    while (ln!=NULL && ln != &bat->attackerlist->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      if (1==1) {
        destroyUnit(uni);
        nbcausalities++;
      }
      ln = ln->list_next;
    }
 
    int nblost = 0;
    //winners
    ln = list_first(bat->defenderlist);
    while (ln != &bat->defenderlist->list_nilnode) {
      unit *uni = (unit *)ln->list_data;
      dest = uni->location;
      float ratio = ((float)(1+dice-(bat->attackBonusMalus*bat->attackStrength)))/(bat->defenseStrength);
      //printf("  opponent winner ratio %f\n", ratio);
      uni->health = (int)(ratio*uni->health);
      if(uni->health<=0) {
        destroyUnit(uni);
        nblost++;
      }
      ln = ln->list_next;
    }
    char *msg = (char *)malloc(512);
    sprintf(msg, "BATTLELOST: %02d/%4d: battle lost against %s(%s). %d units were destroyed", 1+apptime%12, 1492+apptime/12, bat->defender->name, nationTexts[bat->defender->nation-FIRST_NATION], nbcausalities);
    addMsg(msg);
    free(msg);
    if (nblost>0){
      char *msg = (char *)malloc(512);
      sprintf(msg, "BATTLEWIN:   ... but before dying we destroyed %d units :-)", 1+apptime%12, 1492+apptime/12, bat->defender->name, nationTexts[bat->defender->nation-FIRST_NATION], nbcausalities);
      addMsg(msg);
      free(msg);
    }    
  }

  free(bat->text);
  list_destroy_nodes(bat->attackerlist);
  list_destroy(bat->attackerlist);
  list_destroy_nodes(bat->defenderlist);
  list_destroy(bat->defenderlist);
  free(bat);
  if (inspector->ul!=NULL) {
    list_destroy_nodes(inspector->ul);
    list_destroy(inspector->ul);
    inspector->ul = NULL;
  }
  if (inspector->opponentl!=NULL) {
    list_destroy_nodes(inspector->opponentl);
    list_destroy(inspector->opponentl);
    inspector->opponentl = NULL;
  }

  //printf("dest =  %i, %i = %i units\n", dest->posX, dest->posY, list_count(dest->unitList));

  if (list_count(dest->unitList)==0) {
    list_destroy_nodes(dest->unitList);
    dest->unitList = NULL;
    updatesInspector(NULL, NULL);
    inspector->t = dest;
    list_destroy_nodes(unitSelectionList);
  } else {
    updatesInspector(dest->unitList, NULL);
    list_destroy_nodes(unitSelectionList);
    copylistTo(dest->unitList, unitSelectionList);
  }
}// doFight() --------------------------------------------------------------------


/**
 * ask ... to do nothing
*/
void doNothing(list_t *ul, char *order) {
  lnode_t *ln = list_first(ul);
  while (ln!=NULL && ln!=&ul->list_nilnode){
    unit *u = (unit*)ln->list_data;
    if (u->itinerary!=NULL) {
      list_destroy_nodes(u->itinerary);
      list_destroy(u->itinerary);
      u->itinerary = NULL;
    }
    u->status = WAITING;
    ln = ln->list_next;
  }
}// doNothing() --------------------------------------------------------------------


/*
 Newcol is starting with 1 arguments
 random distribution   : |  76 | 100 |  97 | 100 |  95 | 105 | 107 | 104 | 108 | 108 |
 gaussian distribution : | 307 | 254 | 190 | 126 |  74 |  33 |  12 |   3 |   1 |   0 |
 perlin values       :   | -15 | -14 | -14 | -14 | -14 | -14 | -13 | -13 | -13 | -13 |
 | -12 | -12 | -12 | -12 | -11 | -11 | -11 | -10 | -10 | -10 |
 | -10 |  -9 |  -9 |  -8 |  -8 |  -8 |  -7 |  -7 |  -6 |  -6 |
 |  -5 |  -5 |  -4 |  -4 |  -3 |  -3 |  -2 |  -2 |  -1 |   0 |
 |   0 |   0 |   0 |   1 |   2 |   2 |   3 |   4 |   4 |   5 |
 |   5 |   6 |   7 |   7 |   8 |   8 |   9 |   9 |  10 |  11 |
 |  11 |  12 |  12 |  12 |  13 |  13 |  14 |  14 |  14 |  15 |
 |  15 |  15 |  16 |  16 |  16 |  16 |  16 |  17 |  17 |  17 |
 |  17 |  17 |  17 |  17 |  17 |  17 |  17 |  17 |  17 |  17 |
 |  17 |  16 |  16 |  16 |  16 |  16 |  16 |  16 |  15 |  15 |

 perlin loop values :     |   0 |  -2 |  -6 | -10 | -14 | -18 | -21 | -23 | -23 | -23 |
 | -21 | -19 | -16 | -13 | -10 |  -7 |  -5 |  -3 |  -2 |   0 |
 |   0 |   1 |   1 |   2 |   2 |   2 |   2 |   2 |   2 |   2 |
 |   2 |   3 |   4 |   5 |   6 |   7 |   8 |   8 |   7 |   6 |
 |   5 |   3 |   2 |   1 |   0 |   0 |   0 |   1 |   3 |   6 |
 |   9 |  11 |  14 |  16 |  18 |  18 |  18 |  17 |  14 |  11 |
 |   7 |   3 |   0 |  -4 |  -7 | -11 | -13 | -15 | -15 | -15 |
 | -13 | -11 |  -8 |  -4 |  -1 |   0 |   1 |   2 |   1 |   1 |
 |   0 |   0 |  -1 |  -1 |  -1 |   0 |   0 |   2 |   5 |   8 |
 |  12 |  15 |  17 |  17 |  17 |  15 |  13 |   9 |   6 |   3 |
 |   0 |
 |
 perlin 2d values     :   | -18 | -20 | -19 | -18 | -17 | -18 | -18 | -18 | -17 | -14 |
 | -18 | -19 | -18 | -16 | -15 | -15 | -15 | -16 | -15 | -13 |
 | -17 | -18 | -16 | -14 | -13 | -12 | -13 | -13 | -13 | -11 |
 | -16 | -16 | -15 | -12 | -11 | -10 | -10 | -10 | -10 |  -8 |
 | -14 | -15 | -14 | -11 |  -9 |  -9 |  -8 |  -8 |  -7 |  -5 |
 | -13 | -14 | -13 | -10 |  -9 |  -8 |  -7 |  -6 |  -5 |  -2 |
 | -13 | -14 | -13 | -11 |  -9 |  -8 |  -7 |  -5 |  -3 |   0 |
 | -13 | -14 | -13 | -12 | -10 |  -8 |  -7 |  -5 |  -3 |   0 |
 | -12 | -14 | -14 | -12 | -11 |  -9 |  -8 |  -5 |  -3 |   0 |
 | -11 | -13 | -13 | -12 | -11 |  -9 |  -7 |  -5 |  -3 |   0 |
 sounds system started !
 Available Modes
 0:  2560 x 1600
 1:  2048 x 1536
 2:  1920 x 1440
 3:  2048 x 1280
 4:  1920 x 1200
 5:  1600 x 1200
 6:  1600 x 1000
 7:  1344 x 1008
 8:  1280 x 960
 9:  1344 x 840
 10:  1280 x 800
 11:  1024 x 768
 12:  1024 x 640
 13:  800 x 600
 14:  800 x 500
 15:  640 x 480
 choosen Mode : 0
 SDL is started !
 surface   screen image info: : w:2560 h:1600 bpp:32 ff0000 ff00 ff 0
 fonts are loaded !
 Newcol is loading sounds ...
 sounds are loaded !
 Newcol is loading images ...
 loading images ... mask=ff0000 ff00 ff ff000000
 last image is loaded 0x3a8490 (30*30)
 Initialisation finished !

 ERROR: A* didn't work to draw river path! we used a Scout(-101 horses)
 ***ERROR***: It is impossible to create a non naval unit on sea 684, 271!
 */
